.\" $Id: ch01.ms,v 1.2 1992/12/14 13:25:50 davy Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.bp
.NH1
\s12GoPATH\s0 SOURCES ORGANIZATION
.LP
If you have received a binary version you can skip this chapter.
.LP
The \fBGo\fP sources are organized in a directory hierarchy. The root of
this hierarchy is called \fIsrc\fP. The following tables gives the
source organization for the two first levels of the hierarchy.
.LP
.sp 1
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc\fP Directory
_

Copyright	file	T{
contains the \fICopyright\fP notice concerning all
the files of public \fBGoPATH\fP distribution.
T}

ReadMe	file	T{
gives some information about the directory.
T}

Imakefile\u\s41\s0\d	file	T{
used by \fIimake(1)\fP for generating the
Makefile file.
T}

lib	directory	T{
contains the source directory hierarchy of \fBGo\fP libraries.
T}

include	directory	T{
contains the header files for \fBGo\fP programming.
T}

util	directory	T{
contains useful files for international text and
PostScript\u\s4TM\s0\d use in \fBGo\fP.
T}

bin	directory	T{
contains the source directory hierarchy of
\fBGo\fP Companions (e.g. \fIgodraw\fP) and examples.
It also contains \fIscripts\fP used to generate \fBGo\fP.
T}

doc	directory	T{
contains the source directory hierarchy of \fBGoPATH\fP documentation.
It also contains the PostScript\u\s4TM\s0\d version of every document.
T}

.TE
.FS
1) The Imakefile files are not used in the MS-Windows environment and
the Makefile files are distributed directly.
.FE
.bp
.LP
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc/lib\fP Directory
_

Imakefile	file	T{
used by \fIimake(1)\fP to generate the Makefile file.
T}

go	directory	T{
contains the source directory hierarchy
of the basic classes (i.e. \fIGo\fP, \fIGoInterf\fP,
\fIGoStream\fP, \fIGoUI\fP, ...).
T}

bgo	directory	T{
contains the source directory hierarchy
of predefined \fIGo\fP subclasses
(i.e. \fIGoGeometric\fP, \fIGoTextual\fP, \fIGoImage\fP,
\fIGoGraph\fP, \fIBGoUI\fP, ...).
T}

extensions\u\s41\s0\d	directory	T{
contains the source directory hierarchy
of application oriented object classes
(editor, clipboard, converter, help, ...).
T}

Xb\u\s42\s0\d	directory	T{
contains the source directory hierarchy of
some widgets which are used in \fBGo\fP Companions.
T}

misc	directory	T{
contains source files of some convenient functions available in the
\fBGo\fP libraries.
T}

.TE
.FS
1) Some parts are not in the public release.
.FE
.FS
2) Not part of the public release.
.FE
.sp 1
.LP
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc/include\fP Directory
_

Imakefile	file	T{
used by \fIimake(1)\fP to generate the Makefile.
T}

Go\u\s41\s0\d	directory	T{
contains the header files needed to generate and use \fBGo\fP.
It includes the \fITools\fP directory for tool objects and
the \fIExt\fP directory for the application oriented objects.
T}

Xb\u\s41\s0\d	directory	T{
contains the header files needed to generate and use
the Xb widgets. It also contains the \fIGraphic\fP widget header file. This
widget is a Motif\u\s4TM\s0\d widget
subclass and can be used in applications integrating Motif and \fBGo\fP.
T}

.TE
.bp
.LP
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc/util\fP Directory
_

Imakefile	file	T{
used by \fIimake(1)\fP to generate the Makefile.
T}

psfonts	directory	T{
contains the PostScript\u\s4TM\s0\d font metrics used by the
\fIPSGoInterf\fP objects.
T}

hyphen\u\s42\s0\d	directory	T{
contains dictionaries for international hyphenation.
These dictionaries are used by \fIGoText\fP formatters.
T}

.TE
.sp 1
.LP
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc/bin\fP Directory
_

Imakefile	file	T{
used by \fIimake(1)\fP to generate the Makefile.
T}

examples	directory	T{
contains the source directory hierarchy of some simple \fBGo\fP
programs (e.g. \fIclock\fP).
T}

editors\u\s41\s0\d	directory	T{
contains the source directory hierarchy of \fBGo\fP based editors
(\fBGo\fP Companions).
Only \fIgodraw\fP is available in the public release.
T}

scripts	directory	T{
contains shell scripts used to generate \fBGoPATH\fP.
T}

.TE
.FS
1) Some parts are not in the public release.
.FE
.FS
2) Not part of the public release.
.FE
.bp
.LP
.TS
expand, box;
c s s
cBw(1.i)| cI | lw(3.5i).
\fBsrc/doc\fP Directory
_

Imakefile	file	T{
used by \fIimake(1)\fP to generate Makefile.
T}

InstGuide	directory	T{
contains this present guide \fItroff\fP source files.
It also includes a compressed PostScript\u\s4TM\s0\d version of this guide.
T}

go	directory	T{
contains the \fBGo\fP libraries \fItroff\fP source files (\fIGoPATH
Reference Manual (man pages)\fP, \fIGoPATH Programmer's Guide\fP,
\fIGoPATH Advanced Programmer's Manual\fP).
It also includes a compressed PostScript\u\s4TM\s0\d version of these
manuals.
T}

editors	directory	T{
contains the \fIman\fP pages \fItroff\fP source files for the editors.
T}

Xb	directory	T{
contains the documentation the widgets used by the \fBGo\fP companions
(\fIXb Programmer's Guide, Xb Reference Manual (man pages)\fP).
It also includes a compressed PostScript\u\s4TM\s0\d version of this
documentation.
T}

.TE

.LP
.SH
NOTES:
.LP
The source files for \fBGo\fP \fIC\fP interface are located in the
same directories as the \fIC++\fP code. A generation parameter allows
to include or not this interface in the \fBGo\fP libraries.
.LP
The source file versions are controlled with \fIRCS\fP\u\s41\s0\d(Revision
Control System) and \fICVS\fP\u\s42\s0\d (Concurrent Versions System).
.FS
1) From Walter F. Tichy, RCS is a part of the GNU environment from the Free
Software Foundation.
.br
2) From Dick Grune at Vrije Universiteit in Amsterdam, Brian Berliner at
Prisma in Colorado Springs (CO) and Jeff Polk.
.FE
This allows you to install the successive versions of \fBGo\fP in your
own \fICVS\fP or \fIRCS\fP control.
