.\" $Id: ch02.ms,v 1.5 1992/12/30 13:03:57 davy Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.bp
.NH1
\s12GoPATH\s0 IN THE UNIX ENVIRONMENT
.LP
.NH2
The GoPATH Distribution
.LP
\fBGoPATH\fP is available on request on a 150 Mb cartridge.
The public release of \fBGoPATH\fP is available on the network on two machines:
.IP
.TS
l l l l.
\fICountry	hostname	IP address	directory/files\fP
_
France	avahi.inria.fr	138.96.24.30	/pub/gopath/*
USA	export.lcs.mit.edu	18.24.0.12	/contrib/gopath/*
_
.TE
.sp 1
.LP
You also may receive a tape (150M cartridge).The tape is a \fItar(1)\fP
format tape and contains the files available on the networks.
.LP
There are at least five files:
.IP
\(bu go-\fIv.r.p\fP-RelNote: the release note (version \fIv\fP,
release \fIr\fP, patch \fIp\fP).
.br
\(bu go-\fIv.r.p\fP-ReadMe: some information about \fBGo\fP file organization
and contacts.
.br
\(bu go-\fIv.r.p\fP-src.tar.Z: the source files (\fIcompress(1)\fPed
\fItar(1)\fP format of the version \fIv\fP, release \fIr\fP, patch \fIp\fP
of \fBGoPATH\fP.
.br
\(bu go-\fIv.r.p\fP-doc.tar.Z: the documentation files (\fIcompress(1)\fPed
\fItar(1)\fP format of the version \fIv\fP, release \fIr\fP, patch \fIp\fP
of \fBGoPATH\fP.
.br
\(bu go-\fIv.r.p\fP.str.tar.Z: some \fIGoStream\fP files for demos and examples.
.LP
After retrieving files in a directory (e.g. \fIgo\fP), you have to
.br
	uncompress | tar xf
.br
the files to get the \fIsrc\fP directory, the \fIsrc/doc\fP directory or
the \fIgodb\fP directory. The \fIsrc\fP and \fIsrc/doc\fP organizations is
given in the chapter 1.
.bp
.NH2
Generating GoPATH
.NH3
The Generation Source Hierarchy
.LP
You may want to preserve the original source distribution or you may
need to generate \fBGoPATH\fP in various environments. In that case, you have
to create new source hierarchies. You may use \fImkls.sh\fP or
\fImklk.sh\fP. Both are located in the \fIsrc/bin/scripts\fP directory
(\fBmkls.sh\fP creates symbolic links and \fBmklk.sh\fP creates hard
links).
.IP
$ cd go
.br
$ src/bin/mkls.sh src gen
.LP
This \fIShell\fP sequence will create the \fIgen\fP hierarchy with
symbolic links to the \fIsrc\fP hierarchy. In the following text,
\fIgen\fP will be used to mention the generation root directory.
.NH3
Configuration Files
.LP
The \fBGoPATH\fP generation is performed using \fBimake(1)\fP\u\s41\s0\d and
\fBmakedepend(1)\fP\u\s42\s0\d. Both are available in the X Window System
distribution from the MIT. These two tools allow to create the generation
files \fIMakefiles\fP used by \fBmake(1)\fP.
.FS
1) From Todd Brunhoff, Tektronix and MIT Project Athena; Jim Fulton, MIT X Consortium.
.br
2) From Todd Brunhoff, Tektronix, Inc. and MIT Project Athena.
.FE
.LP
Before generating the \fIMakefiles\fP, some configuration files \fImust\fP be
read and/or edited to be adapted to your site (usually, only \fBSite.def\fP
should be edited). These files are located in the
\fIgen/config\fP directory.
.NH4
Imake.tmpl File
.LP
This file is the \fItemplate\fP file used by \fIimake(1)\fP. It follows
the \fIcpp(1)\fP syntax. It is recommended to read the \fIimake\fP man
pages.
.LP
\fIImake.tmpl\fP \fIshould not\fP be edited. Read it to understand which and
when other configuration files are taken into account. \fIImake.tmpl\fP
is the skeleton of the generated \fIMakefile\fP files. It includes
all the following files in the following order:
.IP
.nf
\fIArch.def\fP (determine which platform-specific.\fIcf\fP to be included)
\fISite.def\fP (site specific parameters with \fIBeforeVendorCF\fP defined)
platform-specific.\fIcf\fP (platform specific parameters)
\fISite.def\fP (site specific parameters with \fIAfterVendorCF\fP defined)
\fIParams.def\fP (other default parameters)
\fIMacros.def\fP (macros definition)
\fIImakefile\fP (what has to be generated)
\fIRules.def\fP (Makefile entries definition)
.fi
.bp
.NH4
Params.def File
.LP
This file contains parameters used to generate \fBGo\fP. It \fIshould
not\fP be edited. Parameters may be overridden in the \fISite.def\fP or
\fIImakefile\fP files. Parameters defined in this file are listed below.
Parameter names start with an upper case letter (e.g. \fIGoDir\fP), actual
\fImake(1)\fP variables, after all (re)definitions of the parameters,
are in capital letter between two parentheses (e.g. \fI$(GODIR)\fP).
\fIMake(1)\fP variables may be used in the \fISite.def\fP and \fIImakefile\fP
files.
.LP
.ad l
.TS
expand;
l lb lw(3.5i).
Category	Parameter	\fIDefault\fP, description
_
Release information
	GoRevision	\fBGoPATH\fP version.revision, for example \fI1.2\fP.
	GoLicense	\fINO\fP for the public release, else \fIYES\fP.
_
System dependencies
	SystemV	\fINO\fP, Unix family.
	BourneShell	\fI/bin/sh\fP, Shell.
	HasLargeTmp	T{
\fINO\fP,
Choose YES in \fISite.def\fP if your /tmp is greater than 3Mb.
T}
_
Usr Directories
	UsrDir	\fI/usr\fP
	UsrIncludeDir	\fI/usr/include\fP
	UsrLibDir	\fI/usr/lib\fP
_
X Environment
	XIncludeDir	\fI-I/usr/include/X11\fP
	XLibDir	\fI-L/usr/lib\fP
	XLibs	\fI-lX11\fP
	XtIncludeDir	\fI-I/usr/include/X11\fP
	XtLibDir	\fI-L/usr/lib\fP
	XtLibs	\fI-lXt -lXmu\fP
	XExtIncludeDir	\fI-L/usr/include/X11/extensions\fP
	XExtLibDir	\fI-L/usr/lib\fP
	XExtLibs	\fI-lXext\fP
_
Motif Environment
	HasMotif	T{
\fIYES\fP, Choose NO in \fISite.def\fP to avoid generating object files
depending on Motif (\fIXmGoInterf\fP, \fIgodraw\fP).
T}
	XmIncludeDir	\fI-I/usr/include/Xm\fP
	XmLibDir	\fI-L/usr/lib\fP
	XmLibs	\fI-lXm\fP
_
Go Environment
	GoDir	T{
\fI/go/src\fP,
Root directory for the generation, it \fBMUST\fP defined as a full path in the
Site.def file (e.g. /proj/go/gen).
T}
	GoIncludeDir	\fI-I$(GODIR)/include\fP
	GoLibDir	T{
\fI-L$(GODIR)/lib/extensions -L$(GODIR)/lib/bgo -L$(GODIR)/lib/go\fP
T}
	GoLibs	\fI-lgoext -lbgo -lgo\fP
	GoBinDir	\fI$(GODIR)/bin\fP
	GoScriptDir	\fI$(GOBINDIR)/scripts\fP

	XbIncludeDir	\fI$(GODIR)/include\fP
	XbLibDir	\fI$(GODIR)/lib/Xb\fP
	XbLibs	\fI-lXb\fP

	ConfigDir	T{
\fI$(GODIR)/config\fP, Location of the configuration files
T}
_
Installation
	InstallCmd	T{
\fIinstall\fP,
or $(GOSCRIPTDIR)/install.sh if SystemV = YES.
T}
	InstallDir	T{
\fI$(USRDIR)/local\fP,
Root for the installation.
T}
	InstallPrefix	T{
\fIGo\fP,
Should not be changed.
T}
	InstallIncludeDir	T{
\fI$(INSTALLDIR)/include/$(INSTALLPREFIX)\fP,
Location of Go ans Xb header files, used by the \fIInstallInclude()\fP macro.
T}
	InstallLibDir	T{
\fI$(INSTALLDIR)/lib/$(INSTALLPREFIX)\fP,
Location of Go libraries (libgo.a, libbgo.a, libgoext.a), used by the
\fIInstallLib()\fP macro. It is also the root for other Go files
(doc, app-files, ...).
T}
	InstallBinDir	T{
\fI$(INSTALLDIR)/bin/$(INSTALLPREFIX)\fP,
Location of Go based applications, used by the \fIInstallBin()\fP macro.
T}
	InstallPSDir	T{
\fI$(INSTALL_LIBRARY_DIR)/ps\fP,
PostScript files (see \fIPSGoInterf(3Go)\fP), used by the
\fIInstallPSFiles()\fP macro.
T}
	InstallPSFontsDir	T{
\fI$(INSTALL_PS_DIR)/fonts\fP,
PostScript font metrics (see \fIPSGoInterf(3Go)\fP), used by the
\fIInstallPSFonts()\fP macro.
T}
	InstallHyphenDir	T{
\fI$(INSTALL_LIBRARY_DIR)/hyphen\fP,
Dictionaries for international hyphenation (see \fIGoText(3Go)\fP), used
by the \fIInstallHyphen()\fP macro.
T}
	InstallConfigDir	T{
\fI$(INSTALL_LIBRARY_DIR)/config\fP,
Location of the configuration files, used by the \fIInstallConfig()\fP
macro.
T}
	InstallManDir	T{
\fI$(INSTALLDIR)/man/mann\fP,
Location of Go and Xb man pages, used by the \fIInstallManPages()\fP macro.
T}
	InstallDocDir	T{
\fI$(INSTALL_LIBRARY_DIR)/doc\fP,
Location of Manuals and Guides, used by the \fIInstallDoc()\fP macro.
T}
	InstallAppDir	T{
\fI$(INSTALL_LIBRARY_DIR)/app-files\fP, Go based application files.
T}
	InstallAppName	T{
\fInone\fP,
Subdir name for a given application, it should be defined in \fIImakefile\fP
with the SetInstallAppName() macro.
T}
	InstallAppFilesDir	T{
\fI$(INSTALL_APP_DIR)/$(INSTALL_APP_NAME)\fP
T}
	InstallGouiDir	T{
\fI$(INSTALL_APP_DIR)/$(INSTALL_APP_NAME)/goui\fP,
Location of GoUI files, used by the \fIInstallGoui()\fP macro.
T}
	InstallHelpDir	T{
\fI$(INSTALL_APP_DIR)/$(INSTALL_APP_NAME)/help\fP,
Location of Help files of a given application (APP_NAME), used by the
\fIInstallHelp()\fP macro.
T}
	InstallXDefDir	T{
\fI/usr/bin/X11/app-defaults\fP (this implies to be super user
to run ``make install'').
Location of X resources files, used by the \fIInstallXDefaults()\fP macro.
T}
_
Installation Flags		T{
Rights for the installed files, used by the installation macros.
T}
	StripInstalledPrograms	T{
\fINO\fP,
Choose YES in \fISite.def\fP to remove the symbol table from installed programs
T}
	InstPgmFlags	T{
\fInone\fP,
The default is ``-s'' if program stripping is requested.
T}
	InstBinFlags	-m 0755
	InstUidFlags	-m 4755
	InstLibFlags	-m 0644
	InstIncFlags	-m 0644
	InstPSFlags	-m 0444
	InstHypFlags	-m 0444
	InstConfFlags	-m 0444
	InstManFlags	-m 0444
	InstDocFlags	-m 0644
	InstAppFilesFlags	-m 0644
	InstGouiFlags	-m 0644
	InstHelpFlags	-m 0644
	InstXDefFlags	-m 0644
_
Imake
	ImakeCmd	T{
\fIimake\fP, Must be in the PATH variable
T}
	SpecialImakeFlags	T{
\fInone\fP, you may add here some ``define'' that
will be used in \fIArch.def\fP or other configuration files.
T}
	ImakeIncludes	\fI-I$(CONFIGDIR)\fP
	ImakeFlags	T{
\fI-T $(IMAKE_TMPL) ImakeIncludes $(SPECIAL_IMAKEFLAGS)\fP
T}
_
Makedepend
	DependCmd	T{
\fImakedepend\fP,
Must be in the PATH variable
T}
	DependFlags	T{
\fI$(CCDEFINES) $(CDEFINES) -I/usr/include/CC $(CCINCLUDES) $(CINCLUDES)\fP,
if HasGnu = YES, the default is: -D__GNUC__ $(CCDEFINES) $(CDEFINES)
-I/usr/local/lib/g++-include -I/usr/local/lib/gcc-include $(CCINCLUDES) $(CINCLUDES).
T}
_
Compilers
	HasGnu	T{
\fINO\fP,
Choose YES in your \fISite.def\fP to select the GNU
environment (g++, gcc, ...).
T}
_
Cpp
	CppCmd	\fI/lib/cpp\fP
	PreProcessCmd	\fI$(CC) -E\fP
	StandardCppDefines	T{
\fInone\fP, or \fI-DSYSV -DUSG\fP if SystemV = YES.
T}
_
C++
	CcCmd	\fICC\fP, or g++ if HasGnu = YES
	CCOptimizedFlags	\fI-O\fP
	CCDebugFlags	\fI-g\fP
	CCPicFlags	\fI-pic\fp (for shared libraries)
	CCDefaultFlags	T{
\fInone\fP, platform dependent.
T}
	CCDefaultOptions	T{
\fInone\fP, platform dependent.
T}
	StandardCCIncludes	T{
\fInone\fP, platform dependent.
T}
	StandardCCDefines	T{
\fInone\fP,
or -DSYSV -DUSG if SystemV = YES.
T}
	ExtraCCDefines	T{
\fInone\fP, site dependent.
T}
	ExtraCCIncludes	T{
\fInone\fP, site dependent.
T}
	ExtraCCFlags	T{
\fInone\fP, site dependent.
T}
_
C
	ccCmd	\fIcc\fP, or gcc if HasGnu = YES
	CBinding	T{
\fINO\fP,
Choose YES in the \fISite.def\fP, if you want the C interface
to \fBGo\fP.
T}
	COptimizedFlags	\fI-O\fP
	CDebugFlags	\fI-g\fP
	CPicFlags	\fI-pic\fP (for shared libraries)
	CDefaultFlags	T{
\fInone\fP, platform dependent.
T}
	CDefaultOptions	T{
\fInone\fP, platform dependent.
T}
	StandardCIncludes	T{
\fInone\fP, platform dependent.
T}
	StandardCDefines	T{
\fInone\fP,
or -DSYSV -DUSG if SystemV = YES.
T}
	ExtraCDefines	T{
\fInone\fP, site dependent.
T}
	ExtraCIncludes	T{
\fInone\fP, site dependent.
T}
	ExtraCFlags	T{
\fInone\fP, site dependent.
T}
_
Ld
	LdCmd	\fIld\fP
	SharedLibCmd	\fInone\fP, site dependent.
	SysLibraries	T{
\fI-lm\fP, \fBGo\fP needs the mathematical library
T}
	LdFlags	\fInone\fP
	SharedLibCmdFlags	\fInone\fP, site dependent.
	ExtraLibraries	T{
\fInone\fP, site dependent.
T}
	ExtraLdFlags	T{
\fInone\fP, site dependent.
T}
_
Ar
	ArCmd	T{
\fIar cq\fP,
use /tmp for temporary files if HasLargeTmp is YES, else
use the local directory.
T}
	ArUpdateCmd	T{
\fIar ru\fP,
use /tmp for temporary files if HasLargeTmp is YES, else
use the local directory.
T}
	ArDeleteCmd	T{
\fIar d\fP,
use /tmp for temporary files if HasLargeTmp is YES, else
use the local directory.
T}
	RanlibCmd	T{
\fIranlib(1)\fP or \fItrue(1)\fP if SystemV = YES.
T}
_
Other Commands
	AsCmd	as
	LintCmd	\fIlint(1)\fP
	LintOpts	T{
\fI-axz\fP, \fI-ax\fP if SystemV = YES.
T}
	MkDirHierCmd	\fI$(GOSCRIPTDIR)/mklk.sh\fP
	UilCmd	\fIuil\fP for Motif uil files

	CpCmd	\fIcp(1)\fP
	MakeCmd	\fImake(1)\fP
	MvCmd	\fImv(1)\fP
	RmCmd	\fIrm(1)\fP
	LnCmd	T{
\fIln(1)\fP, the option ``-s'' is used if SystemV = NO.
T}
	CompressCmd	\fIcompress(1)\fP
	UncompressCmd	\fIuncompress(1)\fP

	PicCmd	\fIpic(1)\fP
	EqnCmd	\fIeqn(1)\fP
	TblCmd	\fItbl(1)\fP
	PrintCmd	\fIlpr(1)\fP
	PrintOpts	\fI-h\fP
	TroffCmd	\fItroff(1)\fP
	PTroffCmd	\fIptroff(1)\fP

	FilesToClean	T{
\fI*.bak *~ C++.*\fP, used by ``make clean'' and ``make clear''.
T}
	FilesToClear	T{
\fI*.o *.a a.out Makefile *.log\fP, use by ``make clear''.
T}
_
.TE
.ad
.bp
.NH4
Macros.def Files
.LP
This file defines ``cpp-style macros'' that may be used in the \fIImakefile\fP
files in order to generate the \fIMakefile\fP. Using macros makes
the \fIImakefile\fP writing very easy and more secure. Some macros allows to
initialize \fIParams.def\fP variables or to instance rules (see
\fIRules.def\fP). This file \fIshould not\fP be edited. The following macros
are defined (file names in lists are separated by a blank):
.LP
.ad l
.TS
expand;
l lb lw(3.5i).
Category	Parameter	description
_
Flags
	SetOptimize()	T{
Forces the optimize flags when compiling.
T}
	SetDebug()	T{
Forces the debug flags and the ``-DDEBUG'' define when compiling.
T}
_
Environment
	UseX()	T{
X header files and libraries will be used when compiling, linking and doing
\fIdependencies\fP.
T}
	UseXt()	T{
X and Xt header files and libraries will be used when compiling, linking and 
doing \fIdependencies\fP.
T}
	UseExtensions()	T{
X Extensions header files and libraries will be used when compiling, linking
and doing \fIdependencies\fP.
T}
	UseMotif()	T{
X, Xt and Motif header files and libraries will be used when compiling, linking
and doing \fIdependencies\fP.
T}
	UseGo()	T{
Go header files and libraries will be used when compiling, linking
and doing \fIdependencies\fP.
T}
	UseXb()	T{
Xb header files and libraries will be used when compiling, linking
and doing \fIdependencies\fP.
T}
	UseInstalledGo()	T{
Installed Go header files and libraries will be used when compiling, linking
and doing \fIdependencies\fP.
T}
_
Local Environment
	SetFirstIncludeDir(dirlist)	T{
Asks the compiler and \fImakedepend\fP to look in the given ``include''
directories (``dirlist'') before looking in the ``include'' directories defined
by the environment.
T}
	SetFirstLibraryDir(dirlist)	T{
Asks the linker to look in the given ``library'' directories (``dirlist'')
before looking in the ``library'' directories defined by the environment.
T}
	SetFirstLibraries(libs)	T{
Asks the linker to load the given libraries before loading the
libraries defined by the environment.
T}
_
Variables
	SetDependList(files)	T{
Asks \fImakedepend(1)\fP to be executed on the given list of source files.
T}
	SetMakeList(files)	T{
Asks \fImake(1)\fP to make the given list files (i.e. object files).
T}
	SetSubdirList(files)	T{
Asks \fImake(1)\fP to go in the given subdirectories.
T}
	SetClearList(files)	T{
Adds the given files in the ``clear'' list.
T}
_
Entries
	MakeProgram(prog, files)	T{
Asks \fImake(1)\fP to make the program \fIprog\fP using
the given object files in the defined environment.
T}
	MakeLibrary(lib, files)	T{
Asks \fImake(1)\fP to create the library \fIlib\fP with the
given object file list.
T}
	MakeLargeLibrary
	    (lib, files1, files2, files3)	T{
Asks to create the library \fIlib\fP with three given lists of
object files. This macros exists to avoid some system limits
(i.e. too many directories opened when checking dependencies).
T}
	MakeLargeLibrarySteps
	        (lib, files1, files2, files3)	T{
Asks to update the library \fIlib\fP with three given lists of
object files. This macros exists to avoid some system limits
(i.e. make command line too long).
T}
	SharedLibraryName(name)	T{
\fIConcat(name,.a)\fP, allows to create a name of a shared library.
T}
	SharedLibraryDataName(name)	T{
\fIConcat(name,.a)\fP, allows to create a name of a shared library (data part).
T}
	MakeCCSharedLibraryObjects
	        (object_files)	T{
Allows to create a shared library from a list of C++ object files.
T}
	MakeCCSharedLibraryDataObjects
	        (object_files)	T{
Allows to create a shared library (data part) from a list of C++ object
files.
T}
	MakeCSharedLibraryObjects
	        (object_files)	T{
Allows to create a shared library (code part) from a list of C object
files.
T}
	MakeCSharedLibraryDataObjects
	        (object_files)	T{
Allows to create a shared library (data part) from a list of C object
files.
T}
_
Install
	InstallInclude(files)	T{
Asks to install the given files in the ``include'' directory.
T}
	InstallLibrary(files)	T{
Asks to install the given files in the ``lib'' directory.
T}
	InstallBin(files)	T{
Asks to install the given files in the ``bin'' directory.
T}
	InstallPSFiles(files)	T{
Asks to install the given files in the ``ps'' directory.
T}
	InstallPSFonts(files)	T{
Asks to install the given PostScript font files in the ``ps/fonts''
directory.
T}
	InstallHyphenDict(files)	T{
Asks to install the given hyphenation dictionaries in the ``hyphen''
directory.
T}
	InstallConfig(files)	T{
Asks to install the given files in the ``config'' directory.
T}
	InstallManPages(files)	T{
Asks to install the given files in the ``man'' directory.
T}
	InstallDoc(files)	T{
Asks to install the given files in the ``doc'' directory.
T}
_
	SetInstallAppName(name)	T{
Sets the application name. It is used to install application files
in the app-files subdirectories.
T}
	InstallGouiFiles(files)	T{
Asks to install the given files in the ``goui'' directory of the
application.
T}
	InstallHelpFiles(files)	T{
Asks to install the given files in the ``help'' directory of the
application.
T}
	InstallXDefaults(files)	T{
Asks to install the given files in the X default file directory.
T}
	InstallAppFiles(files)	T{
Asks to install the given files in the application specific directory.
T}
_
.TE
.ad
.bp
.NH4
Rules.def
.LP
This file defines the \fIMakefile\fP entries. They are:
.RS .8i
.IP "\fBall: subdir local\fP"
The entry goes in the subdirectories before making the local directory.
Makefile files are not rebuilt.
.IP "\fBWorld:\fP
This entry rebuilds the Makefile files and builds everything in the sub
and local directories (from the root directory, the documentation is not
rebuilt).
.IP "\fBgodoc:\fP
.br
This entry allows to rebuild the documentation from the root directory.
.IP "\fBMakefile:\fP"
This entry allows to make a new Makefile file (with the dependencies), the old
one is saved in Makefile.bak.
.IP "\fBMakefiles:\fP"
This entry allows to make all the Makefile files (with the dependencies)
in the subdirectories.
.IP "\fBdepend:\fP"
This entry allows to add in the Makefile file, the dependencies (see \fImakedepend(1)\fP).
This entry is invoked by ``make Makefile'' and ``make Makefiles''.
.IP "\fBclean:\fP"
.br
This entry cleans the directory and its subdirectories by removing
files defined by the variable ``\fIFilesToClean\fP'' (see the file
\fIParams.def\fP).
.IP "\fBclear:\fP"
.br
This entry cleans the directory and its subdirectories by removing
files defines by the variable ``\fIFilesToClear\fP'' (see the file
\fIParams.def\fP).
.IP "\fBinstall:\fP"
.br
This entry allows to install files with respect to the \fIImakefile\fP
macros in the local and subdirectories.
.IP "\fBinstalldoc:\fP"
.br
This entry allows to install the documentation files (including the man
pages) with respect to the \fIImakefile\fP macros from the root directory.
.RE
.bp
.NH4
Arch.def
.LP
This file is used by \fIimake(1)\fP to identify the
platform specific file which has to be taken in account.
\fImake\fP uses a symbol defined by the platform
\fIcpp(1)\fP program. If \fIcpp\fP does not define any
platform specific symbol, the parameter \fISpecialImakeFlags\fP
should be defined in your platform specific file and used in
the first \fIimake\fP call.
.LP
\fIArch.def\fP contains a number of predefined entries, if your platform
is not referred, you have to include it. A typical entry is :
.IP
.nf
#ifdef dpx
/**/# dpx platform ...
#define MacroIncludeFile <dpx.cf>
#define MacroFile dpx.cf
#undef dpx
#define DpxArchitecture
#endif /* dpx */
.fi
.LP
Thus, the ``DpxArchitecture'' symbol may be used in the \fIdpx.cf\fP,
\fISite.def\fP or \fIImakefile\fP files.
.NH4
Platform Specific Parameters
.LP
The platform specific parameters must be located in the file mentioned
in the \fIArch.def\fP file (i.e. \fIdpx.cf\fP). They will override the
parameters defined in the \fIParams.def\fP file. For example the \fIdpx.cf\fP
file might include :
.IP
.TS
l l l.
#define	SpecialImakeFlags	-Ddpx2
#define	SystemV	YES
#define	SysLibraries	-lm -lxinet
.TE
.NH4
Site.def
.LP
This file contains the site specific parameters. This file
\fBmust be edited\fP in order to adapt it to the local site.
At least, one parameter must be edited: \fBGoDir\fP. This
parameter is the \fBfullpath\fP of the generation directory
(e.g. /go/gen). Other parameters will take the default
values defined in \fIParams.def\fP.
.LP
Nevertheless, depending on the compiler (C++, g++, ...) some
parameters must be defined. The default \fISite.def\fP file gives
the parameters requested for a system \fIbsd4.3\fP either with
the \fIAT&T\fP C++ translator or the GNU g++ depending on
the \fIHasGnu\fP variable (default is NO). It also keeps
\fIHasMotif\fP = YES.
.LP
Making dependencies takes an amount of time. If you want to same time,
define \fIDependCmd\fP as \fItrue\fP.
.bp
.NH3
Make World !
.LP
After having edited the configuration files you are ready to
build the World ! Note that the documentation will not be
rebuilt (see make godoc). Follow the script Shell :
.IP
.nf

# Go to the generation directory (i.e. /go/gen)

$ cd /go/gen

# Build the first Makefile file
# (with special flags if needed: i.e. -Ddpx)

$ imake -s Makefile -I/go/gen/config -Ddpx

# Build Go 

$ make World
.fi
.LP
At this point everything should be built (after some time).
If errors occur, what could you do ?
.IP 1)
Errors occur when building the Makefile files; you should verify
your PATH, the makedepend flags, ... then \fBremove\fP all Makefiles
and restart the generation.
.IP 2)
Errors occur when compiling C++ files; check that your compiler match the
variable HasGnu, verify the include directories and flags (ExtraCCIncludes,
ExtraCCFlags and ExtraCCDefine) in your \fISite.def\fP file, then restart
the generation (make World).
.IP 3)
Errors occur when compiling C files (you must have chosen CBinding);
check that your compiler match the variable HasGnu, verify the include
directories and flags (ExtraCIncludes, ExtraCFlags and ExtraCDefines) in your
\fISite.def\fP, then restart the generation (make World).
.IP 4)
Errors occur when compiling files in lib/interfaces/xm;
if you do not have Motif platform, check that the variable HasMotif is set to
NO in your \fISite.def\fP, then restart the generation (make World).
.IP 5)
Errors occur when archiving the library; maybe you should
redefine the MakeLargeLibray as MakeLargeLibrarySteps
in your \fISite.def\fP file.
.LP
.NH3
Make godoc !
.LP
The documentation is delivered in PostScript\u\s4TM\s0\d (see \fIhardcopy\fP
directory). You may want to rebuild it, in that case, go to the root
directory (\fI/go/gen\fP) and type:
.IP
	$ make godoc
.LP
The documentation will be rebuilt using: \fIpic, tbl, troff, ptroff\fP.
.bp
.NH 2
Installing GoPATH
.LP
You may install \fBGo\fP directly from a binary distribution or from the
binaries generated from the source tree as described above.
.NH3
Make install
.LP
After generating \fBGo\fP (see the \fImake World\fP section),
you may install it by the following command :
.IP
$ make install
.br
$ make installdoc
.LP
Everything is installed with respect to the variable ``InstallDir''
(the default is /usr/local). You may redefine this
variable in your \fISite.def\fP. ``InstallDir'' is the root for the
installation. You may also redefine the installation subdirectories.
.LP
The default installation will install:
.IP
.TS
l c l.
Category		Directory
_
Executable files	in	/usr/local/bin/Go
Libraries	in	/usr/local/lib/Go
Include files	in	/usr/local/include/Go
Man pages	in	/usr/local/man/mann
_
PostScript files	in	/usr/local/lib/Go/ps
PostScript fonts	in	/usr/local/lib/Go/ps/fonts
Hyphenation dictionaries	in	/usr/local/lib/Go/hyphen
_
Configuration files	in	/usr/local/lib/Go/config
Documentation	in	/usr/local/lib/Go/doc
_
\fIApplication\fPpplication files	in	/usr/local/lib/Go/app-files/\fIapplication\fP
\fIApplication\fP X resources	in	/usr/lib/X11/app-defaults
_
.TE
.LP
Then, if you want to use \fBGo\fP based applications, you should set
the \fBGoENVIRON\fP variable to /usr/local/lib/Go. This allows
applications to retrieve their private files (goui, help, ...).
.NH3
Binary Distribution
.LP
The binary distribution contains the result of a ``\fImake install\fP'' and
a ``\fImake installdoc\fP'' commands,
thus the file organization is the one given above with the directory
``\fIinstalled\fP'' as root directory.
.LP
In order to install the binary version of \fBGo\fP in another
directory, you have to use the \fIscript\fP shell:
.IP
\fBinstalled/bin/Go/install-go.sh\fP
.LP
This script shell takes one parameter : the new installation root (no script
shell is available for tailoring installations). Don't forget to update
your \fIPATH\fP and \fIGoENVIRON\fP variables.
