.\" $Id: ColorSel.n,v 1.1 1992/12/14 13:21:48 davy Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XbColorSelector 3Xb "December 1992" "Version 1.1" "Xb Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXbColorSelector\fP \(em the ColorSelector widget class.
.iX "XbColorSelector"
.iX "widget class" "ColorSelector"
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Xb/ColorSel.h>\fP
.SH 
\fBDESCRIPTION\fP
.IP
The \fBColor Selector\fP implements a user dialog allowing to select a color
among the system color set. 
.br
The selection can be made using five different methods. The user can 
choose a color, by using three scales representing the RGB values or HSV values, or by selecting a color displayed anywhere on the screen, or by selecting a color already set in the system colormap, or by making a color interpolation between two colors with the "ColorSet" widget, or by giving color's name.
.br
At every time, two small boxes display the current selected color. By default, one box has a white border and the other a black border, but the border colors may be changed. After selecting a color, the user can confirm, cancel his selection or go back to the initial color selection.
.br
The use of the "ColorSet" widget is really easy. The user can pick a couple of colors (by clicking on each color) and automatically the ramp between these two colors is calculated and displayed. The user can pick a color among the eight basic colors and the last ramp. Nevertheless, if the user wants to pick another color on the screen or only change one of the extreme color of the ramp, he can click on the correct button displayed in the "ColorSet" widget. At every time, he can "undo" its last choice. When the user finds the color he wants, he just double-clicks on this color to select it. The "Colorset" could use patterns to make the ramp. If the user selects a pattern, the application can get the pattern or the corresponding color.
.br
A XmMessageBoxDialog is displayed when a color allocation error occurs (i.e. system colormap is full). In this case, the user can choose to allocate the closest color existing in the colormap or to set the last selected color.
.sp 1
.SH
\fBCLASS\fP
.IP
ColorSelector inherits behavior and resources from \fBCore\fP,
\fBComposite\fP, \fBConstraint\fP, \fBXmManager\fP, \fBXmBulletinBoard\fP and
\fBXmForm\fP classes.
.br
The class pointer is \fBxbColorSelectorWidgetClass\fP.
.br
The class name is \fBXbColorSelectorWidget\fP
.sp 1
.SH
\fBRESOURCES\fP
.SS
\fINew Resources\fP
.IP
The following table defines a set of widget resources used by the programmer
to specify data. The programmer can also set the resource values for the
inherited classes to set atttributes for this widget. To reference a resource
by name or by class in a .Xdefault file, remove the \fBXmN\fP, \fBXbN\fP,
\fBXmC\fP or \fBXbC\fP prefix and use the remaining letters.
To specify one of the defined values for a resource in a .Xdefaults file,
remove the \fBXm\fP or \fBXb\fP prefix and use the remaining letters
(in either lower case or upper case, but include any underscores between
words).
The codes in the access column indicate if the given resource can be
set at creation time (\fBC\fP),
set by using \fBXtSetValues\fP (\fBS\fP),
retrieved by using \fBXtGetValues\fP (\fBG\fP), or is not applicable
(\fBN/A\fP).
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XbColorSelector Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
XbNblueLabel	XmCString	XmString	"Blue"	CSG
XbNcancelCallback	XmCCallback	XtCallbackList	NULL	C
XbNcancelLabel	XmCString	XmString	"Cancel"	CSG
XbNcmapVisualisationLabel	XmCString	XmString	"Colormap Visualisation >>"	CSG
XbNcolorChangedCallback	XmCCallback	XtCallbackList	NULL	C
XbNcolormapUnmapLabel	XmCString	XmString	"Unmap"	CSG
XbNcolorNameCallback	XmCCallback	XtCallbackList	NULL	C	
XbNcolorNameLabel	XmCString	XmString	"Color Name"	CSG
XbNcolorSelPickColorLabel	XmCString	XmString	"Pick a Color >>"	CSG
XbNcolorSetLabel	XmCString	XmString	"Color Set >>"	CSG
XbNcolorSetPickLeftColorLabel	XmCString	XmString	"Pick Left Color"	CSG
XbNcolorSetPickRightColorLabel	XmCString	XmString	"Pick Right Color"	CSG
XbNcolorSetUndoLabel	XmCString	XmString	"Undo"	CSG
XbNcolorSetUnmapLabel	XmCString	XmString	"Unmap"	CSG
XbNcolorSystem	XbCColorSelector	int	XbRGB_AND_HSV_SYSTEM	CG
XbNerrorMessageString	XmCString	XmString	"Do you want to allocate the closest color ?"	CSG
XbNgreenLabel	XmCString	XmString	"Green"	CSG
XbNhsvSystemLabel	XmCString	XmString	"HSV Color System"	CSG
XbNhueLabel	XmCString	XmString	"Hue"	CSG
XbNinitialColorSystem	XbCColorSelector	int	XbRGB_SYSTEM	CG
XbNleftAlternateColor	XbCColorSelector	Pixel	White	CSG
XbNlightnessLabel	XmCString	XmString	"Lightness"	CSG
XbNmessageCancelLabel	XmCString	XmString	"No"	CSG
XbNmessageOkLabel	XmCString	XmString	"Yes"	CSG
XbNokCallback	XmCCallback	XtCallbackList	NULL	C
XbNokLabel	XmCString	XmString	"Apply"	CSG
XbNputCancelButton	XmCBoolean	Boolean	True	CG
XbNputOkButton	XmCBoolean	Boolean	True	CG
XbNputReinitButton	XmCBoolean	Boolean	True	CG
XbNredLabel	XmCString	XmString	"Red"	CSG
XbNreinitCallback	XmCCallback	XtCallbackList	NULL	C
XbNreinitLabel	XmCString	XmString	"Reinit"	CSG
XbNrgbSystemLabel	XmCString	XmString	"RGB Color System"	CSG
XbNrightAlternateColor	XbCColorSelector	Pixel	Black	CSG
XbNsaturationLabel	XmCString	XmString	"Sat."	CSG
XbNshowBorderWidth	XbCColorSelector	int	5	CG
XbNshowColormap	XmCBoolean	Boolean	True	CG
XbNshowColorSet	XmCBoolean	Boolean	True	CG
XbNvalueLabel	XmCString	XmString	"Value"	CSG
XbNvisual	XbCColorSelector	int	DefaultVisual	CG
XbNwithPattern	XmCBoolean	Boolean	True	CG
.sp
.TE
.DE
.ps 10
.sp1
.IP "\fIXbNblueLabel\fP"
.br
Specifies the title string to appear in the third scale, when the RGB color system is selected and the screen is a color screen. This scale displays the Blue value of the selected color.
.IP "\fIXbNcancelCallback\fP"
.br
This callback list is invoked when the user clicks on the Cancel button, and when the XbColorSelectorCancelFunction function is called.
.br
The reason for this callback is XmR_CANCEL.
.IP "\fIXbNcancelLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used for the color selection abort. This XmPushButtonWidget is created only if the XbNputCancelButton is set to True.
.IP "\fIXbNcmapVisualisationLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to display the system colormap representation.
.IP "\fIXbNcolorChangedCallback\fP"
.br
Specifies the list of callbacks called after allocating and displaying a color in the boxes. The structure returned by this callback is XbColorSelectorCallbackStruct. The reason sent by the callback is \fBXmCR_VALUE_CHANGED\fP.
.IP "\fIXbNcolormapUnmapLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to unmap the system colormap representation.
.IP "\fIXbcolorNameCallback\fP"
.br
Specifies the list of callbacks called when the XmText subwidget is activated (by hitting Return key when editing the color name). The structure returned by this callback is XbColorSelectorCallbackStruct. The reason sent by the callback is \fBXmCR_ACTIVATE\fP.
.br
If the do_it field of the \fBXbColorSelectorCallbackStruct\fP is True after
calling the list of callbacks, the color corresponding to the color name is allocated (if it exists).
.IP "\fIXbNcolorNameLabel\fP"
.br
Specifies the label string to appear in the XmLabelWidget displayed on the left on the XmTextWidget used to edit a color name.
.IP "\fIXbNcolorSelPickColorLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to allow the user to pick a color anywhere on the screen.
.IP "\fIXbNcolorSetLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to display the "ColorSet" widget.
.IP "\fIXbNcolorSetPickLeftColorLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to allow the user to pick a color anywhere on the screen and put this color as the first color of the ramp. 
.IP "\fIXbNcolorSetPickRightColorLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to allow the user to pick a color anywhere on the screen and put this color as the last color of the ramp. 
.IP "\fIXbNcolorSetUndoLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to get back at the last ramp. 
.IP "\fIXbNcolorSetUnmapLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used to unmap the "ColorSet" widget. 
.IP "\fIXbNcolorSystem\fP"
.br
Specifies which color system will be used. The following are the values:
.br
XbRGB_SYSTEM, XbHSV_SYSTEM, XbRGB_AND_HSV_SYSTEM.
.br
 This resource is checked only if the screen is a color screen.
.br
If the resource value is XbRGB_AND_HSV_SYSTEM, two toggles buttons are created. Then the user can changed th ecolor system. At the initialization, the selected color system depends on the XbNinitialColorSystem resource's value.
.IP "\fIXbNerrorMessageString\fP"
.br
Specifies the string to appear in the XmMessageBoxDialog when an allocation color error occurs.
.IP "\fIXbNgreenLabel\fP"
.br
Specifies the title string to appear in the second scale, when the RGB color system is selected and the screen is a color screen. This scale displays the Green value of the selected color.
.IP "\fIXbNhsvSystemLabel\fP"
.br
Specifies the label string to appear in the XmToggleButtonWidget used to allow the user to select the HSV color system.
.IP "\fIXbNhueLabel\fP"
.br
Specifies the title string to appear in the first scale, when the HSV color system is selected and the screen is a color screen. This scale displays the Hue value of the selected color.
.IP "\fIXbNinitialColorSystem\fP"
.br
If the screen is a color screen and the XbNcolorSystem is set to XbRGB_AND_HSV_SYSTEM, this resource specifies which color system will be  at the initialization.
.IP "\fIXbNleftAlternateColor\fP"
.br
Specifies the border color of the left box used to display the selected color.
.IP "\fIXbNlightnessLabel\fP"
.br
Specifies the title string to appear in the only displayed scale, when the screen is a monochrome or gray scale screen. This scale displays the lightness value of the selected gray color.
.IP "\fIXbNmessageCancelLabel\fP"
.br
Specifies the label string for the cancel button displayed in the XmMessageBoxDialog.
.IP "\fIXbNmessageOkLabel\fP"
.br
Specifies the label string for the ok button displayed in the XmMessageBoxDialog.
.IP "\fIXbNokCallback\fP"
.br
This callback list is invoked when the user clicks on the Ok button, and when the XbColorSelectorOkFunction function is called.
.br
The reason for this callback is XmR_OK.
.IP "\fIXbNokLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used for the color selection apply. This XmPushButtonWidget is created only if the XbNputOkButton is set to True.
.IP "\fIXbNputCancelButton\fP"
.br
Specifies whether the Cancel button is created and displayed in the Color Selector widget.
.IP "\fIXbNputOkButton\fP"
.br
Specifies whether the Ok button is created and displayed in the Color Selector widget.
.IP "\fIXbNputReinitButton\fP"
.br
Specifies whether the Reinit button is created and displayed in the Color Selector widget.
.IP "\fIXbNredLabel\fP"
.br
Specifies the title string to appear in the first scale, when the RGB color system is selected and the screen is a color screen. This scale displays the Red value of the selected color.
.IP "\fIXbNreinitCallback\fP"
.br
This callback list is invoked when the user clicks on the Reinit button, and when the XbColorSelectorReinitFunction function is called.
.br
The reason for this callback is XmR_DEFAULT_ACTION.
.IP "\fIXbNreinitLabel\fP"
.br
Specifies the label string to appear in the XmPushButtonWidget used for the color selection reinitialization. This XmPushButtonWidget is created only if the XbNputReinitButton is set to True.
.IP "\fIXbNrgbSystemLabel\fP"
.br
Specifies the label string to appear in the XmToggleButtonWidget used to allow the user to select the RGB color system.
.IP "\fIXbNrightAlternateColor\fP"
.br
Specifies the border color of the right box used to display the selected color.
.IP "\fIXbNsaturationLabel\fP"
.br
Specifies the title string to appear in the twice scale, when the HSV color system is selected and the screen is a color screen. This scale displays the Saturation value of the selected color.
.IP "\fIXbNshowBorderWidth\fP"
.br
Specifies the border width of the two XmLabelWidgets where the selected color is displayed.
.IP "\fIXbNshowColormap\fP"
.br
If this resource is set to True, the XmPushButtonWidget, used to display the system colormap representation, is created, otherwise it isn't.
.IP "\fIXbNshowColorSet\fP"
.br
If this resource is set to True, the XmPushButtonWidget, used to display the "ColorSet" widget, is created, otherwise it isn't.
.IP "\fIXbNvalueLabel\fP"
.br
Specifies the title string to appear in the third scale, when the HSV color system is selected and the screen is a color screen. This scale displays the Value value of the selected color.
.IP "\fIXbNvisual\fP"
.br
Specifies the visual to be used by the Color Selector widget. The application programer need to specify this resource at creation time, only if his application don't use the default visual.
.IP "\fIXbNwithPattern\fP"
.br
Specifies if the "ColorSet" widget can use patterns to display the ramp. Using patterns permit to have a smoother ramp than ramp without patterns.
.SS
\fIInherited Resources\fP
.IP
ColorSelector inherits behavior and resources from the following
superclasses.  For a complete description of these resources, refer to the
man page for that superclass.
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XmForm Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNfractionBase	XmCMaxValue	int	100	CSG
XmNhorizontalSpacing	XmCSpacing	int	0	CSG
XmNrubberPositioning	XmCRubberPositioning	Boolean	False	CSG
XmNverticalSpacing	XmCSpacing	int	0	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XmForm Constraint Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNbottomAttachment	XmCAttachment	unsigned char	XmATTACH_NONE	CSG
XmNbottomOffset	XmCOffset	int	0	CSG
XmNbottomPosition	XmCAttachment	int	0	CSG
XmNbottomWidget	XmCWidget	Widget	NULL	CSG
XmNleftAttachment	XmCAttachment	unsigned char	XmATTACH_NONE	CSG
XmNleftOffset	XmCOffset	int	0	CSG
XmNleftPosition	XmCAttachment	int	0	CSG
XmNleftWidget	XmCWidget	Widget	NULL	CSG
XmNresizable	XmCBoolean	Boolean	True	CSG
XmNrightAttachment	XmCAttachment	unsigned char	XmATTACH_NONE	CSG
XmNrightOffset	XmCOffset	int	0	CSG
XmNrightPosition	XmCAttachment	int	0	CSG
XmNrightWidget	XmCWidget	Widget	NULL	CSG
XmNtopAttachment	XmCAttachment	unsigned char	XmATTACH_NONE	CSG
XmNtopOffset	XmCOffset	int	0	CSG
XmNtopPosition	XmCAttachment	int	0	CSG
XmNtopWidget	XmCWidget	Widget	NULL	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmBulletinBoard Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNallowOverlap	XmCAllowOverlap	Boolean	True	CSG
XmNautoUnmanage	XmCAutoUnmanage	Boolean	False	CSG
XmNbuttonColorList	XmCButtonColorList	XmColorList	NULL	CSG
XmNcancelButton	XmCWidget	Widget	NULL	SG
XmNdefaultButton	XmCWidget	Widget	NULL	SG
XmNdefaultPosition	XmCDefaultPosition	Boolean	True	CSG
XmNdialogStyle	XmCDialogStyle	unsigned char	dynamic	CSG
XmNdialogTitle	XmCXmString	XmString	NULL	CSG
XmNfocusCallback	XmCCallback	XtCallbackList	NULL	C
XmNlabelColorList	XmCLabelColorList	XmColorList	NULL	CSG
XmNmapCallback	XmCCallback	XtCallbackList	NULL	C
XmNmarginHeight	XmCMarginHeight	short	10	CSG
XmNmarginWidth	XmCMarginWidth	short	10	CSG
XmNnoResize	XmCNoResize	Boolean	False	CSG
XmNresizePolicy	XmCResizePolicy	unsigned char	XmRESIZE_ANY	CSG
XmNshadowType	XmCShadowType	unsigned char	XmSHADOW_OUT	CSG
XmNtextColorList	XmCTextColorList	XmColorList	NULL	CSG
XmNtextTranslations	XmCTranslations	XtTranslations	NULL	C
XmNunmapCallback	XmCCallback	XtCallbackList	NULL	C
.sp
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmManager Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNbottomShadowColor	XmCForeground	Pixel	dynamic	CSG
XmNbottomShadowPixmap	XmCBottomShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNforeground	XmCForeground	Pixel	dynamic	CSG
XmNhelpCallback	XmCCallback	XtCallbackList	NULL	C
XmNhighlightColor	XmCForeground	Pixel	Black	CSG
XmNhighlightPixmap	XmCHighlightPixmap	Pixmap	dynamic	CSG
XmNshadowThickness	XmCShadowThickness	short	0	CSG
XmNtopShadowColor	XmCBackground	Pixel	dynamic	CSG
XmNtopShadowPixmap	XmCTopShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNuserData	XmCUserData	caddr_t	NULL	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
Composite Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNinsertPosition	XmCInsertPosition	XmRFunction	NULL	CSG
.sp 1
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Core Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNaccelerators	XmCAccelerators	XtTranslations	NULL	CSG
XmNancestorSensitive	XmCSensitive	Boolean	True	G
XmNbackground	XmCBackground	Pixel	dynamic	CSG
XmNbackgroundPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderColor	XmCBorderColor	Pixel	Black	CSG
XmNborderPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderWidth	XmCBorderWidth	Dimension	0	CSG
XmNcolormap	XmCColormap	Colormap	XtCopyFromParent	CG
XmNdepth	XmCDepth	int	XtCopyFromParent	CG
XmNdestroyCallback	XmCCallback	XtCallbackList	NULL	C
XmNheight	XmCHeight	Dimension	0	CSG
XmNmappedWhenManaged	XmCMappedWhenManaged	Boolean	True	CSG
XmNscreen	XmCScreen	Pointer	XtCopyScreen	CG
XmNsensitive	XmCSensitive	Boolean	True	CSG
XmNtranslations	XmCTranslations	XtTranslations	NULL	CSG
XmNwidth	XmCWidth	Dimension	0	CSG
XmNx	XmCPosition	Position	0	CSG
XmNy	XmCPosition	Position	0	CSG
.sp
.TE
.DE
.ps 10
.SH
\fBFUNCTIONS\fP
.IP
.nf
.ta .50i 1.50i
Widget \fBXbCreateColorSelector\fP (\fIparent, name, arglist, argcount\fP)
	Widget	\fIparent\fP;
	String	\fIname\fP;
	ArgList	\fIarglist\fP;
	Cardinal	\fIargcount\fP;
.fi
.RS .8i
.IP \fIparent\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIarglist\fP
Specifies the application override argument list.
.IP \fIargcount\fP
Specifies the number of attributes in the \fIarglist\fP.
.RE
.HP .8i
.IP
The \fBXbCreateColorSelector\fP function creates a new ColorSelector widget
and returns the associated widget ID. This widget ID will be used in the
following function calls.
.IP
.nf
.ta .50i 1.50i
Widget \fBXbCreateColorSelectorDialog\fP (\fIparent, name, arglist, argcount\fP)
	Widget	\fIparent\fP;
	String	\fIname\fP;
	ArgList	\fIarglist\fP;
	Cardinal	\fIargcount\fP;
.fi
.RS .8i
.IP \fIparent\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIarglist\fP
Specifies the application override argument list.
.IP \fIargcount\fP
Specifies the number of attributes in the \fIarglist\fP.
.RE
.HP .8i
.IP
The \fBXbCreateColorSelectorDialog\fP is a convenience function for creating
an instance of popup ColorSelector.
.br
It creates a DialogShell via \fBXtCreateWidget()\fP, and then creates a
ColorSelector as a child of the DialogShell.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
XColor \fBXbColorSelectorGetColor\fP (\fIColorsel, last_validated\fP);
	Widget	\fIColorsel\fP;
	Boolean	\fIlast_validated\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID.
.IP \fIlast_validated\fP 1.2i
See below.
.RE
.HP .8i
.IP
If \fIlast_validated\fP = True, this function returns the last confirmed color setting in  \fIColorsel\fP, otherwise it returns the current selected color. It performs an allocation of the returned color and it's the client's responsability to free this color when he doesn't need it any more.
.br
RGB values are generally in [0, 65535], but it can depend on the X11 server.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
Pixmap \fBXbColorSelectorGetPattern\fP (\fIColorsel, last_validated\fP);
	Widget	\fIColorsel\fP;
	Boolean	\fIlast_validated\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID.
.IP \fIlast_validated\fP 1.2i
See below.
.RE
.HP .8i
.IP
If the \fIXbNwithPattern\fP resource is set to True, the user can select a pattern rather than a color. In this case, the application programmer can get the selected pixmap with the \fIXbColorSelectorGetPattern\fP function. 
If \fIlast_validated\fP = True, this function returns the last confirmed pixmap setting in  \fIColorsel\fP, otherwise it returns the current selected pixmap. It's the client's responsability to free this pixmap when he doesn't need it any more.
.br
If no pixmap was selected, this function returns XmUNSPECIFIED_PIXMAP.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void \fBXbColorSelectorUnmapColormap\fP (\fIColorsel\fP);
	Widget	\fIColorsel\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID.
.RE
.HP .8i
.IP
Unmaps the system colormap representation.
When the ColorSelector widget is not a dialog widget, this function is usefull
if the application programmer wants to unmap the ColorSelector's parent widget.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
Boolean \fBXbColorSelectorSetColor\fP (\fIColorsel, Color, last_validated\fP)
	Widget	\fIColorsel\fP;
	XColor	\fI*Color\fP;
	Boolean	\fIlast_validated\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.IP \fIColor\fP
Specifies desired RGB values, and also returns the pixel value and the RGB values actually used in the colormap. 
.IP \fIlast_validated\fP 1.2i
See below.
.RE
.HP .8i
.IP
The \fBColorSelectorSetColor\fP function tries to set the selected color to the given value. If no color allocation error occurs, the function returns True, and sets fields of the XColor structure with the exact RGB values and the pixel which has been allocated. If an error occurs, the function returns False, and set fields of the XColor structure with RGB values and pixel value of the actually selected color in the Color Selector widget.
.br
If \fIlast_validated\fP = True then this function set also the "last confirmed color" to the value specified.
.br
This function performs no color allocation. If the application programmer wants to use this color, he has to do the allocation himself.
.br
RGB values are generally in [0, 65535], but it can depend on the X11 server.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
Boolean \fBXbColorSelectorSetLeftAlternateColor\fP (\fIColorsel, Color\fP)
	Widget	\fIColorsel\fP;
	XColor	\fI*Color\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.IP \fIColor\fP
Specifies desired RGB values, and also returns the pixel value and the RGB values actually used in the colormap. 
.RE
.HP .8i
.IP
The \fBColorSelectorSetLeftAlternateColor\fP function sets to the given value the border color of the left box used to diplay the selected color. If no color allocation error occurs, the function returns True, and sets fields of the XColor structure with the exact RGB values and the pixel which has been allocated. If an error occurs, the function returns False, and set fields of the XColor structure with RGB values and pixel value of the actually border color of the left box in the Color Selector widget.
.br
RGB values are generally in [0, 65535], but it can depend on the X11 server.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
Boolean \fBXbColorSelectorSetRightAlternateColor\fP (\fIColorsel, Color\fP)
	Widget	\fIColorsel\fP;
	XColor	\fI*Color\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.IP \fIColor\fP
Specifies desired RGB values, and also returns the pixel value and the RGB values actually used in the colormap. 
.RE
.HP .8i
.IP
The \fBColorSelectorSetRightAlternateColor\fP function sets to the given value the border color of the right box used to diplay the selected color. If no color allocation error occurs, the function returns True, and sets fields of the XColor structure with the exact RGB values and the pixel which has been allocated. If an error occurs, the function returns False, and set fields of the XColor structure with RGB values and pixel value of the actually border color of the right box in the Color Selector widget.
.br
RGB values are generally in [0, 65535], but it can depend on the X11 server.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
Widget \fBXbColorSelectorGetChild\fP (\fIcolorsel, child_id\fP)
	Widget	\fIcolorsel\fP;
	unsigned char	\fIchild_id\fP;
.fi
.RS .8i
.IP \fIcolorsel\fP 1.2i
Specifies the ColorSelector ID.
.IP \fIchild_id\fP
Specifies child to be returned. It may have the following constant values:
.br
\fBXbCS_RED_SCALE\fP, 
.br
\fBXbCS_GREEN_SCALE\fP, 
.br
\fBXbCS_BLUE_SCALE\fP (standing for the three corresponding Scales)
.br
\fBXbCS_COLOR_NAME_TEXT\fP (standing for the corresponding TextField)
.br
\fBXbCS_RGB_SYSTEM_BUTTON\fP,
.br
\fBXbCS_HSV_SYSTEM_BUTTON\fP (standing for the corresponding ToggleButtons)
.RE
.HP .8i
.IP
The \fBColorSelectorGetChild\fP function returns the widget ID of the subwidget
specified by \fIchild_id\fP. It returns NULL if \fIchild_id\fP has an unknown
value or if the corresponding widget has not been created due to ColorSelector
resources or bad initializing procedure.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void \fBXbColorSelectorCancelFunction\fP (\fIColorsel, unmanage\fP)
	Widget	\fIColorsel\fP;
	Boolean \fIunmanage\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.IP \fIunmanage\fP
See below
.RE
.HP .8i
.IP
The \fBXbColorSelectorCancelFunction\fP function resets the current color to the "last confirmed color" and calls the callbacks for \fBXbNcancelCallback\fP. If \fIunmanage\fP is set to true, this function unmanages the Color Selector widget.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void \fBXbColorSelectorOkFunction\fP (\fIColorsel, unmanage\fP)
	Widget	\fIColorsel\fP;
	Boolean \fIunmanage\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.IP \fIunmanage\fP
See below
.RE
.HP .8i
.IP
The \fBXbColorSelectorOkFunction\fP function sets the "last confirmed color" to the  color currently selected and calls the callbacks for \fBXbNokCallback\fP. If \fIunmanage\fP is set to true, this function unmanages the Color Selector widget.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void \fBXbColorSelectorReinitFunction\fP (\fIColorsel)
	Widget	\fIColorsel\fP;
.fi
.RS .8i
.IP \fIColorsel\fP 1.2i
Specifies the ColorSelector widget ID. 
.RE
.HP .8i
.IP
The \fBXbColorSelectorReinitFunction\fP function resets the current color to the "last confirmed color" and calls the callbacks for \fBXbNreinitCallback\fP.
.HP .5i
.sp 1
.SH 
\fBTYPES\fP
.IP
The following structure is returned with the XbNcolorNameCallback list.
.sp1
.nf
.ta .25i 1.2i
typedef struct
{
	\fBint	\fIreason\fP;
	\fBXEvent	\fI*event\fP;
	\fBint	\fImask\fP;
	\fBBoolean	\fIdo_it\fP;
	\fBString	\fIcolor_name\fP;
	\fBunsigned short	\fIred\fP;
	\fBunsigned short	\fIgreen\fP;
	\fBunsigned short	\fIblue\fP;
	\fBBoolean	\fIpattern\fP;
} \fBXbColorSelectorCallbackStruct\fP;
.fi
.sp1
.RS .8i
.IP "\fIreason\fP" .75i
Indicates why the callback was invoked.
.IP "\fIevent\fP" .75i
Points to the \fBXEvent\fP that triggered the callback.
.IP "\fImask\fP" .75i
The mask definition is :
.br
XbCOLOR_NAME
.br
XbCOLOR_VALUE
.br
If \fImask\fP is set to XbCOLOR_NAME, the following fields are valid :
\fIreason, event, do_it, color_name\fP
.br
If \fImask\fP is set to XbCOLOR_VALUE, the following fields are valid :
\fIreason, event, do_it, red, green, blue, pattern\fP
.IP "\fIdo_it\fP" .75i
This field is always set to True when callbacks are called. Setting it to False, implies that the color corresponding to \fIcolor_name\fP or to \fIred\fP, \fIgreen\fP and \fIblue\fP values will not be allocated by the ColorSelector Widget.
.IP "\fIcolor_name\fP" .75i
Indicates the color name that was edited by the user.
.IP "\fIred\fP" .75i
Indicates the value of the Red component of the color chosen by the user.
.IP "\fIgreen\fP" .75i
Indicates the value of the Green component of the color chosen by the user.
.IP "\fIblue\fP" .75i
Indicates the value of the Blue component of the color chosen by the user.
.IP "\fIpattern\fP" .75i
If the user has selected a pattern, this resource is set to True, otherwise it is set to False.
.br
The application programmer can get the selected pattern, using the convenience function XbColorSelectorGetPattern.
.HP .5i
.sp 1
.SH 
\fBBEHAVIOR\fP
.IP
Following is a summary of the behavior of ColorSelector widget.
.LP
< Ok Button Activated >
.IP
An Ok PushButton activation sets the "last confirmed color" to the color currently selected, unmanages the ColorSelector widget and calls the callbacks for \fBXbNokCallback\fP.
.LP
< Cancel Button Activated >
.IP
A Cancel PushButton activation unmanages the ColorSelector widget, resets its
current color to the "last confirmed color" and calls the callbacks for \fBXbNcancelCallback\fP.
.LP
< Reinit Button Activated >
.IP
A Reinit PushButton activation resets its current color to the
"last confirmed color" and calls the callbacks for \fBXbNreinitCallback\fP
(it does not unmanage the ColorSelector widget).
.SH 
\fBRELATED INFORMATION\fP
.IP
\fBComposite(3X)\fP, \fBConstraint(3X)\fP, \fBCore(3X)\fP,
\fBXmBulletinBoard(3X)\fP, \fBXmForm(3X)\fP and \fBXmManager(3X)\fP.
.sp 1
.nrPN \n%
