.\" $Id: Numerical.n,v 1.1 1992/12/14 13:21:50 davy Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XbNumerical 3Xb " December 1992" "Version 1.1" "Xb Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXbNumerical\fP \(em the Numerical widget class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
.bd I 3
\fI#include <Xb/Numerical.h>\fP
.bd I
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
A \fBNumerical Widget\fP implements a user dialog allowing to display and
modify a numerical field either by editing it or by using optional increment
buttons.
.IP
The widget contains an optionally editable text area (\fBXmTextFieldWidget\fP)
where it displays a string representing a double precision number (the widget
current value). It may also contain two buttons (\fBXmArrowButtonGadget\fP)
through which the user can manipulate the current value (incrementing with
right arrow and decrementing with left arrow). Both of them may use a timer
to speed up incrementation if desired.
.br
The application programmer may choose the output format of the numerical
string:
.RS 8
.IP \(bu 3
integer notation
.IP \(bu 3
decimal notation with a fixed number of digits after the decimal point
.IP \(bu 3
floating point notation.
.RE 1
.IP
Note that regardless of the output format chosen, the Numerical widget only
deals with double precision numbers internally.
.sp 1
.SH
\fBCLASS\fP
.IP
\fBNumerical\fP inherits behavior and resources from \fBCore\fP, 
\fBComposite\fP, \fBConstraint\fP, \fBXmManager\fP and \fBXmBulletinBoard\fP
Classes.
.br
The class pointer is \fBxbNumericalWidgetClass\fP.
.br
The class name is \fBXbNumerical\fP.
.sp 1
.SH
\fBRESOURCES\fP
.SS 
\fINew Resources\fP
.IP
The following table defines a set of widget resources used by the programmer
to specify data.  The programmer can also set the resource values for the 
inherited classes to set attributes for this widget.  To reference a
resource by name or by class in a .Xdefaults file, remove the \fBXmN\fP, 
\fBXbN\fP, \fBXmC\fP or \fBXbC\fP prefix and use the remaining letters.  
To specify one of the defined values for a resource in a .Xdefaults file, 
remove the \fBXm\fP or \fBXb\fP prefix and use the remaining letters 
(in either lower case or upper case, but include any underscores between 
words).
The codes in the access column indicate if the given resource can be
set at creation time (\fBC\fP),
set by using \fBXtSetValues\fP (\fBS\fP), 
retrieved by using \fBXtGetValues\fP (\fBG\fP), or is not applicable 
(\fBN/A\fP).
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XbNumerical Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XbNactivateTextCallback	XmCCallback	XtCallbackList	NULL	C
XbNarmIncrementCallback	XmCCallback	XtCallbackList	NULL	C
XbNdecimalCharacter	XbCDecimalCharacter	char	XbDOT	CSG
XbNdecimalDigits	XbCDecimalDigits	int	2	CSG
XbNdisarmIncrementCallback	XmCCallback	XtCallbackList	NULL	C
XbNdoubleValue	XbCDouble	double	0	CSG
XbNincrementOn	XmCBoolean	Boolean	True	CG
XbNincrementPosition	XbCIncrementPosition	unsigned char	XbSPLIT_INCREMENT	CSG
XbNincrementValue	XbCDouble	double	1	CSG
XbNisEditable	XmCBoolean	Boolean	True	CGS
XbNjustification	XmCAlignment	unsigned char	XmALIGNMENT_CENTER	CSG
XbNmaxValue	XbCDouble	double	MAXINT-1	CSG
XbNminValue	XbCDouble	double	-(MAXINT-1)	CSG
XbNprecision	XbCDouble	double	1e-10	CG
XbNsizeInChars	XmCMaxLength	int	12	CSG
XbNtimerInterval	XbCTimerInterval	int	100	CSG
XbNtimerMode	XbCTimerMode	unsigned char	XbLINEAR_TIMER	CSG
XbNvalueChangedCallback	XmCCallback	XtCallbackList	NULL	C
XbNvalueType	XbCValueType	unsigned char	XbFLOAT	CSG
XbNverifyWhenActivating	XmCBoolean	Boolean	True	CGS
XbNverifyWhenLosingFocus	XmCBoolean	Boolean	True	CGS
.TE
.DE
.ps 10
.sp 1
.IP "\fIXbNactivateTextCallback\fP"
.br
Specifies the list of callbacks that is called when the TextField
subwidget is activated (by hitting Return key when editing the numerical
string). The structure returned by this callback is
\fBXbNumericalCallbackStruct\fP. The reason sent by the callback is
\fBXmCR_ACTIVATE\fP and the callback structure field \fIdo_it\fP is not used.
.br
If \fBXbverifyWhenActivating\fP is set to True, the \fIold_double_value\fP and
\fInew_double_value\fP fields might have different values.
.IP "\fIXbNarmIncrementCallback\fP"
.br
Specifies the list of callbacks that is called when any of the increment
ArrowButtonGadgets are armed. The call is done before starting the timer (if
the timer is used).
.br
The structure returned by this callback is \fBXbNumericalCallbackStruct\fP. The
reason sent by the callback is \fBXmCR_ARM\fP. If the returned callback
structure field \fIdo_it\fP is set to False, the timer does not start.
.IP "\fIXbNdecimalCharacter\fP"
.br
Specifies the ASCII character to stand as decimal point in the numerical
string. It may take the constant values \fBXbDOT\fP or \fBXbCOMMA\fP. This
attribute is ignores if \fBXbNvalueType\fP is \fBXbINTEGER\fP.
.IP "\fIXbNdecimalDigits\fP"
.br
Specifies the number of digits to be displayed after the decimal point. This
attribute is only checked if \fBXbNvalueType\fP is \fBXbDECIMAL\fP and ignored
otherwise.
.IP "\fIXbNdisarmIncrementCallback\fP"
.br
Specifies the list of callbacks that is called when any of the increment
buttons are disarmed. The call is done after stoping the timer if
the timer is used and before incrementing/decrementing the current value if
the timer is not used.
.br
The structure returned by this callback is \fBXbNumericalCallbackStruct\fP. The
reason sent by the callback is \fBXmCR_DISARM\fP.
If the returned callback structure field \fIdo_it\fP is set to False an
\fBXbNtimerMode\fP is \fBXbNO_TIMER\fP, the increment or decrement function
that should be called is not called. When the timer is used, setting
\fIdo_it\fP to False has no effect.
.IP "\fIXbNdoubleValue\fP"
.br
Specifies the current value stored in the Numerical widget.
.br
Warning : this value is always a double precision number, regardless of the
\fBXbNvalueType\fP resource.
.br
For a quicker access to this main Numerical resource, an application should
use the convenience functions \fBXbNumericalGetRealValue\fP and
\fBXbNumericalSetRealValue\fP rather than \fBXtGetValues\fP and
\fBXtSetValues\fP.
.IP "\fIXbNincrementOn\fP"
.br
This attribute indicates whether the sensitive increment are to be created or
not. This resource may only be set at creation time and cannot be modified
thereafter.
.IP "\fIXbNincrementPosition\fP"
.br
This attribute indicates the position of the sensitive increment
ArrowButtonGadgets. This attribute is ignored if \fBXbNincrementOn\fP
is False. It may have the following constant values:
.RS 8
.IP \(em 3
\fBXbLEFT_INCREMENT\fP : both ArrowButtonGadgets are displayed on
the left of the TextField subwidget. 
.IP \(em 3
\fBXbRIGHT_INCREMENT\fP : both ArrowButtonGadgets are displayed on the right
of the text subwidget.
.IP \(em 3
\fBXbSPLIT_INCREMENT\fP : the TextField is displayed between the
increment ArrowButtonGadgets.
.RE 1
.IP "\fIXbNisEditable\fP"
.br
This attribute indicates whether the TextField is editable or not.
.IP "\fIXbNincrementValue\fP"
.br
Specifies the value to be added to or substracted from the Numerical current
value when one of the increment areas is activated (left arrow decrements and
right arrow increments). If using the timer, the actual increment value will
be an increasing multiple of this value as the timer speeds up. This attribute
is ignored if \fBXbNincrementOn\fP is False or if
\fBXbNtimerMode\fP is \fBXbNO_TIMER\fP.
.br
Warning : this value is always a double precision number, regardless of the
.IP "\fIXbNjustification\fP"
.br
This attribute, very similar to the \fBXmNalignment XmLabel\fP resource,
indicates the position of the TextField subwidget within the space left by the
arrows. It may have the following constant values: 
.RS 8
.IP \(em 3
\fBXmALIGNMENT_BEGINNING\fP
.IP \(em 3
\fBXmALIGNMENT_CENTER\fP (default value)
.IP \(em 3
\fBXmALIGNMENT_END\fP
.RE 1
.IP
Note that positionning the TextField subwidget does not mean positionning the
text string, specially in the two later cases (refer to \fBXmTextField\fP
manual).
.IP "\fIXbNmaxValue\fP"
.br
Specifies the maximal value allowed.
.br
Warning : this value is always a double precision number, regardless of the
\fBXbNvalueType\fP resource.
.IP "\fIXbNminValue\fP"
.br
Specifies the minimal value allowed.
.br
Warning : this value is always a double precision number, regardless of the
\fBXbNvalueType\fP resource.
.IP "\fIXbNprecision\fP"
.br
Specifies the maximal error tolerated when comparing a double precision number
to minValue or maxValue or 0. This resource should not be reset unless an
extemely high precision is required when using \fBXbNvalueType\fP at
\fBXbFLOAT\fP in which case the value of the resource should be lowered (but
not set to 0).
.br
This attribute may only be set at creation time and cannot be modified thereafter.
.IP \fIXbNsizeInChars\fP
.br
This resource is equivalent to the \fBXmNcolumns\fP resource of the TextField
subwidget. It indicates the initial width of the subwidget measured in
character spaces.
.IP "\fIXbNtimerInterval\fP"
.br
Specifies interval in milliseconds between two timer expirations (i.e.
indicates timer basic speed). This attribute is ignored if
\fBXbNincrementOn\fP is False or if \fBXbNtimerMode\fP is \fBXbNO_TIMER\fP.
.IP "\fIXbNtimerMode\fP"
.br
Specifies the increment areas timer behavior. This attribute is ignored if
\fBXbNincrementOn\fP is set to False. It may take the
following values :
.RS 8
.IP \(em 3
\fBXbNO_TIMER\fP : disables the timer.
.IP \(em 3
\fBXbLINEAR_TIMER\fP : enables the timer. The timer acceleration is constant
until its speed reaches the maximal value which is kept while activated.
.RE 1
.IP "\fIXbNvalueChangedCallback\fP"
.br
Specifies the list of callbacks that is called after performing a modification
of the current value by any other way than \fBXbNumericalWidget\fP creation.
.br
The structure returned by this callback is \fBXbNumericalCallbackStruct\fP. The
reason sent by the callback is \fBXmCR_VALUE_CHANGED\fP. The callback
structure field \fIdo_it\fP is not used here.
.IP "\fIXbNvalueType\fP"
.br
Specifies the "virtual" type of numbers to deal with ("virtual" because
Numerical will use double precision numbers anyway!).
.br
This resource can have the following constant values :
.RS 8
.IP \(em 3
\fBXbINTEGER\fP in which case the \fBXbNdecimalDigits\fP and
\fBXbNdecimalCharacter\fP resources will be ignored. The closest integer to
current value will be displayed in the TextField subwidget.
.IP \(em 3
\fBXbDECIMAL\fP in which case the \fBXbNdecimalDigits\fP  resource will be
used to display the proper string.
.IP \(em 3
\fBXbFLOAT\fP in which case the Numerical widget chooses the most convenient
way to display the string, only using scientific notation if necessary. The
\fBXbNdecimalDigits\fP resource is ignored.
.RE 1
.IP \fIXbNverifyWhenActivating\fP
.br
This resource affects the Numerical behavior when the user activates the
TextField (i.e. types <CR>). If it is set to True, the convenience function
\fBXbNumericalVerifyString\fP is called prior to the callback list
\fBXbNactivateTextCallback\fP and the fields \fIold_double_value\fP and
\fInew_double_value\fP of the \fBXbNumericalCallbackStruct\fP will reflect the
changes (field \fIdo_it\fP is not used here).
.IP \fIXbNverifyWhenLosingFocus\fP
.br
This resource affects the Numerical behavior when the TextField loses focus.
If it is set to True, the convenience function \fBXbNumericalVerifyString\fP
is called prior to the callback list \fBXbNlosingFocusTextCallback\fP and the
fields \fIold_double_value\fP and \fInew_double_value\fP of the
\fBXbNumericalCallbackStruct\fP will reflect the changes (field \fIdo_it\fP is
not used here).
.SS
\fIInherited Resources\fP
.sp 1
.IP
Numerical inherits behavior and resources from the following   
superclasses.  For a complete description of these resources, refer to the
man page for that superclass.
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmBulletinBoard Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNallowOverlap	XmCAllowOverlap	Boolean	True	CSG
XmNautoUnmanage	XmCAutoUnmanage	Boolean	False	CSG
XmNbuttonFontList	XmCButtonFontList	XmFontList	NULL	CSG
XmNcancelButton	XmCWidget	Widget	NULL	SG
XmNdefaultButton	XmCWidget	Widget	NULL	SG
XmNdefaultPosition	XmCDefaultPosition	Boolean	True	CSG
XmNdialogStyle	XmCDialogStyle	unsigned char	dynamic	CSG
XmNdialogTitle	XmCXmString	XmString	NULL	CSG
XmNfocusCallback	XmCCallback	XtCallbackList	NULL	C
XmNlabelFontList	XmCLabelFontList	XmFontList	NULL	CSG
XmNmapCallback	XmCCallback	XtCallbackList	NULL	C
XmNmarginHeight	XmCMarginHeight	short	0	CSG
XmNmarginWidth	XmCMarginWidth	short	0	CSG
XmNnoResize	XmCNoResize	Boolean	False	CSG
XmNresizePolicy	XmCResizePolicy	unsigned char	XmRESIZE_ANY	CSG
XmNshadowType	XmCShadowType	unsigned char	XmSHADOW_OUT	CSG
XmNtextFontList	XmCTextFontList	XmFontList	dynamic	CSG
XmNtextTranslations	XmCTranslations	XtTranslations	NULL	C
XmNunmapCallback	XmCCallback	XtCallbackList	NULL	C
.sp
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmManager Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNbottomShadowColor	XmCForeground	Pixel	dynamic	CSG
XmNbottomShadowPixmap	XmCBottomShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNforeground	XmCForeground	Pixel	dynamic	CSG
XmNhelpCallback	XmCCallback	XtCallbackList	NULL	C
XmNhighlightColor	XmCForeground	Pixel	Black	CSG
XmNhighlightPixmap	XmCHighlightPixmap	Pixmap	dynamic	CSG
XmNshadowThickness	XmCShadowThickness	short	dynamic	CSG
XmNtopShadowColor	XmCBackground	Pixel	dynamic	CSG
XmNtopShadowPixmap	XmCTopShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNuserData	XmCUserData	caddr_t	NULL	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Composite Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNinsertPosition	XmCInsertPosition	XmRFunction	NULL	CSG
.sp 1
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Core Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNaccelerators	XmCAccelerators	XtTranslations	NULL	CSG
XmNancestorSensitive	XmCSensitive	Boolean	True	G
XmNbackground	XmCBackground	Pixel	dynamic	CSG
XmNbackgroundPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderColor	XmCBorderColor	Pixel	Black	CSG
XmNborderPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderWidth	XmCBorderWidth	Dimension	0	CSG
XmNcolormap	XmCColormap	Colormap	XtCopyFromParent	CG
XmNdepth	XmCDepth	int	XtCopyFromParent	CG
XmNdestroyCallback	XmCCallback	XtCallbackList	NULL	C
XmNheight	XmCHeight	Dimension	0	CSG
XmNmappedWhenManaged	XmCMappedWhenManaged	Boolean	True	CSG
XmNscreen	XmCScreen	Pointer	XtCopyScreen	CG
XmNsensitive	XmCSensitive	Boolean	True	CSG
XmNtranslations	XmCTranslations	XtTranslations	NULL	CSG
XmNwidth	XmCWidth	Dimension	0	CSG
XmNx	XmCPosition	Position	0	CSG
XmNy	XmCPosition	Position	0	CSG
.sp
.TE
.DE
.ps 10
.SH 
\fBSUBWIDGET NAMES\fP
.IP
The following list gives the names of the Numerical subwidgets,
allowing to set their resources in a default file.
.IP
.br
.IP "\fIplusArea\fP"
.br
Name of the ArrowButtonGadget used to increment the Numerical Widget current
value.
.IP "\fIminusArea\fP"
.br
Name of the ArrowButtonGadget used to decrement the Numerical Widget current
value.
.IP "\fItextArea\fP
.br
Name of the TextField used to display and edit the numerical string.
.SH
\fBFUNCTIONS\fP
.IP
.nf
.ta .50i 1.50i
Widget \fBXbCreateNumerical\fP (\fIparent, name, arglist, argcount\fP)
	Widget	\fIparent\fP;
	char*	\fIname\fP;
	ArgList	\fIarglist\fP;
	int	\fIargcount\fP;
.fi
.RS .8i
.IP \fIparent\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIarglist\fP
Specifies the application override argument list.
.IP \fIargcount\fP
Specifies the number of attributes in the \fIarglist\fP.
.RE
.HP .8i
.IP
The \fBXbCreateNumerical\fP function creates an instance of the Numerical
Widget and returns its associated Widget ID.
.HP .5i
.IP
.nf
.ta .50i 1.50i
void \fBXbCreateNumericalDialog\fP (\fIparent, name, arglist, argcount\fP)
	Widget	\fIparent\fP;
	char*	\fIname\fP;
	ArgList	\fIarglist\fP;
	int	\fIargcount\fP;
.fi
.RS .8i
.IP \fIparent\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIarglist\fP
Specifies the application override argument list.
.IP \fIargcount\fP
Specifies the number of attributes in the \fIarglist\fP.
.RE
.HP .8i
.IP
The \fBXbCreateNumericalDialog\fP is a convenience function for creating
an instance of popup Numerical.
.br
It creates a DialogShell via \fBXtCreateWidget()\fP, and then creates a
Numerical as a child of the DialogShell.
.HP .5i
.IP
.nf
.ta .50i 1.50i
Widget \fBXbNumericalGetChild\fP (\fInumerical_widget, child\fP)
	Widget	\fInumerical_widget\fP;
	unsigned char \fIchild\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.IP \fIchild\fP 1.2i
Specifies a component within the Numerical widget. The following are legal values for this parameter:
.br
\(em \fBXbNUMERICAL_TEXT_AREA\fP
.br
\(em \fBXbNUMERICAL_PLUS_AREA\fP
.br
\(em \fBXbNUMERICAL_MINUS_AREA\fP
.RE
.HP .8i
.IP
The \fBXbNumericalGetChild\fP is used to access a component within a Numerical widget. The parameters given to the function are the Numerical widget and a value indicating which child to access.
.HP .5i
.IP
.nf
.ta .50i 1.50i
String \fBXbNumericalGetString\fP (\fInumerical_widget\fP)
	Widget	\fInumerical_widget\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.RE
.HP .8i
.IP
The \fBXbNumericalGetString\fP is a convenience function which returns
the string currently stored in the TextField subwidget. This function
performs memory allocation to store the returned string; it is the client's
responsability to free that memory space.
.HP .5i
.IP
.nf
.ta .50i 1.50i
long \fBXbNumericalVerifyString\fP (\fInumerical_widget, reset_if_wrong\fP)
	Widget	\fInumerical_widget\fP;
	Boolean \fIreset_if_wrong\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.IP \fIreset_if_wrong\fP 1.2i
Specifies if the function must reset the Numerical widget string if the new
string or the corresponding value are not correct.
.RE
.HP .8i
.IP
The \fBXbNumericalVerifyString\fP is a convenience function which returns
an error code after checking the string currently stored in the TextField
subwidget. If the string syntax is correct, the corresponding numerical value
is checked. If and error is found, the function returns an error code after
resetting the Numerical widget (if \fIreset_if_wrong\fP is True), otherwise
the new value becomes the Numerical widget current value and the function
returns 0.
.br
The returned error code is \fBXbBAD_STRING\fP if the string syntax is not
correct or may be a combination, by mean of exclusive OR ( | ), of the following
values:
.br
\(em \fBXbVALUE_OVER_MAX\fP if the value is beyond the maximal value allowed
.br
\(em \fBXbVALUE_UNDER_MIN\fP if the value is beyond the minimal value allowed
.br
\(em \fBXbBAD_VALUE_FORMAT\fP if the value "virtual type" does not match
\fBXbNvalueType\fP resource (ex: value = 1.05 and \fBXbNvalueType\fP =
\fBXbINTEGER\fP).
.HP .5i
.IP
.nf
.ta .50i 1.50i
double \fBXbNumericalGetRealValue\fP (\fInumerical_widget\fP)
	Widget	\fInumerical_widget\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.RE
.HP .8i
.IP
The \fBXbNumericalGetRealValue\fP is a convenience function which returns
the current value stored in the Numerical Widget.
.br
Warning: this value is always a double precision number regardless of the
\fBXbNvalueType\fP resource. To get the closest integer value, this result
has to be converted properly.
.br
Ex: closest_int = (int) (XbNumericalGetRealValue(numerical_widget) + | - 0.5);
.HP .5i
.IP
.nf
.ta .50i 1.50i
Boolean \fBXbNumericalSetRealValue\fP (\fInumerical_widget, value\fP)
	Widget	\fInumerical_widget\fP;
	double	\fIvalue\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.IP \fIvalue\fP
Specifies the value to stand as the Numerical widget current value.
.RE
.HP .8i
.IP
The \fBXbNumericalSetRealValue\fP is a convenience function which sets
the current value of the Numerical Widget. If this value is acceptable (ie:
not beyond \fImin/maxValue\fP ...) the current value is set and the function
returns True, otherwise it returns False and the Numerical current value
remains unchanged.
.br
Warning: \fIvalue\fP is always a double precision number regardless of the
\fBXbNvalueType\fP resource.
.HP .5i
.IP
.nf
.ta .50i 1.50i
double \fBXbNumericalClosestValueAllowed\fP (\fInumerical_widget, value\fP)
	Widget	\fInumerical_widget\fP;
	double	\fIvalue\fP;
.fi
.RS .8i
.IP \fInumerical_widget\fP 1.2i
Specifies the Numerical Widget ID.
.IP \fIvalue\fP
Specifies the reference value.
.RE
.HP .8i
.IP
The \fBXbNumericalClosestValueAllowed\fP is a convenience function which
returns a double precision number, as close as possible to \fIvalue\fP, that
the Numerical Widget would accept as current value (with respect to all
format an limit resources).
.br
Warning: this function does not modified the widget state nor resources; it
just performs calulation an returns a result.
.HP .5i
.sp 1
.SH 
\fBCALLBACK INFORMATION\fP
.IP
The following structure is returned with each callback:
.sp1
.nf
.ta .25i 1.0i
typedef struct
{
	\fBint	\fIreason\fP
	\fBXEvent	\fI* event\fP
	\fBBoolean	\fIdo_it\fp
	\fBshort	\fIvalue_type\fP
	\fBdouble	\fInew_double_value\fP
	\fBdouble	\fIold_double_value\fP
} \fBXbNumericalCallbackStruct\fP;
.fi
.sp1
.RS .8i
.IP "\fIreason\fP" .75i
Indicates why the callback was invoked.
.IP "\fIevent\fP" .75i
Points to the \fBXEvent\fP that triggered the callback.
.IP "\fIdo_it\fP" .75i
This field is only used with \fBXbNdisarmIncrementCallback\fP and
\fBXbNArmIncrementCallback\fP. Setting it to False negates the action that
triggered the callback, except on \fBXbNdisarmIncrementCallback\fP when the
timer is running; this action stops the timer regardless of \fIdo_it\fP field
value.
.IP "\fIvalue_type\fP" .75i
Indicates \fBXbNvalueType\fP resource current value.
.IP "\fInew_double_value\fP" .75i
Indicates the value attempting to become the Numerical Widget current value.
.IP "\fIold_double_value\fP" .75i
Indicates the value which was stored in the Numerical Widget prior to the
action that triggered the callback (this can be usefull when using the
\fBXbNvalueChangedCallback\fP resource).
.HP .5i
.sp1
.SH 
\fBNUMERICAL STRING SYNTAX\fP
.IP
.nf
.ta .25i 1.0i
	num_string	: [sign] digit* [ dec_char digit* ] [ exp_char [sign] digit * ]
	digit	: '0' .. '9'
	sign 	: '+' | '-'
	dec_char	: '.' | ','
	exp_char	: 'e' | 'E'
.fi
.HP .5i
.sp 1
.SH 
\fBTRANSLATIONS\fP
.IP
Default translations for the TextField of a Numerical Widget.
.sp1
.IP
.nf
.ta .45i 2i
	\fBBSelect Press\fP:	grab-focus()
	\fBBSelect Motion\fP:	extend-adjust()
	\fBBSelect Release\fP:	extend-end()
.sp1
	\fBBExtend Press\fP:	extend-start()
	\fBBExtend Motion\fP:	extend-adjust()
	\fBBExtend Release\fP:	extend-end()
.sp1
	\fBBToggle Press\fP:	move-destination()
.sp1
	\fBKUp\fP:	traverse-prev()
	\fBKDown\fP:	traverse-next()
.sp1
	\fBKLeft\fP:		backward-character()
	\fBMShift KLeft\fP:	key-select(left)
	\fBMCtrl KLeft\fP:	backward-word()
	\fBMShift MCtrl KLeft\fP:	backward-word(extend)
.sp1
	\fBKRight\fP:	forward-character()
	\fBMShift KRight\fP:	key-select(right)
	\fBMCtrl KRight\fP:	forward-word()
	\fBMShift MCtrl KRight\fP:	forward-word(extend)
.sp1
	\fBKPageLeft\fP:	page-left()
	\fBKPageRight\fP:	page-right()
.sp1
	\fBKBeginLine\fP:	beginning-of-line()
	\fBMShift KBeginLine\fP:	beginning-of-line(extend)
.sp1
	\fBKEndLine\fP:	end-of-line()
	\fBMShift KEndLine\fP:	end-of-line(extend)
.sp1
	\fBKTab\fP:	next-tab-group()
	\fBKPrevField\fP:	prev-tab-group()
.sp1
	\fBKActivate\fP:	activate()
	\fBKDelete\fP:	delete-next-character()
	\fBKBackSpace\fP:	delete-previous-character()
.sp1
	\fBKAddMode\fP:	toggle-add-mode()
.sp1
	\fBKSelect\fP:	set-anchor()
	\fBKExtend\fP:	key-select()
	\fBMAny KCancel\fP:	process-cancel()
	\fBKClear\fP:	clear-selection()
	\fBKSelectAll\fP:	select-all()
	\fBKDeselectAll\fP:	deselect-all()
.sp1
	\fBKCut\fP:	cut-clipboard()
	\fBKCopy\fP:	copy-clipboard()
	\fBPaste\fP:	paste-clipboard()
.sp1
	\fBKPrimaryCut\fP:	cut-primary()
	\fBKPrimaryCopy\fP:	copy-primary()
	\fBKPrimaryPaste\fP:	copy-primary()
.sp1
	\fBKQuickCut\fP:	quick-cut-set()
	\fBKQuickCopy\fP:	quick-copy-set()
	\fBKQuickPaste\fP:	quick-copy-set()
	\fBKQuickExtend\fP:	do-quick-action()
.sp1
	\fBKHelp\fP:	Help()
.sp1
	\fBK0-K9\fP:		self-insert()
	\fBKPeriod\fP:		self-insert()
	\fBKComma\fP:		self-insert()
	\fBKPlus\fP:		self-insert()
	\fBKMinus\fP:		self-insert()
	\fBKE\fP:		self-insert()
.fi
.sp 1
.SH 
\fBACTION ROUTINES\fP
.IP
For a complete description, refer to the XmTextField man page.
.SH
\fBRELATED INFORMATION\fP
.IP
\fBXmBulletinBoard(3X)\fP, \fBComposite(3X)\fP, \fBConstraint(3X)\fP,
\fBCore(3X)\fP, and \fBXmManager(3X)\fP.
.sp 1
.nrPN \n%
