.\" $Id: Ruler.n,v 1.1 1992/12/14 13:21:51 davy Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XbRuler 3Xb "December 1992" "Version 1.1" "Xb Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXbRuler\fP \(em the Ruler widget class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
.bd I 3
\fI#include <Xb/Ruler.h>\fP
.bd I
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
A \fBRuler Widget\fP presents graduations with an optional marker 
(XmArrowButtonGadget). A number is displayed close to each graduation bar.
The space between two bars may have two levels of subdivisions (but no number
will be attached to the sub-bars).
.br
It can be :
.RS 8
.IP \(bu 3
\fBhorizontal\fP, with graduations on top or bottom
.IP \(bu 3
\fBvertical\fP, with graduations on the left or right side
.IP
Concerning the graduation bars, the programmer can set :
.RS 8
.IP \(bu 3
the \fBspace\fP between 2 bars,
.IP \(bu 3
the number of \fBsub-bars\fP  (i.e. number of subdivisions between 2 bars - 1).
.IP \(bu 3
the number of \fBsub-sub-bars\fP (i.e. number of subdivisions between 2
sub-bars - 1).
.IP \(bu 3
the \fBlength\fP of bars, sub-bars and sub-sub-bars,
.IP \(bu 3
the \fBthickness\fP of bars, sub-bars and sub-sub-bars,
.RE 1
.IP
About the numbers accompanying the graduations, the programer has control of :
.RS 8
.IP \(bu 3
the \fBfont\fP used to display these numbers,
.IP \(bu 3
the \fBinitial value\fP,
.IP \(bu 3
the \fBincrement\fP between 2 numbers,
.IP \(bu 3
the \fBdecimal point\fP.
.RE 1
.IP
He can choose to display a marker and set its size.  Then, he places that
marker with XbRulerUpdateMarker function (see FUNCTIONS).
.sp 1
.SH
\fBCLASS\fP
.IP
A Ruler inherits behavior and resources from \fBCore\fP, 
\fBComposite\fP, \fBConstraint\fP, \fBXmManager\fP and \fBXmDrawingArea\fP
Classes.
.br
The class pointer is \fBxbRulerWidgetClass\fP.
.br
The class name is \fBXbRuler\fP.
.sp 1
.SH
\fBRESOURCES\fP
.SS 
\fINew Resources\fP
.IP
The following table defines a set of widget resources used by the programmer
to specify data.  The programmer can also set the resource values for the 
inherited classes to set attributes for this widget.  To reference a
resource by name or by class in a .Xdefaults file, remove the \fBXmN\fP, 
\fBXbN\fP, \fBXmC\fP or \fBXbC\fP prefix and use the remaining letters.  
To specify one of the defined values for a resource in a .Xdefaults file, 
remove the \fBXm\fP or \fBXb\fP prefix and use the remaining letters 
(in either lower case or upper case, but include any underscores between 
words).
The codes in the access column indicate if the given resource can be
set at creation time (\fBC\fP),
set by using \fBXtSetValues\fP (\fBS\fP), 
retrieved by using \fBXtGetValues\fP (\fBG\fP), or is not applicable 
(\fBN/A\fP).
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XbRuler Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XbNdecPoint	XbCRulerValue	short	0	CSG
XbNchangeGradCallback	XmCCallback	XtCallbackList	NULL	CSG
XmNfontList	XmCFontList	XmFontList	fixed	CSG
XbNgradForeground	XmCForeground	Pixel	dynamic	CSG
XbNgradLength	XmCWidth	short	15	CSG
XbNgradSpace	XbCGradSpace	short	50	CSG
XbNgradThickness	XbCGradThickness	short	0	CSG
XbNinitialValue	XbCRulerValue	short	0	CSG
XbNmarkerPosition	XmCPosition	Position	0	CSG
XbNmarkerSize	XbCMarkerSize	short	15	CSG
XbNrulerMargin	XmCMarginWidth	short	5	CSG
XbNrulerOrientation	XbCRulerOrientation	unsigned char	XbVERTICAL_LEFT	CG
XbNshowMarker	XbCShowMarker	Boolean	TRUE	CSG
XbNsubGrad	XbCSubGrad	short	0	CSG
XbNsubGradLength	XmCWidth	short	10	CSG
XbNsubGradThickness	XbCGradThickness	short	0	CSG
XbNsubSubGrad	XbCSubGrad	short	0	CSG
XbNsubSubGradLength	XmCWidth	short	5	CSG
XbNsubSubGradThickness	XbCGradThickness	short	0	CSG
XbNvalueStep	XbCRulerValue	short	1	CSG
.TE
.DE
.ps 10
.sp 1
.IP "\fIXbNdecPoint\fP"
.br
Specifies the number of decimal points to shift the graduation values when 
displaying it.
.br
For example : initialValue = 0  valueStep = 1 and decPoint = 2 means that
the numbers accompanying the graduations are :  0   0.01   0.02   0.03 ...
.IP "\fIXmNchangeGradCallback\fP"
.br
Specifies the list of callbacks that is called after any modification involving
\fBXbNgradSpace\fP, \fBXbNsubGrad\fP or \fBXbNsubSubGrad\fP resources.
The structure returned by this callback is \fBXbRulerCallbackStruct\fP. The
reason sent by the callback is \fBXmCR_VALUE_CHANGED\fP.
.IP "\fIXmNfontList\fP"
.br
Specifies the font used to display the numbers accompanying the graduations.
.IP "\fIXbNgradForeground\fP"
.br
Specifies the foreground color used to draw the graduations (bars and numbers).
.IP "\fIXbNgradLength\fP"
.br
Specifies the length of the graduation bars.
.IP "\fIXbNgradSpace\fP"
.br
Specifies the space between 2 graduations.
.IP "\fIXbNgradThickness\fP"
.br
Specifies the thickness of the graduation bars.
.IP "\fIXbNinitialValue\fP"
.br
Specifies the first number of the graduations.
.IP "\fIXbNmarkerPosition\fP"
.br
Specifies the cursor position when it exists. This number represents the
coordinate of the cursor "hot spot" (cursor_x + 1/2 cursor_width if horizontal
ruler, cursor_y + 1/2 cursor_height if vertical).
.IP "\fIXbNmarkerSize\fP"
.br
Specifies the size (width = height) of the cursor when it exists.
.IP "\fIXbNrulerMargin\fP"
.br
.IP "\fIXbNrulerOrientation\fP"
.br
Specifies the Ruler orientation. The legal values are:
.RS 8
.IP \(em 3
\fBXbVERTICAL_LEFT\fP
.IP \(em 3
\fBXbVERTICAL_RIGHT\fP
.IP \(em 3
\fBXbHORIZONTAL_TOP\fP
.IP \(em 3
\fBXbHORIZONTAL_BOTTOM\fP
.RE 1
.br
indicating the Ruler direction and the position of graduation bars.
.IP "\fIXbNshowMarker\fP"
.br
Indicates if a cursor (XmArrowButtonGadget) is created in the Ruler.
.IP "\fIXbNsubGrad\fP"
.br
Specifies the number of sub-graduation bars between two graduation bars.
.IP "\fIXbNsubSubGrad\fP"
.br
Specifies the number of sub-sub-graduation bars between two sub-graduation
bars.
.IP "\fIXbNsubGradLength\fP"
.br
Specifies the length of the sub-graduation bars.
.IP "\fIXbNsubGradThickness\fP"
.br
Specifies the thickness of the sub-graduation bars.
.IP "\fIXbNsubSubGradLength\fP"
.br
Specifies the length of the sub-sub-graduation bars.
.IP "\fIXbNsubSubGradThickness\fP"
.br
Specifies the thickness of the sub-sub-graduation bars.
.IP "\fIXbNvalueStep\fP"
.br
Specifies the graduation number increment.
.SS
\fIInherited Resources\fP
.IP
Ruler inherits behavior and resources from the following   
superclasses.  For a complete description of these resources, refer to the
man page for that superclass.
.IP
LIMITATION: the \fBCore\fP resource \fBXmNbackgroundPixmap\fP is used by the
\fBXbRuler\fP to draw graduations and cannot be set or modified by the
application programmer.
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmDrawingArea Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNexposeCallback	XmCCallback	XtCallbackList	NULL	C
XmNinputCallback	XmCCallback	XtCallbackList	NULL	C
XmNmarginHeight	XmCMarginHeight	short	10	CSG
XmNmarginWidth	XmCMarginWidth	short	10	CSG
XmNresizeCallback	XmCCallback	XtCallbackList	NULL	C
XmNresizePolicy	XmCResizePolicy	unsigned char	XmRESIZE_ANY	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmManager Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNbottomShadowColor	XmCForeground	Pixel	dynamic	CSG
XmNbottomShadowPixmap	XmCBottomShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNforeground	XmCForeground	Pixel	dynamic	CSG
XmNhelpCallback	XmCCallback	XtCallbackList	NULL	C
XmNhighlightColor	XmCForeground	Pixel	Black	CSG
XmNhighlightPixmap	XmCHighlightPixmap	Pixmap	dynamic	CSG
XmNshadowThickness	XmCShadowThickness	short	dynamic	CSG
XmNtopShadowColor	XmCBackground	Pixel	dynamic	CSG
XmNtopShadowPixmap	XmCTopShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNuserData	XmCUserData	caddr_t	NULL	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Composite Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNinsertPosition	XmCInsertPosition	XmRFunction	NULL	CSG
.sp 1
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Core Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNaccelerators	XmCAccelerators	XtTranslations	NULL	CSG
XmNancestorSensitive	XmCSensitive	Boolean	True	G
XmNbackground	XmCBackground	Pixel	dynamic	CSG
XmNbackgroundPixmap	XmCPixmap	Pixmap	Private	G
XmNborderColor	XmCBorderColor	Pixel	Black	CSG
XmNborderPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderWidth	XmCBorderWidth	Dimension	0	CSG
XmNcolormap	XmCColormap	Colormap	XtCopyFromParent	CG
XmNdepth	XmCDepth	int	XtCopyFromParent	CG
XmNdestroyCallback	XmCCallback	XtCallbackList	NULL	C
XmNheight	XmCHeight	Dimension	0	CSG
XmNmappedWhenManaged	XmCMappedWhenManaged	Boolean	True	CSG
XmNscreen	XmCScreen	Pointer	XtCopyScreen	CG
XmNsensitive	XmCSensitive	Boolean	True	CSG
XmNtranslations	XmCTranslations	XtTranslations	NULL	CSG
XmNwidth	XmCWidth	Dimension	0	CSG
XmNx	XmCPosition	Position	0	CSG
XmNy	XmCPosition	Position	0	CSG
.sp
.TE
.DE
.ps 10
.SH 
\fBFUNCTIONS\fP
.IP
.nf
.ta .50i 1.50i
Widget \fBXbCreateRuler\fP (\fIparent_widget, name, override_arglist, 
			override_argcount\fP)
	Widget	\fIparent_widget\fP;
	char*	\fIname\fP;
	ArgList	\fIoverride_arglist\fP;
	int	\fIoverride_argcount\fP;
.fi
.RS .8i
.IP \fIparent_widget\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIoverride_arglist\fP
Specifies the application override argument list.
.IP \fIoverride_argcount\fP
Specifies the number of attributes int the override_arglist.
.RE
.HP .8i
.IP
The \fBXbCreateRuler\fP function creates an instance of the Ruler Widget and 
returns its associated Widget ID.
.HP .5i
.IP
.nf
.ta .50i 1.50i
void \fBXbRulerUpdateMarker\fP (\fIruler_widget, position\fP)
	Widget	\fIruler_widget\fP;
	int	\fIposition\fP;
.fi
.RS .8i
.IP \fIruler_widget\fP 1.2i
Specifies the Ruler Widget ID.
.IP \fIposition\fP
Specifies the new position of the marker (in pixels).
.RE
.HP .8i
.IP
The \fBXbRulerUpdateMarker\fP function allows to set the marker position.
.br
position = new x if the ruler is horizontal, new y if the ruler is vertical. 
.HP .5i
.IP
.nf
.ta .50i 1.50i
int \fBXbRulerGetPosition\fP (\fIruler_widget, grad, sub_grad, sub_sub_grad\fP)
	Widget	\fIruler_widget\fP;
	int	\fIgrad\fP;
	int	\fIsub_grad\fP;
	int	\fIsub_sub_grad\fP;
.fi
.RS .8i
.IP \fIruler_widget\fP 1.2i
Specifies the Ruler Widget ID.
.IP \fIgrad\fP
Specifies the number of graduations.
.IP \fIsub_grad\fP
Specifies the number of sub graduations.
.IP \fIsub_sub_grad\fP
Specifies the number of sub sub graduations.
.RE
.HP .8i
.IP
The \fBXbRulerGetPosition\fP function returns a position, expressed in the
widget unit type (XmNunitType), and corresponding to the position of
\fIgrad\fP graduations \fI+ sub_grad\fP sub graduations \fI+ sub_sub_grad\fP
sub sub graduations. It is actually a converter from the Ruler unit
(graduations) to the widget XmNunitType.
.HP .5i
.sp 1
.SH 
\fBTYPES\fP
.IP
.sp 1
.SH 
\fBCALLBACK INFORMATION\fP
.IP
The following structure is returned with each callback:
.sp1
.nf
.ta .25i 1.0i
typedef struct
{
	\fBint	\fIreason\fP
	\fBXEvent	\fI* event\fP
	\fBint	\fIgrad_space\fP
	\fBint	\fIsub_grad\fP
	\fBint	\fIsub_sub_grad\fP
} \fBXbRulerCallbackStruct\fP;
.fi
.sp1
.RS .8i
.IP "\fIreason\fP" .75i
Indicates why the callback was invoked.
.IP "\fIevent\fP" .75i
Points to the \fBXEvent\fP that triggered the callback.
.IP "\fIgrad_space\fP" .75i
Indicates \fBXbNgradSpace\fP resource (new) value.
.IP "\fIsub_grad\fP" .75i
Indicates \fBXbNsubGrad\fP resource (new) value.
.IP "\fIsub_sub_grad\fP" .75i
Indicates \fBXbNsubGrad\fP resource (new) value.
.SH 
\fBBEHAVIOR\fP
.SH 
\fBRELATED INFORMATION\fP
.IP
\fBComposite(3X)\fP, \fBConstraint(3X)\fP, \fBCore(3X)\fP,
\fBXmDrawingArea(3X)\fP and \fBXmManager(3X)\fP.
.sp 1
.nrPN \n%
