.\" $Id: gocolor.n,v 1.1 1993/01/04 09:49:58 kuta Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH gocolor 1Go "November 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBgocolor\fP \(em graphic color editor.
.SH
\fBDESCRIPTION\fP
.IP
\fBgocolor\fP is a graphic editor based on Graphic Objects library (Go) and following the OSF/Motif Style Guide. The user interface is built using OSF/Motif widgets. Resource file allows to customize the look of the editor. \fBgocolor\fP is part of the Go Companions.
.sp
This editor allows the application developper to create and modify colors which could bu used in others editors (godraw, gopen). These colors could be saved into dictionnaries. So, the application developper can manage a number of dictionnary to store the colors created.
.sp
This graphic editor has a common look with others resource editors (godash, gopen). There are four main parts in theses editors:
.RS 8
.IP \(em 3
in the top : the menu bar.
.IP \(em 3
in the left : the dictionnary part.
.IP \(em 
in the right : the specific part called editor part.
.IP \(em 3
in the bottom right : the command report.
.SH 
.IP
Three parts have a common look with the others resource editors (godash, gopen): the menu bar, dictionnary part and the command report. The fourth part (the editor part) is specific to each editor.
.SH
\fBMENU BAR\fP
.IP 
With the \fBFile\fP Button in the menu bar, the application developper can access to the dictionnary management:
.RS 8
.IP \(em 3
New : New dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). The color list and the current dictionnary name are cleared (see below what are the color list and the current dictionnary name).
.IP \(em 3
Open : Open a new dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to load. The color list and the current dictionnary name are updated.
.IP \(em 3
Merge : Merge a new dictionnary with the current one (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to merge. The color list and the current dictionnary name are updated.
.IP \(em 3
Save : Save the current dictionnary.  
.IP \(em 3
SaveAs : Save the current dictionnary with a new name. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary.
.IP \(em 3
SaveSelectedObjects : Save the current selected colors. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary for these selected colors (If there is no selected color, a report is written in Commmand Report part).
.IP \(em 3
Exit : Exit graphic color editor (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue).
.SH 
.IP
With the \fBEdit\fP Button in the menu bar, the application developper can access to the clipboard management:
.RS 8
.IP \(em 3
Copy : Copy (Store) the current color (the current color is the color who is shown in the specific editor part) into the clipboard. The clipboard allows the application developper to "send" color to other graphic editors (without copying them into files).
.IP \(em 3
Paste : Paste (Restore) the object present in the clipboard like the current color of the graphic color editor. If there is a problem with the clipboard or if the object present in the clipboard is not a color, a report is written in the Command Report part.
.SH
\fBDICTIONNARY PART\fP
.IP
The dictionnary part allows the user to save and restore colors created with the specific part (editor part) into Dictionnaries. All the disk management (new, load, save, etc...) of the dictionnary part is made by using the \fBfile\fP Button of the Menu Bar. 
.sp
Warning : The created dictionnaries are BINARY GoStream Files (with file extension : ".dic")
.sp
The dictionnary part is composed of three parts: the Dictionnary Name part (on the top), the Color List (in the middle), and at the bottom: the Push-Buttons part (Add, Remove, Deselect). 
.sp
This dictionnary part allows the user to see the currents colors he has created or loaded (the Color List), the current Dictionnary Name he used (Dictionnary Name part). 
.br
A star (*) is visible if the dictionnary is modified but not saved. When this star is visible, and when the user wants to save the curent Dictionnary, a Diolog box is opened to ask him if he wants to continue.
.sp
With the Push-Buttons part (Add, Remove, Deselect), the user can manage the Color List of the current dictionnary: 
.RS 8
.IP \(em 3
Add : allows the user to add the current color shown in the editor part in the Color List of the current dictionnary. The current color must have a name (see below the editor part). If there is already a color in the current dictionnary with the same name, a dialog box is opened to ask the user if he wants to continue.
.IP \(em 3
Remove : allows the user to remove the current color(s) selected in the Color List of the current dictionnary (to select one (or more) color(s) in the Color List, the user must click on the name(s). When a color is selected, it is displayed in inverse color. A dialog box is opened to ask the user if he wants to continue. If there is no selected color, a report is written in Commmand Report part.
.IP \(em 3
Deselect : allows the user to cleared all the selections he made in the Color List of the current dictionnary.
.SH
.IP
To see a color in the editor part, the user must double-click on the color name. Then, in the white window of th specific editor part, the go polyline takes all the values of the selected color (width, color, lineStyle, capStyle, joinStyle, alternate-Color, dash).
.SH
\fBEDITOR PART\fP
.IP 
In the specific part (called the editor part), the application developper can select a color among the system color set.
.br
The selection can be made using four different methods. The user can choose a color:
.RS 8
.IP \(em 3
By using three scales representing the RGB values or HSV values.
.IP \(em 3
By selecting a color displayed anywhere on the screen.
.IP \(em 3
By selecting a color already set in the system colormap.
.IP \(em 3
By making a color interpolation between two colors with the "ColorSet" widget.
.SH
.IP
At every time, on the top of the specific editor part, two small boxes display the current selected color. By default, one box has a white border and the other a black border, but the border colors may be changed. After selecting a color, the user can confirm, cancel his selection or go back to the initial color selection.
.sp
The user can pick a couple of colors (by clicking on each color) and automatically the ramp between these two colors is calculated and displayed. The user can pick a color among the eight basic colors and the last ramp. Nevertheless, if the user wants to pick another color on the screen or only change one of the extreme color of the ramp, he can click on the correct button displayed in the "ColorSet" widget. At every time, he can "undo" its last choice. When the user finds the color he wants, he just double-clicks on this color to select it. The "Colorset" could use patterns to make the ramp. If the user selects a pattern, the application can get the pattern or the corresponding color.
.sp
A Dialog Box is opened when a color allocation error occurs (i.e. system colormap is full). In this case, the user can choose to allocate the closest color existing in the colormap or to set the last selected color.
.SH
.IP
When the Application Developper have choosen a color, he must give first a name to this color before saving it in a dictionnary. To give a name to this color, he must click in the specific widget named Color Mame, then type the name and RETURN (or ENTER).
.sp
Warning : The color name is not stored until RETURN (or ENTER) is typed !
.sp
Then, the Application Developper can save this color by using the Add Button of the dictionnary part (see the Dictionnary Part). 
.sp
He can also copy this color for another editor in the clipboard by using the Copy Button of the Menu Bar (see the Menu Bar Part). To use the clipboard, it is not necessary to give a name to the current color.
.br
 If the current has a name, a "nammed" color is copied to the clipboard.
.br
 If the current has a no name, a "unnammed" color is copied to the clipboard.
.SH
\fBENVIRONMENT\fP
.IP
\fBGoENVIRON\fP is a shell variable used to find :
.RS 8
.IP \(em 3
files used by gocolor and other applications.
.sp
(See Installation Guide for more informations).
.RE 2
.RE
.sp1
.SH
\fBFILES\fP
.IP
\fBgocolor\fP needs a Motif resources file to run correctly. This file is :
.RS 8
.IP \(em 3
\fBXmGoColor\fP
.sp
This file is the Motif resources file.
.sp
The user can use three different ways to load the XmGoColor file:
.RS 8
.IP \(em 3
Make "xrdb -merge XmGoColor" to initialize the server resource manager.
.IP \(em 3
Initialize the XENVIRONMENT variable.
.IP \(em 3
Put XmGoColor file in the directory "/usr/lib/X11/app-defaults"
.sp
.RE
.sp1
.nrPN \n%
