.\" $Id: godash.n,v 1.1 1993/01/04 09:50:03 kuta Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH godash 1Go "November 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBgodash\fP \(em graphic dash editor.
.SH
\fBDESCRIPTION\fP
.IP
\fBgodash\fP is a graphic editor based on Graphic Objects library (Go) and following the OSF/Motif Style Guide. The user interface is built using OSF/Motif widgets. Resource file allows to customize the look of the editor. \fBgodash\fP is part of the Go Companions.
.sp
This editor allows the application developper to create and modify dashes which could bu used in others editors (godraw, gopen). These dashes could be saved into dictionnaries. So, the application developper can manage a number of dictionnary to store the dashes created.
.sp
This graphic editor has a common look with others resource editors (gopen, gocolor). There are four main parts in theses editors:
.RS 8
.IP \(em 3
in the top : the menu bar.
.IP \(em 3
in the left : the dictionnary part.
.IP \(em 
in the right : the specific part called editor part.
.IP \(em 3
in the bottom right : the command report.
.SH 
.IP
Three parts have a common look with the others resource editors (gopen, gocolor): the menu bar, dictionnary part and the command report. The fourth part (the editor part) is specific to each editor.
.SH
\fBMENU BAR\fP
.IP 
With the \fBFile\fP Button in the menu bar, the application developper can access to the dictionnary management:
.RS 8
.IP \(em 3
New : New dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). The dash list and the current dictionnary name are cleared (see below what are the dash list and the current dictionnary name).
.IP \(em 3
Open : Open a new dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to load. The dash list and the current dictionnary name are updated.
.IP \(em 3
Merge : Merge a new dictionnary with the current one (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to merge. The dash list and the current dictionnary name are updated.
.IP \(em 3
Save : Save the current dictionnary. 
.IP \(em 3
SaveAs : Save the current dictionnary with a new name. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary.
.IP \(em 3
SaveSelectedObjects : Save the current selected dashes. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary for these selected dashes (If there is no selected dash, a report is written in Commmand Report part).
.IP \(em 3
Exit : Exit graphic dash editor (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue).
.SH 
.IP
With the \fBEdit\fP Button in the menu bar, the application developper can access to the clipboard management:
.RS 8
.IP \(em 3
Copy : Store the current dash (the current dash is the dash who is shown in the specific editor part) into the clipboard. The clipboard allows the application developper to "send" dash to other graphic editors (without copying them into files).
.IP \(em 3
Paste : Restore the object present in the clipboard like the current dash of the graphic dash editor. If there is a problem with the clipboard or if the object present in the clipboard is not a dash, a report is written in the Command Report part.
.IP \(em 3
Reinit : Reinit the current dash. The current dash is set to default dash (see below in the editor part what are the default values for the current dash).
.SH 
.IP
With the \fBTools\fP Button in the menu bar, the application developper can access to tools management:
.RS 8
.IP \(em 3
Samples : Open a new window to see GO Samples with the specific dash shown in the Editor Part. This new window can be closed with the specific "Close" Button of this new window, or can be closed using the Samples Button again.  
.SH
\fBDICTIONNARY PART\fP
.IP
The dictionnary part allows the user to save and restore dashes created with the specific part (editor part) into Dictionnaries. All the disk management (new, load, save, etc...) of the dictionnary part is made by using the \fBFile\fP Button of the Menu Bar. 
.sp
Warning : The created dictionnaries are BINARY GoStream Files (with file extension : .dic)
.sp
The dictionnary part is composed of three parts: the Dictionnary Name part (on the top), the Dash list (in the middle), and at the bottom: the Push-Buttons part (Add, Remove, Deselect). 
.sp
This dictionnary part allows the user to see the currents dashes he has created or loaded (the Dash list), the current Dictionnary Name he used (Dictionnary Name part). 
.br
A star (*) is visible if the dictionnary is modified but not saved. When this star is visible, and when the user wants to save the curent Dictionnary, a Diolog box is opened to ask him if he wants to continue.
.sp
With the Push-Buttons part (Add, Remove, Deselect), the user can manage the Dash list of the current dictionnary:  
.RS 8
.IP \(em 3
Add : allows the user to add the current dash shown in the editor part in the Dash list of the current dictionnary. The current dash must have a name (see below the editor part). If there is already a dash in the current dictionnary with the same name, a dialog box is opened to ask the user if he wants to continue.
.IP \(em 3
Remove : allows the user to remove the current dash(s) selected in the Dash list of the current dictionnary (to select one (or more) dash(s) in the Dash list, the user must click on the name(s). When a dash is selected, it is displayed in inverse color. A dialog box is opened to ask the user if he wants to continue. If there is no selected dash, a report is written in Commmand Report part.
.IP \(em 3
Deselect : allows the user to cleared all the selections he made in the Dash list of the current dictionnary.
.SH
.IP
To see a dash in the editor part, the user must double-click on the dash name. Then, in the specific editor part, the go line is set with the selected dash.
.SH
\fBEDITOR PART\fP
.IP 
In this specific part (called the editor part), the application developper can modify the current dash. There are two parts. 
.sp
The first one (at the bottom) allows the user to select the current dash (with black and white rectangles and two little black triangles). To select a dash : 
.RS 8
.IP \(em 3
The user can click on rectangles (if the recatngle is black, it becomes white, if it is white, it becomes black). The first rectangle can't be changed (it is always black). This allows the user to select the dash : black = dash; white = gap.
.IP \(em 3
With the two little black triangles (by default, on the top of the two first rectangles), the user can select the "frequency" (dash/gap number) of the dash (by default the dash is symetric : dash/gap with a dash/gap number of 2). To  increase the "frequency" (dash/gap number) the user must drag the right triangle to the right.
.SH
.IP 
The second one (at the top) allows the user to see the current created dash with a single Go Line. The user can change the width of the Go Line with the slider on the right (by default the width is 1 pixel). 
.sp
The sliders on the bottom of the two parts allowed the user to select a specific part of the created dash.
.SH
.IP
When the Application Developper have choosen a dash, he must give first a name to this dash before saving it in a dictionnary. To give a name to this dash, he must click in the specific widget named Dash Mame, then type the name and RETURN (or ENTER).
.sp
Warning : The dash name is not stored until RETURN (or ENTER) is typed !
.sp
Then, the Application Developper can save this dash by using the Add Button of the dictionnary part (see the Dictionnary Part). 
.sp
He can also copy this dash for another editor in the clipboard by using the Copy Button of the Menu Bar (see the Menu Bar Part). To use the clipboard, it is not necessary to give a name to the current dash.
.br
If the current has a name, a "nammed" dash is copied to the clipboard.
.br
If the current has a no name, a "unnammed" dash is copied to the clipboard.
.SH
\fBENVIRONMENT\fP
.IP
\fBGoENVIRON\fP is a shell variable used to find :
.RS 8
.IP \(em 3
files used by godash and other applications.
.sp
(See Installation Guide for more informations).
.RE 2
.RE
.sp1
.SH
\fBFILES\fP
.IP
\fBgodash\fP needs a GoUI file, a Motif resources file to run correctly. This file is :
.RS 8
.IP \(em 3
\fBgodash.goui\fP.
.br
This file defines the user interaction in the specific Editor Part.
It has to be in one of the following directories :
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/godash/goui"
.IP \(em 3
"/usr/local/lib/Go/app-files/godash/goui"
.RE
.IP \(em 3
\fBXmGodash\fP
.sp
This file is the Motif resources file.
.sp
The user can use three different ways to load the XmGodash file:
.RS 8
.IP \(em 3
Make "xrdb -merge XmGodash" to initialize the server resource manager.
.IP \(em 3
Initialize the XENVIRONMENT variable.
.IP \(em 3
Put XmGodash file in the directory "/usr/lib/X11/app-defaults"
.RE 2
.RE
.sp1
.nrPN \n%
