.\" $Id: godraw.n,v 1.2 1992/12/01 14:31:15 jacomet Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH godraw 1Go "January 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBgodraw\fP \(em Graphic Object editor.
.SH
\fBDESCRIPTION\fP
.IP
\fBgodraw\fP is a Graphic Editor based on Graphic Objects library (Go) and following the OSF/Motif Style Guide. The user interface is built using OSF/Motif widgets. Resource file allows to customize the look of the editor.
.sp
This editor allows the application developper to interactively create objects and their attributes. When created, objects can be stored on GoStream files in order to be retrieved by applications when presenting their data. \fBgodraw\fP is the necessary tool for builting beautiful graphical presentations.
.sp
A icon palette allows the user to choose among the predefined Go's: polylines, polygons, ellipses, texts and so on ... After created, the object geometry can be modified either using the "Edit" menu commands or by using the mouse and keyboard accelerators on the object.
.sp
Attribute forms allow to define default attributes when creating a new object or to modify attributes of some selected objects.
.sp
In Go, objects are organized in an object tree. \fBgodraw\fP provides functionnalities in order to build such Go subtree which can be seen by the user as "complex Go's".
.sp
\fBgodraw\fP provides functionnalities for saving/restoring graphics in ascii GoStream files. Typically, these files will be used by applications when presenting their data.
.sp
\fBgodraw\fP allows to generate PostScript files containing either the selected objects or the entire window.
.sp
See interactive Help for more details.
.IP
.SH
\fBASSOC MANAGEMENT\fP
.IP
In \fBgodraw\fP, you can associate keys and values in a Assoc for every Go.
It allows to semanticaly link Graphic Objects and "user's data".
These associations are saved in GoStream files.
If another application wants to restore such associations, it has to set a 
GoMetaclass::restorePostcond().
.br
This postcond must follow the following scheme :
.sp
void RestoreAssoc(void*, Go* go, GoStream* stream)
.br
{
.br
    char c;
.br
    char k[1024];
.br
    char v[1024];
.br
    char* key = k;
.br
    char* val = v;
.br
    stream->readChar(&c);
.br
    while(c == 'a') {
.br
	stream->readString(100, &key);  // This is the key string;
.br
	stream->readString(100, &val);  // This is the value string;
.br
	stream->readChar(&c);
.br
    }
.br
}
.IP
.SH
\fBHELP\fP
.IP
An interactive Help may be used. Seven items are defined.
.RS 8
.IP \(em 3
\fBContext-Sensitive\fP
.br
This item allows you to have help on menus, icon palette, Graphic Objects and dialogs. When you click on "Context-Sensitive" item, a question mark is displayed. Move the question mark to the thing that you need help on and click.
.IP \(em 3
\fBOverview\fP
.br
This item allows you to have information on Graphic Objects displayed in the Work window.
.IP \(em 3
\fBIndex\fP
.br
This item lists alphabetically a series of topics on which help is available. You may select the topic of interest, click on "Read on Help" pushbutton and help on this topic is displayed in the window.
.IP \(em 3
\fBKeyboard\fP
.br
This item provides information about the Graphic Editor's use of mnemonics, keyboard accelerators and mouse actions.
.IP \(em 3
\fBGoDraw Information\fP
.br
This item provides information about the Graphic Editor's goals, architecture, contacts ...
.IP \(em 3
\fBGo Information\fP
.br
This item provides information about the Go library.
.RE 2
.RE
.sp 1
.IP
.SH 
\fBENVIRONMENT\fP
.IP
\fBGoENVIRON\fP is a shell variable used to find :
.RS 8
.IP \(em 3
files used to generating PostScript files.
.IP \(em 3
files used by the Multi Column GoText.
.IP \(em 3
files used by godraw and other applications.
.sp
See Installation Guide for more information.
.RE 2
.RE
.sp1
.SH
\fBFILES\fP
.IP
\fBgodraw\fP needs one GoUI file, a Motif resources file and two GoStream files to run correctly. These files are :
.RS 8
.IP \(em 3
\fBgodraw.goui\fP
.br
This file defines the user interaction in the Work window.
It has to be in one of the following directories :
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/godraw/goui"
.IP \(em 3
"/usr/local/lib/Go/app-files/godraw/goui"
.RE
.IP \(em 3
\fBXmGoDraw\fP
.br
This file is the Motif resources file.
.br
If you want to print Graphic Objects, you have to initialize, in the XmGoDraw file, the resource "\fBXmGoDraw.lpr\fP" with printer command.
.br
If you want to specify the Undo stack size, you have to initialize, in the XmGoDraw file, the resource "\fBXmGoDraw.undoStack\fP" with the actions number you want to store.
.br
You can use three different ways to load the XmGoDraw file:
.RS 8
.IP \(em 3
Make "xrdb -merge XmGoDraw" to initialize the server resource manager.
.IP \(em 3
Initialize the XENVIRONMENT variable.
.IP \(em 3
Put XmGoDraw file in the directory "/usr/lib/X11/app-defaults"
.RE
.IP \(em 3
\fBattributes.go\fP and \fBnamed-obj.str\fP
.br
These files are GoStream files.
.br
\fBattributes.go\fP is used for attributes modifications.
.br
\fBnamed-obj.str\fP contains predefined named shared objects.
.br
These files have to be in one of the following directories:
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/godraw"
.IP \(em 3
"/usr/local/lib/Go/app-files/godraw"
.RE 2
.RE
.sp1


.nrPN \n%
