.\" $Id: gohyper.n,v 1.1 1992/12/01 14:34:12 jacomet Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH gohyper 1Go "November 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBgohyper\fP \(em graphic hypertext editor.
.SH
\fBDESCRIPTION\fP
.IP
\fBgohyper\fP is a graphic editor based on Graphic Objects library (Go) and following the OSF/Motif Style Guide. The user interface is built using OSF/Motif widgets. Resource file allows to customize the look of the editor.
.sp
This editor allows the application developper to interactively sensitive objects, to link scripts to defined sensitive areas (these areas are called sensors) and to play these scripts. When created, objects, sensors and scripts can be stored on GoStream files in order to be retrieved by applications when presenting their data. \fBgohyper\fP is the necessary tool for builting hypertext presentations.
.sp
A menu allows the user to choose among the predefined sensor types: rectangular sensors, polygonal sensors, ellipsoidal sensors and full sensors (the object associated with a full sensor is completely sensitive and a GoRoot can be associated with a full sensor). After created, the sensor geometry can be modified by using the mouse and keyboard accelerators on the sensor and the sensor name can be changed.
.sp
A menu allows to change attributes of selected sensors. Full sensors can be have an outline but no background. Geometric sensors can be have an outline and a background.
.sp
\fBgohyper\fP provides functionnalities for saving/restoring graphics in ascii or binary GoStream files. Typically, these files will be used by applications when presenting their data.
.sp
\fBgohyper\fP allows to associate scripts with sensors. A script editor is used by gohyper. This script editor interprets files written with the GoUI language. When the gohyper editor is in mode Play, the scripts are loaded.
.sp
\fBgohyper\fP allows to generate PostScript files containing either the selected objects or the entire window.
.sp
See interactive Help for more information.
.IP
.SH
\fBASSOC MANAGEMENT\fP
.IP
In \fBgohyper\fP, you can associate keys and values in a Assoc for every Go and sensors.
It allows to semanticaly link Graphic Objects and "user's data".
These associations are saved in GoStream files.
If another application wants to restore such associations, it has to set a 
GoMetaclass::restorePostcond().
.br
This postcond must follow the following scheme :
.sp
void RestoreAssoc(void*, Go* go, GoStream* stream)
.br
{
.br
    char c;
.br
    char k[1024];
.br
    char v[1024];
.br
    char* key = k;
.br
    char* val = v;
.br
    stream->readChar(&c);
.br
    while(c == 'a') {
.br
	stream->readString(100, &key);  // This is the key string;
.br
	stream->readString(100, &val);  // This is the value string;
.br
	stream->readChar(&c);
.br
    }
.br
}
.IP
.SH
\fBHELP\fP
.IP
An interactive Help may be used. Eight items are defined.
.RS 8
.IP \(em 3
\fBContext-Sensitive\fP
.br
This item allows you to have help on menus, Graphic Objects and dialogs. When you click on "Context-Sensitive" item, a question mark is displayed. Move the question mark to the thing that you need help on and click.
.IP \(em 3
\fBOverview\fP
.br
This item allows you to have information on Graphic Objects and sensors displayed in the Work window.
.IP \(em 3
\fBContents\fP
.br
This item lists all chapters and subchapters on which help is available. You may click on the topic of interest and help on this topic is displayed in the window. Don't forget to mark the contents file if you want to go back to it.
.IP \(em 3
\fBIndex\fP
.br
This item lists alphabetically a series of topics on which help is available. You may click on the topic of interest and help on this topic is displayed in the window. Don't forget to mark the index file if you want to go back to it.
.IP \(em 3
\fBKeyboard\fP
.br
This item provides information about the Graphic Editor's use of mnemonics, keyboard accelerators and mouse actions.
.IP \(em 3
\fBGoHyper Information\fP
.br
This item provides information about the Graphic Editor's goals, architecture, contacts ...
.IP \(em 3
\fBGo Information\fP
.br
This item provides information about the Go library.
.RE 2
.RE
.sp 1
.IP
.SH 
\fBENVIRONMENT\fP
.IP
\fBGoENVIRON\fP is a shell variable used to find :
.RS 8
.IP \(em 3
files used to generating PostScript files.
.IP \(em 3
files used by gohyper and other applications.
.sp
See Installation Guide for more information.
.RE 2
.RE
.sp1
.SH
\fBFILES\fP
.IP
\fBgohyper\fP needs three GoUI files, a Motif resources file and three GoStream files to run correctly. These files are :
.RS 8
.IP \(em 3
\fBgohyper.goui\fP, \fBhelp.goui\fP and \fBedit.goui\fP.
.br
These files define the user interaction in the Work window, the Help window and the script editor.
They have to be in one of the following directories :
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/gohyper/goui"
.IP \(em 3
"/usr/local/lib/Go/app-files/gohyper/goui"
.RE
.IP \(em 3
\fBXmGoHyper\fP
.br
This file is the Motif resources file.
.br
If you want to print Graphic Objects, you have to initialize, in the XmGoHyper file, the resource "\fBXmGoHyper.lpr\fP" with printer command.
.br
If you want to specify the Undo stack size, you have to initialize, in the XmGoHyper file, the resource "\fBXmGoHyper.undoStack\fP" with the actions number you want to store.
.br
You can use three different ways to load the XmGoHyper file:
.RS 8
.IP \(em 3
Make "xrdb -merge XmGoHyper" to initialize the server resource manager.
.IP \(em 3
Initialize the XENVIRONMENT variable.
.IP \(em 3
Put XmGoHyper file in the directory "/usr/lib/X11/app-defaults"
.RE
.IP \(em 3
\fBpen.str\fP, \fBbrush.str\fP and \fBedit.str\fP.
.br
These files are GoStream files.
.br
\fBbrush.str\fP and \fBpen.str\fP are used by attributes menu. They contain some shared colors and these colors are displayed in the sensor attributes menu. If you want to modify these files, you can edit them by using the GoColor editor.
.br
\fBedit.str\fP is used by the script editor. Do not modify it.
.br
These files have to be in one of the following directories:
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/gohyper"
.IP \(em 3
"/usr/local/lib/Go/app-files/gohyper"
.RE 2
.RE
.sp1


.nrPN \n%
