.\" $Id: gopen.n,v 1.1 1993/01/04 09:50:08 kuta Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH gopen 1Go "November 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBgopen\fP \(em graphic pen editor.
.SH
\fBDESCRIPTION\fP
.IP
\fBgopen\fP is a graphic editor based on Graphic Objects library (Go) and following the OSF/Motif Style Guide. The user interface is built using OSF/Motif widgets. Resource file allows to customize the look of the editor. \fBgopen\fP is part of the Go Companions.
.sp
This editor allows the application developper to create and modify pens which could bu used in others editors (godraw). These pens could be saved into dictionnaries. So, the application developper can manage a number of dictionnary to store the pens created.
.sp
This graphic editor has a common look with others resource editors (godash, gocolor). There are four main parts in theses editors:
.RS 8
.IP \(em 3
in the top : the menu bar.
.IP \(em 3
in the left : the dictionnary part.
.IP \(em 
in the right : the specific part called editor part.
.IP \(em 3
in the bottom right : the command report.
.SH 
.IP
Three parts have a common look with the others resource editors (godash, gocolor): the menu bar, dictionnary part and the command report. The fourth part (the editor part) is specific to each editor.
.SH
\fBMENU BAR\fP
.IP 
With the \fBFile\fP Button in the menu bar, the application developper can access to the dictionnary management:
.RS 8
.IP \(em 3
New : New dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). The pen list and the current dictionnary name are cleared (see below what are the pen list and the current dictionnary name).
.IP \(em 3
Open : Open a new dictionnary (if the user did'nt save the current dictionnary, a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to load. The pen list and the current dictionnary name are updated.
.IP \(em 3
Merge : Merge a new dictionnary with the current one (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue). Then a File Selection Box is opened to ask him what dictionnary he wants to merge. The pen list and the current dictionnary name are updated.
.IP \(em 3
Save : Save the current dictionnary. 
.IP \(em 3
SaveAs : Save the current dictionnary with a new name. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary.
.IP \(em 3
SaveSelectedObjects : Save the current selected pens. A File Selection Box is opened to ask the user what name he wants to give to the dictionnary for these selected pens (If there is no selected pen, a report is written in Commmand Report part).
.IP \(em 3
Exit : Exit graphic pen editor (if the user did'nt save the current dictionnary a dialog box is opened to ask him if he wants to continue).
.SH 
.IP
With the \fBEdit\fP Button in the menu bar, the application developper can access to the clipboard management:
.RS 8
.IP \(em 3
Copy : Copy (Store) the current pen (the current pen is the pen who is shown in the specific editor part) into the clipboard. The clipboard allows the application developper to "send" pen to other graphic editors (without copying them into files).
.IP \(em 3
Paste : Paste (Restore) the object present in the clipboard like the current pen of the graphic pen editor. If there is a problem with the clipboard or if the object present in the clipboard is not a pen, a report is written in the Command Report part.
.IP \(em 3
Reinit : Reinit the current pen. The current pen is set to default pen (see below in the editor part what are the default values for the current pen).
.SH
\fBDICTIONNARY PART\fP
.IP
The dictionnary part allows the user to save and restore pens created with the specific part (editor part) into Dictionnaries. All the disk management (new, load, save, etc...) of the dictionnary part is made by using the \fBfile\fP Button of the Menu Bar. 
.sp
Warning : The created dictionnaries are BINARY GoStream Files (with file extension : ".dic")
.sp
The dictionnary part is composed of three parts: the Dictionnary Name part (on the top), the Pen List (in the middle), and at the bottom: the Push-Buttons part (Add, Remove, Deselect). 
.sp
This dictionnary part allows the user to see the currents pens he has created or loaded (the Pen List), the current Dictionnary Name he used (Dictionnary Name part). 
.br
A star (*) is visible if the dictionnary is modified but not saved. When this star is visible, and when the user wants to save the curent Dictionnary, a Diolog box is opened to ask him if he wants to continue.
.sp
With the Push-Buttons part (Add, Remove, Deselect), the user can manage the Pen List of the current dictionnary:  
.RS 8
.IP \(em 3
Add : allows the user to add the current pen shown in the editor part in the Pen List of the current dictionnary. The current pen must have a name (see below the editor part). If there is already a pen in the current dictionnary with the same name, a dialog box is opened to ask the user if he wants to continue.
.IP \(em 3
Remove : allows the user to remove the current pen(s) selected in the Pen List of the current dictionnary (to select one (or more) pen(s) in the Pen List, the user must click on the name(s). When a pen is selected, it is displayed in inverse color. A dialog box is opened to ask the user if he wants to continue. If there is no selected pen, a report is written in Commmand Report part.
.IP \(em 3
Deselect : allows the user to cleared all the selections he made in the Pen List of the current dictionnary.
.SH
.IP
To see a pen in the editor part, the user must double-click on the pen name. Then, in the white window of th specific editor part, the go polyline takes all the values of the selected pen (width, color, lineStyle, capStyle, joinStyle, alternate-Color, dash).
.SH
\fBEDITOR PART\fP
.IP 
In the specific part (called the editor part), the application developper can modify the following values of the current pen:
.RS 8
.IP \(em 3
the width.
.IP \(em 3
the color.
.IP \(em 3
the lineStyle.
.IP \(em 3
the capStyle.
.IP \(em 3
the joinStyle.
.IP \(em 3
the alternate-Color.
.IP \(em 3
the dash.
.sp
.IP \(em 3
The width : To modify the width, the user must click in the center of the specific widget named Width ant type a new value, or click on the right (or left) black arrow to increase (or decrease) the value. In the white area where a Go Polyline is drawned, the user can see the choosen value of the pen's width. 
.br
The width in is millimeter. By default, the width is set to 2 millimeters.
.IP \(em 3
The color, alternate-Color : To modify the color (alternate color), the user must click in the specific widget named Color (Alt.Color) and then select one of the posssible colors (alternate colors) by clicking on the corresponding Button. On the Go Polyline draw, the user can see the choosen color (alternate color).
.br
By default, the color is set to the first color of the color GoStream File, the alternate-Color is set to the last color of the color GoStream File (see below the GoStream file for the Color (Alt.Color) Menu in FILE part).
.br
There is also a specific Button called "Paste". If the Application Developper wants a specific color (alternate-Color) which is not defined in the color (Alt.Color) Menu, he can defined it with the gocolor editor, copy it to the clipboard with the Copy Button of the gocolor editor, and then Paste it with this specific Button of the gopen editor. If there is a problem with the clipboard or if the object present in the clipboard is not a shared color, a report is written in the Command Report part.
.IP \(em 3
The lineStyle : To modify the lineStyle, the user must click in the specific widget named LineStyle, and then select one of the posssible lineStyle by clicking on the corresponding Button. There are three possible lineStyle : the first is called LineSolid (no dash); the second is called LineOnOffDash (no alternate color); the third is called LineDoubleDash (the user can then see : color, dash and alt color). 
On the Go Polyline draw, the user can see the choosen value of the lineStyle.
.br
By default, lineStyle is set to LineSolid (no dash).
.IP \(em 3
The capStyle : To modify the capStyle, the user must click in the specific widget named CapStyle, and then select one of the posssible capStyle by clicking on the corresponding Button. There are three possible capStyle: the first is called CapButt; the second is called CapRound; the third is called CapProjecting. On the Go Polyline draw, the user can see the choosen value of the capStyle. 
.br
By default, capStyle is set to CapButt.
.IP \(em 3
The joinStyle : To modify the joinStyle, the user must click in the specific widget named JoinStyle, and then select one of the posssible joinStyle by clicking on the corresponding Button. There are three possible joinStyle: the first is called JoinMiter; the second is called JoinRound; the third is called JoinBevel. On the Go Polyline draw, the user can see the choosen value of the joinStyle. 
.br
By default, joinStyle is set to JoinMiter.
.IP \(em 3
The dash : To modify the dash, the user must click in the specific widget named Dash, and then select one of the posssible dashes by clicking on the corresponding Button. On the Go Polyline draw, the user can see the choosen dash (if LineStyle is set to LineOnOffDash or LineDoubleDash).
.br
By default, the dash is set to the first dash of the dash GoStream File (see below the GoStream file for the Dash Menu in FILE part).
.br
There is also a specific Button called "Paste". If the Application Developper wants a specific dash which is not defined in the dash Menu, he can defined it with the godash editor, copy it to the clipboard with the Copy Button of the godash editor, and then Paste it with this specific Button of the gopen editor. If there is a problem with the clipboard or if the object present in the clipboard is not a shared dash, a report is written in the Command Report part.
.SH
.IP
When the Application Developper have choosen a pen, he must give first a name to this pen before saving it in a dictionnary. To give a name to this pen, he must click in the specific widget named Pen Mame, then type the name and RETURN (or ENTER).
.sp
Warning : The pen name is not stored until RETURN (or ENTER) is typed !
.sp
Then, the Application Developper can save this pen by using the Add Button of the dictionnary part (see the Dictionnary Part). 
.sp
He can also copy this pen for another editor in the clipboard by using the Copy Button of the Menu Bar (see the Menu Bar Part). To use the clipboard, it is not necessary to give a name to the current pen.
.br
 If the current has a name, a "nammed" pen is copied to the clipboard.
.br
 If the current has a no name, a "unnammed" pen is copied to the clipboard.
.SH
\fBENVIRONMENT\fP
.IP
\fBGoENVIRON\fP is a shell variable used to find :
.RS 8
.IP \(em 3
files used by gopen and other applications.
.sp
(See Installation Guide for more informations).
.RE 2
.RE
.sp1
.SH
\fBFILES\fP
.IP
\fBgopen\fP needs a Motif resources file and three GoStream files to run correctly. These files are :
.RS 8
.IP \(em 3
\fBXmGopen\fP
.sp
This file is the Motif resources file.
.br
If the user wants to specify a specific GoStream file for the color Menu, the user has to modify, in the XmGopen file, the resource \fBXmGopen*colorMenuFile\fP with the specific GoStream file.
.br
If the user wants to specify a specific GoStream file for the altColor Menu, the user has to modify, in the XmGopen file, the resource \fBXmGopen*altColorMenuFile\fP with the specific GoStream file.
.br
If the user wants to specify a specific GoStream file for the dash Menu, the user has to modify, in the XmGopen file, the resource \fBXmGopen*dashMenuFile\fP with the specific GoStream file.
.sp
The user can use three different ways to load the XmGopen file:
.RS 8
.IP \(em 3
Make "xrdb -merge XmGopen" to initialize the server resource manager.
.IP \(em 3
Initialize the XENVIRONMENT variable.
.IP \(em 3
Put XmGopen file in the directory "/usr/lib/X11/app-defaults"
.sp
.RE
.IP \(em 3
\fBmyColor.bstr\fP, \fBmyAltColor.bstr\fP and \fBmyDash.bstr\fP.
.sp
These files are BINARY GoStream files.
.sp
\fBmyColor.bstr\fP and \fBmyAltColor.bstr\fP are used by the Color and Alt.Color menus. These files contain shared colors (black, blue, cyan, green, purple, red, white, yellow) and these colors are displayed in the Color and Alt.Color menus. If the user wants more (or less) colors in these menus, he can define specific colors by using the color Editor : gocolor and then change the resource \fBXmGopen*colorMenuFile\fP (and \fBXmGopen*altColorMenuFile\fP) with his specific GoStream file.
.sp
\fBmyDash.bstr\fP is used by the Dash menu. This file contain three shared dashes, and these dashes are displayed in the Dash Menu. If the user wants more (or less) dashes, he can define specific dashes by using the dash Editor : godash and then change the resource \fBXmGopen*dashMenuFile\fP with the specific GoStream file.
.sp
These files have to be in one of the following directories:
.RS 8
.IP \(em 3
"."
.IP \(em 3
"$GoENVIRON/app-files/gopen"
.IP \(em 3
"/usr/local/lib/Go/app-files/gopen"
.RE 2
.RE
.sp1
.nrPN \n%
