.\" $Id: ch05.ms,v 1.1.1.1 1992/03/18 09:37:07 uep Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.bp
.NH1
PREDEFINED \s12Go\s0's
.NH2
Predefined Go Classes
.LP
The \fBGo\fP libraries also includes a set of predefined \fIGo's\fP. These
objects can be used when writing \fBGo\fP based applications, the \fIGo
Reference Manual\fP gives a complete description for programming issues.
Predefined \fIGo's\fP can be used for subclassing by \fIGo writers\fP, the
\fIAdvanced Programmer's Manual\fP intends to give the necessary information.
.NH2
Predefined Go Class Hierarchy
.LP
Following figures show the predefined \fIGo\fP classes:
.DS B
.PS
down
Box3: box height 0.50i width 1.0i "Go*"
line down .3i
line left 2.5i
line down .30i
Box4: box height 0.50i width 1.0i "GoGeometric"
move up .8i
move right 1.25i
line down .3i
Box5: box height 0.50i width 1.0i "GoTextual"
move up .8i
move right 1.25i
line down .3i
Box6: box height 0.50i width 1.0i "GoImage"
move up .8i
line right 2.5i
line down .3i
Box7: box height 0.50i width 1.0i "GoTree"
move up .8i
move left 1.25i
line down .3i
Box8: box height 0.50i width 1.0i "GoGraph"
.PE
.DE
.DS C
\fIfigure 5.1 : Predefined Go Class Hierarchy\fP
.DE
.FS
* Actually, a \fIGo\fP subclass defining how the \fIGo\fP data are stored.
In order to allow ``lightweight'' \fIGos\fP implementation, the \fIGo\fP
does not store any data but protected methods for accessing them. It is the
reason why the predefined \fIGos\fP use \fIGos\fP subclasses like 
\fIGoGraphStruct\fP for \fIGraph\fP and \fITree\fP classes and
\fIGoStdDS\fP for others.
.FE
.sp 3
.DS B
.PS
down
line down 0.3i
Box3: box height 0.50i width 1.0i "GoTextual"
line down .3i
line left 1.25i
line down .30i
Box4: box height 0.50i width 1.0i "GoLabel"
move up .8i
move right 1.25i
line down .3i
Box5: box height 0.50i width 1.0i "GoSimpleText"
line down .3i
Box55: box height 0.50i width 1.0i "GoScrolledText"
move up 1.6i
line right 1.25i
line down .3i
Box6: box height 0.50i width 1.0i "GoText"
.PE
.DE
.DS C
\fIfigure 5.2 : Textual Go Class Hierarchy\fP
.DE
.sp 1
.DS B
.PS
line down 0.3i
Box0: box height 0.50i width 1.0i "GoGeometric"
line down .3i
line right 2.0i
line down .3i
box height .5i width 1.0i "GoArc"
line down .3i
box height .5i width 1.0i "GoEllipse"
line down .3i
box height .5i width 1.0i "GoCircle"
move up 2.4i
move left 2.0i
line left 1.0i
line down .3i
Box10:box height .5i width 1.0i "GoPolypoint"
line down .3i
line left 1.5i
line down  2.5i
box height .5i width 1.0i "GoCurve"
line down .3i
line left .5i
line down .3i
box height .5i width 1.0i "GoBezier"
move up .8i
move right .5i
line right 1.2i
line down .3i
box height .5i width 1.0i "GoCubic"
line down .3i
line left 1.54i
line down .3i
box height .5i width 1.0i "GoCardinal"
move up .8i
move right 1.3i
line down .3i
box height .5i width 1.0i "GoBSpline"
move up .8i
move right .24i
line right 2.36i
line down .3i
box height .5i width 1.0i "GoBetaSpline"
move up .8i
move left 1.3i
line down .3i
box height .5i width 1.0i "GoTauSpline"
move to Box10 down 0.55i
line right 1.0i
line down .3i
box height .5i width 1.0i "GoPolyline"
line down .3i
line left 1.2i
line down .3i
box height .5i width 1.0i "GoLine*"
move up .8i
move right 1.2i
line right 0.5i
line down 0.3
box height .5i width 1.0i "GoPolygon"
line down 0.3
line left 1.0i
line down .3i
box height .5i width 1.0i "GoRectangle"
move up .8i
move right 1.0i
line right 1.0i
line down .3i
box height .5i width 1.0i "GoRegPolygon"
line down .3i
box height .5i width 1.0i "GoSquare*"
.PE
.DE
.DS C
\fIfigure 5.3 : GoGeometric Class Hierarchy\fP
.DE
.FS
* Not yet available.
.FE
.bp
.NH2
GoGeometric Class And Subclasses
.LP
\fBGoGeometric\fP is the base class of all geometric objects. It is an abstract
class, which means that instances cannot be created unless they belong to a
subclass. Geometric objects are polylines, curves, arcs...
.LP
A \fIGoGeometric\fP is defined by a shape, visible or not and possibly filled.
This class manages the graphic attributes of the shape (outline) through a
\fIPen\fP and the filling attributes (background) through a \fIBrush\fP. The
implementation of the shape is subclass dependent : \fIGoRectangle\fP defines
its shape as a rectangle. Pens and brushes may be shared between several
objects.
By default, a \fIGoGeometric\fP is created with the standard \fIPen\fP and
\fIBrush\fP default values, has a visible outline and is not filled. 
Pre and postconditions on \fISharedObject\fP methods allow to control the pen
or brush modifications.
.LP
\fIGoPolypoint\fP and \fIGoArc\fP are directly subclassed from
\fIGoGeometric\fP as shown in the subclass hierarchy on \fIfigure 5.3\fP.
.NH3
GoPolypoint Class And Subclasses
.LP
\fBGoPolypoint\fP is an abstract class (instances cannot be created unless
they belong to a subclass). It inherits behavior from \fIGoGeometric\fP. A
\fIGoPolypoint\fP is an geometric object that can be defined by a list of
points (called \fIcontrol points\fP), like polylines, polygons and curves.
Consecutive control points may be connected by lines (see \fIGoPolyline\fP
class and subclasses) or approximated (or interpolated) by curves (see
\fIGoCurve\fP class and subclasses). The control points are relative to the
\fIGoPolypoint\fP coordinate system. Unless otherwise specified in subclasses,
this coordinate system is not related to the absolute position of the control
points. In other words, nothing keeps the \fIGoPolypoint\fP coordinate system
in the object bounding box, but actions on this coordinate system (\fImove\fP()
for instance) will still affect control points absolute position.
.LP
\fBGoPointSensor\fP is a subclass of \fIGoSensor\fP dedicated to
\fIGoPolypoint\fP
control points interactive manipulation (move, insert, delete or any user
defined action)
.LP
Pre and postconditions allow to control and be notified when the list of
control points is modified.
.NH4
GoPolyline Class And Subclasses
.LP
A \fBGoPolyline\fP is a \fIGoPolypoint\fP whose consecutive control points are
connected by segments. Line drawing attributes (join style, line width etc) are
inherited from \fIGoGeometric\fP. \fIGoPolyline\fP provide two attributes,
\fIround\fP and \fIroundOffset\fP, in addition to the \fIPen\fP and \fIBrush\fP
attributes inherited from \fIGoGeometric\fP. They allow to draw rounded corners
between connected lines.
.sp 1
.LP
Only one class is directly subclassed from \fIGoPolyline\fP :
.IP \fBGoPolygon\fP
It is a closed polyline : an extra segment is drawn from the last control point
to the first one.
.LP
\fIGoPolygon\fP subclasses:
.RS .3i
.IP "\fBGoRegPolygon:\fP"
it is a polygon whose edges have equal length and define equal angles in the
object coordinate system. The origin of this coordinate system gives the
position of the center of the regular polygon. Thus a \fIGoRegPolygon\fP could
be determined by a radius, an angle (both giving the position of the first
control point) and the number of control points.
.IP "\fBGoRectangle:\fP"
it is a four points polygon whose consecutive edges are orthogonal in the object
coordinate system. The origin of this coordinate system gives the absolute
position of the first control point. Thus a \fIGoRegPolygon\fP could
be determined by two numbers : width and height.
.RE
.NH4
GoCurve Class And Subclasses
.LP
The \fBGoCurve\fP class is the base for curve object subclasses, \fIGoCurve\fP
instances cannot be directly created. \fIGoCurve\fP consecutive points may
or may not belong to the curve depending of the subclass.
.sp 1
.LP
Subclasses of \fIGoCurve\fP are :
.IP "\fBGoBezier:\fP"
a general order bezier curve. A n-th order bezier curve is an interpolating
spline characterized by n+1 control points. Bezier curve control points do not
belong to the drawn curve.
.IP "\fBGoCubic:\fP"
the base class for all curves made up of one or more cubic curve segments. The 
closeness of any \fIGoCubic\fP subclass curve to its control polygon can be
varied by a changing a parameter called \fItension\fP.
The following subclasses are provided :
.RS .3i
.IP "\fBGoCardinal:\fP"
an interpolating spline with tension.
.IP \fBGoBSpline:\fP
an approximating spline with tension.
.IP \fBGoTauSpline:\fP
a tensed interpolating spline like \fIGoCardinal\fP with an additional parameter
called \fIbias\fP. By changing the \fIbias\fP the symmetry of the curve near
the control points can be altered.
.IP \fBGoBetaSpline:\fP
a tensed approximating spline like \fIGoBSpline\fP with the additional
\fIbias\fP like \fIGoTauSpline\fP.
.RE
.NH3
GoArc Class And Subclasses
.LP
\fBGoArc\fP directly inherits from \fIGoGeometric\fP class. It defines
elliptical arc objects. The origin of the object coordinate system gives the
absolute position of the center of the ellipse. Thus a \fIGoArc\fP may be
determined by four numbers : two radii, \fIradiusX\fP and \fIradiusY\fP
(both positive) and two angles \fBamplitude\fP and \fBstart\fP (both possibly
negative). A chord or a pie may be optionally drawn and/or filled by setting
the additional attributes \fIpie\fP and \fIclosed\fP (\fIpie\fP says if the
object has the shape "arc chord" or "arc pie" and \fIclosed\fP says if
additional segment(s) must be drawn to closed the arc according to \fIpie\fP
recommendations).
.LP
Pre and postconditions may be set for controlling arc modifications.
.LP
Subclasses of \fBGoArc\fP are:
.IP \fBGoEllipse:\fP
a full ellipse arc (the arc amplitude is 2*PI). It may be determined by its two
radii.
.RS .3i
.IP \fBGoCircle:\fP
a full circle (a \fIGoEllipse\fP whose radii are equal). It may be determined
by one radius.
.RE
.bp
.NH2
Textual Class and Subclasses
.LP
The \fBGoTextual\fP class is the base class for all textual object classes, and
instances cannot be directly created. Textual
objects are able to manage text.
.LP
Text attributes are defined by one or more \fITextBrush\fP objects and an
optional background may be drawn by using \fIBrush\fP objects. The
\fIGoTextual\fP offers a \fIBrush\fP in order to fill the text background,
a \fIPen\fP to draw the underline and a \fIPen\fP to draw the cursor (the
graphical representation of the insertion point).
Other graphical attributes are available: underline (thickness, position)
and presentation (none, lower case, upper case or title styles).
.LP
The \fIGoTextual\fP class specially defines methods in order to edit
pieces of text (insert, delete, replace, search, select, ...). Cut/copy/paste
operation will be provided at this level for all textual objects
(\fIa more general clipboard approach in Go will replace
this specific implementation\fP).
.LP
Pre and postconditions
allow to control and to be notified of any modification (text string,
text attributes and cursor movements).
.NH3
GoLabel Class
.LP
The \fBGoLabel\fP class defines one line text object. \fIGoLabels\fP are
the cheapest textual objects and are useful for drawing and editing individual
strings or words.
.NH3
GoSimpleText Class
.LP
The \fBGoSimpleText\fP class allows to create simple text objects. Simple text
means multi lines but mono font (only on \fITextBrush\fP) text object. Such objects
are not confined in a region, no line wrapping is available, the new line
character ``\fI\\n\fP'' is the line separator.
.LP
\fIGoSimpleText\fP objects inherit some presentation attributes from the 
\fIGoTextual\fP class (background, underline and case management). In addition, they
provide new attributes: interline spacing and justification (right, left or
center) styles).
.NH3
GoScrolledText Class
.LP
The \fBGoScrolledText\fP class provides a scrollable \fIGoSimpleText\fP.
The visible part is defined by a number of visible lines. Methods are
available to scroll up, scroll down, page up and page down the text in the view port. Other
methods are inherited from the \fIGoSimpleText\fP class.
.NH3
GoText Class
.LP
The \fBGoText\fP class defines multi fonts and multi lines text objects.
.LP
In a \fIGoText\fP object, the text is divided into text segments. A text
segment has its own attributes (\fITextBrush\fP for drawing text, 
\fIBrush\fP for drawing the background and \fIPen\fP for the underline).
.LP
As the \fIGoSimpleText\fP class, the \fIGoText\fP class offers interline
and justification attributes.
.LP
The \fIGoText\fP must be used with a text \fBFormatter\fP. Two formatters
are provided: a \fISimpleFormatter\fP or a \fIMCFormatter\fP (for
multi-columns). When a \fISimpleFormatter\fP is used, the behavior
of the \fIGoText\fP is about the same of the \fIGoSimpleText\fP (no confinement
and no line wrapping). When a \fIMCFormatter\fP is used, the \fIGoText\fP is
confined inside a box and may be divided in several columns with optional
word-hyphenation.
.bp
.NH2
GoImage Class
.LP
The \fBGoImage\fP class defines objects which are color or monochrome images.
Basicly, an image is a pixel array (\fIPixelArray\fP) and an image brush
(\fIImageBrush\fP) which has to be displayed in a given size (independently
of the pixel array size - resolution). Basicly The \fIImageBrush\fP gives the
colormap (\fIColormap\fP) information to display the pixel array.
.LP
In addition, any coordinate system transformation is allowed.
.LP
No method to modify the \fIGoImage\fP or the \fIImageBrush\fP are provided.
It is the responsibility of application to provide modifications of
\fIGoImage\fP resources. The object will be automatically notified when
resource modification occurs.
.bp
.NH2
GoGraph and GoTree Classes
.LP
The \fBGoGraph\fP class defines graph objects. A graph is defined a set of
nodes connected by links. \fIGoGraph\fP does not offer any service concerning
node placement but guarantees the link-node connections when node are moved.
.LP
The \fBGoTree\fP class defines tree objects. A tree is an oriented graph
where only one link arrives to a node. \fIGoTree\fP does not impose any
constraint on node placement but proposes predefined algorithms and
maintains the link-node connections.
.LP
In \fIGoTree's\fP, nodes are instances of the \fBGoTreeNode\fP class (subclass
of the abstract \fBGoNode\fP class). \fIGoTree\fP and \fIGoTreeNode\fP classes
provide methods in order to manage tree structures (insert, suppress, move ...
nodes, open, close subtrees, ...).
.LP
In \fIGoGraph's\fP, nodes are instances of the \fBGoGraphNode\fP class (subclass
of the abstract \fIGoNode\fP class). \fIGoGraph\fP and \fIGoGraphNode\fP
classes provide methods in order to manage graph structures (insert, suppress,
move, ... nodes).
.LP
\fIGoTreeNode\fP and \fIGoGraphNode\fP instances do not draw anything them selves.
The graphical appearance of a node is given by the \fIGo's\fP it contains (from
\fIGo\fP hierarchy point of view).
Thus, the graphical appearance of \fIGoNode's\fP can be structured graphics including
geometric, textual and image objects. In addition, \fIGoNode's\fP can be dynamically
editable by simply editing \fIGo subtrees\fP.
.LP
There is one link object class (\fBGoLink\fP) used to connect nodes either in
a graph or in a tree. As \fIGoNode's\fP, \fIGoLink\fP instances do not draw
anything themselves; their graphical appearance is given by \fIGo's\fP
in their \fIGo subtree\fP. So, as \fIGoNode's\fP,
\fIGoLink's\fP can be edited. 
.LP
Graphical appearances of \fIGoNode's\fP and \fIGoLink's\fP can be also
obtained by subclassing \fIGoGraphNode\fP, \fIGoTreeNode\fP and \fIGoLink\fP
classes (two subclasses of GoLink class are defined : \fBGoSimpleLink\fP and \fBGoBusLink\fP).
.LP
\fIGoGraph\fP, \fIGoTree\fP, \fIGoNode\fP and \fIGoLink\fP are \fIGo's\fP;
they may have \fISensors\fP and then sensitive area may be defined on them.
.LP
Pre and postconditions are available to control or to be notified when
a modification occurs in \fIGoGraph\fP or \fIGoTree\fP, \fIGoNode\fP
or \fIGoLink\fP  instances.
.bp
.NH3
GoComposite Class
.LP
The \fBGoComposite\fP class defines an \fIGo\fP object class which can be
used to ``\fIgroup\fP'' other graphic objects as children. The
\fIGoComposite\fP object does not draw any thing, it acts as any other
\fIGo\fP having \fIGo\fP children.
