.\" $Id: ch06.ms,v 1.4 1992/12/30 18:31:22 andre Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.bp
.NH1
\s12Go\s0 COMPANIONS
.LP
\fBGo\fP companions come with the libraries in order to extend the
development environment of the \fBGo\fP based applications.
Mainly, \fBGo\fP companions produce \fIGoStreams\fP which will be
used in the applications. These tools cooperate together and can exchange
information in \fIGoStreams\fP, they are designed to be integrated in
application development desktop.
.LP
There are to kinds of \fBGo Companions\fP: the \fIGo\fP editors
(\fBgodraw, gowrite, gopaint, gohyper\fP) and the resource editors
(\fBgopen, gobrush, godash, gopattern, gocolor, gotextbrush\fP).
.NH2
The Go Editors
.LP
All the \fIGo\fP editors follow the same design. They provide common
functionalities and specific functionalities.
.NH3
The Go Editors Common Functionalities
.IP "File Management"
\fIGoStream\fP files can be loaded, merged or saved. Independently of the
\fIGo\fP editor, all the graphical object classes can be loaded or saved
but the available editing functionalities depends on the editor. That means
\fBgowrite\fP can load a file containing \fIGoPolyline\fP objects but
cannot add or remove points in these objects.
.IP "Editing"
.br
The \fIGo\fP editors are able to make a number of modifications like
move, rescale, rotate, ... independently of the object classes. Cut/Copy/Paste
(for the clipboard) and Undo/Redo are also available. 
.IP "Association Management"
The \fBGo\fP editors allow to associate one or more semantic values
(\fIassociations\fP) to the
graphic objects at the designing and drawing time. These associations
are couples (\fIkey/values\fP), both are strings. The associations
are saved and restored along with the graphic objects, thus they
can be used by the applications at the execution time.
.IP "Printing"
.br
The \fBGo\fP editors allow to generate \fBPostScript\fP files containing
either the selected objects or the entire window.
.IP "Help Management"
An on-line help is also provided by the \fBGo\fP editors. It gives either
general information about \fBGo\fP and the editors or specific information
about command or object as well as contextual help.
.NH3
\s12godraw\fP
.LP
\fBGodraw\fP is a \fBGo\fP editor allowing the application developer to
interactively create basic objects and their attributes. When created, objects
can be stored in \fIGoStream\fP
files in order to be retrieved by applications when presenting their
data. \fBGodraw\fP is the necessary tool for builting beautiful
graphical presentations.
.LP
\fBGodraw\fP is a Motif\u\s4TM\s0\d application and follows the \fIMotif Style
Guide\fP.
The following sections give some details of the possibilities of the
editor.
.IP "Creating Predefined Gos"
A icon palette allows the user to choose among the predefined \fBGo's\fP:
polylines, polygons, regular polygons, rectangles, squares, arcs, ellipses,
circles, simple or multifont texts, images, bezier and various spline curves.
.IP
After created, the object geometry can be modified either using the
"Edit" menu commands or by using mouse and keyboard accelerators on the
object. Modifications include commands like \fImove, rescale,
rotate, align, deform\fP. The \fIUndo\fP command allows to restore
previous object status.
.IP
Class dependent attributes can be modified by using class specific
popup menus. For example, when pressing  the right button on a polyline,
a popup menu appears allowing to edit the polyline attributes (\fIpoint
number or positions, round offset, ...\fP).
.IP "Structure Management"
In \fBGo\fP, objects are organized in a object tree. One of the consequences
of this organization is the possibilities to modify (\fIrescale, rotate,
move, ...\fP)
an entire subtree by manipulating on the subtree root coordinate system.
.IP
\fBGo\fP editors provide functionalities in order to build such \fIGo\fP
subtree which can be seen by the user as ``complex \fIGo's\fP''. Thus, it is
possible to move, rotate, rescale, ... these \fIGo's\fP subtrees exactly like
simple \fIGo's\fP.
.IP
\fIGo's\fP inside a subtree are still editable until that the \fIGo\fP
subtree becomes a \fIleaf\fP. That allows to group objects, to continue
to edit them and finally to ``freeze'' the editing.
.IP "Setting Attributes"
Attribute forms allow to define default attributes when creating a new object
(\fICurrent Attributes\fP) or to modify attributes of some selected
objects. Attributes are \fIPen\fP (for outline object attributes),
\fIBrush\fP (for background object attributes) and \fITextBrush\fP 
(for text objects).
.IP
One of the useful features provided by \fBGo\fP is the shared resource
naming. With \fBgodraw\fP, it is possible to name \fIPen's\fP, \fIBrush's\fP
or \fITextBrush's\fP and use these named resources as object attributes.
This functionality allows to define common attributes for objects and
allows to update (by modifying such a named resource) all object attributes
in one operation. For example, if you are drawing a car, you can define
a pen called \fIwheel_pen\fP and a brush called \fIwheel_brush\fP which
will be used to draw the four wheels of the car. In \fBgodraw\fP, forms
are available to create, to save and to restore such named resources.
.IP
\fINote:\fP some attribute editings will be replaced by dedicated \fBGo\fP
companions (color, pixmap, dash, ...), all these tools cooperating
with \fBgodraw\fP.
.NH3
\s12gowrite\fP
.LP
This editor is dedicated for text editing (not for document
editing). It allows to create pieces of text and to format them in
sophisticated ways. Any kind of graphical objects can be imported
to be inserted in a piece of text.
.IP "Style Management"
\fBGowrite\fP provides a style editor which allows the user to manage (add,
remove, modify) and name any combination of text attributes (string
font / color / lineHeight / baselinePosition, underline color / thickness /
 position and background color).
.IP "Format Edition"
\fBGowrite\fP provides a format editor dedicated to the creation, modification
 save and restore of predefined frames which may be multi-columns (like news
 papers), multi-boxes, or circles.
.IP "Inclusion / Insertion"
The user can include any kind of object inside a line with the same behaviour 
than typing a new word. Also, it is possible to insert an object, and 
constraint the text string to be displayed around the object clip. For
instance, the user can insert a picture in a multi-columned framed text, 
creating then a new format.
.IP "Text Attributes Edition"
A form lets the user to edit text attributes such as justification, interline,
margins sizes, background and cursor colors.
.IP "Formatters Attributes Edition"
A form lets the user to edit formatter attributes such as word hypenation 
rules, indentation and justification parameters (See KNUTH Art of Programming).
.NH3
\s12gopaint\fP
.LP
This editor is dedicated for image editing. Any kind of graphical objects
can be imported to be inserted in an image.
.NH3
\s12gohyper\fP
.LP
This editor is dedicated for behavior editing. With \fBgohyper\fP, the
application developer can import \fIGoStream\fP files containing graphical
shemes and create sensitive areas (\fIGoHyperSensors\fP). Attached to these
sensors, scripts describing the behavior can be writen and played. \fBgohyper\fP can be considered as a base for authoring systems.
.IP "Creating Hyper Sensors"
Polygonoidal sensors, rectangular sensors, ellipsoidal sensors or full sensors can be created. The full sensors completely sensitive their parent. The others sensors sensitive a part of their parent. 
.IP 
After created, the object geometry can be modified by using mouse and keyboard accelerators on the object. Modifications include commands like \fImove, rescale and rotate\fP. The \fIUndo\fP command allows to restore previous object status.
.IP "Naming Hyper Sensors"
The default sensor name can be changed by using the Sensor menu. The sensor name defines the used interaction.
.IP "Showing/Hiding Sensors"
Sensors can be visible or not. In any case, the visibility does not change the
sensitivity.
.IP "Editing Scripts"
Scripts can be associated to Hyper Sensors. They are edited by using a specific script editor. They can be saved, restored and played.
.IP "Setting Hyper Sensors Attributes"
A menu allows to modify attributes of selected sensors. Attributes are \fIPen\fP (for outline sensor attributes) and \fIBrush\fP (for background FULL sensor attributes).
.NH2
The Resource Editors
.LP
The resource editors are resource servers for \fBGo\fP based applications.
Resources are colors, pens, brushed, dashes, patterns, textbrushes and
are exchanged using binary \fIGoStreams\fP through the clipboard.
.NH3
The Resource Editor Common Functionalities
.LP
All the resource editors share a number of functionalities.
.IP "Resource Dictionaries"
Resources can be loaded/saved from/to files which are seen as resource
dictionaries. This allows to classify resources in various set which can
be retrieved when needed (examples: pens for CAD can be gathered in one
file).
.IP
Of course new edited resources can be added in the current dictionary, existing
resources can be removed from the current dictionary.
.IP "Exporting Resource To Applications"
Resources are exported to the application by using the clipboard (typically
\fICopy\fP).
.IP "Help Management"
An on-line help is also provided by the resource editors. It gives either
general information about the editors or specific information
about command as well as contextual help.
.NH3
\s12gopen\fP
.LP
This editor allows to edit a pen object. This object is composed by two colors, a line width, a dash, a pattern.
.NH3
\s12gobrush\fP
.LP
This editor allows to edit a brush object. This object is composed by two colors and a pattern.
.NH3
\s12gocolor\fP
.LP
This editor allows to edit a color by using RGB or HSV values or by making a graduate between two colors ...
.NH3
\s12godash\fP
.LP
This editor allows to edit a dash object.
.NH3
\s12gopattern\fP
.LP
This editor allows to edit a pattern object.
.NH3
\s12gotextbrush\fP
.LP
This editor allows to edit a textbrush object. This object is composed by two colors, a font and a pattern.
