.\" $Id: glossary.ms,v 1.2 1992/12/28 15:48:13 davy Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.bp
.SH
GLOSSARY
.sp 1
.IP "\fIAbsolute Coordinate System\fP"
The absolute coordinate system of the \fBGo\fP universe is (0,0)(1,0)(1,0)
(unit = mm). By extension, the absolute coordinate system of a \fIGo\fP
instance is defined as the coordinates of its own coordinate system relatively
to the reference coordinate system described above.
.IP "\fIAbstract Class\fP
An abstract class is an ordinary object class except the fact that instances
cannot be directly created; they have to be subclass instances. Abstract
classes allow to give a common behavior to a set of subclasses (i.e \fIGo\fP,
\fIGoInterf\fP, \fIGoStream\fP, \fISharedObject\fP, ...)
.IP \fIAssociation\fP
.br
An association is a mechanism provided to applications to associate
opaque data with a access key. Associations are stored and managed by
\fIGAssoc\fP class instances. For example, \fIGo's\fP
maintain an \fIAssoc\fP instance, so applications are
able to link private data to graphic objects.
.IP \fIBGo\fP
.br
\fIBGo\fP is the generic word for the predefined \fIGo\fP set.
.IP \fIBrush\fP
.br
A \fIBrush\fP is an instance of the \fIGBrush\fP class. It provides a regular
interface for the shared object \fIShBrush\fP. A \fIBrush\fP defines all
needed attributes to fill areas (colors, patterning, ...).
.IP \fICallback\fP
.br
Callbacks are procedures provided by applications and triggered by
a given event (not necessary a user input).
.IP "\fIClass and Subclass\fP"
.br
Classes and Subclasses define prototypes for object instances. A subclass
can inherit data and methods from one or several super classes.
.IP "\fIClipping Region\fP"
.br
The clipping region is a list of rectangular areas which represents
the overall dimensions of \fIGo's\fP or \fIGo (sub)tree's\fP.
.IP \fIColor\fP
.br
A color is an instance of the \fIGColor\fP class. It provides a regular
interface
for the shared object \fIShColor\fP. A color may be defined by a set of three
values: RGB, gray value, halftone.
.IP \fIColormap\fP
.br
A colormap is an instance of the \fIGColormap\fP class. It provides a regular
interface
for the shared object \fIShColormap\fP. A colormap is a color table used to 
draw pixel arrays.
.IP "\fICoordinate System\fP"
.br
A coordinate system (or \fICoordSys\fP) is defined by an origin \fIO\fP and
two vectors \fII\fP and \fIJ\fP.
\fIGo's\fP dimensions and positions are expressed relatively to their own
coordinates systems. A \fIGo\fP coordinate system is expressed either
in the \fIGo\fP parent coordinate system or in the absolute \fIGo\fP coordinate
system. A \fICoordSys\fP is an instance of the \fIGCoordSys\fP class.
.IP \fIFont\fP
.br
A \fIFont\fP is an instance of the \fIGFont\fP class. It provides a regular
interface for the shared object \fIShFont\fP. A \fIFont\fP defines
font attributes for text drawing.
.IP \fIGEvent\fP
.br
\fIGEvents\fP are the result of user inputs. They are dispatched
by \fIGoUI\fP to the \fIGoSensors\fP to be interpreted by the
\fGInteractorPgm\fP.
.IP \fIGInteractor\fP
.br
The \fIGInteractor\fP object class is the abstract class for all
interactions. An interaction is started by a sensor and executes
an interaction program (\fIGInteractorPgm\fP instance).
.IP \fIGInteractorPgm\fP
.br
The \fIGInteractorPgm\fP object class is the abstract class for all
interaction programs. They give the implementation of an interaction
(\fGInteractor\fP). An interaction program can shared by several interactions.
.IP \fIGo\fP
.br
A \fIGo\fP is an instance of the \fIGo\fP (sub)class. It is the generic 
word for all graphic objects.
.IP "\fIGoAscii\fP"
.br
A \fIGoAscii\fP is an instance of the \fIGoAscii\fP class which is
a subclass of the \fIGoStream\fP class. It stores or retrieves objects
in a readable ASCII format.
.IP "\fIGo Based Application\fP"
.br
An application using \fBGo\fP for the external graphical representation
of its objects/data, is called \fIGo based application\fP.
.IP "\fIGoBinary\fP"
.br
A \fIGoBinary\fP is an instance of the \fIGoBinary\fP class which is
a subclass of the \fIGoStream\fP class. It stores or retrieves objects
in a binary format.
.IP "\fIGo Companion\fP"
An application which comes with \fBGo\fP in order to extend the
development environment of the \fIGo based application\fP developers.
.IP \fIGoENVIRON\fP
.br
The Shell variable which can be used in order to retrieve \fIGo\fP
application files (see \fIGo Installation Guide\fP).
.IP \fIGoInterf\fP
.br
The \fIGoInterf\fP class is the base for subclasses which implement the
interface between \fBGo\fP and graphic/window
systems. \fIGoInterf\fP subclasses are \fIXGoInterf\fP (for the X
Window System), \fIPSGoInterf\fP (for a PostScript language generator), ...
.IP "\fIGo kernel\fP"
.br
This term is used to identify a set of object classes constituting the
\fBGo\fP definition (i.e. \fIGo\fP, \fIGoInterf\fP, \fIGoUI\fP,
\fIGoSensor\fP ... classes).
.IP "\fIGo leaf\fP"
.br
A \fIGo leaf\fP is a \fIGo subtree\fP which is seen as a single \fIGo\fP.
.IP \fIGoRoot\fP
.br
A \fIGoRoot\fP is an instance of the \fIGoRoot\fP class, it allows
to connect a \fIGo subtree\fP to a \fIGoInterf\fP.
.IP \fIGoSensor\fP
.br
A \fIGoSensor\fP is an instance of the \fIGoSensor\fP class. See also
\fISensor\fP below.
.IP "\fIGo tree\fP"
.br
\fIGo's\fP are organized in a hierarchy called a tree
or a subtree.
A \fIGo\fP instance may have a parent, a previous brother, a next
brother and children. The tree root may be an ordinary \fIGo\fP instance
or a \fIGoRoot\fP instance.
.br
\fIWarning:\fP Don't make the confusion with \fIGoTree\fP which is an
instance of the \fIGoTree\fP class.
.IP \fIGoStream\fP
.br
A \fIGoStream\fP is an instance of a \fIGoStream\fP subclass. A \fIGoStream\fP allows
to save/restore (export/import) objects to/from a \fImedium\fP. The
external format depends of the \fIGoStream\fP subclass and is hidden to
\fIGo's\fP.
.IP \fIGoUI\fP
.br
The term ``\fIGoUI\fP'' is used either for the object set involved in
the user interactions (that is to say: \fIGoUI, GoSensor, GInteractor,
GInteractorPgm\fP) or for the object class \fIGoUI\fP (which is
responsible to dispatch events coming in a given window to the
concerned sensor).
.IP "\fIGraphic and Window System\fP"
.br
A graphic and window system is the basic platform for graphic outputs
and inputs. A graphic and window system provides a set of functionalities
which will be used by the corresponding \fIGoInterf\fP subclass instance. 
.IP "\fIGraphic Object\fP"
.br
A graphic object is an instance of a \fIGo\fP (sub)class.
.IP "\fIGray Scale\fP"
.br
A gray scale value represents a gray color among 256 possible values. The
minimum value is 0 (black) and the maximum value is 255 (white). Such
a value is used in the color definition for gray scale output devices.
.IP \fIHalftone\fP
.br
An halftone is a monochrome \fIShPattern\fP which is used in a color definition.
Halftones replace colors on black and white screens.
.IP \fIImageBrush\fP
.br
A \fIImageBrush\fP is an instance of the \fIGImageBrush\fP class. It provides a
regular interface for the shared object \fIShImageBrush\fP. An \fIImageBrush\fP
mainly contains a colormap used to draw images.
.IP "\fIMedium\fP"
.br
A \fIMedium\fP is an instance of the \fIGMedium\fP class. It offers a
common interface for any kind of media (file, network, pipe, ...) and it is
used by the \fIGoStream\fP classes.
.IP "\fIMetaclasses\fP"
.br
Metaclasses define common behaviors at the class levels.
Metaclasses exist for every \fIGo\fP (sub)classes. Methods of the metaclass
can be accessed by \fI(go->metaclass())->methodName()\fP.
.IP \fIObject\fP
.br
An object is the generic word for any instance of a given class. An
object maintains internal data and provides \fImethods\fP to manipulate
it. A \fIconstructor\fP is a method to create a new instance
of an object. The \fIdestructor\fP is the method called
when an instance is deleted.
.IP "\fIOutput Device\fP"
.br
This term defines any medium (window, pixmap, file, memory, ...) 
used to perform graphic outputs through a \fIGoInterf\fP subclass instance.
.IP \fIPattern\fP
.br
A \fIPattern\fP is an instance of the \fIGPattern\fP class. It provides a regular interface
for the shared object \fIShPattern\fP. A pattern is mainly defined by a pixel
array and a colormap.
.IP \fIPen\fP
.br
A \fIPen\fP is an instance of the \fIGPen\fP class. It provides a regular
interface
for the shared object \fIShPen\fP. A pen defines attributes used to draws lines
or curves (line width, dashing, patterning, ...).
.IP \fIPostconditions\fP
\fIPostconditions\fP are callback procedures called \fIafter\fP the
\fIGo\fP modification method executions. They allow applications to take some
decisions after \fIGo\fP modifications.
.IP \fIPreconditions\fP
\fIPreconditions\fP are callback functions called \fIbefore\fP
executing \fIGo\fP modification methods. These functions may accept
(return \fIGTRUE\fP) or refuse (return \fIGFALSE\fP) the method execution.
In some case, they are able to force the method parameters. Preconditions
are available at the instance level and at the class level.
.IP "\fIPredefined Go\'s\fP"
.br
In addition to the \fIGo\fP kernel, a set of predefined graphic object
classes is provided to \fIGo\fP based application programmers. Such
classes are \fIGoGeometric, GoText, GoImage, ...\fP.
.IP \fIPSGoInterf\fP
.br
A \fIPSGoInterf\fP is an instance of the \fIPSGoInterf\fP class. It is
a PostScript language generator and allows to store in a file the PostScript
representation of a \fIGo tree\fP.
.IP \fIRegion\fP
.br
A \fIRegion\fP is an instance of the \fIGRegion\fP class. It is defined by
a list of rectangular areas. \fIRegions\fP are used by \fIGo's\fP in
order to express their clipping area.
.IP \fIResources\fP
\fIResources\fP are shared objects used as \fIGo's\fP attributes (pen, brush,
font, color, ...).
.IP "\fIRGB values\fP"
.br
Red, Green and Blue (RGB) intensity values used in a color definition.
The structure \fIGRgb\fP is defined to manipulate these three values.
.IP \fISharedObject\fP
.br
A \fISharedObject\fP is an instance of a \fIGSharedObject\fP subclass. Such
objects maintain a reference count and may be shared between several other
regular objects. Such objects are often used for shared resources.
Existing \fISharedObject\fP subclasses are \fIShColor,
ShColormap, ShDash, ShPen, ShBrush, ShTextBrush, ShImageBrush, ShPixelArray,
ShPattern\fP).
.IP \fISensor\fP
.br
\fISensors\fP are instances of the \fIGoSensor\fP class. \fISensors\fP are
used to
create sensitive areas on \fIGo's\fP. Sensors receive events from the
\fIGoUI\fP instance and send them to the attached interactions.
.IP \fITextBrush\fP
A \fITextBrush\fP is an instance of the \fIGTextBrush\fP class. It provides a
regular interface for the shared object \fIShTextBrush\fP. A \fITextBrush\fP
defines all necessary attributes to draw text (font, patterning, ...).
.IP "\fIUser Input\fP"
.br
A user input is the result of an action on an input device. Such an action
generates a device dependent event (i.e. \fIXEvent\fP) which is translated into
a \fIGEvent\fP instance and delivered by \fIGoInterf\fP.
.IP "\fIWidget\fP
.br
A dialog object (form, dialog box, menu, ...) define in the X Window
System\u\s4TM\s0\d environments like Motif\u\s4TM\s0\d.
.IP \fIWinGoInterf\fP
.br
A \fIWinGoInterf\fP is an instance of the \fIGoInterf\fP class.
A \fIWinGoInterf\fP instance is the interface between \fIGo's\fP and a
MS-Window\u\s4TM\s0\d window.
.IP \fIXGoInterf\fP
.br
A \fIXGoInterf\fP is an instance of the \fIXGoInterf\fP class. A \fIXGoInterf\fP
is the interface between \fIGo's\fP and a X drawable (window or pixmap).
.IP \fIXmGoInterf\fP
.br
A \fIXmGoInterf\fP is an instance of the \fIXmGoInterf\fP class. It allows
to use \fBGo\fP in the Motif\u\s4TM\s0\d world.
