.\" $Id: preface.ms,v 1.3 1992/12/28 16:36:30 davy Exp $
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.OH "''GoPATH - Programmer\'s Guide''"
.EH "''GoPATH - Programmer\'s Guide''"
.ds CF -%-

.TL
\s36GoPATH\s0
.sp 30p
.br
\s18PROGRAMMER'S GUIDE\s0
.sp 20p
Version 1.2 - December 1992

.AU
Jacques Davy
.AI
Bull - Imaging & Office Solutions
\(co Bull S.A., 1990, 1991, 1992 Paris

.SH
PREFACE
.LP
The \fBGoPATH Programmer's Guide\fP gives a general presentation of
\fBGoPATH\fP, which is a graphical and interactive object oriented toolkit for
application data presentation and editing.
.LP
This guide is intended for new \fBGoPATH\fP
users who are \fBapplication developers\fP. It may be considered as
technical reference guide. The conceptual model and the architecture
are described along with the components.
.LP
The reader is not expected to be expert in graphic technology
or in object oriented programming but he/she is supposed to be familiar with
interactive applications and visual representation.
.LP
This guide has three complements: the
\fBGo Reference Manual\fP which is needed to write \fBGo\fP based
applications, the \fBGo Advanced Programmer's Manual\fP which is
required to create new graphic objects or to extend existing functionalities
of \fBGo\fP and the \fBGoPATH Installation Guide\fP for the genration and
installation of the software.
.sp 2
.LP
This manual is organized as follows:
.sp2
.in 0.5i
.br
Chapter 1:	End User Environment Description
.br
Chapter 2:	The Role of Go
.br
Chapter 3:	The Object Oriented Approach
.br
Chapter 4:	Go Description
.br
Chapter 5:	Predefined Go's
.br
Chapter 6:	Go Companions
.br
Chapter 7:	Using Go
.br
Glossary
.br
Abbreviations
.br
References
.in
.bp
.SH
TRADEMARK NOTICES:
.LP
This guide uses some or all of the following trademarks:
.IP
\fBUNIX\fP is a registered trademark of AT&T Bell Laboratories.
.IP
\fBX Window System\fP is a trademark of the Massachusetts Institute
of Technology.
.IP
\fBMotif\fP is a trademark of Open Software Foundation Inc.
.IP
\fBPostScript\fP is a registered trademark of Adobe Systems Inc.
.IP
\fBMS-DOS\fP is a trademark of Microsoft Corporation.
.IP
\fBWindows\fP is a trademark of Microsoft Corp.
.IP
\fBXView\fP is a trademark of Sun Microsystems Inc.
.IP
\fBOPEN LOOK\fP is trademark of AT&T.
.IP
\fBPresentation Manager\fP is a trademark of IBM Corp.
.IP
\fBOS/2\fP is a trademark of IBM Corp.
.sp 4
.ce
\fBPREAMBLE\fP
.sp 1
.LP
\fBGoPATH\fP is the new name of what we called \fBGo\fP. Like \fBGo\fP,
\fBGoPATH\fP components include a set of libraries (for graphical
application developpement) called \fIGo\fP libraries, a set of editors
(for graphical presentation design) called \fIGo\fP companions and the
documentation.
.LP
In order to promote \fBGoPATH\fP, a part of it is distributed on the network
with a restrictive copyright. Any commercial use of \fBGoPATH\fP is controled
by a \fBlicense\fP.
