.\" $Id: ChoosePoint.n,v 1.3 1992/12/29 11:56:29 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ChoosePoint 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBChoosePointPgm\fP \(em the common superclass program to choose a point.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/ChoosePoint.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGChoosePointPgm\fP inherits behavior from:
.RS 10
\fBGGrabberPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGChoosePointPgm\fP program is a Grabber program. Its purpose is to define a \fIcursor\fP to choose a point. We terminate the interaction only on BUTTON PRESS. The default cursor used during the interaction is GCURSOR_CROSSHAIR.
.br
See superclass to modify the wanted cursor.
.sp
The name of the program  "Go.choosePoint"
.sp 2
.nf
.ta .15i .25i 1.0i
class GChoosePointPgm : public GGrabberPgm
{
     public:
	static GChoosePointPgm* create();
	virtual GInteractor* start(const GEvent*, Go*);
	GEventMask inputmask() const;
};
.fi
.IP
GChoosePointPgm*  \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
The method creates a new GChoosePoint grabber, initializes and returns it.
.sp
.IP \fIevent\fP .5i
.br
Specifies the first \fIevent\fP.
.sp
.IP \fIgo\fP .5i
.br
Speficies the \fIgo\fP to be used to retreive the \fIinterf\fP. This \fIinterf\fP will be used to defined the wanted \fIcursor\fP.
.RE
.sp
.IP
GEventMask \fBinputMask\fP() const
.RS .8i
.IP \fIDescription\fP .5i
Returns the superclass \fIinputMask\fP except the GBUTTON_RELEASE_MASK.
.RE
.sp 2
.SH
\fBCLASS\fP
.IP
\fBGChoosePoint\fP inherits behavior from:
.RS 10
\fBGGrabber\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGChoosePoint\fP is a Grabber. Its purpose is to grab (see GoUI (3Go)) and to display a specific cursor
.br
.sp 2
.nf
.ta .15i .25i 1.0i
class GChoosePoint : public GGrabber
{
     public:
	GChoosePoint(GChoosePointPgm*, const GEvent*, Go);
	virtual void doit();
	virtual GBool isDoitEvent(const GEvent*) const;
	const GPoint& choosenPoint() const;
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGChoosePoint\fP(GChoosePointPgm* \fIpgm\fP, const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
Creates a new ChoosePoint interactor. \fIgo\fP is used to retreive the \fIinterface\fP to be used.
.RE
.IP
\fBdoit\fP()
.RS .8i
.IP \fIDescription\fP .5i
.br
The interactor  \fIreads\fP the current pointer position and updates its private variable.
.RE
.IP
GBool \fBisDoitEvent\fP(const GEvent* \fIevent\fP)
.RS .8i
.IP \fIDescription\fP .5i
.br
If the \fIevent\fP is GBUTTON_RELEASE_MASK it returns False otherwise it returns the result of  GGrabber::isDoitEvent().
.RE
.IP
const GPoint& \fBchoosenPoint\fP()
.RS .8i
.IP \fIDescription\fP .5i
.br
Returns the point read by the \fIdoit()\fP method. So the result is avaliable only if the interactor state is GITOR_DONE.
.sp 2
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The \fBGChoosePointPgm\fP is not instanciable. The \fIstart\fP method is not defined: It does not know which grabber to run.
.br
The purpose of the GChoosePoint grabber is to be subclassed (.e.g GEditRectangle).
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBGrabber (3Go), Cursor (3Go). \fP
.nrPN \n%
