.\" $Id: Circle.n,v 1.1.1.1 1992/03/18 09:38:12 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoCircle 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoCircle\fP \(em the Circle object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Circle.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoCircle\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoEllipse\fP class
.IP \(em 3
\fBGoArc\fP class
.IP \(em 3
\fBGoGeometric\fP class
.IP \(em 3
\fBGoStdDS\fP class
.IP \(em 3
\fBGo\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
A \fBGoCircle\fP object is a \fBGoEllipse\fP with the following constraint :
.RS 10
.IP \(bu 3
the \fIradiusX\fP and \fIradiusY\fP \fBGoArc\fP attributes have always the same value.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoCircle : public GoEllipse {

	public:

		GoCircleMetaclass* metaclass ();
		GoCircle* create ();
		GoCircle* create (GNumber);
		GoCircle (GNumber = 1);
		void radiusX (GNumber);
		void radiusY (GNumber);
		void reset (GNumber, GNumber = 0, GNumber = 0, GNumber = 0);
};
.fi
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGoCircleMetaclass\fP* \fBmetaclass\fP ()
.RS .8i
.IP \fIDescription\fP .3i
This static member function returns the \fBGoCircleMetaclass\fP instance.
.RE
.sp 1
.IP
.nf
\fBGoCircle\fP* \fBcreate\fP ()
\fBGoCircle\fP* \fBcreate\fP (GNumber \fIradius\fP)
.fi
.RS .8i
.IP \fIDescription\fP .3i
These static member functions are constructors with pre/postconditions.
They return a pointer on a new instance of \fBGoCircle\fP if no precondition
refuses the creation, else they return NULL;
.IP \fIradius\fP .3i
Specifies the circle radius value.
.RE
.sp 1
.IP
\fBGoCircle\fP (GNumber \fIradius\fP = 1);
.RS .8i
.IP \fIDescription\fP .3i
constructor
.IP \fIradius\fP .3i
Specifies the circle radius value.
.RE
.sp 1
.IP
.nf
void \fBradiusX\fP (GNumber \fIradius\fP);
void \fBradiusY\fP (GNumber \fIradius\fP);
void \fBreset\fP (GNumber \fIradius\fP, GNumber = 0, GNumber = 0, GNumber = 0);
.fi
.RS .8i
.IP \fIDescription\fP .3i
These methods have the same purpose : change the radius of the circle.
Note that only the first parameter is effective in method \fBreset\fP, other
parameters are ignored and may be omitted when calling the function.
.IP \fIradius\fP .3i
Specifies the circle radius value; if negative, nothing is done.
.RE
.SH
\fBC BINDING\fP
.DE
.SS 
\fBResources\fP
.IP
Inherited. See superclasses manual pages.
.SS 
\fBFunctions\fP
.IP
void \fBGoCircleInitialize\fP ();
.RS .8i
.IP \fIDescription\fP .3i
This function must be called before any use of the GoCircle C Binding.
.RE
.sp 1
.IP
.nf
GObjectId \fBGoCircleCreate\fP (GNumber \fIradius\fP);
GObjectId \fBGoCircleMetaclass\fP ();
.fi
.sp 1
.RS .8i
.IP \fIDescription\fP .3i
See \fBGoCircle\fP following members :
.sp 1
.nf
GoCircle* create (GNumber).
GoMetaclass* metaclass ().
.fi
.RE
.SH
\fBUSER INTERACTIONS\fP
.IP
Inherited.
.SH
\fBUSAGE INFORMATION\fP
.IP
If willing to use pre/postconditions on object creation,
one should use \fBGoCircle::create\fP instead of the public
\fBGoCircle\fP constructor; this is highly recommended.
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP, \fBGoArc\fP, \fBGoArcMetaclass\fP,
\fBGoEllipse\fP, \fBGoEllipseMetaclass\fP and \fBGoCircleMetaclass\fP classes.
.nrPN \n%
