.\" $Id: CircleForm.n,v 1.2 1992/12/28 10:33:18 andre Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH CircleFormatter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBCircleFormatter\fP \(em The circle formatter class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/CircleForm.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGCircleFormatter\fP inherits behavior from class \fBGFrFormatter\fP.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
When linked with a \fBGCircleFormatter\fP, a \fBGoText\fP is confined inside a circle.
.br
.sp 2
.br
.nf
.ta .15i .25i 1.50i

class GCircleFormatterCtxt::public GFormatterCtxt
{
public:

    void	radius (GNumber);
    GNumber	radius() const;
}

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
GNumber \fBGCircleFormatterCtxt::radius\fP() const
.br
void \fBGCircleFormatterCtxt::radius\fP (GNumber \fIr\fP)
.RS .8i
.IP \fIDescription\fP .5i
These functions are used to get/set the radius of the formatter.
.IP \fIr\fP .5i
.br
Value of the radius to set.
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
.br
.sp1
The \fBGoUI\fP object provides two functions to resize the radius of the 
formatter (See GoUI).
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cCircleForm.h>
.br
.SS
\fBFunctions\fP
.sp 1
.RE
.IP
GObjectId \fBGCircleFormatterCreate\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function creates an instance of the GCircleFormatter class.
.sp1
.RE
.SH
\fBSEE ALSO\fP
.IP
\fBGoText\fP, \fBGFormatter\fP, \fBGFrFormatter\fP, \fBGMCFormatter\fP, \fBGMBFormatter\fP and \fBGSimpleForm\fP classes.
.nrPN \n%
