.\" $Id: Curve.n,v 1.1.1.1 1992/03/18 09:38:22 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoCurve 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoCurve\fP \(em the Curve object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Curve.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoCurve\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoPolypoint\fP class
.IP \(em 3
\fBGoGeometric\fP class.
.IP \(em 3
\fBGoStdDS\fP class.
.IP \(em 3
\fBGo\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
\fBGoCurve\fP is a base class for all the curve sub classes. This class provides
the common functions for the sub classes like drawing the curve during
fast redraw, drawing of the curve during interactive manipulation of
control points, checking whether the curve contains a point etc. In order
to use these functions, the sub class has to implement the virtual
function 
.IP
GPoint* \fBgetCurvePoints\fP (int& \fIn\fP)
.br
which returns the points on the curve with a specified precision.
.IP
This object class has no public members at all, thus only subclasses have some
use of it.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoCurve : public GoPolypoint {

	public:

		static GoCurveMetaclass* metaclass();
};
.fi
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGoCurveMetaclass\fP* \fBmetaclass\fP ()
.RS .8i
.IP \fIDescription\fP .3i
This static member function returns the \fBGoCurveMetaclass\fP instance.
.RE
.SH
\fBC BINDING\fP
.DE
.SS 
\fBResources\fP
.IP
Inherited. See superclasses manual pages.
.SS 
\fBFunctions\fP
.IP
void \fBGoCurveInitialize\fP ();
.RS .8i
.IP \fIDescription\fP .3i
This function must be called before any use of the GoCurve C Binding.
.RE
.sp 1
.IP
GObjectId \fBGoCurveMetaclass\fP ();
.sp 1
.RS .8i
.IP \fIDescription\fP .3i
See \fBGoCurve\fP following members :
.sp 1
GoMetaclass* metaclass ().
.RE
.SH
\fBUSER INTERACTIONS\fP
.IP
Inherited.
.SH
\fBUSAGE INFORMATION\fP
.IP
\fBGoCurve\fP is an abstract class, thus it has no public constructor : creation
may only occur through subclasses constructors.
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP, \fBGoPolypoint\fP,
\fBGoPolypointMetaclass\fP and \fBGoCurveMetaclass\fP classes.
.nrPN \n%
