.\" $Id: EdArc.n,v 1.2 1992/12/31 15:13:04 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditArc 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditArcBeginPgm\fP, \fBEditArcEndPgm\fP, \fBEditArcRadiiPgm\fP, \fBEditArcRadxy\fP \(em the common superclasses programs for editing a Go Arc. They are grabber programs.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdArc.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP 
\fBGEditArcBeginPgm\fP 
.IP
\fBGEditArcEndPgm\fP 
.IP
\fBGEditArcRadii\fP 
.IP
\fBGEditArcRadxy\fP 
.IP 
\fBGMoveArcPointPgm\fP
.br
inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The above programs are grabber programs. The editing of an arc consists of changing \fParc\fP parameters without changing its \fIcoordinate system\fP. A modification is computed with the mouse position according the type of the wanted modification. For any modifications, preconditions are called prior the modification. If accepted, the modifications are done onto the \fIworking go\fP (see EdGeometric 3(Go)). If the interaction is not cancelled by the user, the \fIarc\fP to be edited will be reseted with the last accepted modification.
.br
Each programs provides a particular modification:
.RS .8i
.IP \fBBegin\fP .5i
change the \fPstart\fP angle of the arc.
.IP \fBEnd\fP .5i
change the last angle of the arc. This modification will modify the \fIamplitude\fP of the arc.
.IP \fBRadii\fP .5i
change the \fIradiusX\fP and the \fIradiusY\fP of the arc. Keep the two \fIradii\fP equal to have a \fIcircle\fP arc.
.IP \fBRadxy\fP .5i
change the \fIradiusX\fP and the \fIradiusY\fP of the arc. The two \fIradii\fP will follow the mouse position. This is to have an \fIellipse\fP arc.
.IP \fBMovePoint\fP .5i
determinate  if the user wants to modify the first angle: \fIeditBegin\fP or the last one \fIeditEnd\fP.
.RE
.sp
 The purpose of the programs is to defined:
.RS .5i
.br
The \fIname\fP of the program:
.IP "GoArc.editBegin" .5i
for GEditArcBeginPgm.
.IP "GoArc.editEnd" .5i
for GEditArcEnd.
.IP "GoArc.editRadii" .5i
for GEditArcRadiiPgm.
.IP "GoArc.edit" .5i
for GEditArcRadxyPgm.
.br
The name of the GEditRadxyPgm is "GoArc.edit" and not "GoArc.editRadxy" to provide a default editing program name. Here the default is to edit an arc like an ellipse.
.IP "GoArc.movePoint" .5i
for GMoveArcPointPgm.
.RE
.sp
The cursor used during interaction. The default cursor the cursor define by the superclass program: GEditGeometricPgm.
.br
.RE
.sp 2
.nf
.ta .15i .25i 1.0i

class GEditArcBeginPgm : public GEditGeometricPgm
{
	public:
	static GEditArcBeginPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};

class GEditArcEndPgm : public GEditGeometricPgm
{
	public:
	static GEditArcEndPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};

class GEditArcRadiiPgm : public GEditGeometricPgm
{
	public:
	static GEditArcRadiiPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};

class GEditArcRadxyPgm : public GEditGeometricPgm
{
	public:
	static GEditArcRadxyPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};

class GMoveArcPointPgm : public GEditGeometricPgm
{
	public:
	static GMoveArcPointPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditArcBeginPgm* \fBcreate\fB();
.IP
GEditArcEndPgm* \fBcreate\fB();
.IP
GEditArcRadiiPgm* \fBcreate\fB();
.IP
GEditArcRadxyPgm* \fBcreate\fB();
.IP
GMoveArcPointPgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoArc, the method creates a new GEditArc grabber with a \fImask\fP to define the wanted modification. It initializes it and returns it. If \fIgo\fP is not a subclass of GoArc it returns NULL.
.br
The \fPGMoveArcPointPgm\fP start method is a little bit particular. It computes itself if the user wants to edit the \fIfirst\fP or the \fIlast\fP angle. To do this it uses the \fIevent\fP position (if available) or the pointer position.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditArc\fP inherits behavior from:
.RS 10
\fBGEditGeometric\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditArc\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the arc editing programs. This grabber supposes that the \fIPen\fP read from the program  can be used to clear a drawing by drawing twice at the same place.
.sp 2
.nf
.ta .15i .25i 1.0i

/*
 * values for arc manipulation cf mask parameter
 */

#define G_DO_RADX     1<<0
#define G_DO_RADY     1<<1
#define G_DO_RADII    1<<2
#define G_DO_END      1<<3
#define G_DO_BEGIN    1<<4

class GEditArc : public GEditGeometric
{
	public:
	GEditArc (GEditArcPgm*, const GEvent*, GoArc*, int mask);
	virtual void  draw ();
	virtual void  doit ();
	virtual void  compute (const GEvent*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditArc\fP (GEditGeometricPgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoArc* \fIarc\fP, int \fImask\fP);
.RS .8i
.IP \fIDescription\fP .5i
Creates a new GEditArc grabber corresponding to wanted modification.
.IP \fIpgm\fP .5i
.br
Specifies the program to be used by this grabber.
.IP \fIevent\fP .5i
.br
Specifies the first event of the interaction.
.br
.IP \fIarc\fP .5i
.br
Specifies the arc to edit.
.IP \fImask\fP .5i
.br
Specifies the wanted modification.
.RE
.IP
void \fBdraw\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws  \fIWorkGo\fI (cf EdGeometric 3(Go)).
.RE
.sp
.IP
void \fBdoit\fP()
.RS .8i
.IP \fIDescription\fP .5i
The \fBdoit\fP method reads from the \fIWorkGo\fP the \fIradiusX, radiusY, start\fP and \fIamplitude\fP parameters and \fIresets\fP (cf GoArc 3(Go)) the \fIarc\fP to be edited.
.RE
.sp
.IP
void \fBcompute\fP(const GEvent* \fIevent\fP);
.RS .8i
.IP \fIDescription\fP .5i
The method calls the superclass \fIcompute\fP method. With the \fIevent\fP position it computes the new arc parameters according the wanted edition. It calls the \fIreset\fP preconditions with the computed value. If the modification is accepted is \fIresets\fP the \fIWorkGo\fP (cf GEditGeometric class).
.RE
.sp
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
The default arc editing program is called "GoArc.edit". It corresponds to a resize of the two \fIradii\fP of the arc (see GEditArcRadxyPgm program).
.br
Remember that "GoArc.editRadii" specifies a \fIcircle\fP edition and "GoArc.edit" specifies an \fIellipse\fP edition.
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditGeometric (3Go), GoArc(3Go).\fP
.nrPN \n%





