.\" $Id: EdGeometric.n,v 1.2 1992/12/28 13:07:45 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditGeometric 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditGeometricPgm\fP \(em the common superclass program for editing a Go Geometric. It is grabber program
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdGeometric.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditGeometricPgm\fP inherits behavior from:
.RS 10
\fBGGrabberPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditGeometricPgm\fP program is a Grabber program. Its purpose is to defined the \fIPen\fP and the \fIquality\fP to be used by geometric editor (.e.g GEditRectangle) at drawing time.
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditGeometricPgm : public GGrabberPgm
{
     public:
	 GPen& drawingPen() const;
	 GQuality drawingQuality() const;
         void     drawingQuality(GQuality quality);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GPen& \fBdrawingPen\fB() const;
.RS .8i
.IP \fIDescription\fP .5i
The method returns a reference to the \fIPen\fP used to draw a Go geometric during interaction. The default values of this \fPPen\fP are the default values of Pen (cf Pen (3Go)) except the \fIfunction\fP which is GINVERT. Modifing this \fPPen\fP provides a way to program the Pen during the edition of Go Geometric.
.br
Keep in mind that many grabbers using this program suppose that drawing something twice at the place clears the previous draw.
.RE
.sp
.IP
GQuality \fBdrawingQuality\fP() const
.br
void \fBdrawingQuality\fP(GQuality \fIquality\fP)
.RS .8i
.IP \fIDescription\fP .5i
These methods get/set the drawing quality used by editor of Go Geometric.
.RE
.sp 2
.bp
.SH
\fBCLASS\fP
.IP
\fBGEditGeometric\fP inherits behavior from:
.RS 10
\fBGGrabber\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditGeometric\fP is a Grabber. It purpose is to duplicate the Geometric to be edited and to program the duplicated Geometric with no background and with outline. The \fIPen\fP of the outline will be \fIread\fP from the GEditGeometric program.
.br
Subclasses of GEditGeometric can used the  duplicated Go to update its values (.e.g its width for a rectangle edition) and  to draw it.
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditGeometric : public GGrabber
{
     public:
	static	void* interactionKey();

    protected:
	GoGeometric* WorkGo();
	virtual   void Initialize();
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
void* \fBinteractionKey\fP () const
.RS .8i
.IP \fIDescription\fP .5i
The method returns an \fIunique\fP identifier. The duplicated Geometric is identified by getting the value associated to \fIinteractionKey\fP. This value will be the \fIgeometric\fP which is being edited.
.RE
.sp 2
.SH
\fBPROTECTED METHODS\fP
.IP
GoGeometric* \fBWorkGo\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns the \fIduplicated\fP Go used by subclasses to be updated during interaction. At drawing time, subclasses asks \fIWorkGo()\fP to draw itselft.
.RE
.sp
.IP
virtual void \fBInitialize\fP ()
.RS .8i
.IP \fIDescription\fP .5i
The method \fIduplicates\fP the go to be edited. It reparents the \fIduplicated Go\fP (\fIWorkGo()\fP) onto the GoRoot of the Go to be edited. the background of \fIWorkGo()\fP is removed, the outline of \fIWorkGo()\fP is used. The used \fIPen\fP is the Pen defined in the \fIGEditGeometricPgm\fP class.
.br
After it calls the superclass's Initialize method.
.RE
.sp 2
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The \fBGEditGeometricPgm\fP is not instanciable. The \fIstart\fP method is not defined: It does not know which grabber to run.
.br
The purpose of the GEditGeometric grabber is to be subclassed (.e.g GEditRectangle).
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBGrabber (3Go), Pen(3Go)\fP and subclasses.
.nrPN \n%
