.\" $Id: EdHandPLine.n,v 1.1 1992/12/29 09:45:33 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditHandPolyline 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditHandPolylinePgm\fP \(em the common superclass program for editing a Go Polyline. This is a grabber program.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdHandPLine.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditHandPolylinePgm\fP inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditHandPolylinePgm\fP program is a Grabber program. The free hand editing of a polyline consists of \fIadding\fP points inside the polyline. Each added point is computed from the \fIevent\fP position. Optimizations are done to do not take points where are too closed or which are on a same line.
.br
This program may be used to edit a GoPolyline (not a subclass). It does not work on subclass of polyline because the corresponding interactor \fIoptimizes\fP the drawing of the polyline: we do not draw all the polyline on each \fIevent\fP (see GEditGeometric).
.br
Note that this grabber does not call preconditions for each added point inside the polyline.
.br
 The purpose of the GEditHandPolylinePgm is to defined the \fIname\fP of the edit polyline program (see \fIcreate\fP method) and to \fIstart\fP the corresponding interactor.
.sp
The name of the program is "GoPolyline.handEdit".
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditHandPolylinePgm : public GEditGeometricPgm
{
	public:
	static GEditHandPolylinePgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditHandPolylinePgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a GoPolyline, the method creates a new GEditHandPolyline grabber, initializes and returns it. Otherwise it returns NULL.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditHandPolyline\fP inherits behavior from:
.RS 10
\fBGEditGeometric\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditHandPolyline\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the GEditHandPolyline program. This grabber supposes that the \fIPen\fP read from the program  can be used to clear a drawing by drawing twice at the same place.
.br
The grabber is used by GEditHandPolylinePgm.
.sp 2
.nf
.ta .15i .25i 1.0i

class GEditHandPolyline : public GEditGeometric
{
	public:
	GEditHandPolyline (GEditGeometricPgm*, const GEvent*, GoPolyline*);

	virtual void  compute(const GEvent*);
	virtual void  doit();
	virtual void  draw ();
	virtual void  drawAll ();
	virtual void  clear ();
	virtual void  clearAll ();
	
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditHandPolyline\fP (GEditGeometricPgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoPolyline* \fIpolyline\fP)
.RS .8i
.IP \fIDescription\fP .5i
Creates a new free hand polyline grabber.
.IP \fIpgm\fP .5i
.br
Specifies the program to be used by this grabber. The \fIPen\fP to draw during the interaction is read from this \fIpgm\fP.
.IP \fIevent\fP .5i
.br
Specifies the first event of the interaction. This \fIevent\fP will determinate the index of the current point.
.br
.IP \fIpolyline\fP .5i
Specifies the polyline to edit.
.RE
.sp
.IP
void \fBcompute\fP(const GEvent* \fIevent\fP);
.RS .8i
.IP \fIDescription\fP .5i
The  \fIcompute\fP method computes the position of a new point to be added inside the polyline at the current index. The position is computed from the \fIevent\fP position. If The new point is too closed from the current one, it is ignored; If  the new point, the current one and the previous one are on the same line the current point is replaced by the new one.
.br
Note that the \fIaddPoint\fP preconditions of the polyline are not called for this grabber.
.RE
.sp
.IP
void \fBdoit\fP();
.RS .8i
.IP \fIDescription\fP .5i
The  \fIdoit\fP method calls the \fIreset\fP method of the polyline to edit with the computed array of points.
.RE
.IP
void \fBdraw\fP();
.IP
void \fBclear\fP();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws only the \fIline\fP from the current point and the current position defined by \fIWorkGo\fP (see GEditGeometric::compute()).
.RE
.IP
void \fBdrawAll\fB();
.IP
void \fBclearAll\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method redraws all the updated polyline: \fIWorkGo\fP (see GEditGeometric::compute()).
.RE
.sp 4
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The GEditHandPolyline is available only for a GoPolyline and not subclasses.
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditGeometric (3Go), EditPolyline (3Go) and GoPolyline (3Go).\fP
.nrPN \n%





