.\" $Id: EdPolyline.n,v 1.3 1992/12/28 13:07:51 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditPolyline 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditPolylinePgm\fP, \fBMovePolylinePgm\fP \(em the common superclass program for editing a Go Polyline. They are grabber programs.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdPolyline.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditPolylinePgm\fP inherits behavior from:
.RS 10
\fBGEditPolypointPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditPolylinePgm\fP program is a Grabber program. The editing of a polyline consists of \fIadd\fP or \fIremove\fP points of the polyline, and \fImove\fP the current point. The button event used to add/remove is programmable. The current point is defined as the closest point which matches the first \fIevent\fP position.  The new point is inserted just after the computed index.
.br
This program may be used to edit a GoPolyline (not a subclass). It does not work on subclass of polyline because the corresponding interactor \fIoptimizes\fP the drawing of the polyline: we do not draw all the polyline on each \fIevent\fP (see GEditPolypoint).
.br
 The purpose of the GEditPolylinePgm is to defined the \fIname\fP of the edit polyline program (see \fIcreate\fP method) and to \fIstart\fP the corresponding interactor.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditPolylinePgm : public GEditPolypointPgm
{
	public:
	static GEditPolylinePgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditPolylinePgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoPolyline.edit".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a GoPolyline, the method creates a new GEditPolyline grabber, initializes and returns it. Otherwise it returns NULL.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGMovePolylinePgm\fP inherits behavior from:
.RS 10
\fBGMovePolypointPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGMovePolylinePgm\fP program is used to moving a point of a polyline. The point to move is the closest point which matches the first \fIevent\fP position.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GMovePolylinePgm : public GEditPolypointPgm
{
	public:
	static GEditPolylinePgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp
.IP
GEditPolylinePgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoPolyline.movePoint".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a GoPolyline, the method creates a new GEditPolyline grabber with flag indicating move a point only, initializes and returns it. Otherwise it returns NULL.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditPolyline\fP inherits behavior from:
.RS 10
\fBGEditPolypoint\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditPolyline\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the GEditPolyline program or the GMovePolyline program. This grabber supposes that the \fIPen\fP read from the program  can be used to clear a drawing by drawing twice at the same place.
.br
The grabber is used by GEditPolylinePgm and GMovePolylinePgm which are all subclasses of GEditGeometricPgm.
.sp 2
.nf
.ta .15i .25i 1.0i

class GEditPolyline : public GEditPolypoint
{
	public:
	GEditPolyline (GEditGeometricPgm*, const GEvent*, GoPolyline*,
			int mode, GButton add_point_button);
	virtual void  draw ();
	virtual void  drawAll ();
	virtual void  clear ();
	virtual void  clearAll ();
	
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditPolyline\fP (GEditGeometricPgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoPolyline* \fIpolyline\fP, int \fImode\fP, GButton \fIadd_point_button\fP);
.RS .8i
.IP \fIDescription\fP .5i
Creates a new edit polyline grabber. See the GEditPolypoint description.
.RE
.IP
void \fBdraw\fB();
.IP
void \fBclear\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws only the \fIline\fP from the current point and the current position defined by \fIWorkGo\fP (see GEditPolypoint::compute()).
.RE
.IP
void \fBdrawAll\fB();
.IP
void \fBclearAll\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method redraws all the updated polyline: \fIWorkGo\fP (see GEditPolypoint::compute()).
.RE
.sp 4
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The GEditPolyline is available only for a GoPolyline and not subclasses.
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditPolypoint (3Go), EditHandPolyline (3Go) and GoPolyline (3Go).\fP
.nrPN \n%





