.\" $Id: EdPolypoint.n,v 1.4 1992/12/28 13:07:53 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditPolypoint 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditPolypointPgm\fP, \fBMovePolypointPgm\fP \(em the common superclass program for editing a Go Polypoint. They are grabber programs.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdPolypoint.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditPolypointPgm\fP inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditPolypointPgm\fP program is a Grabber program. The editing of a polypoint consists of \fIadd\fP or \fIremove\fP points of the polypoint, and \fImove\fP the current point. The button event used to add/remove is programmable. The current point is defined as the closest point which matches the first \fIevent\fP position.  The new point is inserted just after the computed index.
.br
This program may be used to edit an instanciable GoPolypoint subclass (.e.g Curve).
.br
 The purpose of the GEditPolypointPgm is to defined:
.RS .5i
.br
The \fIname\fP of the edit polypoint program. see \fIcreate\fP method.
.br
The cursor used during interaction. The default cursor is GCURSOR_CROSSHAIR (see GInteractorPgm method to modify it).
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditPolypointPgm : public GEditGeometricPgm
{
	public:
	static GEditPolypointPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
	GButton addPointButton() const;
	void    addPointButton(GButton button);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditPolypointPgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoPolypoint.edit".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoPolypoint, the method creates a new GEditPolypoint grabber, initializes and returns it. Otherwise it returns NULL.
.REx1
.sp
.IP
int \fBaddPointButton\fP() const
.br
void \fBaddPointButton\fP(int \fIbutton\fP)
.RS .8i
.IP \fIDescription\fP .5i
These methods get/set the \fIbutton\fP used to \fIadd\fP a point during the edition. The corresponding event to \fIremove\fP the current point is the same one with the GCONTROL modifier.
.br
Valid \fIbutton\fP is a button which does not \fIcancel\fP the interaction (see GGrabber (3Go)) for \fIcancel\fP definition.
.br
The default \fIbutton\fP is GBUTTON1.
.br
The button  which terminates the interaction is GBUTTON2 for GBUTTON1 and GBUTTON1 for GBUTTON2.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGMovePolypointPgm\fP inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGMovePolypointPgm\fP program is used to moving a point of a polypoint. The point to move is the closest point which matches the first \fIevent\fP position.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GMovePolypointPgm : public GEditGeometricPgm
{
	public:
	static GEditPolypointPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp
.IP
GEditPolypointPgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoPolypoint.movePoint".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoPolypoint, the method creates a new GEditPolypoint grabber with flag indicating move a point only, initializes and returns it. Otherwise it returns NULL.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditPolypoint\fP inherits behavior from:
.RS 10
\fBGEditGeometric\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditPolypoint\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the GEditPolypoint program or the GMovePolypoint program. This grabber supposes that the \fIPen\fP read from the program  can be used to clear a drawing by drawing twice at the same place.
.br
The grabber is used by GEditPolypointPgm and GMovePolypointPgm which are subclasses of GEditGeometricPgm.
.sp 2
.nf
.ta .15i .25i 1.0i

/*
 * mode of editing for GEditPolypoint interactor;
 */

#define GEDIT_POLYPOINT 1
#define GMOVE_POINT 2

class GEditPolypoint : public GEditGeometric
{
	public:
	GEditPolypoint (GEditGeometricPgm*, const GEvent*, GoPolypoint*,
			int mode, GButton add_point_button);
	virtual void  draw ();
	virtual void  doit ();
	virtual void  handle (const GEvent*);
	virtual void  compute (const GEvent*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditPolypoint\fP (GEditGeometricPgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoPolypoint* \fIpolypoint\fP, int \fImode\fP, GButton \fIadd_point_button\fP);
.RS .8i
.IP \fIDescription\fP .5i
Creates a new edit polypoint grabber.
.IP \fIpgm\fP .5i
.br
Specifies the program to be used by this grabber. The \fIPen\fP to draw during the interaction is read from this \fIpgm\fP.
.IP \fIevent\fP .5i
.br
Specifies the first event of the interaction. This \fIevent\fP will determinate the index of the current point.
.br
.IP \fIpolypoint\fP .5i
.br
Specifies the polypoint to edit.
.IP \fImode\fP .5i
.br
Specifies the \fImode\fP of the edition. \fImode\fP must be GEDIT_POLYPOINT to have an interaction which is able edit completly the polypoint. To move only the current point pass: GMOVE_POINT.
.IP \fIadd_point_button\fP .5i
.br
Used only is \fImode\fP is GEDIT_POLYPOINT. It Specifies the button used to add  or remove a point inside \fIpolypoint\fP (see GEditPolypointPgm description).
.RE
.IP
void \fBdraw\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws  \fIWorkGo\fP (cf EdGeometric 3(Go)). Note the \fIdraw\fP method of \fIWorkGo\fP is virtual so, by this way, we call the effective draw of the polypoint (subclass) to edit.
.RE
.sp
.IP
void \fBdoit\fP()
.RS .8i
.IP \fIDescription\fP .5i
The \fBdoit\fP method reads the \fIWorkGo\fP list of \fIpoints\fP and \fIresets\fP the  polypoint to edit (see GoPolypoint::reset method).
.RE
.sp
.IP
GBool \fBhandle\fP(const GEvent* \fIevent\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fImode\fP is GEDIT_POLYPOINT and \fIevent\fP is the \fIadd_point_button\fP:
.br
On release it returns GTRUE (handled) but do nothing.
.br
On press. If \fImodifier\fP is 0 it adds a point after the current point. The \fIaddPoint\fP preconditions are called. If \fImodifier\fP is GCONTROL  it removes the current point and \fIdelPoint\fP preconditions are called.
.br
Otherwise it calls the superclass \fIhandle\fP method.
.RE
.sp 
.IP
void \fBcompute\fP(const GEvent* \fIevent\fP);
.RS .8i
.IP \fIDescription\fP .5i
The method is called by the GGrabber::handle() method, when a new mouse position occurs.
.br
The method calls the superclass \fIcompute\fP method. With the \fIevent\fP position it computes the new position of the current point inside the polypoint. It calls the \fImovePoint\fP preconditions for the current point and updates the \fIWorkGo\fP.
.RE
.sp 4
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The GEditPolypointPgm is used to 'edit' a subclass of Polypoint (.e.g Curve). Note that, with this program,  all the polypoint will drawn for each \fIevent\fP (see GEditPolyline (3Go), GEditPolygon (3Go) which are particular subclasses of GEditPolypoint).
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditGeometric (3Go), and subclasses and GoPolypoint (3Go).\fP
.nrPN \n%





