.\" $Id: EdRectangle.n,v 1.4 1992/12/28 13:07:55 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditRectangle 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditRectanglePgm\fP, \fBEditSquarePgm\fP  \(em the common superclass program for editing a Go Rectangle. They are grabber program.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdRectangle.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditRectanglePgm\fP inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditRectanglePgm\fP program is a Grabber program. The editing of a rectangle consists of changing the \fIwidth\fP and/or the \fIheight\fP of a rectangle without changing the \fII\fP and \fIJ\fP vector of its \fIcoordinate system\fP. A modification is computed with the mouse position according the \fIgravity\fP (see EdAsRectangle 3(Go) for gravity explanations). For any modifications, preconditions are called prior the modification. If accepted, the modifications are done onto the \fIworking go\fP (see EdGeometric 3(Go)). If the interaction is not cancelled by the user, the \fIrectangle\fP to be edited will be reseted with the last accepted modification.
.br
 The purpose of the GEditRectanglePgm is to defined:
.RS .5i
.br
The \fIname\fP of the edit rectangle program. see \fIcreate\fP method.
.br
the  \fIgravity\fP to be used by rectangle editor (.e.g GEditRectangle) at drawing time.
.br
The cursor used during interaction. It is computed according the \fIgravity\fP. see EdAsRectangle 3(Go).
.br
The \fBGEditSquarePgm\fP program is defined to edit a rectangle as a square.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditRectanglePgm : public GEditGeometricPgm
{
	public:
	static GEditRectanglePgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
	int gravity() const;
	void gravity(int);	
};


.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditRectanglePgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoRectangle.edit".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoRectangle, the method creates a new GEditRectangle grabber, initializes and returns it. Otherwise it returns NULL.
.RE
.sp
.IP
int \fBgravity\fP() const
.br
void \fBgravity\fP(int \fIgravity\fP)
.RS .8i
.IP \fIDescription\fP .5i
These methods get/set the gravity used by editor of GoRectangle. The default gravity is G_OPPOSITE_GRAVITY.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditSquarePgm\fP inherits behavior from:
.RS 10
\fBGEditRectanglePgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditSquarePgm\fP program is a convenient program subclass of GEditRectanglePgm. The purpose of this program is to \fIname\fP a grabber program to edit a rectangle as a square. It is useful because the GoSquare does not exit yet.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditSquarePgm : public GEditRectanglePgm
{
	public:
	static GEditRectanglePgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp
.IP
GEditSquarePgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoRectangle.squareEdit".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program). The default \fIgravity\fP of the program is (G_DO_SQUARE | G_NO_GRAVITY). 
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoRectangle, the method creates a new GEditRectangle grabber, initializes and returns it. Otherwise it returns NULL. The GEditRectangle grabber reads from the program the wanted \fIgravity\fP, so for this program it will run as a square.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditRectangle\fP inherits behavior from:
.RS 10
\fBGEditGeometric\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditRectangle\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the GEditRectangle program. This grabber supposes that the \fIPen\fP read from the GEditRectangle program  can be used to clear a drawing by drawing twice at the same place. Note that the \fIgravity\fP of the program is read at Initialization time.; so changing the program \fIgravity\fP during the life of the grabber will have no effect for the current grabber.
.br
The grabber is used by GEditRectanglePgm and GEditSquarePgm.
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditRectangle : public GEditGeometric
{
	public:
	GEditRectangle (GEditRectanglePgm*, const GEvent*, GoRectangle*);
	virtual void  draw ();
	virtual void  doit ();
	virtual void  compute (const GEvent*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditRectangle\fP (GEditRectanglePgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoRectangle* \fIrect\fP);
.RS .8i
.IP \fIDescription\fP .5i
The constructor reads the  \fIgravity\fP of the \fIpgm\fI program.
.IP \fIpgm\fP .5i
.br
Specifies the program to be used by this grabber.
.IP \fIevent\fP .5i
.br
Specifies the first event of the interaction.
.br
.IP \fIrect\fP .5i
.br
Specifies the rectangle to edit.
.RE
.IP
void \fBdraw\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws  \fIWorkGo\fI (cf EdGeometric 3(Go)).
.RE
.sp
.IP
void \fBdoit\fP()
.RS .8i
.IP \fIDescription\fP .5i
The \fBdoit\fP method reads the \fIWorkGo\fP width and height and \fIresets\fP (cf GoRectangle 3(Go)) the \fIrectangle\fP to be edited. It also modify the abosolute coordinate system origin of the rectangle but not the children (see  Go::SetThisAbscs()). It is useful because the GoRectangle class has not private \fIorigin\fP.
.RE
.sp
.IP
void \fBcompute\fP(const GEvent* \fIevent\fP);
.RS .8i
.IP \fIDescription\fP .5i
The method calls the superclass \fIcompute\fP method. With the \fIevent\fP position it computes the new \fIwidth\fP and \fIheight\fP of the rectangle according the \fIgravity\fP. It calls the \fIresetPreconditions\fP of the \fIrectangle\fP to be edited and \fPresets\fP the \fIWorkGo\fP used a drawing time (cf \fIdraw()\fP). It calls the \fIabscsPreconditions\fP of the rectangle to be edited and updates the coordinate system origin of the \fIWorkGo\fP.
.RE
.sp
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The GEditSquarePgm is a convenient program to edit a rectangle as a square. Another way to edit rectangle as a square is to program the \fIgravity\fP of the GEditRectanglePgm and to run it. 
.br
Remember that if you modify the \fIgravity\fP of the GEditRectanglePgm; this gravity will be used each time you run the program "GoRectangle.edit".
.br
Warning: Using a \fIgravity\fP which may modify the \fPtopLeft\fP point of the rectangle will modify the \fIcoordinate system\fP of the rectangle.
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditGeometric (3Go), EditAsRectangle (3Go), GoRectangle(3Go).\fP
.nrPN \n%





