.\" $Id: EdRegPolygon.n,v 1.2 1992/12/28 13:07:57 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH EditRegPolygon 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEditRegPolygonPgm\fP \(em the common superclass program for editing a GoRegPolygon. This is a grabber program.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/EdRegPolygon.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGEditRegPolygonPgm\fP inherits behavior from:
.RS 10
\fBGEditGeometricPgm\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditRegPolygonPgm\fP program is a Grabber program. The editing of a RegPolygon consists of changing the \fIradius\fP and the \fIangle\fP of a regular polygon. The edition does not modify the coordinate system.
.br
 The purpose of the GEditRegPolygonPgm is to defined:
.RS .5i
.br
The \fIname\fP of the edit RegPolygon program. see \fIcreate\fP method.
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditRegPolygonPgm : public GEditGeometricPgm
{
	public:
	static GEditRegPolygonPgm* create();
	virtual GInteractor*  start(const GEvent*, Go*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
GEditRegPolygonPgm* \fBcreate\fB();
.RS .8i
.IP \fIDescription\fP .5i
The name of the program is: "GoRegPolygon.edit".
.br
If the program is not created, it creates the program and returns it. Otherwise it creates it. The method returns NULL on error (.e.g the same name is used by something which is not an interactor program).
.RE
.sp
.IP
GInteractor* \fBstart\fP(const GEvent* \fIevent\fP, Go* \fIgo\fP)
.RS .8i
.IP \fIDescription\fP .5i
if \fIgo\fP is a subclass of GoRegPolygon, the method creates a new GEditRegPolygon grabber, initializes and returns it. Otherwise it returns NULL.
.RE
.sp 4
.SH
\fBCLASS\fP
.IP
\fBGEditRegPolygon\fP inherits behavior from:
.RS 10
\fBGEditGeometric\fP class,
.IP \(em 3
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGEditRegPolygon\fP is a Grabber. This grabber is created and Initialized by the \fIstart\fP method of the GEditRegPolygon program. This grabber supposes that the \fIPen\fP read from the GEditRegPolygon program  can be used to clear a drawing by drawing twice at the same place.
.br
The grabber is used by GEditRegPolygonPgm.
.sp 2
.nf
.ta .15i .25i 1.0i
class GEditRegPolygon : public GEditGeometric
{
	public:
	GEditRegPolygon (GEditRegPolygonPgm*, const GEvent*, GoRegPolygon*);
	virtual void  draw ();
	virtual void  doit ();
	virtual void  compute (const GEvent*);
};
.fi
.sp 2
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGEditRegPolygon\fP (GEditRegPolygonPgm* \fIpgm\fP, const GEvent* \fIevent\fP, GoRegPolygon* \fIreg_polygon\fP);
.RS .8i
.IP \fIDescription\fP .5i
Creation of a new GEditRegPolygon grabber.
.IP \fIpgm\fP .5i
.br
Specifies the program to be used by this grabber.
.IP \fIevent\fP .5i
.br
Specifies the first event of the interaction.
.br
.IP \fIreg_polygon\fP .5i
.br
Specifies the regular polygon to edit.
.RE
.IP
void \fBdraw\fB();
.RS .8i
.IP \fIDescription\fP .5i
The \fBdraw\fP method draws  \fIWorkGo\fI (cf EdGeometric 3(Go)).
.RE
.sp
.IP
void \fBdoit\fP()
.RS .8i
.IP \fIDescription\fP .5i
The \fBdoit\fP method reads the \fIWorkGo\fP radius and angle and \fIresets\fP (cf GoRegPolygon 3(Go)) the \fIRegPolygon\fP to be edited.
.RE
.sp
.IP
void \fBcompute\fP(const GEvent* \fIevent\fP);
.RS .8i
.IP \fIDescription\fP .5i
The method calls the superclass \fIcompute\fP method. With the \fIevent\fP position it computes the new \fIradius\fP and \fIangle\fP of the RegPolygon. It calls the \fIresetPreconditions\fP of the regular polygon to be edited. If the modification is accepted, it updates the \fIWorkGo\fP used a draw time.
.RE
.sp
.SH
\fBC BINDING\fP
.IP
\fITo be defined.\fP
.sp
.SH
\fBUSAGE INFORMATION\fP
.IP
.br
The GEditRegPolygon never changes the number of edges of the regular polygon.
.sp
.SH
\fBSEE ALSO\fP
.IP
\fBEditGeometric (3Go), GoRegPolygon(3Go).\fP
.nrPN \n%





