.\" $Id: Ellipse.n,v 1.1.1.1 1992/03/18 09:38:26 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoEllipse 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoEllipse\fP \(em the Ellipse object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ellipse.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoEllipse\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoArc\fP class
.IP \(em 3
\fBGoGeometric\fP class
.IP \(em 3
\fBGoStdDS\fP class
.IP \(em 3
\fBGo\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
A \fBGoEllipse\fP object is a \fBGoArc\fP with the following constraints :
.RS 10
.IP \(bu 3
the \fIamplitude\fP angle is set to 2*PI and cannot be modified
.IP \(bu 3
the \fIstart\fP angle is set to 0 and cannot be modified
.IP \(bu 3
\fIpie\fP and \fIclosed\fP attributes are set to GFALSE and cannot be modified
.RE
.sp 1
.IP
.nf
.ta .15i .25i 1.0i
class GoEllipse : public GoArc {

	public:

		static GoEllipseMetaclass* metaclass ();
		static GoEllipse* create ();
		static GoEllipse* create (GNumber, GNumber = 1);
		GoEllipse (GNumber = 1, GNumber = 1);
		void reset (GNumber, GNumber, GNumber = 0, GNumber = 2*PI);
};
.fi
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGoEllipseMetaclass\fP* \fBmetaclass\fP ()
.RS .8i
.IP \fIDescription\fP .3i
This static member function returns the \fBGoEllipseMetaclass\fP instance.
.RE
.sp 1
.IP
.nf
\fBGoEllipse\fP* \fBcreate\fP ();
\fBGoEllipse\fP* \fBcreate\fP (GNumber \fIradX\fP, GNumber \fIradY\fP = 1)
.fi
.RS .8i
.IP \fIDescription\fP .3i
These static member functions are constructors with pre/postconditions.
They return a pointer on a new instance of \fBGoEllipse\fP if no precondition
refuses the creation, else they return NULL;
.IP \fIradX\fP .3i
Specifies the X radius
.IP \fIradY\fP .3i
Specifies the Y radius
.RE
.sp 1
.IP
\fBGoEllipse\fP (GNumber \fIradX\fP = 1, GNumber \fIradY\fP = 1);
.RS .8i
.IP \fIDescription\fP .3i
Constructor
.IP \fIradX\fP .3i
Specifies the X radius
.IP \fIradY\fP .3i
Specifies the Y radius
.RE
.sp 1
.IP
void \fBreset\fP (GNumber \fIradX\fP, GNumber \fIradY\fP, GNumber = 0, GNumber = 0);
.RS .8i
.IP \fIDescription\fP .3i
resets the two ellipse radii. Third and forth parameters are not used and
may be omitted when calling the function.
.IP \fIradX\fP .3i
Specifies the X radius
.IP \fIradY\fP .3i
Specifies the Y radius
.RE
.SH
\fBC BINDING\fP
.DE
.SS 
\fBResources\fP
.IP
Inherited. See superclasses manual pages.
.SS 
\fBFunctions\fP
.IP
void \fBGoEllipseInitialize\fP ();
.RS .8i
.IP \fIDescription\fP .3i
This function must be called before any use of the GoEllipse C Binding.
.RE
.sp 1
.IP
.nf
GObjectId \fBGoEllipseCreate\fP (GNumber \fIradX\fP, GNumber \fIradY\fP);
GObjectId \fBGoEllipseMetaclass\fP ();
.fi
.sp 1
.RS .8i
.IP \fIDescription\fP .3i
See \fBGoEllipse\fP following members :
.sp 1
.nf
GoEllipse* create (GNumber, GNumber).
GoMetaclass* metaclass ().
.fi
.RE
.SH
\fBUSER INTERACTIONS\fP
.IP
Inherited.
.SH
\fBUSAGE INFORMATION\fP
.IP
If willing to use pre/postconditions on object creation,
one should use \fBGoEllipse::create\fP instead of the public
\fBGoEllipse\fP constructor; this is highly recommended.
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP, \fBGoArc\fP, \fBGoArcMetaclass\fP and
\fBGoEllipseMetaclass\fP classes.
.nrPN \n%
