.\" $Id: Form.n,v 1.2 1992/12/28 10:33:20 andre Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Formatter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBFormatter\fP \(em The formatter abstract class
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Form.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGFormatter\fP does not inherit behavior from any class.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
A formatter is an object used to organize the words inside the \fBGoText\fP to which
it is linked. The \fBGFormatter\fP class is an abstract class for the \fBGSimpleForm\fP
class and the \fBGMCFormatter\fP class (MC means Multi-Column).
.br
.sp 1
When linked with a \fBGSimpleFormatter\fP, a \fBGoText\fP takes the appearance
of a \fBGoSimpleText\fP, ie the lines are replied by the user. When used with a
\fBGMCFormatter\fP, the \fBGoText\fP is confined inside a frame and may be divided
into several columns.
.br
.sp 1
The interface between the formatter and the application is done with its context
(\fBGFormatterCtxt\fP).
.br
.sp 2
.br
.nf
.ta .15i .25i 1.50i

class GFormatter{
public:
    GFormatterCtxt*	ctxt();
}

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
GFormatterCtxt* \fBGFormatter::ctxt\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function returns the context of the formatter.
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
see \fIGoText(3Go)\fP.
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cForm.h>
.br
.sp1
.SS
\fBFunctions\fP
.sp 1
.IP
GObjectId \fBGFormatterGetCtxt\fP (GObjectId \fIform\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GFormatter::ctxt().
.RE
.sp1
.SH
\fBSEE ALSO\fP
.IP
\fBGoText\fP, \fBGSimpleFormatter\fP and \fBGMCFormatter\fP classes.
.nrPN \n%
