.\" $Id: GraphElt.n,v 1.1.1.1 1992/03/18 09:38:46 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoGraphElement 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoGraphElement\fP \(em the graph element object abstract class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/GraphElt.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoGraphElement\fP inherits behavior from the \fBGo\fP class.
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGoGraphElement\fP class is the common superclass for node and link graphic objects, so it defines common characteristics.
.br
Nodes and links may be reparented only on GoGraph or GoTree objects.
.IP
.nf
.ta .15i .25i 1.0i
class GoGraphElement {
	public:
		static GoMetaclass* metaclass();
};
.fi
.sp 1
.SH
\fBPUBLIC MEMBERS\fP
.IP
static GoMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of the \fIthis\fP.
.RE
.sp1
.RE
.sp 2
.SH
\fBUSER INTERACTION\fP
.IP
No user interaction.
.RE
.sp 2
.SH
\fBC BINDING\fP
.IP
No C Binding.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
\fIGoGraphElement\fP instances cannot be directly created but \fIGoGraphElement\fP subclass instances, this explains why there are not public constructors.
.sp 2
.SH
\fBSEE ALSO\fP
.IP
\fBGoNode\fP, \fBGoLink\fP classes.
.nrPN \n%
