.\" $Id: Label.n,v 1.1.1.1 1992/03/18 09:39:10 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoLabel 3Go "February 1992" "Version 1.1" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoLabel\fP \(em The label class
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/GoLabel.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoLabel\fP inherits behavior from class \fBGoTextual\fP.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGoLabel\fP is the cheapest BGo that may be used to display text. It is single-lined, mono font, and the underlining, if any, is drawn all along its width. The \fBGoLabel\fP class inherit methods from the \fBGoTextual\fP class and doesn't offer new functions.

.RS 10
.sp 2
.br
.nf
.ta .15i .25i 1.50i

class GoLabel: public Go
{
public:
    GoLabel();
    static GoMetaclass* metaclass();
    static GoLabel* create();
};


.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGoLabel\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function allows to create an instance of the \fBGoLabel\fP class.
.RE
.sp 1
.IP
static GoLabel* \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
Creates a new GoLabel instance. Returns the created label.
.RE
.sp 1
.IP
static GoMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of \fIthis\fP.
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
see \fIGoTextual(3Go)\fP.
.sp 1
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cLabel.h>
.SS
\fBFunctions\fP
.sp 1
.IP
void \fBGoLabelInitialize\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function must be called before any use of the GoLabel C Binding.
.RE
.sp 1
.IP
GObjectId \fBGoLabelMetaclass\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function returns the GoLabel metaclass.
.RE
.sp 1
.IP
GObjectId \fBGoLabelCreate\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function creates an instance of the GoLabel class.
.RE
.sp1
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoUI\fP, \fBGoTextual\fP, \fBGoTextualMetaclass\fP classes.
.nrPN \n%
