.\" $Id: MCForm.n,v 1.3 1992/12/28 10:33:24 andre Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH MCFormatter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBMCFormatter\fP \(em The multi-column formatter class
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/MCForm.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGMCFormatter\fP inherits behavior from class \fBGFrFormatter\fP.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
When linked with a \fBGMCFormatter\fP, a \fBGoText\fP is confined inside a frame and may be divided into several columns.
.br
The \fBGoUI\fP object provides function to change interactively the frame (width, height)
of the text.
.br
.sp 2
.br
.nf
.ta .15i .25i 1.50i


class GMCFormatterCtxt::public GFormatterCtxt
{
public:

    GNumber	interColumn();
    void	interColumn (GNumber);
    int		numberOfColumns();
    void	numberOfColumns (int);
    GNumber	height();
    void	height (GNumber);
    GNumber	width();
    void	width (GNumber);
}

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
GNumber \fBGMCFormatterCtxt::interColumn\fP()
.br
void \fBGMCFormatterCtxt::interColumn\fP (GNumber \fIi\fP)
.RS .8i
.IP \fIDescription\fP .5i
These functions are used to get/set the width between two columns.
.IP \fIi\fP .5i
.br
Specifies the inter column width.
.RE
.sp 1
.IP
int \fBGMCFormatterCtxt::numberOfColumns\fP()
.br
void \fBGMCFormatterCtxt::numberOfColumns\fP (int \fIn\fP)
.RS .8i
.IP \fIDescription\fP .5i
These functions are used to get/set the number of columns.
.IP \fIn\fP .5i
.br
Specifies the number of columns and is set to 1 by default.
.RE
.sp 1
.IP
GNumber \fBGMCFormatterCtxt::height\fP()
.br
void \fBGMCFormatterCtxt::height\fP (GNumber \fIh\fP)
.RS .8i
.IP \fIDescription\fP .5i
These functions are used to get/set the height of the formatter. The number of columns
remains the same but the column width and the global width may change.
.RE
.sp 1
.RS .8i
.IP \fIh\fP .5i
Value of the height to set.
.RE
.sp 1
.IP
GNumber \fBGMCFormatterCtxt::width\fP()
.br
void \fBGMCFormatterCtxt::width\fP (GNumber \fIw\fP)
.RS .8i
.IP \fIDescription\fP .5i
This function is used to get/set the width of the formatter. The number of columns
remains the same but the height may change.
.IP \fIw\fP .5i
.br
Specifies the width of the text and is set to 50 by default.
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
.br
.sp1
The \fBGoUI\fP object provides two functions to resize the frame of the 
formatter (See GoUI).
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cMCForm.h>
.br
.SS
\fBFunctions\fP
.sp 1
.RE
.IP
GObjectId \fBGMCFormatterCreate\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function creates an instance of the GMCFormatter class.
.sp1
.RE
.IP
void \fBGMCFormatterCtxtSetNumberOfColumns\fP (GMCFormatterCtxt*, int nbc);
.br
int \fBGMCFormatterCtxtGetNumberOfColumns\fP (GMCFormatterCtxt*);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GMCFormatter::numberOfColumns (int) and int
GMCFormatter::numberOfColumns().
.sp1
.RE
.IP
void \fBGMCFormatterCtxtSetInterColumn\fP (GMCFormatterCtxt*, GNumber);
.br
GNumber \fBGMCFormatterCtxtGetInterColumn\fP (GMCFormatterCtxt*);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GMCFormatter::interColumn (GNumber) and GNumber
GMCFormatter::interColumn().
.sp1
.RE
.IP
void \fBGMCFormatterCtxtSetWidth\fP (GMCFormatterCtxt*, GNumber);
.br
GNumber \fBGMCFormatterCtxtGetWidth\fP (GMCFormatterCtxt*);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GMCFormatter::width (GNumber).
.sp1
.RE
.IP
void \fBGMCFormatterCtxtSetHeight\fP (GMCFormatterCtxt*, GNumber);
.br
GNumber \fBGMCFormatterCtxtGetHeight\fP (GMCFormatterCtxt*);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GMCFormatter::height (GNumber).
.SH
\fBSEE ALSO\fP
.IP
\fBGoText\fP, \fBGFrFormatter\fP, \fBGMBFormatter\fP, \fBGCircleFormatter\fP and \fBGSimpleFormatter\fP classes.
.nrPN \n%
