.\" $Id: Polygon.n,v 1.1.1.1 1992/03/18 09:39:33 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoPolygon 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoPolygon\fP \(em the polygon object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Polygon.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoPolygon\fP inherits behavior from: 
.RS 10
.IP \(em 3
\fBGoPolyline\fP class
.IP \(em 3
\fBGoPolypoint\fP class
.IP \(em 3
\fBGoGeometric\fP class
.IP \(em 3
\fBGoStorage\fP class
.IP \(em 3
\fBGo\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
A \fBGoPolygon\fP object is a \fBGoPolyline\fP an extra segment joining the
first and the last point.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoPolygon : public GoPolyline {

	public:

		static GoPolygonMetaclass* metaclass ();
		static GoPolygon* create ();
		static GoPolygon* create (int, const GPoint*);
		GoPolygon ();
		GoPolygon (int, const GPoint*);
};
.fi
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGoPolygonMetaclass\fP* \fBmetaclass\fP ()
.RS .8i
.IP \fIDescription\fP .3i
This static member function returns the \fBGoPolygonMetaclass\fP instance.
.RE
.sp 1
.IP
.nf
\fBGoPolygon\fP* \fBcreate\fP ();
\fBGoPolygon\fP* \fBcreate\fP (int \fInpoint\fP, const GPoint* \fIpoints\fP);
.fi
.RS .8i
.IP \fIDescription\fP .3i
These static member functions are constructors with pre/postconditions.
They return a pointer on a new instance of \fBGoPolygon\fP if no precondition
refuses the creation, else they return NULL;
.IP \fInpoint\fP .3i
Specifies the number of control point in the array \fIpoints\fP
.IP \fIpoints\fP .3i
Specifies the control point array.
.RE
.sp 1
.IP
.nf
\fBGoPolygon\fP ();
\fBGoPolygon\fP (int \fInpoint\fP, const GPoint* \fIpoints\fP);
.fi
.RS .8i
.IP \fIDescription\fP .3i
Constructors (same as \fBGoPolyline\fP constructors)
.IP \fInpoint\fP .3i
Specifies the number of elements in \fIpoints\fP.
.IP \fIpoints\fP .3i
Specifies the array of polygon summits.
.RE
.SH
\fBC BINDING\fP
.SS 
\fBHeader\fP
.IP
#include <Go/cPolygon.h>
.SS 
\fBResources\fP
.IP
Inherited. See superclass man pages.
.RE
.SS 
\fBFunctions\fP
.IP
void \fBGoPolygonInitialize\fP();
.RS .8i
.IP \fIDescription\fP .3i
This function must be called before any use of the GoPolygon C Binding.
.RE
.sp 1
.IP
.nf
GObjectId \fBGoPolygonCreate\fP(int \fInb\, const GPoint* \fIpts\fP);
GObjectId \fBGoPolygonMetaclass\fP();
.fi
.sp 1
.RS .8i
.IP \fIDescription\fP .3i
See \fBGoPolygon\fP following members :
.sp 1
.nf
GoPolygon* create(int, const GPoint*).
GoMetaclass* metaclass().
.fi
.RE
.SH
\fBUSER INTERACTIONS\fP
.IP 
Inherited.
.SH
\fBUSAGE INFORMATION\fP
.IP
If willing to use pre/postconditions on object creation,
one should use \fBGoPolygon::create\fP instead of the public
\fBGoPolygon\fP constructor; this is highly recommended.
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStorage\fP, \fBGoStorageMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP, \fBGoPolypoint\fP,
\fBGoPolypointMetaclass\fP, \fBGoPolyline\fP, \fBGoPolylineMetaclass\fP and
\fBGoPolygonMetaclass\fP classes.
.nrPN \n%

