.\" $Id: SText.n,v 1.1.1.1 1992/03/18 09:40:02 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoSimpleText 3Go "February 1992" "Version 1.1" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoSimpleText\fP \(em The simple text class
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/SText.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoSimpleText\fP inherits behavior from class \fBGoTextual\fP.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGoSimpleText\fP is a simple but efficient block of text. Unlike the \fBGoText\fP, the \fBGoSimpleText\fP  is mono-font and none of its parts can be processed separately, but any portion of the text can be underlined as well.
.br
.sp 2
.br
.nf
.ta .15i .25i 1.50i

class GoSimpleText{
public:
    				GoSimpleText();
    static GoMetaclass*		metaclass();
    static GoSimpleText*	create();
}
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGoSimpleText\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function allows to create an instance of the \fBGoSimpleText\fP class.
.RE
.sp 1
.IP
static GoSimpleText* \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
Creates a new GoSimpleText instance. Returns the created simpletext.
.RE
.sp 1
.IP
static GoMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of \fIthis\fP.
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
see \fIGoTextual(3Go)\fP.
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cSText.h>
.SS
\fBFunctions\fP
.sp 1
.IP
void \fBGoSimpleTextInitialize\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function must be called before any use of the GoSimpleText C Binding.
.RE
.sp 1
.IP
GObjectId \fBGoSimpleTextMetaclass\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function returns the GoSimpleText metaclass.
.RE
.sp 1
.IP
GObjectId \fBGoSimpleTextCreate\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function creates an instance of the GoSimpleText class.
.RE
.sp1
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoUI\fP, \fBGoTextual\fP, \fBGoTextualMetaclass\fP and \fBGoSimpleTextMetaclass\fP classes.
.nrPN \n%
