.\" $Id: ScText.n,v 1.3 1992/12/28 10:33:26 andre Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoScrolledText 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoScrolledText\fP \(em The scrolled text class
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/ScText.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoScrolledText\fP inherits behavior from class \fBGoSimpleText\fP.
.RS 10
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGoScrolledText\fP is a \fBGoSimpleText\fP provided with scrolling capabalities. The string
is displayed inside a window of which the height (expressed in number of lines) and the width (expressed in GNumber) are set by the user. The \fBGoScrolledText\fP allows the user to set some pre/postconditions on the geometry of the window and the scrolling. Unlike the \fBGoSimpleText\fP, the \fBGoScrolledText\fP has no interline spacing and justification capabalities.
.RS 10
.sp 2
.br
.nf
.ta .15i .25i 1.50i

class GoScrolledText: public Go
{
public:
		GoScrolledText();

    static GoMetaclass*	metaclass();
    static GoScrolledText* create();

    /* geometry methods */
    GBool	nbLinesToShow (ushort);
    ushort	nbLinesToShow();
    GBool	addLineToShow();
    GBool	removeLineToShow();
    void	width (GNumber);

    /* scrolling methods */
    GBool	firstLineToShow (int);
    int	firstLineToShow();
    GBool	vScroll (short);
    GBool	scrollUp();
    GBool	scrollDown();
    GBool	pageUp();
    GBool	pageDown();
    GBool	hScroll (GNumber);
    GNumber	hScroll();

    /* tools methods */
    GBool	visibleChar (Pos);
    GNumber	textWidth();

    /* pre/postconds on firstLineToShow value */
    void	firstLineToShowPrecond (GBool (*)(void*, const GoScrolledText*, int),
.br
				void* closure, GAddOrRemove = GADD);
    void	firstLineToShowPostcond (void (*)(void*, GoScrolledText*, int),
.br
				void* closure, GAddOrRemove = GADD);

    /* pre/postconds on nbLinesToShow value */
    void	nbLinesToShowPrecond (GBool (*)(void*, const GoScrolledText*, ushort)
.br
				,void* closure, GAddOrRemove = GADD);
    void	nbLinesToShowPostcond (void (*)(void*, GoScrolledText*, ushort),
.br
				void* closure, GAddOrRemove = GADD);

    /* pre/postconds on hScroll value */
    void	hScrollPrecond (GBool (*)(void*, const GoScrolledText*, GNumber*)
.br
				,void* closure, GAddOrRemove = GADD);
    void	hScrollPostcond (void (*)(void*, GoScrolledText*, GNumber*),
.br
				void* closure, GAddOrRemove = GADD);
};


.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGoScrolledText\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create an instance of the \fBGoScrolledText\fP class.
.RE
.sp 1
.IP
static GoMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of \fIthis\fP.
.RE
.sp1
.IP
static GoScrolledText* \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
Creates a new instance. Returns the created scrolled text.
.RE
.sp 1
.IP
GBool \fBnbLinesToShow\fP (ushort \fInbLines\fP)
.br
ushort \fBnbLinesToShow\fP()
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to set/get the height (expressed in number of lines) of the window.
.IP \fInbLines\fP .5i
.br
Number of lines that will determine the height of the window.
.RE
.sp 1
.IP
GBool \fBaddLineToShow\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to increase the height of the window by one line.
.RE
.sp 1
.IP
GBool \fBremoveLineToShow\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to decrease the height of the window by one line.
.RE
.sp 1
.IP
void \fBwidth\fP (GNumber \fIw\fP)
.RS .8i
.IP \fIDescription\fP .5i
This method allows to set the width of the window.
.IP \fIw\fP .5i
.br
Value of the width expressed in GNumber.
.RE
.sp 1
.IP
GBool \fBfirstLineToShow\fP (int \fIfirst\fP)
.br
int \fBfirstLineToShow\fP()
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to set/get the line to be displayed at the top of the window.
.IP \fIfirst\fP .5i
.br
Number of the line to be placed on top.
.RE
.sp 1
.IP
GBool \fBscrollUp\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to scroll up the text value by one line.
.RE
.sp 1
.IP
GBool \fBscrollDown\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to scroll down the text value by one line.
.RE
.sp 1
.IP
GBool \fBpageUp\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to scroll up the text value by one page.
.RE
.sp 1
.IP
GBool \fBpageDown\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method allows to scroll down the text value by one page.
.RE
.sp 1
.IP
GBool \fBvScroll\fP (short \fInb\fP)
.RS .8i
.IP \fIDescription\fP .5i
This method returns allows to scroll vertically the text.
.IP \fInb\fP .5i
.br
Vertical scroll value expressed in number of lines. The scroll
starts from the current first line showed.
.RE
.sp 1
.IP
GBool \fBhScroll\fP (GNumber \fIx\fP)
.br
GNumber \fBhScroll\fP()
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to set/get the horizontal scroll of the window.
The scroll starts from the origin of the text.
.IP \fIx\fP .5i
.br
Horizontal scroll value.
.RE
.sp 1
.IP
GBool \fBvisibleChar\fP (Pos \fIpos\fP)
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE if the character of which position is
\fIpos\fP is visible inside the window, GFALSE otherwise.
.IP \fIpos\fP .5i
.br
Position of the charcter to be querried.
.RE
.sp 1
.IP
GNumber \fBtextWidth\fP()
.RS .8i
.IP \fIDescription\fP .5i
This method returns the real width of the text string (the largest line width).
.RE
.sp 1
.IP
void \fBfirstLineToShowPrecond\fP (GBool \fIproc\fP(*)(void* \fIclosure \fP, const GoScrolledText* \fIgo\fP,
.br
		int \fIline\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.br
void \fBfirstLineToShowPostcond\fP (void \fIproc\fP(*)(void* \fIclosure \fP, GoScrolledText* \fIgo\fP,
.br
		int \fIline\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add/remove pre/postcondition callbacks which will be called when a change of the first line to be chown occurs.
.IP \fIproc\fP .5i
Specifies the pre/postcondition procedure. The precondition and the postcondition take three parameters: the closure (private application data), the GoScrolledText itself, and a line number. In the case of the precondition, \fIline\fP is the new line to be chown, and the old one for a postcondtion.
.RE
.sp 1
.IP
void \fBnbLinesToShowPrecond\fP (GBool \fIproc\fP(*)(void* \fIclosure \fP, const GoScrolledText* \fIgo\fP,
.br
		ushort \fInb\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.br
void \fBnbLinesToShowPostcond\fP (void \fIproc\fP(*)(void* \fIclosure \fP, GoScrolledText* \fIgo\fP,
.br
		ushort \fInb\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add/remove pre/postcondition callbacks which will be called when the number of lines to show changes.
.IP \fIproc\fP .5i
Specifies the pre/postcondition procedure. The precondition and the postcondition take three parameters: the closure (private application data), the GoScrolledText itself, and a number of lines. In the case of the precondition, \fInb\fP is the new number of lines to show, and the old one for a postcondtion.
.br
.RE
.sp 1
.IP
void \fBhScrollPrecond\fP (GBool \fIproc\fP(*)(void* \fIclosure \fP, const GoScrolledText* \fIgo\fP,
.br
		GNumber* \fIx\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.br
void \fBhScrollPostcond\fP (void \fIproc\fP(*)(void* \fIclosure \fP, GoScrolledText* \fIgo\fP,
.br
		GNumber* \fIx\fP),
.br
		const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add/remove pre/postcondition callbacks which will be called when the horizontal scrolling changes.
.IP \fIproc\fP .5i
Specifies the pre/postcondition procedure. The precondition and the postcondition take three parameters: the closure (private application data), the GoScrolledText itself, and the horizontal scrolling value. In the case of the precondition, \fInb\fP is the new value, and the old one for a postcondtion.
.br
.RE
.sp 1
.SH
\fBUSER INTERACTIONS\fP
.IP
\fISee GoScrolledTextMetaclass(3Go)\fP.
.RE
.sp 2
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
#include <Go/cScText.h>


.DE
.SS
\fBResources\fP
.IP
The following table defines a set of Go resources used by the programmer to specify data. 
The programmer can also set the resource values for the inherited classes to set attributes for this object.
The codes in the access column indicate if the given resource can be set by using \fBGoSetValues\fP (\fBS\fP), retrieved by using \fBGoGetValues\fP (\fBG\fP), or is not applicable (\fBN/A\fP).
.br
For superclass resources, see superclass man pages.
.br
See also Section 2.
.sp 1
.ps 8
.DS
.TS
center box;
cB sss
lB lB lB lB
l l l l.
GoGraphStruct Resource Set
.sp
=
Name    Type    Default Access
.sp
_
goNfirstLineToShow	int	1	SG
goNnbLinesToShow	ushort	1	SG
goNHscroll	GNumber	0	SG

.TE
.DE
.ps 10

.SS
\fBFunctions\fP
.sp 1
.IP
void \fBGoScrolledTextInitialize\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function must be called before any use of the GoScrolledText C Binding.
.RE
.sp 1
.IP
GObjectId \fBGoScrolledTextMetaclass\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function returns the GoScrolledText metaclass.
.RE
.sp 1
.IP
GObjectId \fBGoScrolledTextCreate\fP()
.RS .8i
.IP \fIDescription\fP .5i
This function creates an instance of the GoScrolledText class.
.RE
.sp 1
.IP
GBool \fBGoScrolledTextSetNbLinesToShow\fP (GObjectId \fIid\fP, ushort \fInb\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GBool GoScrolledText::nbLinesToShow (ushort \fInb\fP).
.RE
.sp 1
.IP
ushort \fBGoScrolledTextNbLinesToShow\fP (GObjectId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP ushort GoScrolledText::nbLinesToShow().
.RE
.sp 1
.IP
GBool \fBGoScrolledTextSetFirstLineToShow\fP (GObjectId \fIid\fP, int \fIline\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GBool GoScrolledText::firstLineToShow (int \fIline\fP).
.RE
.sp 1
.IP
int \fBGoScrolledTextFirstLineToShow\fP (GObjectId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP int GoScrolledText::firstLineToShow().
.RE
.sp 1
.IP
GBool \fBGoScrolledTextSetHscroll\fP (GObjectId \fIid\fP, GNumber \fIx\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GBool GoScrolledText::hScroll (GNumber \fIx\fP).
.RE
.sp 1
.IP
GBool \fBGoScrolledScrollUp\fP(GObjectIId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GNumber GoScrolledText::scrollUp().
.RE
.sp 1
.IP
GBool \fBGoScrolledScrollDown\fP(GObjectIId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GNumber GoScrolledText::scrollDown().
.RE
.sp 1
.IP
GBool \fBGoScrolledPageUp\fP(GObjectIId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GNumber GoScrolledText::pageUp().
.RE
.sp 1
.IP
GBool \fBGoScrolledPageDown\fP(GObjectIId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GNumber GoScrolledText::pageDown().
.RE
.sp 1
.IP
GNumber \fBGoScrolledHscroll\fP (GObjectId \fIid\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GNumber GoScrolledText::hScroll().
.RE
.sp 1
.IP
GBool \fBGoScrolledTextVisibleChar\fP (Pos \fIpos\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GBool GoScrolledText::visibleChar (Pos \fIpos\fP).
.RE
.sp 1
.IP
GBool \fBGoScrolledTextVscroll\fP (GObjectId \fIid\fP, ushort \fInb\fP)
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GBool GoScrolledText::vScroll (ushort \fInb\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextNbLinesToShowPrecond\fP (GObjectId \fItext\fP,
.br
	, GBool(*\fIcb\fP)(GObjectId, const GObjectId, ushort),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::nbLinesToShowPrecond (GBool (*\fIcb\fP)
.br
	(void*, const GoScrolledText*, ushort),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextNbLinesToShowPostcond\fP (GObjectId \fItext\fP,
.br
	, void(*\fIcb\fP)(GObjectId, GObjectId, ushort),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::nbLinesToShowPostcond (void (*\fIcb\fP)
.br
	(void*, GoScrolledText*, ushort),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextFirstLineToShowPrecond\fP (GObjectId \fItext\fP,
.br
	, GBool(*\fIcb\fP)(GObjectId, const GObjectId, int),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::firstLineToShowPrecond (GBool (*\fIcb\fP)
.br
	(void*, const GoScrolledText*, int),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextFirstLineToShowPostcond\fP (GObjectId \fItext\fP,
.br
	, void(*\fIcb\fP)(GObjectId, GObjectId, int),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::firstLineToShowPostcond (void (*\fIcb\fP)
.br
	(void*, GoScrolledText*, int),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextHscrollPrecond\fP (GObjectId \fItext\fP,
.br
	, GBool(*\fIcb\fP)(GObjectId, const GObjectId, GNumber*),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::hScrollPrecond (GBool (*\fIcb\fP)
.br
	(void*, const GoScrolledText*, GNumber*),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.sp 1
.IP
void \fBGoScrolledTextHscrollPostcond\fP (GObjectId \fItext\fP,
.br
	, void(*\fIcb\fP)(GObjectId, GObjectId, GNumber*),
.br
	GObjectId \fIclosure\fP, GAddOrRemove \fIadd\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP void GoScrolledText::hScrollPostcond (void (*\fIcb\fP)
.br
	(void*, GoScrolledText*, GNumber*),
.br
	void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.RE
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoUI\fP, \fBGoTextual\fP, \fBGoTextualMetaclass\fP, \fBGoSimpleText\fP and \fBGoSimpleTextMetaclass\fP classes.
.nrPN \n%
