.\" $Id: SimLink.n,v 1.1.1.1 1992/03/18 09:40:17 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoSimpleLink 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoSimpleLink\fP \(em the simple link object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/SimLink.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoSimpleLink\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoLink\fP class
.IP \(em 3
\fBGoGraphElement\fP class
.IP \(em 3
\fBGo\fP class.
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
GoSimpleLink instances draw a line between their two extrem nodes.
.IP
.nf
.ta .15i .25i 1.0i
class GoSimpleLink {
	public:
		// getting values;
		GPen& pen();

		// others;
		GoSimpleLink();

		static GoMetaclass* metaclass();
		static GoSimpleLink* create();
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
GPen& \fBpen\fP();
.RS .8i
.IP \fIDescription\fP .5i
.br
This method returns the pen reference used to draw the link.
.RE
.sp 1
.IP
\fBGoSimpleLink\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a new instance of the \fIGoSimpleLink\fP class.
.RE
.sp 1
.IP
static GoMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of the \fIthis\fP.
.RE
.sp1
.IP
static GoSimpleLink* \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
Creates a new GoSimpleLink instance. Returns the created link.
.RE
.sp1
.RE
.sp 2
.SH
\fBUSER INTERACTION\fP
.IP
No user interaction.
.RE
.sp 2
.SH
\fBC BINDING\fP
.SS 
\fBHeader\fP
.IP
#include <Go/cSimLink.h>
.DE
.SS 
\fBResources\fP
.IP
No resources.
.SS 
\fBFunctions\fP
.IP
void \fBGoSimpleLinkInitialize\fP();
.RS .8i
.IP \fIDescription\fP .5i
This function must be called before any use of the GoSimpleLink C Binding.
.RE
.sp 1
.IP
GObjectId \fBGoCreateGoSimpleLink\fP();
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GoSimpleLink* GoSimpleLink::create().
.RE
.sp 1
.IP
GObjectId \fBGoSimpleLinkMetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP GoMetaclass* GoSimpleLink::metaclass().
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoLink\fP class.
.nrPN \n%
