.\" $Id: mArc.n,v 1.1.1.1 1992/03/18 09:40:49 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoArcMetaclass 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoArcMetaclass\fP \(em the Meta Class object for the \fBGoArc\fP
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/mArc.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoArcMetaclass\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoGeometricMetaclass\fP class
.IP \(em 3
\fBGoStdDSMetaclass\fP class
.IP \(em 3
\fBGoMetaclass\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
The \fBGoArcMetaclass\fP class is the common superclass for all
\fBGoArc\fP objects.
.br
As for other "Metaclasses", there is only one static instance of
\fBGoArcMetaclass\fP: this instance is returned by
\fBGoArc::metaclass ()\fP static method.
.IP
Such object is meant to provide methods on \fBGoArc\fP at
the class level; in particular this allows the programmer to set some
pre/postconditions at the class level.
.IP
.nf
.ta .15i .25i 1.0i
class GoArcMetaclass {

	public:

		/*
		 * \fBpre and post conditions:\fP
		 */

		void radiusXPrecond (GBool (*) (void*, const GoArc*, GNumber*),
			void*, GAddOrRemove = GADD);
		void radiusXPostcond (void (*) (void*, GoArc*),
			void*, GAddOrRemove = GADD);
		void radiusYPrecond (GBool (*) (void*, const GoArc*, GNumber*),
			void*, GAddOrRemove = GADD);
		void radiusYPostcond (void (*) (void*, GoArc*),
			void*, GAddOrRemove = GADD);
		void amplitudePrecond (GBool (*) (void*, const GoArc*, GNumber*),
			void*, GAddOrRemove = GADD);
		void amplitudePostcond (void (*) (void*, GoArc*),
			void*, GAddOrRemove = GADD);
		void startPrecond (GBool (*) (void*, const GoArc*, GNumber*),
			void*, GAddOrRemove = GADD);
		void startPostcond (void (*) (void*, GoArc*),
			void*, GAddOrRemove = GADD);
		void resetPrecond (GBool (*) (void*, const GoArc*,
			GNumber* radX, GNumber* radY, GNumber* ampl, GNumber*),
			void*, GAddOrRemove = GADD);
		void resetPostcond (void (*) (void*, GoArc*),
			void*, GAddOrRemove = GADD);
};
.fi
.SH
\fBPUBLIC MEMBERS\fP
.IP
.nf
void \fBradiusXPrecond\fP (GBool (*\fIf\fP) (void*, const GoArc* \fIarc\fP, GNumber* \fIradX\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBradiusXPostcond\fP (void (*\fIf\fP) (void*, GoArc* \fIarc\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBradiusYPrecond\fP (GBool (*\fIf\fP) (void*, const GoArc* \fIarc\fP, GNumber* \fIradY\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBradiusYPostcond\fP (void (*\fIf\fP) (void*, GoArc* \fIarc\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBamplitudePrecond\fP (GBool (*\fIf\fP) (void*, const GoArc* \fIarc\fP, GNumber* \fIampl\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBamplitudePostcond\fP (void (*\fIf\fP) (void*, GoArc* \fIarc\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBstartPrecond\fP (GBool (*\fIf\fP) (void*, const GoArc* \fIarc\fP, GNumber* \fIstrt\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBstartPostcond\fP (void (*\fIf\fP) (void*, GoArc* \fIarc\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBresetPrecond\fP (GBool (*\fIf\fP) (void*, const GoArc* \fIarc\fP,
			GNumber* \fIradX\fP, GNumber* \fIradY\fP, GNumber* \fIampl\fP, GNumber* \fIstrt\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
void \fBresetPostcond\fP (void (*\fIf\fP) (void*, GoArc* \fIarc\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add or remove functions to the pre/post conditions lists
triggered by \fBradiusX\fP (GNumber), \fBradiusY\fP (GNumber), \fBamplitude\fP
(GNumber), \fBstart\fP (GNumber) and 
\fBreset\fP (GNumber, GNumber, GNumber, GNumber) member functions of
\fBGoArc\fP.
.IP \fIf\fP .5i
Specifies programmer's function to be added/removed.
.IP \fIclosure\fP .5i
Specifies programmer's parameter to call the function with.
.IP \fIarc\fP .5i
Specifies the GoArc object involved.
.IP \fIradX\fP .5i
Specifies the new radiusX value. May be modified by \fIf\fP.
.IP \fIradY\fP .5i
Specifies the new radiusY value. May be modified by \fIf\fP.
.IP \fIampl\fP .5i
Specifies the new amplitude angle. May be modified by \fIf\fP.
.IP \fIstrt\fP .5i
Specifies the new start angle. May be modified by \fIf\fP.
.IP \fIadd\fP .5i
Specifies whether to add or remove the function \fIf\fP from the list.
.RE
.SH
\fBC BINDING\fP
.SS 
\fBHeader\fP
.IP
#include <Go/cArc.h>
.SS 
\fBFunctions\fP
.IP
.nf
void \fBGoArcMetaclassAmplitudePrecond\fP (GObjectId \fIarcMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassAmplitudePostcond\fP (GObjectId \fIarcMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassRadiusXPrecond\fP (GObjectId \fIarcMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassRadiusXPostcond\fP (GObjectId \fIarcMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassRadiusYPrecond\fP (GObjectId \fIarcMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassRadiusYPostcond\fP (GObjectId \fIarcMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassResetPrecond\fP (GObjectId \fIarcMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*, GNumber*, GNumber*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassResetPostcond\fP (GObjectId \fIarcMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassStartPrecond\fP (GObjectId \fIarcMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoArcMetaclassStartPostcond\fP (GObjectId \fIarcMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
.fi
.sp 1
.RS .3i
.IP \fIDescription\fP .3i
See \fBGoArcMetaclass\fP following members :
.sp 1
.nf
void amplitudePrecond (GBool (*\fIf\fP) (void*, const GoArc*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void amplitudePostcond (void (*\fIf\fP) (void*, GoArc*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusXPrecond (GBool (*\fIf\fP) (void*, const GoArc*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusXPostcond (void (*\fIf\fP) (void*, GoArc*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusYPrecond (GBool (*\fIf\fP) (void*, const GoArc*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusYPostcond (void (*\fIf\fP) (void*, GoArc*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPrecond (GBool (*\fIf\fP) (void*,const GoArc*,GNumber*,GNumber*,GNumber*,GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPostcond (void (*\fIf\fP) (void*, GoArc*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void startPrecond (GBool (*\fIf\fP) (void*, const GoArc*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void startPostcond (void (*\fIf\fP) (void*, GoArc*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.fi
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP and \fBGoArc\fP classes.
.nrPN \n%
