.\" $Id: mGraphStr.n,v 1.1.1.1 1992/03/18 09:41:16 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoGraphStructMetaclass 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoGraphStructMetaclass\fP \(em the graph structure class object abstract class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/mGraphStr.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoGraphStructMetaclass\fP inherits behavior from the \fBGoMetaclass\fP class.
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
The \fBGoGraphStructMetaclass\fP class is the common superclass for all \fIGoGraphStruct class\fP objects.
There is only one static instance of the class: it is returned by \fIGoGraphStruct::metaclass()\fP method.
.IP
This instance is defined to provide methods on \fIGoGraphStruct\fP at the class level.  Such class objects exist for every \fIGoGraphStruct\fP class.
.IP
There is no public members.
.fi
.sp 1
.SH
\fBUSER INTERACTION\fP
.IP
User interactions are defined by the following functions which may be included in the customization files to be interpreted by the \fIGo\fP \fIUser\fP \fIInteraction\fP object \fBGoUI\fP (see \fIGoUI(3Go)\fP).
.sp1
.IP
Functions availables for user interaction are:
.br
GoGraphStruct::setBackground(\fIGBool\fP)
.RS .8i
.IP \fIDescription\fP .5i
See the public method background(\fIGBool\fP).
.RE
.sp1
.IP
GoGraphStruct::setPositionType(\fIushort\fP)
.RS .8i
.IP \fIDescription\fP .5i
See the public method positionType(\fIushort\fP).
.RE
.sp1
.IP
GoGraphStruct::setAnchoringType(\fIushort\fP)
.RS .8i
.IP \fIDescription\fP .5i
See the public method anchoringType(\fIushort\fP).
.RE
.sp1
.IP
GoGraphStruct::makePosition(\fIGoNode*=NULL\fP, \fIconst GPoint&=*(GPoint*)NULL\fP)
.RS .8i
.IP \fIDescription\fP .5i
See the public method makePosition(\fIGoNode*=NULL\fP, \fIconst GPoint&=*(GPoint*)NULL\fP)
.RE
.sp1
.SH
\fBC BINDING\fP
.IP
No C Binding.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoGraphStruct\fP class.
.nrPN \n%
