.\" $Id: mPolypoint.n,v 1.1.1.1 1992/03/18 09:41:44 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoPolypointMetaclass 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoPolypointMetaclass\fP \(em the Meta Class object for the \fBGoPolypoint\fP
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/mPolypoint.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoPolypointMetaclass\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoGeometricMetaclass\fP class
.IP \(em 3
\fBGoStdDSMetaclass\fP class
.IP \(em 3
\fBGoMetaclass\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
The \fBGoPolypointMetaclass\fP class is the common superclass for all
\fIGoPolypoint\fP objects.
.br
As for other "Metaclasses", there is only one static instance of
\fBGoPolypointMetaclass\fP: this instance is returned by
\fBGoPolypoint::metaclass ()\fP static method.
.IP
Such object is meant to provide methods on \fBGoPolypoint\fP at
the class level; in particular this allows the programmer to set some
pre/postconditions at the class level.
.IP
.nf
.ta .15i .25i 1.0i
class GoPolypointMetaclass {

	public:

		/*
		 * \fBpre and post conditions:\fP
		 */

		void addPointPrecond (GBool (*) (void*, const GoPolypoint*, int*, GPoint*),
			void*, GAddOrRemove = GADD);
		void addPointPostcond (void (*) (void*, GoPolypoint*, int),
			void*, GAddOrRemove = GADD);
		void delPointPrecond (GBool (*) (void*, const GoPolypoint*, int*),
			void*, GAddOrRemove = GADD);
		void delPointPostcond (void (*) (void*, GoPolypoint*, int),
			void*, GAddOrRemove = GADD);
		void movePointPrecond (GBool (*) (void*, const GoPolypoint*, int*, GPoint*),
			void*, GAddOrRemove = GADD);
		void movePointPostcond (void (*) (void*, GoPolypoint*, int),
			void*, GAddOrRemove = GADD);
		void resetPointsPrecond (GBool (*) (void*, const GoPolypoint*, int nb, const GPoint*),
			void*, GAddOrRemove = GADD);
		void resetPointsPostcond (void (*) (void*, GoPolypoint*),
			void*, GAddOrRemove = GADD);
};
.fi
.SH
\fBPUBLIC MEMBERS\fP
.IP
.nf
void \fBaddPointPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP,
			int* \fIindex\fP, GPoint* \fIpt\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBaddPointPostcond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP, int \fIindex\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBmovePointPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP,
			int* \fIindex\fP, GPoint* \fIpt\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBmovePointPostcond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP, int \fIindex\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBdelPointPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP, int* \fIindex\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBdelPointPostcond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP, int \fIindex\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBresetPointsPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP,
			int \fInb\fP, const GPoint* \fIpts\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
void \fBresetPointsPostcond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoPolypoint* \fIpolypt\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD)
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add or remove functions to the pre/post conditions lists
triggered by \fBaddPoint\fP (...), \fBmovePoint\fP (...) and \fPdelPoint\fP
(...) member functions of \fBGoPolypoint\fP.
.IP \fIf\fP .5i
Specifies programmer's function to be added/removed.
.IP \fIpolypt\fP .5i
Specifies the GoPolypoint object involved.
.IP \fIindex\fP .5i
Specifies the index in the point array. May be modified by \fIf\fP (in
preconditions only).
.IP \fIpt\fP .5i
Pointer to the new point or new position, always expressed in the Go coordinate
system. The structure pointed to may be modified by \fIf\fP (in
preconditions only).
.IP \fInb\fP
Specifies the number of points in the array \fIpts\fP. (resetPointsPrecond only)
.IP \fIpts\fP .5i
New point array, always expressed in the Go coordinate. (resetPointsPrecond only)
system.
.IP \fIadd\fP .5i
Specifies whether to add or remove the function \fIf\fP from the list.
.RE
.SH
\fBC BINDING\fP
.SS 
\fBHeader\fP
.IP
#include <Go/cPolypoint.h>
.SS 
\fBFunctions\fP
.IP
.nf
void \fBGoPolypointMetaclassAddPointPrecond\fP(GObjectId \fIpolyptMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, int*, GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassAddPointPostcond\fP(GObjectId \fIpolyptMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassDelPointPrecond\fP(GObjectId \fIpolyptMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, int*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassDelPointPostcond\fP(GObjectId \fIpolyptMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassMovePointPrecond\fP(GObjectId \fIpolyptMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, int*, GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassMovePointPostcond\fP(GObjectId \fIpolyptMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassResetPointsPrecond\fP(GObjectId \fIpolyptMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, int, const GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoPolypointMetaclassResetPointsPostcond\fP(GObjectId \fIpolyptMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
.fi
.sp 1
.RS .3i
.IP \fIDescription\fP .3i
See \fBGoPolypointMetaclass\fP following members :
.sp 1
.nf
void addPointPrecond(GBool (*\fIf\fP) (void*, const GoPolypoint*, int*, GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void addPointPostcond(void (*\fIf\fP) (void*, GoPolypoint*, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void delPointPrecond(GBool (*\fIf\fP) (void*, const GoPolypoint*, int*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void delPointPostcond(void (*\fIf\fP) (void*, GoPolypoint*, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void movePointPrecond(GBool (*\fIf\fP) (void*, const GoPolypoint*, int*, GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void movePointPostcond(void (*\fIf\fP) (void*, GoPolypoint*, int),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPointsPrecond(GBool (*\fIf\fP) (void*, const GoPolypoint*, int, const GPoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPointsPostcond(void (*\fIf\fP) (void*, GoPolypoint*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.fi
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP and \fBGoPolypoint\fP classes.
.nrPN \n%
