.\" $Id: mRegPoly.n,v 1.1.1.1 1992/03/18 09:41:54 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoRegPolygonMetaclass 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoRegPolygonMetaclass\fP \(em the Meta Class object for the \fBGoRegPolygon\fP
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/mRegPoly.h>\fP
.SH 
\fBCLASS\fP
.IP
\fBGoRegPolygonMetaclass\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoPolygonMetaclass\fP class
.IP \(em 3
\fBGoPolylineMetaclass\fP class
.IP \(em 3
\fBGoPolypointMetaclass\fP class
.IP \(em 3
\fBGoGeometricMetaclass\fP class
.IP \(em 3
\fBGoStdDSMetaclass\fP class
.IP \(em 3
\fBGoMetaclass\fP class.
.RE
.SH
\fBDESCRIPTION\fP
.IP
The \fBGoRegPolygonMetaclass\fP class is the common superclass for all
\fBGoRegPolygon\fP objects.
.br
As for other "Metaclasses", there is only one static instance of
\fBGoRegPolygonMetaclass\fP: this instance is returned by
\fBGoRegPolygon::metaclass ()\fP static method.
.IP
Such object is meant to provide methods on \fBGoRegPolygon\fP at
the class level; in particular this allows the programmer to set some
pre/postconditions at the class level.
.IP
.nf
.ta .15i .25i 1.0i
class GoRegPolygonMetaclass {

	public:

		/*
		 * \fBpre and post conditions:\fP
		 */

		void radiusPrecond(GBool (*) (void*, const GoRegPolygon*, GNumber*),
			void*, GAddOrRemove = GADD) const;
		void radiusPostcond(void (*) (void*, GoRegPolygon*),
			void*, GAddOrRemove = GADD);
		void anglePrecond(GBool (*) (void*, const GoRegPolygon*, GNumber*),
			void*, GAddOrRemove = GADD) const;
		void anglePostcond(void (*) (void*, GoRegPolygon*),
			void*, GAddOrRemove = GADD);
		void nbPointPrecond(GBool (*) (void*, const GoRegPolygon*, int*),
			void*, GAddOrRemove = GADD) const;
		void nbPointPostcond(void (*) (void*, GoRegPolygon*),
			void*, GAddOrRemove = GADD);
		void resetPrecond(GBool (*) (void*, const GoRegPolygon*, int*, GNumber*, GNumber*),
			void*, GAddOrRemove = GADD) const;
		void resetPostcond(void (*) (void*, GoRegPolygon*),
			void*, GAddOrRemove = GADD);
};
.fi
.SH
\fBPUBLIC MEMBERS\fP
.IP
.nf
void \fBradiusPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoRegPolygon* \fIregpoly\fP, GNumber* \fIrad\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBradiusPostcond\fP (void (*\fIf\fP) (void* \fIclosure\fP, GoRegPolygon* \fIregpoly\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBanglePrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoRegPolygon* \fIregpoly\fP, GNumber* \fIangle\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBanglePostcond\fP (void (*\fIf\fP) (void* \fIclosure\fP, GoRegPolygon* \fIregpoly\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBnbPointPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoRegPolygon* \fIregpoly\fP, int* \fInb\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBnbPointPostcond\fP (void (*\fIf\fP) (void* \fIclosure\fP, GoRegPolygon* \fIregpoly\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBresetPrecond\fP (GBool (*\fIf\fP) (void* \fIclosure\fP, const GoRegPolygon* \fIregpoly\fP,
			int* \fInb\fP, GNumber* \fIrad\fP, GNumber* \fIangle\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBresetPostcond\fP (void (*\fIf\fP) (void* \fIclosure\fP, GoRegPolygon* \fIregpoly\fP),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.br
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add or remove functions to the pre/post conditions lists
triggered by \fBnbPoint\fP (int), \fBradius\fP (GNumber), \fBangle\fP (GNumber) and
\fBreset\fP (int, GNumber, GNumber) member functions of \fBGoRegPolygon\fP.
.IP \fIf\fP .5i
Specifies programmer's function to be added/removed.
.IP \fIclosure\fP .5i
Specifies programmer's parameter to call the function with.
.IP \fIregpoly\fP .5i
Specifies the GoRegPolygon object involved.
.IP \fIadd\fP .5i
Specifies whether to add or remove the function \fIf\fP from the list.
.RE
.SH
\fBC BINDING\fP
.SS 
\fBHeader\fP
.IP
#include <Go/cRegPolygon.h>
.SS 
\fBFunctions\fP
.IP
.nf
void \fBGoRegPolygonMetaclassAnglePrecond\fP (GObjectId \fIregpolyMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassAnglePostcond\fP (GObjectId \fIregpolyMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassNbPointPrecond\fP (GObjectId \fIregpolyMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, int*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassNbPointPostcond\fP (GObjectId \fIregpolyMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassRadiusPrecond\fP (GObjectId \fIregpolyMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassRadiusPostcond\fP (GObjectId \fIregpolyMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassResetPrecond\fP (GObjectId \fIregpolyMclass\fP, 
			GBool (*\fIf\fP) (void*, const GObjectId, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
void \fBGoRegPolygonMetaclassResetPostcond\fP (GObjectId \fIregpolyMclass\fP, 
			void (*\fIf\fP) (void*, GObjectId),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP);
.fi
.sp 1
.RS .3i
.IP \fIDescription\fP .3i
See \fBGoRegPolygonMetaclass\fP following members :
.sp 1
.nf
void anglePrecond (GBool (*\fIf\fP) (void*, const GoRegPolygon*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void anglePostcond (void (*\fIf\fP) (void*, GoRegPolygon*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void nbPointPrecond (GBool (*\fIf\fP) (void*, const GoRegPolygon*, int*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void nbPointPostcond (void (*\fIf\fP) (void*, GoRegPolygon*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusPrecond (GBool (*\fIf\fP) (void*, const GoRegPolygon*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void radiusPostcond (void (*\fIf\fP) (void*, GoRegPolygon*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPrecond (GBool (*\fIf\fP) (void*, const GoRegPolygon*, int*, GNumber*, GNumber*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
void resetPostcond (void (*\fIf\fP) (void*, GoRegPolygon*),
			void* \fIclosure\fP, GAddOrRemove \fIadd\fP).
.fi
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGo\fP, \fBGoMetaclass\fP, \fBGoStdDS\fP, \fBGoStdDSMetaclass\fP,
\fBGoGeometric\fP, \fBGoGeometricMetaclass\fP, \fBGoPolypoint\fP,
\fBGoPolypointMetaclass\fP, \fBGoPolyline\fP, \fBGoPolylineMetaclass\fP,
\fBGoPolygon\fP, \fBGoPolygonMetaclass\fP and \fBGoRegPolygon\fP classes.
.nrPN \n%
