.\" $Id: FHypSensor.n,v 1.2 1992/12/17 15:33:09 jacomet Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoFullHyperSensor 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoFullHyperSensor\fP \(em the full hyper sensor object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/FHypSensor.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGoFullHyperSensor\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoHyperSensor\fP class
.IP \(em 3
\fBGoStdSensor\fP class
.IP \(em 3
\fBGoSensor\fP class
.IP \(em 3
\fBGo\fP class
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
\fBGoFullHyperSensors\fP sensitive completely objects. Objects can be GoGeometrics, GoTextuals ... and also GoRoot.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoFullHyperSensor : public GoHyperSensor {
	public:
           static GoFullHyperSensor* create(const char* \fIprogram\fP, Go* \fIparent\fP);
           GoFullHyperSensor();
           ~GoFullHyperSensor();
           GoFullHyperSensorMetaclass* metaclass();
           GPen& pen() const;
};

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
GoFullHyperSensor* \fBcreate\fP(const char* \fIprogram\fP, Go* \fIparent\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method creates a sensor and reparent it on the \fIparent\fP object in order to sensitive completely it. The sensor is disactivated. If an error occured it returns NULL.
.IP \fIprogram\fP .5i
.br
Specifies the name used to retrieve the associated interactor. 
.br
This name may be used in \fI.goui\fP files in order to identify this \fIGoFullHyperSensor\fP. Several \fIGoFullHyperSensor\fP may have the same name and they will have the same behavior.
.br
See GoSensor man pages for more details.
.IP \fIparent\fP .5i
.br
Specifies the parent of the \fIGoFullHyperSensor\fP in the \fIGo\fP tree. \fIparent\fP becames completely sensitive.
.RE
.sp 1
.IP
\fBGoFullHyperSensor\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a new instance of the \fIGoFullHyperSensor\fP class.
.RE
.sp 1
.IP
\fB~GoFullHyperSensor\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to destroy an instance of the \fIGoFullHyperSensor\fP class.
.RE
.sp 1
.IP
static GoFullHyperSensorMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of the \fIthis\fP.
.RE
.IP
GPen& \fBpen\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
Returns the pen used for drawing the sensor outline.
.SH
\fBSEE ALSO\fP
.IP
\fBInteractor(3Go)\fP, \fBGoSensor(3Go)\fP, \fBGoStdSensor(3Go)\fP, \fBGoHyperSensor(3Go)\fP and \fBGoPartHyperSensor(3Go)\fP classes.
.sp
.nrPN \n%
