.\" $Id: HypSensor.n,v 1.2 1992/12/17 15:33:15 jacomet Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoHyperSensor 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoHyperSensor\fP \(em the hyper sensor object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/HypSensor.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGoHyperSensor\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoStdSensor\fP class
.IP \(em 3
\fBGoSensor\fP class
.IP \(em 3
\fBGo\fP class
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
\fBGoHyperSensors\fP are graphic objects used by GoHyper editor to sensitive objects and to implement hypertext functionnalities.
\fBGoHyperSensors\fP may be visible or invisible. The sensor shape is defined in the sub-classes, this is why this class cannot be instanciable.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoHyperSensor : public GoStdSensor {
	public:
		GBool show();
		void show(GBool \fIyes\fP);
		void showPrecond(GBool (*\fIproc\fP)(void*, GoHyperSensor*, GBool*), 
				void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
		void showPostcond(void (*\fIproc\fP)(void*, GoHyperSensor*, GBool*), 
				void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD);
		GPen& pen() const = 0;
};

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
GBool \fBshow\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE if the sensor is visible, otherwise it returns GFALSE.
.RE
.sp 1
.IP
.nf
void \fBshow\fP(GBool \fByes\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to make the sensor visible or not.
.IP \fIyes\fP .5i
.br
Specifies the sensor visibility.
.RE
.sp 1
.IP
.nf
void \fBshowPrecond\fP(GBool (*\fIproc\fP)(void*, GoHyperSensor*, GBool*), void* \fIclosure\fP, 
			GAddOrRemove \fIadd\fP = GADD);
void \fBshowPostcond\fP(void (*\fIproc\fP)(void*, GoHyperSensor*, GBool*), void* \fIclosure\fP, 
			GAddOrRemove \fIadd\fP = GADD);
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add or to remove pre or postcondition procedures when the sensor 
.br
visibility is changed.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the sensor visibility is changed. 
.br
The precondition procedure is called before changing the visibility. It can either 
.br
accept or refuse the modification. The postcondition procedure is invoked after changing 
.br
visibility.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the pre/postcondition procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the modify
callback list. If \fIadd\fP is GREMOVE, the callback procedure \fIproc\fP will be removed
from  the callback list.
.RE
.IP
GPen& \fBpen\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
Returns the pen used for drawing the sensor outline.
.SH
\fBSEE ALSO\fP
.IP
\fBInteractor(3Go)\fP \fBGoSensor(3Go)\fP and \fBGoStdSensor(3Go)\fP classes.
.sp
.nrPN \n%
