.\" $Id: MPEditor.n,v 1.4 1993/01/04 08:46:07 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH MultiPageEditor 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBMultiPageEditor\fP
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/MPEditor.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGMultiPageEditor\fP inherits behavior from;
.RS 10
.IP \(em 3
GEditor class.
.IP \(em 3
GShell class.
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGMultiPageEditor\fP class is a one window - several pages editor. Several GoRoots are created. Only one Goroot is associated with one GoInterf at one time. The others GoRoots are associated to a default GoInterf. Each GoRoots are called \fBpages\fP. All functionnalities to manage pages are implemented in this class.
.sp 1
.nf
.ta .15i .25i 1.0i
class GMultiPageEditor : public GEditor
{
	public:
	GMultiPageEditor(GWindow* \fIwindow\fP);
	~GMultiPageEditor();
	GoRoot* goroot();
	BGoUIEditor* goui();
	ushort newPage(const char* root_sensor_name=NULL, GBool \fIgoui\fP=GTRUE, int \fInum\fP=-1);
	ushort deletePage(int \fInum\fP=-1);
	ushort page(uint \fInum\fP);
	ushort nextPage();
	ushort previousPage();
	uint currentPage();
	uint numberOfPages();
	ushort reparentOnPage(GSet* \fIgos\fP, int \fInum\fP=-1);

};
.fi
.sp 1
.SH
\fBRETURNED VALUE DEFINITIONS\fP
.IP
Some methods return a ushort value. In this case this value is one of the following values :
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
GERROR
GOK
GNO_NEXT_PAGE
GNO_PREVIOUS_PAGE
GNO_INDICATED_PAGE
.fi
.RE
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGMultiPageEditor\fP(GWindow* \fIwindow\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Constructor method. A GMultiPageEditor is always associated with a GWindow instance.
.IP \fIwindow\fP .5i
.br
Specifies the GWindow instance. This instance must contain a BGoUIEditor instance.
.RE
.IP
.nf
\fB~GMultiPageEditor\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Destructor method.
.RE
.IP
.nf
GoRoot* \fBgoroot\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Returns the displayed GoRoot instance.
.RE
.IP
.nf
BGoUIEditor* \fBgoui\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Returns the GoUI instance associated with the displayed GoRoot instance.
.RE
.IP
.nf
ushort \fBnewPage\fP(const char* \fIroot_sensor_name\fP=NULL, GBool \fIgoui\fP=GTRUE, int \fInum\fP=-1);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method creates a new page i.e it creates a new GoRoot instance, creates a GoFullSensor instance (if \fIroot_sensor_name\fP is not NULL) and a BGoUIEditor instance (if \fIgoui\fP is GTRUE). This new page is the page \fInum\fP. 
.br
The returned value may be one of the following: GOK or GNO_INDICATED_PAGE.
.IP \fIroot_sensor_name\fP .5i
.br
If not NULL, a GoFullSensor instance is created and is named \fIroot_sensor_name\fP. This instance is reparented on the new GoRoot instance.
.IP \fIgoui\fP .5i
.br
If GTRUE, a BGoUIEditor instance is created. This instance is associated with the new GoRoot instance.
.IP \fInum\fP .5i
.br
Specifies the page number. If \fInum\fP is not specified, the new page is the current page and the old current page becomes the current page + 1.
.RE
.IP
.nf
ushort \fBdeletePage\fP(int \fInum\fP=-1);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Deletes the specified page.
.br
The returned value may be one of the following: GOK, GNO_INDICATED_PAGE or GERROR.
.IP \fInum\fP .5i
.br
Specifies the page number. If \fInum\fP is not specified, the current page is deleted. If the current page was the first page, the old next page becomes the current page, otherwise the old previous page becomes the current page.
.RE
.IP
.nf
ushort \fBpage\fP(int \fInum\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Displays the page \fInum\fP.
.br
The returned value may be one of the following: GOK or GNO_INDICATED_PAGE.
.IP \fInum\fP .5i
.br
Specifies the page number.
.RE
.IP
.nf
ushort \fBnextPage\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Displays the next page.
.br
The returned value may be one of the following: GOK or GNO_NEXT_PAGE.
.RE
.IP
.nf
ushort \fBpreviousPage\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Displays the previous page.
.br
The returned value may be one of the following: GOK or GNO_PREVIOUS_PAGE.
.RE
.IP
.nf
uint \fBcurrentPage\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Returns the current page number.
.RE
.IP
.nf
uint \fBnumberOfPages\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Returns the total number of pages.
.RE
.IP
.nf
ushort \fBreparentOnPage\fP(GSet* \fIgos\fP, int \fInum\fP=-1);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Reparents Graphic Objects contained in the \fIgos\fP set on the page \fInum\fP.
.br
The returned value may be one of the following: GOK or GNO_INDICATED_PAGE.
.IP \fInum\fP .5i
.br
Specifies the page number. If \fInum\fP is not specified, Graphic Objects are reparented on the current page.
.SH
\fBSEE ALSO\fP
.IP
\fB Shell(3Go) Window(3Go) Editor(3Go)\fP
.nrPN \n%
