.\" $Id: PHypSensor.n,v 1.2 1992/12/17 15:33:21 jacomet Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoPartHyperSensor 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoPartHyperSensor\fP \(em the part hyper sensor object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/PHypSensor.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGoPartHyperSensor\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoHyperSensor\fP class
.IP \(em 3
\fBGoStdSensor\fP class
.IP \(em 3
\fBGoSensor\fP class
.IP \(em 3
\fBGo\fP class
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
\fBGoPartHyperSensors\fP sensitive a part of an object. In fact the sensitive part is defined by at least one GoGeometric. This GoGeometric is the sensor child and only GoGemetrics may be sensor children.
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoPartHyperSensor : public GoHyperSensor {
	public:
           static GoPartHyperSensor* create(const char* \fIprogram\fP, Go* \fIparent\fP, 
					const GoMetaclass** \fItype\fP);
           GoPartHyperSensor();
           ~GoPartHyperSensor();
           static GoPartHyperSensorMetaclass* metaclass();
           GPen& pen() const;
           GBrush& brush() const;
};

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
GoPartHyperSensor* \fBcreate\fP(const char* \fIprogram\fP, Go* \fIparent\fP, const GoMetaclass** \fItype\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method creates a sensor, reparents it on \fIparent\fP object and adds GoGeometric objects as sensor children. The sensor is disactivated. If an error occured it returns NULL.
.IP \fIprogram\fP .5i
.br
Specifies the name used to retrieve the specified interactor.
.br
 This name will be used in \fI.goui\fP files in order to identify this \fIGoPartHyperSensor\fP. Several \fIGoPartHyperSensor\fP may have the same name and they will have the same behavior.
.br
See GoSensor man pages for more details.
.IP \fIparent\fP .5i
.br
Specifies the parent of the \fIGoPartHyperSensor\fP in the \fIGo\fP tree. A part of \fIparent\fP becames sensitive.
.IP \fItype\fP .5i
.br
This is an array of GoMetaclass pointers. An instance of each specified GoMetaclass is created and reparented on the sensor. These GoGeometrics define the sensitive parts of the \fIparent\fP object. Their attributes and characteristics may be modified. If \fItype\fP is NULL, no child is created. In this case you have to
create it yourself and reparent it on the sensor.
.RE
.sp 1
.IP
\fBGoPartHyperSensor\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a new instance of the \fIGoPartHyperSensor\fP class.
.RE
.sp 1
.IP
\fB~GoPartHyperSensor\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to destroy an instance of the \fIGoPartHyperSensor\fP class.
.RE
.sp 1
.IP
static GoPartHyperSensorMetaclass* \fBmetaclass\fP();
.RS .8i
.IP \fIDescription\fP .5i
Returns a pointer to the metaclass object of the \fIthis\fP.
.RE
.IP
.nf
GPen& \fBpen\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
Returns the pen used for drawing the outline of the sensor children.
.RE
.sp 1
.IP
GBrush& \fBbrush\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
Returns the brush used for drawing the background of the sensor children.
.SH
\fBSEE ALSO\fP
.IP
\fBInteractor(3Go)\fP, \fBGoSensor(3Go)\fP, \fBGoStdSensor(3Go)\fP, \fBGoHyperSensor(3Go)\fP  and \fBGoFullHyperSensor(3Go)\fP classes.
.sp
.nrPN \n%
