.\" $Id: PSConverter.n,v 1.2 1992/12/17 15:33:23 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH PSConverter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBPSConverter\fP \(em the converter class form Go format to Postscript.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/PSConverter.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGPSConverter\fP inherits behavior from \fBGConverter\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGPSConverter\fP class implements conversion functions from Go formats (Go Id, ascii GoStream ...) to postscript format.
.sp 1
.nf
.ta .15i .25i 1.0i
class GPSConverter : public GConverter {
	public:
	GPSConverter();
	~GPSConverter();
    
	char* goToPostscript(const GSet* \fIgo\fP, ulong& \fIsize\fP) const;
	ushort goToPostscriptFile(const GSet* \fIgo\fP, const char* \fIfilename\fP) const;
	char* gostreamFileToPostscript(const char* \fIfilename\fP, ulong& \fIsize\fP) const;
	ushort gostreamFileToPostscriptFile(const char* \fIg_filename\fP,						const char* \fIp_filename\fP) const;
	char* gostreamToPostscript(const char* \fIgostream\fP, const ulong \fIg_size\fP, ulong& \fIp_size\fP) const;
	ushort gostreamToPostscriptFile(const char* \fIgostream\fP, const \fIulong\fP g_size,
					const char* \fIfilename\fP) const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGPSConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class constructor.
.RE
.sp 1
.IP
.nf
\fB~GPSConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class destructor.
.RE
.sp 1
.IP
.nf
char* \fBgoToPostscript\fP (const GSet* \fIgo\fP, ulong& \fIsize\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript stream containing Go trees. If no error occured, it returns the postscript stream, otherwise it returns NULL.
.IP \fIgo\fP .5i
.br
Contains the Go trees to convert in postscript format.
.IP \fIsize\fP .5i
.br
Returns the postscript stream size.
.RE
.sp 1
.IP
.nf
ushort \fBgoToPostscriptFile\fP (const GSet* \fIgo\fP, const char* \fIfilename\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript file containing Go trees. If no error occured, it returns GOK, otherwise it returns one of the following values: GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR.
.IP \fIgo\fP .5i
.br
Contains the Go trees to convert in postscript format.
.IP \fIfilename\fP .5i
.br
Specifies the postscript filename.
.RE
.sp 1
.IP
.nf
char* \fBgostreamFileToPostscript\fP (const char* \fIfilename\fP, ulong& \fIsize\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript stream from a gostream file. Only Go trees are converted in postscript (shared objects are ignored). If no error occured, it returns the postscript stream, otherwise it returns NULL.
.IP \fIfilename\fP .5i
.br
Specifies the gostream filename.
.IP \fIsize\fP .5i
.br
Returns the postscript stream size.
.RE
.sp 1
.IP
.nf
ushort \fBgostreamFileToPostscriptFile\fP (const char* \fIg_filename\fP, const char* \fIp_filename\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript file from a gostream file. Only Go trees are converted in postscript (shared objects are ignored). If no error occured, it returns the GOK, otherwise it returns one of the following values: GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GNO_FILE or GLOAD_STREAM_ERROR.
.IP \fIg_filename\fP .5i
.br
Specifies the gostream filename.
.IP \fIp_filename\fP .5i
.br
Specifies the postscript filename.
.RE
.sp 1
.IP
.nf
char* \fBgostreamToPostscript\fP (const char* \fIgostream\fP, const ulong \fIg_size\fP, ulong& \fIp_size\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript stream from a gostream. Only Go trees are converted in postscript (shared objects are ignored). If no error occured, it returns the postscript stream, otherwise it returns NULL.
.IP \fIgostream\fP .5i
.br
Specifies the gostream to read.
.IP \fIg_size\fP .5i
.br
Specifies the gostream size.
.IP \fIp_size\fP .5i
.br
Returns the postscript stream size.
.RE
.sp 1
.IP
.nf
ushort \fBgostreamToPostscriptFile\fP (const char* \fIgostream\fP, const ulong \fIg_size\fP, const char* \fIfilename\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a postscript file from a gostream. Only Go trees are converted in postscript (shared objects are ignored). If no error occured, it returns GOK, otherwise it returns one of the following values: GERROR, GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GNO_FILE or GLOAD_STREAM_ERROR.
.IP \fIgostream\fP .5i
.br
Specifies the gostream to read.
.IP \fIg_size\fP .5i
.br
Specifies the gostream size.
.IP \fIfilename\fP .5i
.br
Specifies the created postscript filename.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS 
\fBHeader file\fP
.IP
#include <Go/Ext/cPSConverter.h>
.SS 
\fBC Functions\fP
.IP
GObjectId \fBGCreatePSConverter\fP ();
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::GPSConverter().
.RE
.sp 1
.IP
void \fBGDestroyPSConverter\fP (GObjectId \fIconv\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::~GPSConverter().
.RE
.sp 1
.IP
char* \fBGPSConverterGoToPostscript\fP(GObjectId \fIconv\fP, const GObjectId \fIgo\fP, ulong* \fIsize\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::goToPostscript().
.RE
.sp 1
.IP
GBool \fBGPSConverterGoToPostscriptFile\fP(GObjectId \fIconv\fP, const GObjectId \fIgo\fP, 
			const char* \fIfilename\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::goToPostscriptFile().
.RE
.sp 1
.IP
char* \fBGPSConverterGostreamFileToPostscript\fP(GObjectId \fIconv\fP, const char* \fIfilename\fP,
			ulong* \fIsize\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::gostreamFileToPostscript().
.RE
.sp 1
.IP
char* \fBGPSConverterGostreamToPostscript\fP(GObjectId \fIconv\fP, const char* \fIgostream\fP,
			const ulong \fIg_size\fP, ulong* \fIp_size\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::gostreamToPostscript().
.RE
.sp 1
.IP
GBool \fBGPSConverterGostreamToPostscriptFile\fP(GObjectId \fIconv\fP, const char* \fIgostream\fP,
			const ulong \fIg_size\fP, const char* \fIfilename\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::gostreamToPostscriptFile().
.RE
.sp 1
.IP
GBool \fBGPSConverterGostreamFileToPostscriptFile\fP(GObjectId \fIconv\fP, const char* \fIg_filename\fP,
			const char* \fIp_filename\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GPSConverter::gostreamFileToPostscriptFile().
.SH
\fBSEE ALSO\fP
.IP
\fBConverter(3Go), GoStream(3Go), PSGoInterf(3Go)\fP.
.nrPN \n%
