.\" $Id: Shell.n,v 1.2 1992/12/17 15:33:25 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Shell 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBShell\fP
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/Shell.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGShell\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGShell\fP class is associated with a GWindow subclass instance. This class manages the Go Assoc (Assoc allows to associate semantic datas with Graphic objects). This class allows to add, remove and get associations on Go. This class automatically sets save/restore postconditions used to save/restore these associations. 
.br
This class also allows to copy Graphic Objects in a ClipboardInterface object.
.sp 1
.nf
.ta .15i .25i 1.0i
class GShell
{
	public:
	GShell(GWindow* \fIwindow\fP);
	~GShell();

	GWindow* window();
	GoInterf* gointerf();
	GoRoot* goroot();
	void clipboardInterf(GClipboardInterf* \fIinterf\fP);
	GClipboardInterf* clipboardInterf();
	GBool copy(GSet* \fIgos\fP, GTimeStamp \fItime\fP);
	void  addAssocOnGo(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
	void  addAssocOnGo(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP,
				int \fIsize\fP=sizeof(void*)); 
	void  setAssocOnGo(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
	void  setAssocOnGo(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP,
				int \fIsize\fP=sizeof(void*)); 
	const void* getAssocOnGo(const Go* \fIgo\fP, const void* \fIkey\fP, int& \fInum_elem\fP);
	const void* getAssocOnGo(const Go* \fIgo\fP, const char* \fIkey\fP, int& \fInum_elem\fP);
	void  removeAssocOnGo(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
	void  removeAssocOnGo(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP,
				int \fIsize\fP=sizeof(void*)); 
	const void* assocKeyOnGo(const Go* \fIgo\fP, int& \fInb_key\fP);
};
.fi
.RE
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGShell\fP(GWindow* \fIwindow\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Constructor method. A GShell is always associated with a GWindow instance.
.IP \fIwindow\fP .5i
.br
Specifies the GWindow instance.
.RE
.sp 1
.IP
.nf
\fB~GShell\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
Destructor method.
.RE
.sp 1
.IP
.nf
GoInterf* \fBgointerf\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created GoInterf instance associated with GShell instance.
.RE
.sp 1
.IP
.nf
GoRoot* \fBgoroot\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created GoRoot instance associated with GShell instance.
.RE
.sp 1
.IP
.nf
void \fBclipboardInterf\fP(GClipboardInterf* \fIinterf\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
Indicates to the GShell instance which GClipboardInterf instance has to be used to copy objects.
.RE
.sp 1
.IP
.nf
G\
ClipboardInterf* \fBclipboardInterf\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the GClipboardInterf instance used by GShell.
.RE
.sp 1
.IP
.nf
GBool \fBcopy\fP(GSet* \fIgos\fP, GTimeStamp \fItime\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method copies Graphic Objects in the GClipboardInterf instance.
.IP \fIgos\fP .5i
.br
This GSet contains the Go trees to copy.
.IP \fItime\fP .5i
.br
Specifies the time indicated in the GEvent structure.
.RE
.IP
.nf
void \fBaddAssocOnGo\fP(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method adds on the Graphic Object \fIgo\fP the association composed by the key \fIk\fP and the value \fIvalue\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key of the association. This key is a NULL terminated string.
.IP \fIvalue\fP .5i
.br
Specifies the value of the association. This value is a NULL terminated string. The string is copied inside the \fIAssoc\fP instance and then may be freed by the application.
.RE
.IP
.nf
void \fBaddAssocOnGo\fP(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP, int \fIsize\fP=sizeof(void*)); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method adds on the Graphic Object \fIgo\fP the association composed by the key \fIk\fP and the value \fIvalue\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key of the association.
.IP \fIvalue\fP .5i
.br
Specifies the value of the association.
.IP \fIsize\fP .5i
.br
The value is a \fIsize\fP byte buffer. The buffer is copied inside the \fIAssoc\fP instance and then may be freed by the application.
.RE
.IP
.nf
void \fBsetAssocOnGo\fP(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method removes the existing associations composed by the key \fIk\fP on the Graphic Object \fIgo\fP and then adds on the Graphic Object \fIgo\fP the association composed by the key \fIk\fP and the value \fIvalue\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key of the association. This key is a NULL terminated string.
.IP \fIvalue\fP .5i
.br
Specifies the value of the association. This value is a NULL terminated string. The string is copied inside the \fIAssoc\fP instance and then may be freed by the application.
.RE
.IP
.nf
void \fBsetAssocOnGo\fP(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP, int \fIsize\fP=sizeof(void*)); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method removes the existing associations composed by the key \fIk\fP on the Graphic Object \fIgo\fP and then adds on the Graphic Object \fIgo\fP the association composed by the key \fIk\fP and the value \fIvalue\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key of the association.
.IP \fIvalue\fP .5i
.br
Specifies the value of the association.
.IP \fIsize\fP .5i
.br
The value is a \fIsize\fP byte buffer. The buffer is copied inside the \fIAssoc\fP instance and then may be freed by the application.
.RE
.IP
.nf
const void* \fBgetAssocOnGo\fP(Go* \fIgo\fP, const void* \fIkey\fP, int& \fInum_elem\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to get all values associated to the key \fIkey\fP on the Graphic Object \fIgo\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIkey\fP .5i
.br
Specifies the key used as the identifier of the association.
.IP \fInum_elem\fP .5i
.br
Specified the value array size returned by the method.
.RE
.IP
.nf
const void* \fBgetAssocOnGo\fP(Go* \fIgo\fP, const char* \fIkey\fP, int& \fInum_elem\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to get all values associated to the key \fIkey\fP on the Graphic Object \fIgo\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIkey\fP .5i
.br
Specifies the key used as the identifier of the association. This key is a NULL terminated string.
.IP \fInum_elem\fP .5i
.br
Specified the value array size returned by the method.
.RE
.IP
.nf
void \fBremoveAssocOnGo\fP(Go* \fIgo\fP, const char* \fIk\fP, const char* \fIvalue\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to remove the value \fIvalue\fP associated to the key \fIk\fP on the Graphic Object \fIgo\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key used as the identifier of the association. This key is a NULL terminated string.
.IP \fIvalue\fP .5i
.br
Specified the value to remove.
.RE
.IP
.nf
void \fBremoveAssocOnGo\fP(Go* \fIgo\fP, const void* \fIk\fP, const void* \fIvalue\fP, int \fIsize\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to remove the value \fIvalue\fP associated to the key \fIk\fP on the Graphic Object \fIgo\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fIk\fP .5i
.br
Specifies the key used as the identifier of the association. This key is a NULL terminated string.
.IP \fvalue\fP .5i
.br
Specified the value to remove.
.IP \fIsize\fP .5i
.br
The value is a \fIsize\fP byte buffer.
.RE
.IP
.nf
const void* \fBassocKeyOnGo\fP(Go* \fIgo\fP, int& \fInb_key\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the association key array of the Graphic Object \fIgo\fP.
.IP \fIgo\fP .5i
.br
Specifies the Graphic Object.
.IP \fInb_key\fP .5i
.br
Returns the size of the key array.
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fB ClipboardInterf(3Go) Assoc(3Go) Window(3Go)\fP
.nrPN \n%
