.\" $Id: Tiff.n,v 1.1 1992/12/16 12:43:48 mbikina Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Tiff 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBTiff\fP \(em the tiff filter.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/Tiff.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBTiff\fP filter gives a way to load/save a \fBtiff\fP image format \fIfile\fP or a \fImedium\fP.
.sp 1
.nf
.ta .15i .25i 1.5i
	GBool GTiffLoad(const char* \fIfullname\fP, GImageBrushValues& \fIib_values\fP,
		GPixelArrayValues& \fIpa_values\fP);

	GBool GTiffLoad(class GMedium* \fImedium\fP,  GImageBrushValues& \fIib_values\fP,
		GPixelArrayValues& \fIpa_values\fP);

	GBool GTiffSave(const char* \fIfullname\fP, GImageBrushValues& \fIib_values\fP,
		GPixelArrayValues& \fIpa_values\fP);

	GBool GTiffSave(class GMedium* \fImedium\fP,  GImageBrushValues& \fIib_values\fP,
		GPixelArrayValues& \fIpa_values\fP);
.fi
.sp 1
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
GBool \fBGTiffLoad\fP(const char* \fIfullname\fP, GImageBrushValues& \fIib_values\fP, GPixelArrayValues& \fIpa_values\fP);
.IP
GBool \fBGTiffLoad\fP(class GMedium* \fImedium\fP, GImageBrushValues& \fIib_values\fP, GPixelArrayValues& \fIpa_values\fP);
.IP
GBool \fBGTiffSave\fP(const char* \fIfullname\fP, GImageBrushValues& \fIib_values\fP, GPixelArrayValues& \fIpa_values\fP);
.IP
GBool \fBGTiffSave\fP(class GMedium* \fImedium\fP, GImageBrushValues& \fIib_values\fP, GPixelArrayValues& \fIpa_values\fP);
.RS .8i
.IP \fIDescription\fP .5i
The function GTiffLoad allows to get, from a Tiff \fIfile\fP or \fImedium\fP, an ImageBrushValues and a PixelArrayValues. It returns GTRUE if the load is correct else it returns GFALSE.
The function GTiffSave allows to save an ImageBrushValues and a PixelArrayValues as a Tiff \fIfile\fP or \fImedium\fP. It returns GTRUE if the save is correct else it returns GFALSE.
.IP \fIfullname\fP .5i
.br
Specifies the full path of the file. The functions opens the file on "r" (cf FileMedium (3Go)).
.IP \fImedium\fP .5i
.br
Specifies the \fImedium\fP used to read the Tiff format. The \fImedium\fP must be available for its \fIread\fP methods (cf Medium (3Go)).
.IP \fIimagebrush_values\fP.
.RS .5i
Specifies the structure used to give back the \fIattributes\fP of the image. The method sets:
.RS .8i
- ib_values.function to GCOPY.
.br
- ib_values.plane_mask to GALL_PLANES.
.br
- ib_values.fill.style to GFILL_SOLID.
.br
- ib_values.stipple to NULL.
.br
- ib_values.colormap to the \fIcolormap\fP read from the tiff format. On error this field is NULL.
.RE
.IP \fPpixelarray_values\fP.
.RS .5i
Specifies the structure used to give back the \fIdata\fP of the image. The function sets all the fields of the \fIpa_values\fP structure. On error \fPpa_values.data\fP is NULL.
.RE
.sp1
.SH
\fBC BINDING\fP
.sp 1
\fBC Header File\fP
.IP
\fI#include <Go/Ext/cTiff.h>\fP
.sp 1
.LP
\fBC Functions\fP
.sp 1
.nf
.ta .15i .25i 1.5i
	GBool GCTiffLoad(const char* \fIfullname\fP,  GImageBrushValues* \fIib_values\fP,
		GPixelArrayValues* \fIpa_values\fP);

	GBool GCTiffLoad(class GMedium* \fImedium\fP, GImageBrushValues* \fIib_values\fP,
		GPixelArrayValues* \fIpa_values\fP);

	GBool GCTiffSave(const char* \fIfullname\fP,  GImageBrushValues* \fIib_values\fP,
		GPixelArrayValues* \fIpa_values\fP);

	GBool GCTiffSave(class GMedium* \fImedium\fP, GImageBrushValues* \fIib_values\fP,
		GPixelArrayValues* \fIpa_values\fP);
.fi
.IP \fIDescription\fP .5i
See above the corresponding C++ function. The C++ reference is equivalent to a pointer in C.
.SH
\fBUSAGE INFORMATION\fP
.IP
.SH
\fBSEE ALSO\fP
.IP
\fBGMedium\fP, \fBGFileMedium\fP, 
\fBGShPixelArray\fP, \fPGShImageBrush\fP classes.
.nrPN \n%





