.\" $Id: Window.n,v 1.3 1992/12/21 16:53:04 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Window 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBWindow\fP
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/Window.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGWindow\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGWindow\fP class creates a GoRoot instance. If specified, it creates a GoUI instance and a GoFullSensor instance which is reparented on the GoRoot instance.
.br
A GoInterf instance is created by the GWindow sub-classes.
.sp 1
.nf
.ta .15i .25i 1.0i
typedef enum {
    GNoGoUI,
    GGoUI,
    GGoUISelector,
    GBGoUIEditor
} GoUIType;

class GWindow
{
	public:
	GoInterf* gointerf();
	GoRoot* goroot();
	GoUI* goui();
	const char* rootSensorName();
	virtual void windowSize(GNumber \fIw\fP, GNumber \fIh\fP)=0;
	GNumber windowWidth();
	GNumber windowHeight();
};
.fi
.RE
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
GoInterf* \fBgointerf\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created GoInterf instance associated with the created GoRoot instance.
.RE
.sp 1
.IP
.nf
GoRoot* \fBgoroot\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created GoRoot instance.
.RE
.sp 1
.IP
.nf
GoUI* \fBgoui\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created GoUI instance.
.RE
.sp 1.
.IP
.nf
const char* \fBrootSensorName\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the name of the GoFullSensor instance.
.RE
.sp 1
.IP
.nf
virtual void \fBwindowSize\fP(GNumber \fIw\fP, GNumber \fIh\fP) = 0;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method sets the width and the height of the created window.
.IP \fIw\fP .5i
.br
Specifies the width.
.IP \fIh\fP .5i
.br
Specifies the height.
.RE
.sp 1
.IP
.nf
GNumber \fBwidth\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the window width.
.RE
.sp 1
.IP
.nf
GNumber \fBheight\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the window height.
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
\fIGWindow\fP instances cannot be directly created but \fIGWindow\fP subclass instances, this explains why there are not public constructors.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBXWindow(3Go) XmWindow(3Go)\fP.
.nrPN \n%
