.\" $Id: XConverter.n,v 1.2 1992/12/17 15:33:30 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XConverter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXConverter\fP \(em the converter class using X Window System formats.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XConverter.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXConverter\fP inherits behavior from \fBGConverter\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXConverter\fP class implements conversion functions from Go formats (Go Id, GoStream ...) and X formats to Go formats and X formats. 
.sp 1
.nf
.ta .15i .25i 1.0i
class GXConverter : public GConverter {
	public:
	GXConverter();
	~GXConverter();
	Pixmap   goToBitmap(XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	ushort goToBitmapFile(XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP,
				const char* \fIfilename\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	Pixmap   goToPixmap(XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	Pixmap   gostreamToBitmap(XGoInterf* \fIinterf\fP, const char* \fIstream\fP,
				const ulong \fIsize\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	ushort gostreamToBitmapFile(XGoInterf* \fIinterf\fP, const char* \fIstream\fP,
				const ulong \fIsize\fP, const char* \fIfilename\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	Pixmap   gostreamToPixmap(XGoInterf* \fIinterf\fP, const char* \fIstream\fP,
				const ulong \fIsize\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	Pixmap   gostreamFileToBitmap(XGoInterf* \fIinterf\fP, const char* \fIfilename\fP, 
				uint& \fIwidth\fP, uint& \fIheight\fP) const;
	ushort gostreamFileToBitmapFile(XGoInterf* \fIinterf\fP, const char* \fIg_filename\fP, 
				const char* \fIb_filename\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
	Pixmap   gostreamFileToPixmap(XGoInterf* \fIinterf\fP, const char* \fIfilename\fP, 
				uint& \fIwidth\fP, uint& \fIheight\fP) const;
	GoImage* bitmapToGo(const XGoInterf* \fIinterf\fP, const Pixmap \fIbitmap\fP) const;
	GoImage* pixmapToGo(const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP) const;
	char*    bitmapToGostream(const XGoInterf* \fIinterf\fP, const Pixmap \fIbitmap\fP, ulong& \fIsize\fP, 
				GStreamFile \fItype\fP, char* \fIheader\fP) const; 
	char*    pixmapToGostream(const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP,
			      ulong& \fIsize\fP, GStreamFile \fItype\fP, char* \fIheader\fP) const;
	ushort bitmapToGostreamFile(const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP,
				const char* \fIfilename\fP, GStreamFile \fItype\fP, char* \fIheader\fP) const;
	ushort pixmapToGostreamFile(const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP,
				const char* \fIfilename\fP, GStreamFile \fItype\fP, char* \fIheader\fP) const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class constructor.
.RE
.sp 1
.IP
.nf
\fB~GXConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class destructor.
.RE
.sp 1
.IP
.nf
Pixmap \fBgoToBitmap\fP (XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap from Go trees. If no error occured, it returns the created bitmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies the XGoInterface on which Go trees are displayed.
.IP \fIgo\fP .5i
.br
Contains the Go trees.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1
.IP
.nf
ushort \fBgoToBitmapFile\fP (XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP, const char* \fIfilename\fP, 
			uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap file from Go trees. If no error occured, it returns GOK, otherwise it returns GERROR.
.IP \fIinterf\fP .5i
.br
Specifies the XGoInterface on which Go trees are displayed.
.IP \fIgo\fP .5i
.br
Contains the Go trees.
.IP \fIfilename\fP .5i
.br
Specifies the bitmap filename.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1
.IP
.nf
Pixmap \fBgoToPixmap\fP (XGoInterf* \fIinterf\fP, const GSet* \fIgo\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a pixmap from Go trees. If no error occured, it returns the created pixmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies the XGoInterface on which Go trees are displayed.
.IP \fIgo\fP .5i
.br
Contains the Go trees.
.IP \fIwidth\fP .5i
.br
Returns the created pixmap width.
.IP \fIheight\fP .5i
.br
Returns the created pixmap height.
.RE
.sp 1
.IP
.nf
Pixmap \fBgostreamToBitmap\fP (XGoInterf* \fIinterf\fP, const char* \fIstream\fP, const ulong \fIsize\fP, 
			uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap from gostream. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns the created bitmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIstream\fP .5i
.br
Specifies the gostream.
.IP \fIsize\fP .5i
.br
Specifies the gostream size.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1
.IP
.nf
ushort \fBgostreamToBitmapFile\fP (XGoInterf* \fIinterf\fP, const char* \fIstream\fP, const ulong \fIsize\fP, 
			const char* \fIfilename\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap file from gostream. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns GOK, otherwise it returns one of the following values: GERROR, GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GNO_FILE or GLOAD_STREAM_ERROR.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIstream\fP .5i
.br
Specifies the gostream.
.IP \fIsize\fP .5i
.br
Specifies the gostream size.
.IP \fIfilename\fP .5i
.br
Specifies the bitmap filename.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1
.IP
.nf
Pixmap \fBgostreamToPixmap\fP (XGoInterf* \fIinterf\fP, const char* \fIstream\fP,
			const ulong \fIsize\fP, uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a pixmap from gostream. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns the created pixmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIstream\fP .5i
.br
Specifies the gostream.
.IP \fIsize\fP .5i
.br
Specifies the gostream size.
.IP \fIwidth\fP .5i
.br
Returns the created pixmap width.
.IP \fIheight\fP .5i
.br
Returns the created pixmap height.
.RE
.sp 1
.IP
.nf
Pixmap \fBgostreamFileToBitmap\fP (XGoInterf* \fIinterf\fP, const char* \fIfilename\fP,
			uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap from gostream file. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns the created bitmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIfilename\fP .5i
.br
Specifies the gostream filename.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1.
.IP
.nf
ushort \fBgostreamFileToBitmapFile\fP (XGoInterf* \fIinterf\fP, const char* \fIg_filename\fP, const char* \fIb_filename\fP,
			uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a bitmap file from gostream file. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns GOK, otherwise it returns one of the following values: GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GNO_FILE, GLOAD_STREAM_ERROR or GERROR.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIg_filename\fP .5i
.br
Specifies the gostream filename.
.IP \fIb_filename\fP .5i
.br
Specifies the bitmap filename.
.IP \fIwidth\fP .5i
.br
Returns the created bitmap width.
.IP \fIheight\fP .5i
.br
Returns the created bitmap height.
.RE
.sp 1.
.IP
.nf
Pixmap \fBgostreamFileToPixmap\fP (XGoInterf* \fIinterf\fP, const char* \fIfilename\fP,
			uint& \fIwidth\fP, uint& \fIheight\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a pixmap from gostream file. Only Go trees are converted to bitmap (shared objects are ignored). If no error occured, it returns the created pixmap, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies a XGoInterface.
.IP \fIfilename\fP .5i
.br
Specifies the gostream filename.
.IP \fIwidth\fP .5i
.br
Returns the created pixmap width.
.IP \fIheight\fP .5i
.br
Returns the created pixmap height.
.RE
.sp 1.
.IP
.nf
GoImage* \fBbitmapToGo\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIbitmap\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a GoImage from a bitmap. If no error occured, it returns the created GoImage, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies the XGoInterface on which the GoImage will be mapped.
.IP \fIbitmap\fP .5i
.br
Specifies the bitmap to convert.
.RE
.sp 1.
.IP
.nf
GoImage* \fBpixmapToGo\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a GoImage from a pixmap. If no error occured, it returns the created GoImage, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies the XGoInterface on which the GoImage will be mapped.
.IP \fIpixmap\fP .5i
.br
Specifies the pixmap to convert.
.RE
.sp 1.
.IP
.nf
char* \fBbitmapToGostream\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIbitmap\fP, ulong& \fIsize\fP, 
			GStreamFile \fItype\fP, char* \fIheader\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a gostream from a bitmap. If no error occured, it returns the created gostream, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies XGoInterface.
.IP \fIbitmap\fP .5i
.br
Specifies the bitmap to convert.
.IP \fIsize\fP .5i
.br
Returns the gostream size.
.IP \fItype\fP .5i
.br
Specifies the gostream type (GASCII_STREAM or GBINARY_STREAM).
.IP \fIheader\fP .5i
.br
This string will be written at the stream beginning.
.RE
.sp 1.
.IP
.nf
char* \fBpixmapToGostream\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP, ulong& \fIsize\fP, 
			GStreamFile \fItype\fP, char* \fIheader\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a gostream from a pixmap. If no error occured, it returns the created gostream, otherwise it returns NULL.
.IP \fIinterf\fP .5i
.br
Specifies XGoInterface.
.IP \fIpixmap\fP .5i
.br
Specifies the pixmap to convert.
.IP \fIsize\fP .5i
.br
Returns the gostream size.
.IP \fItype\fP .5i
.br
Specifies the gostream type (GASCII_STREAM or GBINARY_STREAM).
.IP \fIheader\fP .5i
.br
This string will be written at the stream beginning.
.RE
.sp 1.
.IP
.nf
ushort \fBbitmapToGostreamFile\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIbitmap\fP, const char* \fIfilename\fP, 
			GStreamFile \fItype\fP, char* \fIheader\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a gostream file from a bitmap. If no error occured, it returns the GOK, otherwise it returns one of the following values: GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GSAVE_STREAM_ERROR or GERROR.
.IP \fIinterf\fP .5i
.br
Specifies XGoInterface.
.IP \fIbitmap\fP .5i
.br
Specifies the bitmap to convert.
.IP \fIfilename\fP .5i
.br
Specifies the gostream filename.
.IP \fItype\fP .5i
.br
Specifies the gostream type (GASCII_STREAM or GBINARY_STREAM).
.IP \fIheader\fP .5i
.br
This string will be written at the stream beginning.
.RE
.sp 1.
.IP
.nf
ushort \fBpixmapToGostreamFile\fP (const XGoInterf* \fIinterf\fP, const Pixmap \fIpixmap\fP, const char* \fIfilename\fP, 
			GStreamFile \fItype\fP, char* \fIheader\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a gostream file from a pixmap. If no error occured, it returns the GOK, otherwise it returns one of the following values: GIS_NOT_REG_FILE, GFILE_ACCESS_ERROR, GSAVE_STREAM_ERROR or GERROR.
.IP \fIinterf\fP .5i
.br
Specifies XGoInterface.
.IP \fIpixmap\fP .5i
.br
Specifies the pixmap to convert.
.IP \fIfilename\fP .5i
.br
Specifies the gostream filename.
.IP \fItype\fP .5i
.br
Specifies the gostream type (GASCII_STREAM or GBINARY_STREAM).
.IP \fIheader\fP .5i
.br
This string will be written at the stream beginning.
.RE
.sp 1.
.SH
\fBC BINDING\fP
.SS 
\fBHeader file\fP
.IP
#include <Go/Ext/cXConverter.h>
.SS 
\fBC Functions\fP
.IP
GObjectId \fBGCreateXConverter\fP();
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::GXConverter()
.RE
.sp1
.IP
void \fBGDestroyXConverter\fP(GObjectId \fIconv\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::~GXConverter()
.RE
.sp1
.IP
Pixmap \fBGXConverterGoToBitmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP, const GObjectId \fIgo\fP,
			uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::goToBitmap()
.RE
.sp1
.IP
GBool \fBGXConverterGoToBitmapFile\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP, const GObjectId \fIgo\fP,
			 const char* \fIfilename\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::goToBitmapFile()
.RE
.sp1
.IP
Pixmap \fBGXConverterGoToPixmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP, const GObjectId \fIgo\fP,
			uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::goToPixmap()
.RE
.sp1
.IP
Pixmap \fBGXConverterGostreamToBitmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIstream\fP, const ulong \fIsize\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamToBitmap()
.RE
.sp1
.IP
GBool \fBGXConverterGostreamToBitmapFile\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIstream\fP, const ulong \fIsize\fP, const char* \fIfilename\fP,
			uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamToBitmapFile()
.RE
.sp1
.IP
Pixmap \fBGXConverterGostreamToPixmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIstream\fP, const ulong \fIsize\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamToPixmap()
.RE
.sp1
.IP
Pixmap \fBGXConverterGostreamFileToBitmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIfilename\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamFileToBitmap()
.RE
.sp1
.IP
GBool \fBGXConverterGostreamFileToBitmapFile\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIg_filename\fP, const char* \fIb_filename\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamFileToBitmapFile()
.RE
.sp1
.IP
Pixmap \fBGXConverterGostreamFileToPixmap\fP(GObjectId \fIconv\fP, GObjectId \fIinterf\fP,
			const char* \fIfilename\fP, uint* \fIwidth\fP, uint* \fIheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::gostreamFileToPixmap()
.RE
.sp1
.IP
GObjectId \fBGXConverterBitmapToGo\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIbitmap\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::bitmapToGo()
.RE
.sp1
.IP
GObjectId \fBGXConverterPixmapToGo\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIpixmap\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::pixmapToGo()
.RE
.sp1
.IP
char* \fBGXConverterBitmapToGostream\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIbitmap\fP, ulong* \fIsize\fP, GStreamFile \fItype\fP, char* \fIheader\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::bitmapToGostream()
.RE
.sp1
.IP
char* \fBGXConverterPixmapToGostream\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIpixmap\fP, ulong* \fIsize\fP, GStreamFile \fItype\fP, char* \fIheader\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::pixmapToGostream()
.RE
.sp1
.IP
GBool \fBGXConverterBitmapToGostreamFile\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIbitmap\fP, const char* \fIfilename\fP, GStreamFile \fItype\fP, char* \fIheader\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::bitmapToGostreamFile()
.RE
.sp1
.IP
GBool \fBGXConverterPixmapToGostreamFile\fP(GObjectId \fIconv\fP, const GObjectId \fIinterf\fP,
			const Pixmap \fIpixmap\fP, const char* \fIfilename\fP, GStreamFile \fItype\fP, char* \fIheader\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXConverter::pixmapToGostreamFile()
.SH
\fBSEE ALSO\fP
.IP
\fBConverter(3Go), GoStream(3Go), GoAscii(3Go), GoBinary(3Go)\fP.
.nrPN \n%
