.\" $Id: XWindow.n,v 1.3 1992/12/21 16:53:07 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XWindow 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXWindow\fP
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XWindow.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXWindow\fP inherits behavior from \fBGWindow\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXWindow\fP class creates a GoRoot instance. It creates a XGoInterf instance, and if specified, it creates a GoUI instance and a GoFullSensor instance which is reparented on the GoRoot instance.
.sp 1
.nf
.ta .15i .25i 1.0i
class GXWindow : public GWindow
{
	public:
	GXWindow(GoUIType \fItype\fP, const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP);
	GXWindow(GoUIType \fItype\fP, const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP, 
			Display* \fIdisplay\fP, int \fIscreen\fP, Drawable \fIdrawable\fP, GBool \fIisWindow\fP,
			int \fIwidth_in_pixels\fP, int \fIheight_in_pixels\fP, int \fIdepth\fP,
			ulong \fIbackgroundPixel\fP, Colormap \fIcolormap\fP, Visual* \fIvisual\fP,
			GNumber \fIpixelWidth_in_mm\fP = 0, GNumber \fIpixelHeight_in_mm\fP = 0);
	~GXWindow();
	virtual void windowSize(GNumber \fIw\fP, GNumber \fIh\fP);
};
.fi
.RE
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXWindow\fP(GoUIType \fItype\fP, const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method creates a GXWindow instance. This instance contains a GoRoot instance, a XGoInterf instance, a GoUI instance according to the \fItype\fP specified and a GoFullSensor instance named \fIroot_sensor_name\fP. The XGoInterf instance is created with no parameters.
.IP \fItype\fP .5i
.br
Specifies the GoUI type. If \fItype\fP is GNoGoUI, no GoUI is created.
.IP \fIroot_sensor_name\fP .5i
.br
Specifies the name of the GoFullSensor instance. If \fIroot_sensor_name\fP is NULL, no sensor is created.
.IP \fIargc\fP .5i
.br
This parameter is not yet managed.
.IP \fIargv\fP .5i
.br
This parameter is not yet managed.
.RE
.sp 1
.IP
.nf
\fBGXWindow\fP(GoUIType \fItype\fP, const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP, Display* \fIdisplay\fP,
			int \fIscreen\fP, Drawable \fIdrawable\fP, GBool \fIisWindow\fP,
			int \fIwidth_in_pixels\fP, int \fIheight_in_pixels\fP, int \fIdepth\fP,
			ulong \fIbackgroundPixel\fP, Colormap \fIcolormap\fP, Visual* \fIvisual\fP,
			GNumber \fIpixelWidth_in_mm\fP = 0, GNumber \fIpixelHeight_in_mm\fP = 0);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method creates a GXWindow instance. This instance contains a GoRoot instance, a XGoInterf instance, a GoUI instance according to the \fItype\fP specified and a GoFullSensor instance named \fIroot_sensor_name\fP. The used XGoInterf constructor is :
.br
XGoInterf(Display* display, int screen, Drawable drawable, GBool isWindow, int width_in_pixels, int height_in_pixels, int depth, ulong backgroundPixel, Colormap colormap, Visual* visual, GNumber pixelWidth_in_mm = 0, GNumber pixelHeight_in_mm = 0).
.IP \fItype\fP .5i
.br
Specifies the GoUI type. If \fItype\fP is GNoGoUI, no GoUI is created.
.IP \fIroot_sensor_name\fP .5i
.br
Specifies the name of the GoFullSensor instance. If \fIroot_sensor_name\fP is NULL, no sensor is created.
.IP \fIargc\fP .5i
.br
This parameter is not yet managed.
.IP \fIargv\fP .5i
.br
This parameter is not yet managed.
.IP \fIdisplay screen drawable isWindow width_in_pixels height_in_pixels depth backgroundPixel colormap visual pixelWidth_in_mm pixelHeight_in_mm\fP .5i
.br
These parameters are used in the XGoInterf constructor.
.RE
.sp 1
.IP
.nf
\fB~GXWindow\fP()
.fi
.RS .8i
.IP \fIDescription\fP .5i
Destructor method.
.RE
.sp 1
.IP
.nf
virtual void \fBwindowSize\fP(GNumber \fIw\fP, GNumber \fIh\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method sets the window width and height.
.IP \fIw\fP .5i
.br
Specifies the window width.
.IP \fIh\fP .5i
.br
Specifies the window height.
.RE
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBWindow(3Go) XmWindow(3Go) XGoInterf(3Go)\fP.
.nrPN \n%
