.\" $Id: XmConvertSh.n,v 1.1 1992/12/28 11:55:23 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XmConvertShared 3Go "November 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXmConvertShared\fP \(em the converter class of SharedObject using OSF/Motif formats.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XmConvertSh.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXmConvertShared\fP does not inherit behavior from any class but this class uses a GoConvertShared object to convert GoStream in Shared Object and a XConverter object to create pixmaps.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXmConvertShared\fP class implements conversion functions from GoStream to OSF/Motif formats. The \fBGXmConvertShared\fP class uses a GoConvertShared object to convert GoStream in Shared Object (ShColor, ShDash, ShPattern). Then, the \fBGXmConvertShared\fP class transforms these Shared Objects into PullDown, Option or Popup Menu with a number of PushButton depending of the number of SharedObjects found in the GoStream. The user can also have specific PushButtons in the created menu called : "none" Button and "paste" Button.

.sp 1
.nf
.ta .15i .25i 1.0i
enum GXmMenuType  { GXmOptionMenu, GXmPulldownMenu, GXmPopupMenu };
enum GXmCbType  { GXmNoneButton, GXmPasteButton, GXmButton };
typedef struct 
{
    GSharedObject* 	shObj;
    GXmCbType  		type;
} GXmDataType;

class GXmConvertShared 
{
	public:
	GXmConvertShared();
	~GXmConvertShared();
	Widget gostreamFileToColorMenu(const char* \fIfileName\fP, int& \fInb_color\fP,
					int \fImax_color\fP, Display* \fIdisplay\fP,
					Widget \fIparent\fP, char* \fImenuName\fP,
					char* \fIpullDownName\fP, Widget& \fImenu\fP,
					Widget*& \fImenuEntry\fP,
					XtCallbackProc \fIcallback_proc\fP,
					XtPointer \fIclosure\fP,
					GXmMenuType \fImenuType\fP = GXmOptionMenu,
					GBool \fInone\fP = GFALSE, GBool \fIpaste\fP = GFALSE); 
	Widget gostreamFileToDashMenu(const char* \fIfileName\fP, int& \fInb_dash\fP,
					int \fImax_dash\fP, int \fImax_size\fP,
					Display* \fIdisplay\fP, GoInterf* \fIgointerf\fP,
					unsigned long \fIbackgroundColor\fP,
					Widget \fIparent\fP, char* \fImenuName\fP,
					char* \fIpullDownName\fP, Widget& \fImenu\fP,
					Widget*& \fImenuEntry\fP,
					XtCallbackProc \fIcallback_proc\fP,
					XtPointer \fIclosure\fP,
					GXmMenuType \fImenuType\fP = GXmOptionMenu,
					GBool \fInone\fP = GFALSE, GBool \fIpaste\fP = GFALSE);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXmConvertShared\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class constructor.
.RE
.sp 1
.IP
.nf
\fB~GXmConvertShared\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class destructor.
.RE
.sp 1
.IP
.nf
Widget \fBgostreamFileToColorMenu\fP (const char* \fIfileName\fP, int& \fInb_color\fP,
					int \fImax_color\fP, Display* \fIdisplay\fP,
					Widget \fIparent\fP, char* \fImenuName\fP,
					char* \fIpullDownName\fP, Widget& \fImenu\fP,
					Widget*& \fImenuEntry\fP,
					XtCallbackProc \fIcallback_proc\fP,
					XtPointer \fIclosure\fP, GXmMenuType \fImenuType\fP, 
					GBool \fInone\fP, GBool \fIpaste\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a Color Menu from a gostream. This Color Menu is a OptionMenu, PulldownMenu or PopupMenu with PushButtons Widgets (the background color of these PushButtons is set to the ShColor). If no error occured, it returns the created Widget corresponding to the PullDown, Option or Popup Menu , otherwise it returns NULL.
.IP \fIfileName\fP .5i
.br
Specifies the gostream.
.IP \fInb_color\fP .5i
.br
Returns the number of created Color PushButtons.
.IP \fImax_color\fP .5i
.br
Specifies the max number of Color PushButtons (0 = no limit for number of Color PushButtons).
.IP \fIdisplay\fP .5i
.br
Specifies the display used for this application.
.IP \fIparent\fP .5i
.br
Specifies the parent Widget.
.IP \fImenuName\fP .5i
.br
Specifies the Menu name (for specific ressources).
.IP \fIpullDownName\fP .5i
.br
Specifies the PullDown, Option or Popup Menu name (for specific ressources).
.IP \fImenu\fP .5i
.br
Returns the Widget created (Menu).
.IP \fImenuEntry\fP .5i
.br
Returns a array of the created Widgets (Color, none and paste PushButtons).
.IP \fIcallback_proc\fP .5i
.br
Specifies the callback function used for all Buttons (Color, none and paste PushButtons). The userData resource of the Widget contains the adress of a GXmDataType struct wich contains the type of callback (GXmCbType type) and a pointer to the GShColor (GSharedObject* shObj). If the type of callback is GXmNoneButton or GXmPasteButton, then shObj is NULL.
.IP \fIclosure\fP .5i
.br
Specifies the closure of the callback function.
.IP \fImenuType\fP .5i
.br
Specifies the Menu Type (GXmOptionMenu, GXmPulldownMenu or GXmPopupMenu).
.IP \fInone\fP .5i
.br
Specifies if you want a "none" button (default: no "none" Button).
.IP \fIpaste\fP .5i
.br
Specifies if you want a "paste" button (default: no "paste" Button).
.RE
.sp 1
.IP
.nf
Widget \fBgostreamFileToDashMenu\fP (const char* \fIfileName\fP, int& \fInb_dash\fP,
					int \fImax_cdash\fP, int \fImax_size\fP,
					Display* \fIdisplay\fP, GoInterf* \fIgointerf\fP,
					unsigned long \fIbackgroundColor\fP,
					Widget \fIparent\fP, char* \fImenuName\fP,
					char* \fIpullDownName\fP, Widget& \fImenu\fP,
					Widget*& \fImenuEntry\fP,
					XtCallbackProc \fIcallback_proc\fP,
					XtPointer \fIclosure\fP, GXmMenuType \fImenuType\fP, 
					GBool \fInone\fP, GBool \fIpaste\fP); 
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a Dash Menu from a gostream. This Dash Menu is a OptionMenu, PulldownMenu or PopupMenu with PushButtons Widgets (the pixmap of these PushButtons represents the ShDash). If no error occured, it returns the created Widget (corresponding to the PullDown, Option or Popup Menu), otherwise it returns NULL.
.IP \fIfileName\fP .5i
.br
Specifies the gostream.
.IP \fInb_dash\fP .5i
.br
Returns the number of created Dash PushButtons.
.IP \fImax_dash\fP .5i
.br
Specifies the max number of Dash PushButtons (0 = no limit for number of Dash PushButtons).
.IP \fImax_size\fP .5i
.br
Specifies the max size of the pixmap created in the Dash PushButtons.
.IP \fIdisplay\fP .5i
.br
Specifies the display used for this application.
.IP \fIgointerf\fP .5i
.br
Specifies the GoInterf* used for this application.
.IP \fIbackgroundColor\fP .5i
.br
Specifies the backgroundColor used to create pixmap in Dash PushButtons
.IP \fIparent\fP .5i
.br
Specifies the parent Widget.
.IP \fImenuName\fP .5i
.br
Specifies the Menu name (for specific ressources).
.IP \fIpullDownName\fP .5i
.br
Specifies the PullDown, Option or Popup Menu name (for specific ressources).
.IP \fImenu\fP .5i
.br
Returns the Widget created (Menu).
.IP \fImenuEntry\fP .5i
.br
Returns a array of the created Widgets (Dash, none and paste PushButtons).
.IP \fIcallback_proc\fP .5i
.br
Specifies the callback function used for all Buttons (Dash, none and paste PushButtons). The userData resource of the Widget contains the adress of a GXmDataType struct wich contains the type of callback (GXmCbType type) and a pointer to the GShDash (GSharedObject* shObj). If the type of callback is GXmNoneButton or GXmPasteButton, then shObj is NULL.
.IP \fIclosure\fP .5i
.br
Specifies the closure of the callback function.
.IP \fImenuType\fP .5i
.br
Specifies the Menu Type (GXmOptionMenu, GXmPulldownMenu or GXmPopupMenu).
.IP \fInone\fP .5i
.br
Specifies if you want a "none" button (default: no "none" Button).
.IP \fIpaste\fP .5i
.br
Specifies if you want a "paste" button (default: no "paste" Button).
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBConverter(3Go), ConvertShared(3Go), XConverter(3Go)\fP.
.nrPN \n%
