.\" $Id: XmConverter.n,v 1.2 1992/12/17 15:33:34 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XmConverter 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXmConverter\fP \(em the converter class using OSF/Motif formats.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XmConverter.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXmConverter\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGXConverter\fP class
.IP \(em 3
\fBGConverter\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXmConverter\fP class implements conversion functions from string to compound string and from compound string to string.
.sp 1
.nf
.ta .15i .25i 1.0i
class GXmConverter : public GXConverter {
	public:
	GXmConverter();
	~GXmConverter();
	XmString stringToCompoundString(char* \fItext\fP, 
			const XmStringCharSet \fIcharset\fP = XmSTRING_DEFAULT_CHARSET,
			const XmStringDirection \fIdir\fP = XmSTRING_DIRECTION_L_TO_R,
			const GBool \fIsep\fP = GFALSE) const;
	GBool compoundStringToString(const XmString \fIcompound_string\fP, 
			const XmStringCharSet \fIcharset\fP = XmSTRING_DEFAULT_CHARSET, 
			char** \fItext\fP) const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXmConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class constructor.
.RE
.sp 1
.IP
.nf
\fB~GXmConverter\fP ();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This is the class destructor.
.RE
.sp 1
.IP
.nf
XmString \fBstringToCompoundString\fP (char* \fItext\fP, 
			const XmStringCharSet \fIcharset\fP = XmSTRING_DEFAULT_CHARSET,
			const XmStringDirection \fIdir\fP = XmSTRING_DIRECTION_L_TO_R, 
			const GBool \fIsep\fP = GFALSE) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to convert string onto compound string. If no error occured, it returns the created compound string, otherwise it returns NULL.
.IP \fItext\fP .5i
.br
Specifies a null-terminated string to be used as the text component of the compound string.
.IP \fIcharset\fP .5i
.br
Specifies the character set identifier to be associated with the \fItext\fP.
.IP \fIdir\fP .5i
.br
Specifies the direction of the \fItext\fP.
.IP \fIsep\fP .5i
.br
Specifies separator addition. If GFALSE, the compound string does not have a separator at the end. If GTRUE, a separator immediately follows the text component.
.RE
.sp 1
.IP
.nf
GBool \fBcompoundStringToString\fP (const XmString \fIcompound_string\fP, const XmStringCharSet \fIcharset\fP, 
			char** \fItext\fP) const
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method searches for a text segment in the input compound string that matches the given character set identifier. If no error occured, it returns GTRUE, otherwise it returns GFALSE.
.IP \fIcompound_string\fP .5i
.br
Specifies the compound string.
.IP \fIcharset\fP .5i
.br
Specifies the character set identifier to be associated with the text.
.IP \fItext\fP .5i
.br
Specifies a pointer to a null terminated string.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS 
\fBHeader file\fP
.IP
#include <Go/Ext/cXmConverter.h>
.SS 
\fBC Functions\fP
.IP
GObjectId \fBGCreateXmConverter\fP();
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXmConverter::GXmConverter()
.RE
.sp1
.IP
void \fBGDestroyXmConverter\fP(GObjectId \fIconv\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXmConverter::~GXmConverter()
.RE
.sp1
.IP
XmString \fBGXmConverterStringToCompoundString\fP(GObjectId \fIconv\fP, char* \fItext\fP,
			const XmStringCharSet \fIcharset\fP, const XmStringDirection \fIdir\fP,
			const GBool \fIsep\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXmConverter::stringToCompoundString()
.RE
.sp1
.IP
GBool \fBGXmConverterCompoundStringToString\fP(GObjectId \fIconv\fP,
.br
			const XmString \fIcompound_string\fP, char** \fItext\fP,
.br
			const XmStringCharSet \fIcharset\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXmConverter::compoundStringToString()
.SH
\fBSEE ALSO\fP
.IP
\fBConverter(3Go) XConverter(3Go)\fP.
.nrPN \n%
