.\" $Id: XmWindow.n,v 1.3 1992/12/21 16:53:10 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XmWindow 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXmWindow\fP
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XmWindow.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXmWindow\fP inherits behavior from \fBGWindow\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXmWindow\fP class creates a GoRoot instance, a Graphic Widget. If specified, it creates a GoUI instance and a GoFullSensor instance which is reparented on the GoRoot instance.
.sp 1
.nf
.ta .15i .25i 1.0i
class GXmWindow : public GWindow
{
	public:
	GXmWindow(Widget \fIparent\fP, char* \fIname\fP, Arg* \fIargs\fP, int \fInb_args\fP, GoUIType \fItype\fP, 
			const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP);
	~GXmWindow();

	virtual void windowSize(GNumber \fIw\fP, GNumber \fIh\fP);
	Widget graphicWidget();
};
.fi
.RE
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXmWindow\fP(Widget \fIparent\fP, char* \fIname\fP, Arg* \fIargs\fP, int \fInb_args\fP, GoUIType \fItype\fP, 
				const char* \fIroot_sensor_name\fP, int* \fIargc\fP, char** \fIargv\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method creates a GXmWindow instance. This instance contains a GoRoot instance and  a Graphic widget. It creates a GoUI instance ( if \fItype\fP is not GNoGoUI) and a GoFullSensor instance which is reparented on the GoRoot instance (if \fIroot_sensor_name\fP is not NULL).
.IP \fIparent\fP .5i
.br
Specifies the Graphic parent widget.
.IP \fIname\fP .5i
.br
Specifies the Graphic widget name.
.IP \fIargs\fP .5i
.br
Is passed to the XbCreateGraphicWidget() function.
.IP \fInb_args\fP .5i
.br
Is passed to the XbCreateGraphicWidget() function.
.IP \fItype\fP .5i
.br
Specifies the GoUI type. If \fItype\fP is GNoGoUI, no GoUI is created.
.IP \fIroot_sensor_name\fP .5i
.br
Specifies the name of the GoFullSensor instance. If \fIroot_sensor_name\fP is NULL, no sensor is created.
.IP \fIargc\fP .5i
.br
This parameter is not yet managed.
.IP \fIargv\fP .5i
.br
This parameter is not yet managed.
.RE
.sp 1
.IP
.nf
\fB~GXmWindow\fP()
.fi
.RS .8i
.IP \fIDescription\fP .5i
Destructor method.
.RE
.sp 1
.IP
.nf
virtual void \fBwindowSize\fP(GNumber \fIw\fP, GNumber \fIh\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method sets the window width and height.
.IP \fIw\fP .5i
.br
Specifies the window width.
.IP \fIh\fP .5i
.br
Specifies the window height.
.RE
.IP
.nf
Widget \fBgraphicWidget\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns the created Graphic widget.
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBWindow(3Go) XWindow(3Go) XmGoInterf(3Go) Graphic(3Xb)\fP.
.nrPN \n%
