\" $Id: XtCBInterf.n,v 1.2 1992/12/17 15:33:38 jacomet Exp $
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XtClipboardInterf 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXtClipboardInterf\fP \(em the copy/paste interface class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Ext/XtCBInterf.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGXtClipboardInterf\fP inherits behavior from \fBGClipboardInterf\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGXtClipboardInterf\fP class is an interface for interclient copy/paste based on X selection mechanism. Only one instance of this class can be created per application and per display. This object can be only used by applications using XtGoInterface instances or XtGoInterface subclass instances.
.br
If a clipboard application is running, all copied datas are automatically sent to the clipboard application.
.sp 1
.nf
.ta .15i .25i 1.0i
class GXtClipboardInterf : public GClipboardInterf
{
	public:
	GXtClipboardInterf(XtGoInterf*);
	~GXtClipboardInterf();
	GBool copy(GoInterf* \fIinterf\fP, GTimeStamp \fItime\fP, GClipboardDataFormat \fItype\fP,
			void* \fIdatas\fP, ulong \fIlength\fP, GBool \fIcopy\fP, GLoseCopyProc \fIcallback\fP,
			void* \fIclient_data\fP);
	void paste(GoInterf* \fIinterf\fP, GTimeStamp \fItime\fP, GClipboardDataFormat \fItype\fP,
			GGetDataProc \fIcallback\fP, void* \fIclient_data\fP);
	GBool isThereClipboard();
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGXtClipboardInterf\fP(XtGoInterf* \fIinterf\fP)
.fi
.RS .8i
.IP \fIDescription\fP .5i
This constructor verifies that only one instance is created per application and per display.
.IP \fIinterf\fP .5i
.br
Specifies an XtGoInterf used to retrieve the display Id.
.RE
.sp 1
.IP
.nf
~\fBGXtClipboardInterf\fP()
.fi
.RS .8i
.IP \fIDescription\fP .5i
Destructor method.
.RE
.sp 1
.IP
.nf
GBool \fBcopy\fP(GoInterf* \fIinterf\fP, GTimeStamp \fItime\fP, GClipboardDataFormat \fItype\fP, void* \fIdatas\fP, 
		ulong \fIlength\fP, GBool \fIcopy\fP, GLoseCopyProc \fIcallback\fP, void* \fIclient_data\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to copy datas. In fact it asks the selection to the X server. If the selection is owned, this method returns GTRUE, otherwise it returns GFALSE.
.br
If the application is the selection owner and wants to disown the selection, it has to call \fBcopy\fP with \fBGNO_DATA_FORMAT\fP type.
.IP \fIinterf\fP .5i
.br
Specifies the GoInterface on which datas are displayed.
.IP \fItime\fP .5i
.br
Specifies the time indicated in the GEvent structure.
.IP \fItype\fP .5i
.br
Specifies the type of datas. See \fIClipboardInterf (3Go)\fP man pages.
.IP \fIdatas\fP .5i
.br
Specifies the datas to copy. If the \fItype\fP is \fBGGO\fP or \fBGSHARED_OBJECT\fP, the datas must be a pointer to a \fBGSet\fP containing the Go trees or shared objects, otherwise datas are a character flow.
.IP \fIlength\fP .5i
.br
Specifies the character flow size or the number of objects contained by the \fBGSet\fP.
.IP \fIcopy\fP .5i
.br
Specifies if the GXtClipboardInterf has to duplicate datas. If GFALSE, it is the application responsability not to destroy datas until others datas are copied.
.IP \fIcallback\fP .5i
.br
Specifies the application callback that will be called when others datas are copied. These new datas can belong to the same application or another application. Callback parameters are (see \fIClipboardInterf (3Go)\fP):
.RS 8
.IP \(em 3
a closure.
.IP \(em 3
the GoInterface that owns the old datas.
.IP \(em 3
the old datas type.
.RE 2
.IP \fIclient_data\fP .5i
.br
Specifies the closure that will be passed to the GLoseCopyProc callback.
.RE
.sp 1
.IP
.nf
void \fBpaste\fP(GoInterf* \fIinterf\fP, GTimeStamp \fItime\fP, GClipboardDataFormat \fItype\fP, GGetDataProc \fIcallback\fP, 
		void* \fIclient_data\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to paste datas.
.IP \fIinterf\fP .5i
.br
Specifies the GoInterface on which datas will be displayed.
.IP \fItime\fP .5i
.br
Specifies the time indicated in the GEvent structure.
.IP \fItype\fP .5i
.br
Specifies the type to which the datas should be converted. See \fIClipboardInterf (3Go)\fP man pages.
.IP \fIcallback\fP .5i
.br
Specifies the application callback that will be called when datas have been obtained. Note that this is how the datas are communicated back to the application. Callback parameters are (see \fIClipboardInterf (3Go)\fP):
.RS 8
.IP \(em 3
a closure.
.IP \(em 3
the GoInterface that has asked the datas.
.IP \(em 3
the pasted data type.
.IP \(em 3
the pasted datas. If the pasted data type is \fBGGO\fP or \fBGSHARED_OBJECT\fP, the datas are a pointer to a \fBGSet\fP containing the Go trees or shared objects, otherwise the datas are a character flow. The requesting application owns this storage and is responsible for freeing it when it is done with it.
.IP \(em 3
the size of the pasted datas. If the pasted data type is \fBGGO\fP or \fBGSHARED_OBJECT\fP, the size indicates how many objects are contained in the \fBGSet\fP, otherwise it indicates the character flow size.
.IP \(em 3
the error type, if an error occured. See \fIClipboardInterf (3Go)\fP.
.RE 2
.IP \fIclient_data\fP .5i
.br
Specifies the closure that will be passed to the GGetDataProc callback.
.RE
.sp 1
.IP
.nf
GBool \fBisThereClipboard\fP();
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE if a clipboard application is running, otherwise it returns GFALSE.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS 
\fBHeader file\fP
.IP
#include <Go/Ext/cXtCBInterf.h>
.SS 
\fBC Functions\fP
.IP
GObjectId \fBGCreateXtClipboardInterf\fP(GObjectId \fIinterf\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXtClipboardInterf::GXtClipboardInterf()
.RE
.sp1
.IP
void \fBGDestroyXtClipboardInterf\fP(GObjectId \fIcb\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXtClipboardInterf::~GXtClipboardInterf()
.RE
.sp1
.IP
GBool \fBGXtClipboardInterfCopy\fP(GObjectId \fIcb\fP, GObjectId \fIinterf\fP, GTimeStamp \fItime\fP,
			GClipboardDataFormat \fItype\fP, void* \fIdatas\fP, ulong \fIlength\fP, 
		GBool \fIcopy\fP, 
			GLoseCopyProc \fIcallback\fP, void* \fIclient_data\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXtClipboardInterf::copy(XtGoInterf* \fIinterf\fP, GTimeStamp \fItime\fP, 
		GClipboardDataFormat \fItype\fP, void* \fIdatas\fP, ulong \fIlength\fP, 
		GBool \fIcopy\fP, GLoseCopyProc \fIcallback\fP, void* \fIclient_data\fP)
.RE
.sp1
.IP
.IP
void  \fBGXtClipboardInterfPaste\fP(GObjectId \fIcb\fP, GObjectId \fIinterf\fP, GTimeStamp \fItime\fP,
			GClipboardDataFormat \fItype\fP, GGetDataProc \fIcallback\fP, void* \fIclient_data\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXtClipboardInterf::paste(XtGoInterf* \fIinterf\fP, GTimeStamp \fItime\fP,
		GClipboardDataFormat \fItype\fP, GGetDataProc \fIcallback\fP, 
		void* \fIclient_data\fP)
.RE
.sp1
.IP
GBool \fBGXtClipboardInterfIsThereClipboard\fP(GObjectId \fIcb\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GXtClipboardInterf::isThereClipboard()
.SH
\fBSEE ALSO\fP
.IP
\fBClipboardInterf(3Go)\fP.
.nrPN \n%
