.\" $Id: ClipSensor.n,v 1.3 1993/01/04 16:59:45 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ClipSensor 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoClipSensor\fP \(em the sensor object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/ClipSensor.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGoClipSensor\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoSensor\fP class
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
\fBGoClipSensor\fP is a subclass of \fBGoSensor\fP dedicated to implement a specific \fIcontains\fP functionnality. It goes throw the parent hierarchy to answer to the \fIcontains\fP request.
.IP
.sp 1
.br
.nf
.ta .15i .25i 1.0i

class GoClipSensor : public GoSensor {

	public:
		static GoClipSensorMetaclass* metaclass();
		static GoClipSensor* create(const char* program, Go*,
				const GEvent*,
				void (*procedure)(void* cl, GoSensor*),
				void* closure);
		static GoClipSensor* create();
    
		GoClipSensor();

	private:
		GBool m_contains(const GPoint&, GNumber maxdist); const
};

.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
GoClipSensorMetaclass* \fBmetaclass\fP ();
.RS .8i
.IP \fIDescription\fP .3i
This static member function returns the \fBGoClipSensorMetaclass\fP instance.
.RE
.sp 1
.IP
GoClipSensor* \fBcreate\fP(const char* \fIprogram\fP, Go* \fIgo\fP, const GEvent* \fIevent\fP, GClipSensorPostcond \fIprocedure\fP, void* \fIclosure\fP);
.br
GoClipSensor* \fBcreate\fP();
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to create a new instance of the \fBGoClipSensor\fP class.
They return a pointer on a new instance of GoClipSensor if no precondition
refuses the creation, else they return NULL.
.IP \fIgo\fP .5i
.br
Specifies the parent of the \fBGoClipSensor\fP.
.IP \fIprogram\fP .5i
.br
Specifies the \fIprogram\fP name.
.IP \fIevent\fP .5i
.br
Specifies the first \fIevent\fP (see Sensor (3Go) constructor description).
.IP \fIprocedure,closure\fP .5i
.br
Specify the \fIprocedure\fP called when the \fPprogram\fP interactor is cancelled (see Sensor (3Go)).
.RE
.sp 1
.IP
\fBGoClipSensor\fP();
.RS .8i
.IP \fIDescription\fP .5i
Constructor. Pre/post conditions are NOT invoked if you use this public
constructor.
.br
Use the \fBGoClipSensor::create(...)\fP methods instead if you want to invoke
pre/post conditions.
.RE
.sp 1
.IP
GBool \fBm_contains\fP(const GPoint& \fIpoint\fP, GNumber \fImax_distance\fP);
.RS .8i
.IP \fIDescription\fP .5i
The method returns GTRUE is the absolute position \fIpoint\fP is insides one of a \fIchild\fP of the \fIparent\fP. The method uses the \fIchild()\fP method (see Go (3Go)) to go throw the parent hierarchy. On each \fIchild\fP the method call the \fIcontains\fP method of this \fIchild\fP.
.br
The method is called via the public \fIcontains()\fP method (see Go (3Go)).
.IP \fIpoint\fP
.br
Specifies the absolute position.
.IP \fImax_distance\fP
.br
Specifies the max distance.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fIClipSensor\fP is useful when a Go (.e.g GoComposite) has no private drawing.
.RE
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoUI\fP, \fBGo\fP, \fBGoMetaclass\fP,
\fBGoSensorMetaclass\fP and \fBGoSensorMetaclass\fP.
.nrPN \n%

