.\" $Id: GEvtBtn.n,v 1.2 1992/12/28 13:08:01 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ButtonEvent 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBButtonEvent\fP, \fBButtonPressEvent\fP, \fBButtonReleaseEvent\fP,
\fBDoubleClickEvent\fP, \fBTripleClickEvent\fP \(em the button event object classes.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Event.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGButtonEvent\fP inherits behavior from the \fBGEvent\fP class.
.br
\fBGButtonPressEvent\fP, \fBGButtonReleaseEvent\fP, \fBGDoubleClick\fP
and \fBGTripleClick\fP classes inherit behavoir from the \fBGButtonEvent\fP
class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGButtonEvent\fP class is the common super class for the \fImouse button\fP
dedicated \fBGEvent\fP classes. All these classes have the same behavior.
The \fIbutton(), modifiers(), position()\fP
methods of the \fBGEvent\fP class are valid. The type returned by the
\fItype()\fP method are \fIGBUTTON_PRESS_EVENT\fP, \fIGBUTTON_RELEASE_EVENT\fP,
\fIGDOUBLE_CLICK_EVENT\fP or \fIGTRIPLE_CLICK_EVENT\fP. The masks associated to
these events are \fIGBUTTON_PRESS_MASK\fP, \fIGBUTTON_RELEASE_MASK\fP,
\fIGDOUBLE_CLICK_MASK\fP or \fIGTRIPLE_CLICK_MASK\fP.
.sp 1 
.br
.nf
.ta .15i .25i 1.i
class GButtonEvent : GEvent {
	public:
		virtual GButton button() const;
		virtual ulong modifiers() const;
		virtual GPoint position() const;
};
.sp 1
.ta .15i .25i 1.i
class GButtonPressEvent : GButtonEvent {
	public:
		GButtonPressEvent (GButton \fIbutton\fP, ulong \fImodifiers\fP,
			const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP = NULL);
};
.sp 1
.ta .15i .25i 1.i
class GButtonReleaseEvent : GButtonEvent {
	public:
		GButtonReleaseEvent (GButton \fIbutton\fP, ulong \fImodifiers\fP,
			const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP = NULL);
};
.sp 1
.ta .15i .25i 1.i
class GDoubleClickEvent : GButtonEvent {
	public:
		GDoubleClickEvent (GButton \fIbutton\fP, ulong \fImodifiers\fP,
			const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP = NULL);
};
.sp 1
.ta .15i .25i 1.i
class GTripleClickEvent : GButtonEvent {
	public:
		GTripleClickEvent (GButton \fIbutton\fP, ulong \fImodifiers\fP,
			const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP = NULL);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODSS\fP
.sp 1
.IP
.nf
\fBGButtonPressEvent\fP (GButton \fIbutton\fP, ulong \fImodifiers\fP,
	const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP);
\fBGButtonReleaseEvent\fP (GButton \fIbutton\fP, ulong \fImodifiers\fP,
	const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP);
\fBGDoubleClickEvent\fP (GButton \fIbutton\fP, ulong \fImodifiers\fP,
	const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP);
\fBGTripleClickEvent\fP (GButton \fIbutton\fP, ulong \fImodifiers\fP,
	const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a new instance of the \fBGButtonEvent\fP
class or subclass.
.IP \fItype\fP .5i
.br
Specifies the event type (see \fIGEvent(3Go)\fP).
.IP \fIbutton\fP .5i
.br
Specifies the button value (see \fIGEvent(3Go)\fP).
.IP \fImodifiers\fP .5i
Specifies the modifiers mask (see \fIGEvent(3Go)\fP).
.IP \fIposition\fP .5i
.br
Specifies the pointer position.
.IP \fIorigin\fP .5i
.br
Specifies the \fIGoInterf\fP which has generated the event.
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
See \fIGEvent(3Go)\fP for details of valid methods.
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBEvent\fP, \fBPoint\fP and \fBGoInterf\fP classes.
.nrPN \n%
