.\" $Id: GEvtMtn.n,v 1.2 1992/12/28 13:08:11 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH MotionEvent 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBMotionEvent\fP \(em the pointer motion event object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Event.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGMotionEvent\fP inherits behavior from the \fBGEvent\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGMotionEvent\fP object is a \fIpointer motion\fP dedicated
\fBGEvent\fP object. The \fIposition()\fP
method of the \fBGEvent\fP class is valid. The type returned by the
\fItype()\fP method is \fIGMOTION_EVENT\fP. The mask associated to
this event is \fIGMOTION_MASK\fP.
.sp 1 
.br
.nf
.ta .15i .25i 1.50i
class GMotionEvent : GEvent {
	public:
		GMotionEvent (const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP = NULL);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGMotionEvent\fP (const GPoint& \fIposition\fP, const GoInterf* \fIorigin\fP);
.RS .8i
.IP \fIDescription:\fP .5i
This method allows to create a new instance of the \fIGMotionEvent\fP
class.
.IP \fIposition\fP .5i
.br
Specifies the pointer position.
.IP \fIorigin\fP .5i
.br
Specifies the \fIGoInterf\fP which has generated the event.
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
See \fIGEvent(3Go)\fP for details of valid methods.
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBEvent\fP, \fBGoInterf\fP and \fBPoint\fP classes.
.nrPN \n%
