.\" $Id: GEvtSsr.n,v 1.2 1992/12/28 13:08:14 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH SensorEvent 3Go "December 1992" "Version 1.2" "Go Reference Manual"
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBEnterSensorEvent\fP, \fBLeaveSensorEvent\fP \(em the enter/leave 
sensor event object classes.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Event.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGEnterSensorEvent\fP and \fBGLeaveSensorEvent\fP inherit behavior
from the \fBGEvent\fP class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGEnterSensorEvent\fP and \fBGLeaveSensorEvent\fP objects are
\fIsensor dedicated\fP \fBGEvent\fP objects. These events cannot be
generated be a \fBGoInterf\fP instance, thus the \fIorigin()\fP method will
always return NULL. The \fIsensor()\fP
method of the \fBGEvent\fP class is valid. The type returned by the
\fItype()\fP method are \fIGENTER_SENSOR_EVENT\fP and \fIGLEAVE_SENSOR_EVENT\fP.
The mask associated to this event is \fIGENTER_SENSOR_MASK\fP and
\fIGLEAVE_SENSOR_MASK\fP.
.sp 1 
.br
.nf
.ta .15i .25i 1.50i
class GEnterSensorEvent : GEvent {
	public:
		GEnterSensorEvent (const GoSensor* \fIsensor\fP, const GoInterf* origin = NULL);
};
.fi
.sp 1
.nf
.ta .15i .25i 1.50i
class GLeaveSensorEvent : GEvent {
	public:
		GLeaveSensorEvent (const GoSensor* \fIsensor\fP, const GoInterf* origin = NULL);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGEnterSensorEvent\fP (const GoSensor* \fIsensor\fP, const GoInterf* origin = NULL);
.br
\fBGLeaveSensorEvent\fP (const GoSensor* \fIsensor\fP, const GoInterf* origin = NULL);
.RS .8i
.IP \fIDescription:\fP .5i
This method allows to create a new instance of the \fIGEnterSensorEvent\fP
or \fIGLeaveSensorEvent\fP classes.
.IP \fIsensor\fP .5i
.br
Specifies a pointer to the concerned \fBGoSensor\fP instance.
.IP \fIorigin\fP .5i
.br
Specifies the \fBGoInterf\fP which has generated the event.
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
See \fBGEvent(3Go)\fP for details of valid methods.
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBEvent\fP, \fBGoInterf\fP and \fBGoSensor\fP classes.
.nrPN \n%
