.\" $Id: GoAscii.n,v 1.1.1.1 1992/03/18 09:43:16 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoAscii 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoAscii\fP \(em the ascii file GoStream object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/GoAscii.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoAscii\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGoStream\fP class.
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.sp 1
.IP
\fBGoAscii\fP is a \fBGoStream\fP which only uses ASCII characters to describe
objects. As \fBGoStream\fP, \fBGoAscii\fP needs a \fBMedium\fP to write on or
read from. The device used depends on the \fBMedium\fP subclass. 
.IP
.nf
.ta .15i .25i 1.0i
class GoAscii : public GoStream {

	public:

		GoAscii(GMedium* medium = NULL);
		~GoAscii();
};
.fi
.SH
\fBPUBLIC METHODS\fP
.sp 1
.IP
\fBGoAscii\fP (GMedium* \fImedium\fP = NULL)
.RS .8i
.IP \fIDescription\fP .3i
Class constructor.
.IP \fImedium\fP .3i
.br
Specifies a \fBMedium\fP for the new \fBGoAscii\fP instance.
.RE
.sp 1
.IP
\fB~GoAscii\fP()
.RS .8i
.IP \fIDescription\fP .3i
Class destructor. Does not affect the \fBMedium\fP attached to the
\fBGoAscii\fP instance (if any).
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS
\fBHeader\fP
.IP
\fI#include <Go/cGoAscii.h>\fP
.SS
\fBC Functions\fP
.IP
.nf
GObjectId \fBNewGoAscii\fP (GObjectId \fImedium\fP);
.fi
.sp 1
.RS .8i
.IP \fIDescription\fP .3i
C interface to \fBnew GoAscii\fP (\fImedium\fP).
.br
Use the function \fBDeleteGoStream\fP to delete the object create by
\fBNewGoAscii\fP.
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoStream\fP, \fBMedium\fP classes.
.nrPN \n%
