.\" $Id: StdSensor.n,v 1.1 1993/01/05 16:04:22 jojic Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoStdSensor 3Go "Mai 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoStdSensor\fP \(em the standard sensor object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/StdSensor.h>\fP
.sp 1
.SH
\fBCLASS\fP
.IP
\fBGoStdSensor\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBGo\fP class
.br
\fBGoSensor\fP class
.RE
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
A GoStdSensor has the sensitivity of its superclass, i.e. of a GoSensor.
The differance is that a GoStdSensor is not a light weight Go.
A GoStdSensor may have children, a differant coordinate system of its parent
and its subclasses can make drawings.
.br
A GoStdSensor has no specific public methods.
.sp
.nf
.ta .15i .25i 1.0i
class GoStdSensor : public GoSensor
{
	public:

	/* mandatory static methods: */

		static GoStdSensorMetaclass* metaclass();
		static GoStdSensor* create ();

		static int save (const GoStdSensor*, GoStream*);
		static int restore (GoStdSensor**, GoStream*);   // creates + restores;
		static int readParams (GoStdSensor*, GoStream*); // restores only;
};
.fi
.sp 2
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
\fITo be defined\fP.
.SH
\fBSEE ALSO\fP
.IP
\fBGo(3Go)\fP
.br
and \fBGoSensor\fP,
.nrPN \n%
