.\" $Id: XInDisp.n,v 1.1 1992/07/20 07:33:03 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XInputDispatcher 3Go "June 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXInputDispatcher\fP \(em the input dispatcher object class for X window.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/XInDisp.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBXInputDispatcher\fP inherits behavior from the GoInputDispatcher class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBXInputDispatcher\fP object allows to distribute \fIxevents\fP incoming from input queue associated to a list of XGoInterf. So an \fIevent\fP for the XInputDispatcher class is an XEvent. The list of XGoInterf to handle is initialized by application. To handle an \fIevent\fP, \fIrunEventLoop\fP method will determine which XGoInterf is associated to the \fIevent\fP and will call the XGoInterf::handleXEvent() method.
.br
The XInputDispatcher provides only an UNIQUE input queue; this meams that the \fBXInputDispatcher\fP class assumes that application runs only with ONE DISPLAY.
.br
The type of \fIevent\fP for GInDispFilterProc type is \fIXEvent\fP.
.sp 1
Only specific methods of XInputDispatcher are describe here.
.sp 1
.nf
.ta .15i .25i 1.0i

class XInputDispatcher :: public GoInputDispatcher {
	public:
		XInputDispatcher(Display* \fIdpy\fP);
		~XInputDispatcher();

		void addXGoInterf(XGoInterf* \fIxgointerf\fP)
		void remXGoInterf(XGoInterf* \fIxgointerf\fP)
		Display* display() const;
		const GPointerArray* xGoInterfList() const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBXInputDispatcher\fP(Display* \fIdpy\fP);
.RS .8i
.IP \fIDescription\fP .5i
The constructor creates an new instance of an XInputDispatcher. Incoming events are read from the input queue associated to the display.
.IP \fIdpy\fP .5i
Specifies the display.
.RE
.sp 1
.IP
\fB~XInputDispatcher\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method is called when an \fIXInputDispatcher\fP instance is deleted.
.RE
.sp 1
.IP
void \fBaddXGoInterf\fP(XGoInterf* \fIxgointerf\fP);
void \fBremXGoInterf\fP(XGoInterf* \fIxgointerf\fP);
.RS .8i
.IP \fIDescription\fP .5i
The methods \fIadds\fP or \fIremoves\fP  the \fIxgointerf\fP instance to/from the list of handled interfaces.
.IP \fIxgointerf\fP .5i
Specifies the \fIxgointerf\fP to handle or not. If the \fIdisplay\fP associated of \fIxgointerf\fP is not the \fIdpy\fP of the constructor, \fIxgointerf\fP will not be handled.
.IP
.RE
.sp 1
.IP
Display* \fBdisplay\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
The method returns the display used by the input dispatcher.
.IP
.RE
.sp 1
.IP
const GPointerArray* \fBxGoInterfList\fP() const ;
.RS .8i
.IP \fIDescription\fP .5i
The method returns the list of XGoInterf instances which are handled by the input dispatcher.
.IP
.sp 1
.RE
.SH
\fBC BINDING\fP
.IP
.sp 1
.nf
.ta .15i .25i 1.5i
	\fI#include <Go/cXIndisp.h>\fP

		GObjectId XInputDispatcherCreate(Display* \fIdisplay\fP);
		void      XInputDispatcherAddXGoInterf(GObjectId \fIinput_dispatcher\fP,
					GObjectId \fIxgointerf\fP);
		void      XInputDispatcherRemXGoInterf(GObjectId \fIinput_dispatcher\fP,
					GObjectId \fIxgointerf\fP);
.fi
.IP \fIDescription\fP .5i
See above the corresponding C++ method.
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.br
In general there is only one instance of an \fIinput dispatcher\fP inside an application.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fIXGoInterf\fP, \fIGoInputDispatcher\fP, \fIXtInputDispatcher\fP classes.
.nrPN \n%


