.\" $Id: XbGraphic.n,v 1.1.1.1 1992/03/18 09:44:22 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XbGraphic 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXbGraphic\fP \(em the Graphic widget class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Xb/Graphic.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The Graphic Widget is the privileged interface between widgets and \fBGo\fP (see
\fIGo Programmer's Guide\fP).
.IP
A Graphic Widget creates a \fIXmGoInterf\fP (see \fIXmGoInterf(3Go)\fP) which can
be used to display \fIGo's\fP when a \fIGoRoot\fP instance is attached to it. From
the application point of view, the Graphic Widget appears as a \fIWorkArea\fP 
in which structured graphics may be displayed using \fBGo\fP.
.SH
\fBCLASS\fP
.IP
A Graphic Widget inherits behavior and resources from \fBCore\fP, 
\fBComposite\fP, \fBConstraint\fP, \fBXmManager\fP and \fBXmDrawingArea\fP 
Classes.
.br
The class pointer is \fBxbGraphicWidgetClass\fP.
.br
The class name is \fBXbGraphic\fP.
.SH
\fBRESOURCES\fP
.SS 
\fINew Resources\fP
.IP
The following table defines a set of widget resources used by the programmer
to specify data.  The programmer can also set the resource values for the 
inherited classes to set attributes for this widget.  To reference a
resource by name or by class in a .Xdefaults file, remove the \fBXmN\fP, 
\fBXbN\fP, \fBXmC\fP or \fBXbC\fP prefix and use the remaining letters.  
To specify one of the defined values for a resource in a .Xdefaults file, 
remove the \fBXm\fP or \fBXb\fP prefix and use the remaining letters 
(in either lower case or upper case, but include any underscores between 
words).
The codes in the access column indicate if the given resource can be
set at creation time (\fBC\fP),
set by using \fBXtSetValues\fP (\fBS\fP), 
retrieved by using \fBXtGetValues\fP (\fBG\fP), or is not applicable 
(\fBN/A\fP).
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
l l l l l.
XbGraphic Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XbNautomaticResize	XbCGraphic	Boolean	False	CSG
XmNeditable	XmCEditable	Boolean	True	CSG
XbNscaleOnResize	XbCGraphic	Boolean	False	CSG
.TE
.DE
.ps 10
.sp 1
.IP "\fIXbNautomaticResize\fP"
.br
When set to True, the Graphic Widget size follows the attached \fIGoRoot\fP outer dimensions,
so that all displayed \fGo's\fP are visible in the Graphic Widget window. This resource
may be combined with the \fIResizePolicy\fP resource.
.br
When set to False, the Graphic Widget is not automatically resized, therefore if a \fIGo\fP
is outside the Graphic Widget window, it will not be visible.
.IP "\fIXmNeditable\fP"
.br
When set to True, the user can interact with the \fIGo's\fP within the Graphic Widget using the Go User Interface. 
.br
When set to False, prohibits the user from interacting with the \fIGo's\fP within the Graphic Widget.
.IP "\fIXbNscaleOnResize\fP"
.br
When set to True, the attached \fIGoRoot\fP is scalled proportionally with the Graphic widget,
when the Graphic Widget is resized.
.br
When set to False, inhibits the scalling of \fIGo's\fP when the Graphic Widget is resized.
.SS
\fIInherited Resources\fP
.IP
Graphic inherits behavior and resources from the following   
superclasses.  For a complete description of these resources, refer to the
man page for that superclass.
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmDrawingArea Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNexposeCallback	XmCCallback	XtCallbackList	NULL	C
XmNinputCallback	XmCCallback	XtCallbackList	NULL	C
XmNmarginHeight	XmCMarginHeight	short	10	CSG
XmNmarginWidth	XmCMarginWidth	short	10	CSG
XmNresizeCallback	XmCCallback	XtCallbackList	NULL	C
XmNresizePolicy	XmCResizePolicy	unsigned char	XmRESIZE_NONE	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
lB lB lB lB lB
lllll.
XmManager Resource Set
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNbottomShadowColor	XmCForeground	Pixel	dynamic	CSG
XmNbottomShadowPixmap	XmCBottomShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNforeground	XmCForeground	Pixel	dynamic	CSG
XmNhelpCallback	XmCCallback	XtCallbackList	NULL	C
XmNhighlightColor	XmCForeground	Pixel	Black	CSG
XmNhighlightPixmap	XmCHighlightPixmap	Pixmap	dynamic	CSG
XmNshadowThickness	XmCShadowThickness	short	dynamic	CSG
XmNtopShadowColor	XmCBackground	Pixel	dynamic	CSG
XmNtopShadowPixmap	XmCTopShadowPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNuserData	XmCUserData	caddr_t	NULL	CSG
.sp
.TE
.DE
.ps 10
.sp 1
.ps 9
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Composite Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNinsertPosition	XmCInsertPosition	XmRFunction	NULL	CSG
.sp 1
.TE
.DE
.ps 10
.sp 1
.ps 8
.DS
.TS
center box;
cB ssss
cB cB cB cB cB
lllll.
Core Resource Set 
.sp
=
Name	Class	Type	Default	Access
.sp
_
XmNaccelerators	XmCAccelerators	XtTranslations	NULL	CSG
XmNancestorSensitive	XmCSensitive	Boolean	True	G
XmNbackground	XmCBackground	Pixel	dynamic	CSG
XmNbackgroundPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderColor	XmCBorderColor	Pixel	Black	CSG
XmNborderPixmap	XmCPixmap	Pixmap	XmUNSPECIFIED_PIXMAP	CSG
XmNborderWidth	XmCBorderWidth	Dimension	0	CSG
XmNcolormap	XmCColormap	Colormap	XtCopyFromParent	CG
XmNdepth	XmCDepth	int	XtCopyFromParent	CG
XmNdestroyCallback	XmCCallback	XtCallbackList	NULL	C
XmNheight	XmCHeight	Dimension	0	CSG
XmNmappedWhenManaged	XmCMappedWhenManaged	Boolean	True	CSG
XmNscreen	XmCScreen	Pointer	XtCopyScreen	CG
XmNsensitive	XmCSensitive	Boolean	True	CSG
XmNtranslations	XmCTranslations	XtTranslations	NULL	CSG
XmNwidth	XmCWidth	Dimension	0	CSG
XmNx	XmCPosition	Position	0	CSG
XmNy	XmCPosition	Position	0	CSG
.sp
.TE
.DE
.ps 10
.SH 
\fBFUNCTIONS\fP
.IP
.nf
.ta .50i 1.50i
Widget \fBXbCreateGraphic\fP (\fIparent_widget, name,
		override_arglist, override_argcount\fP)
	Widget	\fIparent_widget\fP;
	String	\fIname\fP;
	ArgList	\fIoverride_arglist\fP;
	Cardinal	\fIoverride_argcount\fP;
.fi
.RS .8i
.IP \fIparent_widget\fP 1.2i
Specifies the parent widget ID.
.IP \fIname\fP
Specifies the name of the created widget.
.IP \fIoverride_arglist\fP
Specifies the application override argument list.
.IP \fIoverride_argcount\fP
Specifies the number of attributes int the override_arglist.
.RE
.HP .8i
.IP
The \fBXbCreateGraphic\fP function creates an instance of the Graphic Widget 
and returns its associated Widget ID.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void* \fBXbGraphicGoInterf\fP (\fIgraphic_widget\fP)
	Widget	\fIgraphic_widget\fP;
.fi
.RS .8i
.IP \fIgraphic_widget\fP 1.2i
Specifies the graphic widget ID.
.RE
.HP .8i
.IP
If the widget is realized, the \fBXbGraphicGoInterf\fP function returns
a pointer to the \fIXmGoInterf\fP instance, else it returns NULL.
.HP .5i
.sp 1
.IP
.nf
.ta .50i 1.50i
void* \fBXbGraphicGoRoot\fP (\fIgraphic_widget\fP)
	Widget  \fIgraphic_widget\fP;
.fi
.RS .8i
.IP \fIgraphic_widget\fP 1.2i
Specifies the graphic widget ID.
.RE
.HP .8i
.IP
If the widget is realized, the \fBXbGraphicGoRoot\fP function returns a
pointer to the attached \fIGoRoot\fP, else it returns NULL.
.HP .5i
.SH 
\fBRELATED INFORMATION\fP
.IP
\fBComposite(3X)\fP, \fBConstraint(3X)\fP, \fBCore(3X)\fP,
\fBXmDrawingArea(3X)\fP and \fBXmManager(3X)\fP.
.IP
\fBGo(3Go)\fP, \fBGoInterf(3Go)\fP, \fBXmGoInterf(3Go), \fBGoRoot(3Go)\fP, 
\fBGo Programmer's Guide\fP.
.sp 1
.nrPN \n%
