.\" $Id: XtGoInterf.n,v 1.1 1992/07/20 07:31:58 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XtGoInterf 3Go "July 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXtGoInterf\fP \(em the X Window System Go interface object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/XtGoInterf.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBXtGoInterf\fP inherits behavior from the \fBXtGoInterf\fP class.
.sp 1
.SH
\fBDESCRIPTION\fP
.RS .8i
.sp 1
The \fBXtGoInterf\fP object class implements the interface between the X toolkit and \fBGo\fP. It just makes an XGoInterf using the widget characteristics.
.sp 1
.br 
.RE
.sp 2
.nf
.ta .15i .25i 1.0i
class XtGoInterf : public XtGoInterf {

	public:
		/** specific Xt methods **/

		XtGoInterf (Widget \fIwidget\fP);
		~XtGoInterf();
		Widget widget();
	}
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBXtGoInterf\fP(Widget \fIwidget\fP);
.RS .8i
.IP \fIDescription:\fP .5i
.IP \fIwidget\fP .5i
.br
Specifies the \fIwidget\fP used to retreive associated window. Note that the \fIwidget\fP must be realized.
.RE
.sp 1
.IP 
\fB~XtGoInterf\fP()
.RS .8i
.IP \fIDescription\fP .5i
The destructor deletes the XtGoInterf and the X resources used. The \fIwidget\fP itself is not destroyed.
.RE
.sp 1
.IP
Widget \fBwidget\fP()
.RS .8i
.IP \fIDescription\fP .5i
The method returns the widget associated to the drawable. The result be NULL.
.RE
.SH
\fBC BINDING\fP
.sp 1
.nf
   \fI#include <Go/cXtGoInterf.h>\fP

	GObjectId \fBXtGoInterfCreate\fP(Widget \fIwidget\fP);
	Widget   \fBXtGoInterfWidget\fP(GObjectId \fIxtgointerf\fP);
.sp 1
.IP \fIDescription\fP .5i
\fIsee\fP the XtGoInterf::\fIname\fP method.
.br
The C interface for the \fIXtGoInterf\fP object provides only the interface for the specific XtGoInterf methods.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
Specific X methods are strongly discouraged because of portability of your application over another GoInterf. To show the portability problem over another interface, it is usual to use XtGoInterf as an GoInterf and to cast in XtGoInterf to use specific XtGoInterf methods.
.IP
.sp 1
An \fBXtGoInterf\fP may be created by application which wants to have Go available onto a specific widget. Note that application has to setup event handler (in the X toolkit) in order to give event to the interface. See the \fIhandleXEvent\fP method of the XGoInterf class.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBXGoInterf(3Go)\fP, \fBGoInterf(3Go)\fP, \fBXtInputDispatcher(3Go)\fP,
.IP
\fBXToolkit\fP, \fBXbGraphic\fP.

.nrPN \n%


