.\" $Id: XtInDisp.n,v 1.1 1992/07/20 07:33:04 smadja Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH XtInputDispatcher 3Go "June 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBXtInputDispatcher\fP \(em the input dispatcher object class for X window.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/XtInDisp.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBXtInputDispatcher\fP inherits behavior from the GoInputDispatcher class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBXtInputDispatcher\fP object allows to distribute \fIevents\fP incoming from input queue associated to an XtAppContext. So an \fIevent\fP for the XtInputDispatcher class is an input which can be designed with the Xt toolkit (XEvent,read/write on a socket etc...). To handle an \fIevent\fP, \fIrunEventLoop\fP method will call the read of the next event associated to the XtAppContext and will dispatch it. So to use the \fIXtInputDispatch\fP we need \fIwidgets\fP.
.br
The XtInputDispatcher provides only an input queue which is associated to an XtAppContext. Keep in mind that an XtAppContext is able to handle several display.
.br
The type of \fIevent\fP for GInDispFilterProc type is \fIXEvent\fP.
.sp 1
Only specific methods of XtInputDispatcher are describe here.
.sp 1
.nf
.ta .15i .25i 1.0i

class XtInputDispatcher :: public GoInputDispatcher {
	public:
		XtInputDispatcher(XtAppContext \fIappcontext\fP);
		~XtInputDispatcher();

		XtAppContext xtAppContext() const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBXtInputDispatcher\fP(XtAppContext \fIappcontext\fP);
.RS .8i
.IP \fIDescription\fP .5i
The constructor creates an new instance of an XtInputDispatcher. Incoming events are read from the input queue associated to the XtAppContext.
.IP \fIdpy\fP .5i
Specifies the XtAppContext.
.RE
.sp 1
.IP
\fB~XtInputDispatcher\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method is called when an \fIXtInputDispatcher\fP instance is deleted.
.RE
.sp 1
.IP
XtAppContext \fBXtAppContext\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
The method returns the XtAppContext used by the input dispatcher.
.IP
.RE
.SH
\fBC BINDING\fP
.IP
.sp 1
.nf
.ta .15i .25i 1.5i
	\fI#include <Go/cXtIndisp.h>\fP

		GObjectId XtInputDispatcherCreate(XtAppContext \fIapp\fP);
.fi
.IP \fIDescription\fP .5i
See above the corresponding C++ method.
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.br
In general there is only one instance of an \fIinput dispatcher\fP inside an application.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fIGoInputDispatcher\fP, \fIXInputDispatcher\fP classes.
.nrPN \n%


