.\" $Id: create-go-class.n,v 1.1 1993/01/05 09:16:36 jojic Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH create-go-class 1Go "June 1992" "Version 1.2" "Go Utilities" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBcreate-go-class\fP \(em help for creation of new go subclasses.
.SH
\fBSYNOPSIS\fP
.IP
\fIcreate-go-class  Class  SuperClass  [-file File]  [-data]  [-rcs]  [-copyright] [-company Company]\fP
.SH 
\fBDESCRIPTION\fP
.IP
This program helps you to implement new Go subclasses. It creates, in the
current directory, a \fI.h\fP file and a \fI.cc\fP file containing a lot
of common stuff needed when you implement a new Go subclass.
The builded \fI.h\fP file contains the declaration of
the new class and of the corresponding metaclass. The \fI.cc\fP file contains
all methods of the class and of the metaclass.
.br
You must then edit these files to add this Go subclass specific code.
.sp
Using \fBcreate-go-class\fP procures two advantages: the big one is the
simplification of the implementation of new Go subclasses; The second one
is the Go code uniformity, independently of the origin.
.SH
\fBPARAMETERS\fP
.IP
\fIClass\fP
.RS .8i
This must be the new class name without the \fIGo\fP prefix. I.e. for the
\fIGoRectangle\fP class, you must pass \fIRectangle\fP.
.RE
.sp
.IP
\fISuperClass\fP
.RS .8i
This must be the superclass name without the \fIGo\fPprefix. I.e. for the
\fIGoPolygon\fP superclass of GoRectangle, you must pass \fIPolygon\fP.
If you write a direct subclass of Go, you must pass ``\fI""\fP'', i.e. the
empty string, for \fISuperClass\fP.
.RE
.sp
.IP
\fI-file File\fP
.RS .8i
If you pass this flag, the program will create files \fIFile.h\fP and
\fIFile.cc\fP. If this flag is not present, the names of the files will be
\fIClass.h\fP and \fIClass.cc\fP.
.RE
.sp
.IP
\fI-data\fP
.RS .8i
Without this option, builded files will not contain methods defining low level
data storage (\fId_get_...\fP and \fId_set_...\fP virtual methods).
.RE
.sp
.IP
\fI-rcs\fP
.RS .8i
Without this option, the line used by rcs (revision control system) or cvs is
not included inside created files.
.RE
.sp
.IP
\fI-copyright\fP
.RS .8i
If you pass this flag, copyright informations will be inserted.
.RE
.sp
.IP
\fI-company Company\fP
.RS .8i
If you want a Copyright, the name of the company will be \fICompany\fP.
\fIBull S.A.\fP is the default company !
.RE
.sp
.SH
\fBSEE ALSO\fP
.IP
The Go Advanced Manual.
.nrPN \n%
