.\" $Id: mGoRoot.n,v 1.1.1.1 1992/03/18 09:44:38 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GoRootMetaclass 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGoRootMetaclass\fP \(em the GoRoot metaclass object class.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/mGoRoot.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBGoRootMetaclass\fP inherits behavior from the \fBGoMetaclass\fP class.
.sp 1
.SH
\fBDESCRIPTION\fP
.IP
A \fBGoRootMetaclass\fP object class represent the metaclass of \fIGoRoot\fP objects (see \fIGoRoot(3Go)\fP).
There is only one static instance of \fIGoRootMetaclass\fP: it may be accessed
with \fBGoRoot::metaclass()\fP.
.IP
The \fBGoRootMetaclass\fP allows to define a common behavior for every instance of
\fIGoRoot\fP. \fBGoRootMetaclass\fP inherits from \fBGoMetaclass\fP (see \fIGoMetaclass(3Go)\fP).
.sp 1
.br
.nf
.ta .15i .25i 1.0i
class GoRootMetaclass : public GoMetaclass {
	public:
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fISee GoMetaclass(3Go)\fP.
.sp 1
.SH
\fBUSER INTERACTION\fP
.IP
\fISee GoMetaclass(3Go)\fP.
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
New \fIGoRootMetaclass\fP instances cannot be created, this explains why there
are not public constructor. There is a single instance of \fBGoRootMetaclass\fP which
may be accessed with \fBGoRoot::metaclass()\fP.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoMetaclass\fP, \fBGoInterf\fP and \fBGoRoot\fP classes.
.nrPN \n%
