.\" $Id: Alloc.n,v 1.1.1.1 1992/03/18 09:44:57 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Alloc 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBAlloc\fP \(em the memory management.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Alloc.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
\fBAlloc\fP is a set of memory management functions. It allows to
allocate, reallocate and free memory and perform some useful tests.
The list of memory management functions is:
.sp 1
.nf
.ta .15i .25i 1.5i
		void* GMALLOC (ulong \fInbytes\fP);
		void* GMALLOC_NO_EXIT (ulong \fInbytes\fP);
		void  GFREE (void* \fIptr\fP);
		void  GREALLOC (void* \fIptr\fP, ulong \fInbytes\fP);
		void  GREALLOC_NO_EXIT (void* \fIptr\fP, ulong \fInbytes\fP);
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
void* \fBGMALLOC\fP (ulong \fInbytes\fP);
.br
void* \fBGMALLOC_NO_EXIT\fP (ulong \fInbytes\fP);
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to alloc a \fInbytes\fP memory buffer. It returns
a pointer to the alloced memory space. \fIGMALLOC\fP will exit if an
error occurs while \fIGMALLOC_NO_EXIT\fP will return \fINULL\fP.
.IP \fInbytes\fP .5i
.br
Specifies the buffer size to be allocated. If 0, \fIGMALLOC\fP and
\fIGMALLOC_NO_EXIT\fP returns \fINULL\fP.
.RE
.sp 1
.IP
void \fBGFREE\fP (void* \fIptr\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to free the memory space pointed by \fIptr\fP. \fIPtr\fP
is set to \fINULL\fP.
.IP \fIptr\fP .5i
.br
Specifies the pointer to the buffer to be freed. If \fINULL\fP, the
function simply returns.
.RE
.sp 1
.IP
void \fBGREALLOC\fP (void* \fIptr\fP, ulong \fInbytes\fP);
.br
void \fBGREALLOC_NO_EXIT\fP (void* \fIptr\fP, ulong \fInbytes\fP);
.RS .8i
.IP \fIDescription\fP .5i
These function allow to resize a buffer previously allocated. Data are kept and
\fIptr\fP is updated with the new pointer.  \fIGREALLOC\fP will exit if an
error occurs while \fIGREALLOC_NO_EXIT\fP will return \fINULL\fP.
.IP \fIptr\fP .5i
.br
Specifies the pointer to the buffer. If \fINULL\fP, a new allocation is
performed (see \fIGMALLOC\fP, \fIGMALLOC_NO_EXIT\fP).
.IP \fInbytes\fP .5i
.br
Specifies the new buffer size. If 0, the buffer pointed by \fIptr\fP is
freed.
.RE
.sp1
.SH
\fBC BINDING\fP
.IP
None.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fIAlloc\fP functions are macros in order to avoid some castings.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fImalloc(3), free(3), realloc(3)\fP
.nrPN \n%
