.\" $Id: Atom.n,v 1.1.1.1 1992/03/18 09:45:11 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Atom 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBAtom\fP \(em the atom management.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Atom.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
\fBAtom\fP is a set of \fIatom\fP management functions. An
atom is a unique identifier of a string. Using \fIAtom\fP allows
to manipulate (compare, assign, ...) strings as \fIvoid*\fP.
.sp 1
\fBGAtom\fP is the C++ type for \fIAtom\fP and is defined as
a \fIvoid*\fP. The list of atom management functions is:
.sp 1
.nf
.ta .15i .25i 1.5i
		GAtom GCreateAtom (const char* \fIstring\fP);
		const char* GAtomToString (const GAtom \fIatom\fP);
		void GFreeAtom (GAtom \fIatom\fP);
.fi
.sp 1
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
GAtom \fBGCreateAtom\fP (const char* \fIstring\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to return the \fIatom\fP associated to the given
string. If such an atom does not exist, it is created.
.IP \fIstring\fP .5i
Specifies the string to be converted into an atom.
.RE
.sp 1
.IP
void \fBGFreeAtom\fP (GAtom \fIatom\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to free the given atom.
.IP \fIatom\fP .5i
.br
Specifies the atom to be freed.
.RE
.sp 1
.IP
const char* \fBGAtomToString\fP (const GAtom \fIatom\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function, which is actually a define, allows to get the string associated
to the \fIatom\fP.
.IP \fIatom\fP .5i
.br
Specifies the concerned atom.
.sp1
.SH
\fBC BINDING\fP
.IP
None.
.SH
\fBUSAGE INFORMATION\fP
.IP
.SH
\fBSEE ALSO\fP
.IP
.nrPN \n%
