.\" $Id: Bind.n,v 1.1 1993/01/05 16:13:56 jojic Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GBind 3Go "June 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGBind\fP \(em the name to pointer database.
.SH
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Bind.h>\fP
.SH 
\fBDESCRIPTION\fP
.IP
\fBThe GBind function allows to set or to get a pointer to/from a string.\fP
.br
The call of:
.br
	GBind(string, pointer)
.br
will set the value \fIpointer\fP to the name \fIstring\fP;
and the call of:
.br
	GBind(string)
will return \fIpointer\fP.
.sp
This function is particularly used by some interactors which allow the
definition of user interactions inside ascii files. These files contain some
function names. Interactors use \fBGBind\fP to retreive the function pointer
associated to this name. This implies that if you want to add some of yours
function names inside one of these files, you have to set their associated
function pointers using \fBGBind\fP.

In the Go World, all objects that want to make such an association use
\fBGBind\fP.
.sp 2
.nf
	void GBind (const char* name, void* value);
	void* GBind (const char* name);
.fi
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
void \fBGBind\fP (const char* \fIname\fP, void* \fIvalue\fP);
.RS .8i
.IP \fIDescription\fP .3i
This function sets the value \fIvalue\fP to
the key \fIname\fP. If a previous value is overwritten, \fBGBind\fP calls
\fIGWarning\fP with a corresponding error message.
.br
\fIname\fP is a string, that means that key comparison is done by comparing all
characters of the string (and not the equality of string addresses).
.RE
.sp
.IP
void* \fBGBind\fP (const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .3i
This method returns the
value \fIvalue\fP which was previously associated to \fIname\fP.
If there were no such assocation, \fBGBind\fP returns \fBNULL\fP.
.RE
.sp 2
.SH
\fBC BINDING\fP
.IP
To be completed.
.sp 2
.SH
\fBSEE ALSO\fP
.IP
To be completed.
.nrPN \n%