.\" $Id: Error.n,v 1.1.1.1 1992/03/18 09:46:02 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Error 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBError\fP \(em the error management.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Error.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
\fBError\fP is a set of \fIerror\fP management functions. These functions
print on the \fIstandard error\fP a message in a given format. The format
takes the \fIprintf(3)\fP syntax.
.IP
The list of memory management functions is:
.sp 1
.nf
.ta .15i .25i 1.0i
		void GWarning(const char* \fIformat\fP, ...);
		void GError(const char* \fIformat\fP, ...);
.fi

extern int gTraceLevel;
.sp 1
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
void \fBGWarning\fP(const char* \fIformat\fP, ...)
.RS .8i
.IP \fIDescription\fP .5i
This function prints the warning message if \fIgTraceLevel\fP is
different of 0 and returns.
.IP \fIformat\fP .5i
Specifies the format of the message (see \fIprintf(3)\fP).
.RE
.sp 1
.IP
void \fBGError\fP(const char* \fIformat\fP, ...)
.RS .8i
.IP \fIDescription\fP .5i
This function prints the error message and exits.
.IP \fIformat\fP .5i
Specifies the format of the message (see \fIprintf(3)\fP).
.RE
.sp1
.SH
\fBC BINDING\fP
.IP
None.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fIprintf(3)\fP.
.nrPN \n%
