.\" $Id: FilePath.n,v 1.3 1992/12/28 12:42:53 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH FilePath 3Go "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBFilePath\fP \(em looking for files in three directories. 
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/FilePath.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBGGetFilePath\fP function looks for files in three directories and returns the full path of files.
.sp 1
.nf
.ta .15i .25i 1.5i
	char* GGetFilePath(const char* \fIsub_path\fP, const char* \fIfilename\fP);
.fi
.sp 1
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
char* \fBGGetFilePath\fP(const char* \fIsub_path\fP, const char* \fIfilename\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function looks for the file \fIfilename\fP in the directories ".", "$GoENVIRON/\fIsub_path\fP" and "/usr/local/lib/Go/\fIsub_path\fP". It returns the full path of the first found file or NULL if file does not exist. GoENVIRON is an environment variable.
.IP \fIsub_path\fP .5i
.br
Specifies the sub path of the file used to looking for the file.
.br
"/" are transformed into "\\" if DOS is defined and "\\" are tranformed into "/" if DOS is undefined.
.IP \fIfilename\fP .5i
.br
Specifies the searched file.
.RE
.sp1
.SH
\fBC BINDING\fP
.SS 
\fBHeader file\fP
.IP
#include <Go/Tools/cFilePath.h>
.SS 
\fBC Functions\fP
.IP
char* \fBGCGetFilePath\fP(char* \fIfullname\fP, char* \fIfilename\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GGetFilePath() function.
.RE
.sp 1
.SH
.nrPN \n%
