.\" $Id: GCdef.n,v 1.1.1.1 1992/03/18 09:46:21 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH GCdef 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBGCdef\fP \(em common definitions for graphic context objects.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/GCdef.h>\fP
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
\fBGCdef\fP is a set of definitions used by the graphic context objects (\fIShPen, ShBrush,
ShTextBrush, ShImageBrush\fP and also by \fIBGoInterf\fP (see \fIGoInterf(3Go)\fP).
.sp 1
.SH
\fBBITMASK FOR SHAREDOBJECT MANAGEMENT\fP
.IP
.nf
.ta .25i 1.0i 2.5i
	#define	GFUNCTION	(1L<<0)
	#define	GPLANE_MASK	(1L<<1)
	#define	GCOLOR	(1L<<2)
	#define	GALT_COLOR	(1L<<3)
	#define	GLINE_WIDTH	(1L<<4)
	#define	GLINE_STYLE	(1L<<5)
	#define	GCAP_STYLE	(1L<<6)
	#define	GJOIN_STYLE	(1L<<7)
	#define	GFILL_STYLE	(1L<<8)
	#define	GFILL_RULE	(1L<<9)
	#define	GTILE		(1L<<10)
	#define	GSTIPPLE	(1L<<11)
	#define	GTILE_STIP_XORIGIN	(1L<<12)
	#define	GTILE_STIP_YORIGIN	(1L<<13)
	#define	GFONT	(1L<<14)
	#define	GDASH	(1L<<15)
	#define	GMITER_LIMIT	(1L<<16)
	#define	GCOLORMAP	(1L<<17)
.fi
.sp 1
.RS .8i
.IP \fBGFUNCTION\fP .5i
.br
When this bit is set, the \fIfunction\fP field of the \fI(GPen/GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGPLANE_MASK\fP .5i
When this bit is set, the \fIplane_mask\fP field of the \fI(GPen/GBrush/GTextBrush/GImageBrush)Values\fP structure
is valid.
.IP \fBGCOLOR\fP .5i
When this bit is set, the \fIcolor\fP field of the \fI(GPen/GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGALT_COLOR\fP .5i
When this bit is set, the \fIalt_color\fP field of the \fI(GPen/GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGLINE_WIDTH\fP .5i
When this bit is set, the \fIline_width\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGLINE_STYLE\fP .5i
When this bit is set, the \fIline.style\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGCAP_STYLE\fP .5i
When this bit is set, the \fIline.cap\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGJOIN_STYLE\fP .5i
When this bit is set, the \fIline.join\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGFILL_STYLE\fP .5i
When this bit is set, the \fIfill.style\fP field of the \fI(GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGFILL_RULE\fP .5i
When this bit is set, the \fIfill.rule\fP field of the \fIGBrushValues\fP structure
is valid.
.IP \fBGTILE\fP .5i
When this bit is set, the \fItile\fP field of the \fI(GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGSTIPPLE\fP .5i
When this bit is set, the \fIstipple\fP field of the \fI(GBrush/GTextBrush/GImageBrush)Values\fP structure
is valid.
.IP \fBGTILE_STIP_XORIGIN\fP .5i
When this bit is set, the \fIts_x_origin\fP field of the \fI(GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGTILE_STIP_YORIGIN\fP .5i
When this bit is set, the \fIts_y_origin\fP field of the \fI(GBrush/GTextBrush)Values\fP structure
is valid.
.IP \fBGFONT\fP .5i
When this bit is set, the \fIfont\fP field of the \fIGTextBrushValues\fP structure
is valid.
.IP \fBGDASH\fP .5i
When this bit is set, the \fIdash\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGMITER_LIMIT\fP .5i
When this bit is set, the \fImiter_limit\fP field of the \fIGPenValues\fP structure
is valid.
.IP \fBGCOLORMAP\fP .5i
When this bit is set, the \fIcmap\fP field of the \fIGImageBrushValues\fP structure
is valid.
.RE
.sp 1
.SH
\fBFUNCTION DEFINITIONS\fP
.IP
The \fIfunction\fP member of the \fI(GPen/GBrush/GTextBrush)Values\fP structure
selects a logical function. \fILogical functions\fP control how the
\fIsource\fP pixel values generated by a graphics request are combined with the
\fIold destination\fP pixel values already present to result in the
\fIfinal destination\fP pixel value. The following table gives the
possible logical functions.
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GCLEAR	0x0	/* 0 */
	#define	GAND	0x1	/* src AND dst */
	#define	GAND_REVERSE	0x2	/* src AND NOT dst */
	#define	GCOPY	0x3	/* src */
	#define	GAND_INVERTED	0x4	/* NOT src AND dst */
	#define	GNO_OP	0x5	/* dst */
	#define	GXOR	0x6	/* src XOR dst */
	#define	GOR	0x7	/* src OR dst */
	#define	GN_OR	0x8	/* NOT src AND NOT dst */
	#define	GEQUIV	0x9	/* NOT src XOR dst */
	#define	GINVERT	0xa	/* NOT dst */
	#define	GOR_REVERSE	0xb	/* src OR NOT dst */
	#define	GCOPY_INVERTED	0xc	/* NOT src */
	#define	GOR_INVERTED	0xd	/* NOT src OR dst */
	#define	GN_AND	0xe	/* NOT src OR NOT dst */
	#define	GSET	0xf	/* 1 */
.fi
.sp 1
.SH
\fBPLANE MASK DEFINITIONS\fP
.IP
The \fIplane_mask\fP member of the \fI(GPen/GBrush/GTextBrush/GImageBrush)Values\fP
structures determines which planes of the destination are modified.
.sp 1
Destination planes are represented by a bit set to 1 in the \fIplane_mask\fP.
If the \fIplane_mask\fP is 0, the graphic primitive don't give any result. 
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GALL_PLANES	~0
.fi
.sp 1
.RS .8i
.IP \fBGALL_PLANES\fP .5i
If the \fIplane_mask\fP value is \fIGALL_PLANES\fP, all planes will be concerned by the drawing.
.RE
.sp 1
.SH
\fBCOLOR DEFINITIONS\fP
.IP
The \fIcolor\fP member of the \fI(GPen/GBrush/GTextBrush)Values\fP structure is the
destination color in all graphic methods. However, some graphic styles don't
only use the \fIcolor\fP member but also the \fIalt_color\fP or the \fItile\fP
members (see below).
.sp 1
.SH
\fBALTERNATE COLOR DEFINITIONS\fP
.IP
The \fIalt_color\fP is used either when drawing lines if the \fIline.style\fP member is
\fIGLINE_DOUBLE_DASH\fP (\fIGPenValues\fP) or when filling areas if the \fIfill.style\fP member is
\fIGFILL_OPAQUE_STIPPLED\fP (\fI(GBrush/GTextBrush)Values\fP).
.sp 1
.SH
\fBLINE WIDTH DEFINITIONS\fP
.IP
The \fIline_width\fP member of the \fIGPenValues\fP structure specifies the width
of the line (\fIpen\fP) in millimeters. \fIZero\fP as line width is acceptable,
it is interpreted as the thinest line that can be rendered on the device.
.sp 1
Wide lines are drawn centered on the path described by the graphic method.
.sp 1
.SH
\fBLINE STYLE DEFINITIONS\fP
.IP
The \fIline.style\fP member of the \fIGPenValues\fP structure specifies whether
the line is solid or dashed.
.sp 1
.nf
.ta .25i 1.0i 2.5i
	#define	GLINE_SOLID	0
	#define	GLINE_ON_OFF_DASH	1
	#define	GLINE_DOUBLE_DASH	2
.fi
.sp 1
.RS .8i
.IP \fBGLINE_SOLID\fP .5i
When \fIGLINE_SOLID\fP is specified, the line is drawn using the \fIcolor\fP
member.
.IP \fBGLINE_ON_OFF_DASH\fP .5i
When \fIGLINE_ON_OFF_DASH\fP is specified the line is dashed in \fIcolor\fP.
.IP \fBGLINE_DOUBLE_DASH\fP .5i
When \fIGLINE_DOUBLE_DASH\fP is specified the line is dashed alterning
\fIcolor\fP and \fIalt_color\fP.
.RE
.sp 1
.SH
\fBCAP STYLE DEFINITIONS\fP
.IP
The \fIline.cap\fP member of the \fIGPenValues\fP structure controls the
appearance of the ends of the line and the ends of dashes (in some cases).
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GCAP_NOT_LAST	0
	#define	GCAP_BUTT	1
	#define	GCAP_ROUND	2
	#define	GCAP_PROJECTING	3
.fi
.sp 1
.RS .8i
.IP \fBGCAP_NOT_LAST\fP .5i
Is equivalent to \fIGCAP_BUTT\fP, except that the final endpoint is not drawn.
If specified with \fIline.style GLINE_ON_OFF_DASH\fP or \fIGLINE_DOUBLE_DASH\fP, the
ends of the dashes or where even and odd dashes meet are treated as \fIGCAP_BUTT\fP.
.IP \fBGCAP_BUTT\fP .5i
Specifies that lines will be square at the endpoint with no projection
beyond. The end is perpendicular to the slope of the line.
.IP \fBGCAP_ROUND\fP .5i
Specifies that lines will be terminated by a circular arc with the
diameter equal to the \fIline_width\fP, centered on the endpoint.
.IP \fBGCAT_PROJECTING\fP .5i
Specifies that lines will be square at the end but with the path
continuing beyond the endpoint for a distance equal to half the
\fIline_width\fP.
.RE
.sp 1
.SH
\fBJOIN STYLE DEFINITIONS\fP
.IP
The \fIline.join\fP member of the \fIGPenValues\fP structure controls the
appearance of joints between consecutive lines drawn within a single
graphic method.
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GJOIN_MITER	0
	#define	GJOIN_ROUND	1
	#define	GJOIN_BEVEL	2
.fi
.sp 1
.RS .8i
.IP \fBGJOIN_MITER\fP .5i
Specifies that the outer edges of the two lines should extend to meet
at an angle. If the angle between the two line is too sharp (see \fImiter_limit\fP),
\fIGJOIN_BEVEL\fP is used.
.IP \fBGJOIN_ROUND\fP .5i
Specifies that lines should be joined by a circular arc with diameter
equal to the \fIline_width\fP, centered on the join point.
.IP \fBGJOIN_BEVEL\fP .5i
Specifies \fIGCAP_BUTT\fP endpoint styles, with the triangular notch
filled.
.RE
.sp 1
.SH
\fBMITER LIMIT DEFINITIONS\fP
.IP
The \fImiter_limit\fP is the limit of the \fImiter length\fP. The
miter length is the distance from the point at witch the inner edges
of the lines intersect to the point at witch the outer edges of the
lines intersect (i.e. the diagonal length of the miter).
.sp 1
If the angle between lines is \fIa\fP, the formula is:
.br
.RS .8i
\fImiter_length / line_width = 1 / sin (a/2)
.RE
.sp 1
.nf
.ta .25i 1.0i 2.0i
	#define	GNO_MITER_LIMIT	-1
.fi
.sp 1
.RS .8i
.IP \fBGNO_MITER_LIMIT\fP .5i
If \fIGNO_MITER_LIMIT\fP is specified, \fIGCAP_BUTT\fP is used, if the angle
is less than 11 degrees.
.RE
.sp 1
.SH
\fBFILL STYLE DEFINITIONS\fP
.IP
The \fIfill_style\fP member of the \fI(GBrush/GTextBrush/GImageBrush)Values\fP structure controls
whether the source graphics are drawn with a solid \fIcolor\fP, a \fItile\fP or one
of the two \fIstipple\fP styles.
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GFILL_SOLID	0
	#define	GFILL_TILED	1
	#define	GFILL_STIPPLED	2
	#define	GFILL_OPAQUE_STIPPLED	3
.fi
.sp 1
.RS .8i
.IP \fBGFILL_SOLID\fP .5i
Specifies that graphics should be drawn using the \fIcolor\fP member.
.IP \fBGFILL_TILED\fP .5i
Specifies that the graphics should be drawn using the \fItile\fP member
(ignored in the \fIImageBrush\fP).
.IP \fBGFILL_STIPPLED\fP .5i
Specifies that the graphics should be drawn using the \fIcolor\fP
value masked by the \fIstipple\fP. In other words, bits set in the source
and \fIstipple\fP are drawn in the \fIcolor\fP value.
.IP \fBGFILL_OPAQUE_STIPPLED\fP .5i
Specifies that the graphics should be drawn using the \fIstipple\fP, using
the \fIcolor\fP member for set bits in the \fIstipple\fP and the
\fIalt_color\fP member for unset bits in the \fIstipple\fP (ignored  in the
\fIImageBrush\fP).
.RE
.sp 1
.SH
\fBFILL RULE DEFINITIONS\fP
.IP
The \fIfill.rule\fP member of the \fIGBrushValues\fP structure
controls what pixels are drawn for oaths given in \fIfillPolygon\fP requests.
.sp 1
.nf
.ta .25i 1.0i 2.0i 3.0i
	#define	GEVEN_ODD_RULE	0
	#define	GWINDING_RULE	1
.fi
.sp 1
.RS .8i
.IP \fBGEVEN_ODD_RULE\fP .5i
Means that if areas overlap an odd number of times, they are not drawn.
.IP \fBGWINDING_RULE\fP .5i
Means that overlapping areas are always filled.
.RE
.sp 1
.SH
\fBTILE DEFINITIONS\fP
.IP
The \fItile\fP member of the \fI(GPen/GBrush/GTextBrush)Values\fP structure
is a \fIShPattern\fP (see \fIShPattern(3Go)\fP) used to pattern the
pixels specified by set bits in the source.
.sp 1
Tiles are so named because they are laid out next to each other in an array
like bathroom tile. The origin of the first tile is specified with
the \fIts_x_origin\fP and \fIts_y_origin\fP members.
.sp 1
.SH
\fBSTIPPLE DEFINITIONS\fP
.IP
The \fIstipple\fP member of the \fI(GPen/GBrush/GTextBrush/GImageBrush)Values\fP structure
is a \fIShPattern\fP (see \fIShPattern(3Go)\fP) of depth 1.
.sp 1
There are two styles of stippling, selected by the \fIfill.style\fP member:
\fIGFILL_OPAQUE_STIPPLED\fP and \fIGFILL_STIPPLED\fP. For the first style, the
\fIcolor\fP value is used for bits set in the \fIstipple\fP and the source, and
the \fIalt_color\fP value is used for bits unset in the stipple but set in the
source. For the \fIGfillStippled\fP style, only the \fIcolor\fP value is
drawn for set bits in the stipple, and other pixels are not affected.
.sp 1
.SH
\fBTILE AND STIPPLE ORIGIN DEFINITIONS\fP
.IP
The \fIts_x_origin\fP and \fIts_y_origin\fP of the \fI(GPen/GBrush/GTextBrush/GImageBrush)Values\fP
structure specifies (in millimeters) the origin of both the \fIstipple\fP and
the \fItile\fP.
.sp 1
.SH
\fBFONT DEFINITIONS\fP
.IP
The \fIfont\fP member of the \fIGTextBrushValues\fP structure is a \fIShFont\fP
(see \fIShFont(3Go)\fP) and it is used to draw text. The \fIfill_style\fP member
affects (\fIGFILL_SOLID, GFILL_TILE, GFILL_STIPPLED, GFILL_OPAQUE_STIPPLED\fP) the
text drawing. The height of the font is specified in the \fIstring\fP request.
.sp 1
.SH
\fBDASH DEFINITIONS\fP
.IP
The \fIdash\fP member of the \fIGPenValues\fP structure is a \fIShDash\fP
(see \fIShDash(3Go)\fP. It is used when the \fIline.style\fP is
\fIGLINE_ON_OFF_DASH\fP and \fIGLINE_DOUBLE_DASH\fP.
.sp 1
.SH
\fBCOLORMAP DEFINITIONS\fP
.IP
The \fIcolormap\fP member of the \fIGImageBrushValues\fP structure
is a \fIShColormap\fP (see \fIShColormap(3Go)\fP). It is used when drawing
images (see \fIShPixelArray(3Go)\fP).
.sp 1
.SH
\fBC BINDING\fP
.IP
All definitions are valid in C.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
These definitions are used in the graphic context objects (\fIShPen, ShBrush, ShTextBrush,
ShImageBrush\fP) and by the \fIGoInterf\fP.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBGoInterf\fP, \fBShColor\fP, \fBShDash\fP, \fBShColormap\fP, \fBShPattern\fP,
\fBShPen\fP, \fBShBrush\fP, \fBTextBrush\fP, \fBShImageBrush\fP classes.
.nrPN \n%
