.\" $Id: LengthUnit.n,v 1.1.1.1 1992/03/18 09:46:50 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH LengthUnit 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBLenghtUnit\fP \(em the length unit object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/LengthUnit.h>\fP
.sp 1
.SH 
n\fBCLASS\fP
.IP
\fBLenghtUnit\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBUnit\fP class.
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBLenghtUnit\fP class implements a length unit conversions. A length
value is defined as a float (\fIGNumber\fP). The length
units are:
.sp 1
.nf
.ta .25i .50i 1.5i 2.5i
	#define	GMETER	0
	#define	GINCH	1	// 2.54 CM
	#define	GFOOT	2	// 3 INCHES
	#define	GYARD	3	// 3 FEET
	#define	GMILE	4	// 1760 YARDS
.fi
.sp 1
\fBGLengthUnit\fP is the C++ type for the \fILengthUnit\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GLengthUnit : public GUnit {
	public:
		GLengthUnit (uchar \fIunit\fP = GMETER, float \fIfactor\fP = 1/1000);

		float to (uchar \fIunit\fP, float \fIfactor\fP, float \fIvalue\fP);
		float from (uchar \fIunit\fP, float \fIfactor\fP, float \fIvalue\fP);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGLengthUnit\fP (uchar \fIunit\fP = GMETER, float \fIfactor\fP = 1/1000);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a new instance of the \fILengthUnit\fP class.
.IP \fIunit\fP .5i
.br
Specifies the base unit. Possible values are \fIGMETER, GINCH, GFOOT, GYARD, GMILE\fP.
.IP \fIfactor\fP .5i
Specifies the unit factor. Default value is 0.001.
.RE
.sp 1
.IP
.nf
float \fBto\fP (uchar \fIunit\fP, float \fIfactor\fP, float \fIvalue\fP);
float \fBfrom\fP (uchar \fIunit\fP, float \fIfactor\fP, float \fIvalue\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to convert a given value expressed in an other unit
(\fIunit, factor\fP) to the current unit or a given value expressed in the
current unit to another unit.
.IP "\fIunit, factor\fP" .5i
Specify the alternate unit.
.IP \fIvalue\fP .5i
Specifies the value to be converted.
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP
.SH
\fBUSAGE INFORMATION\fP
.IP
.SH
\fBSEE ALSO\fP
.IP
\fBUnit(3Go)\fP.
.nrPN \n%
