.\" $Id: Line.n,v 1.1.1.1 1992/03/18 09:46:55 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Line 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBLine\fP \(em the geometric line object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Geomutil.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBLine\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBLine\fP class implements the classical geometric line.
It is defined by \fINumbers a and b\fP such as \fIy = ax + b\fP.
.sp 1
\fBGLine\fP is the C++ type of the \fILine\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GLine {
	public:
		GLine(const GPoint&, const GPoint&);
		GBool setX(GPoint&);
		GBool setY(GPoint&);
};

		GBool intersect(const GPoint&, const GPoint&, const GPoint&, const GPoint&);
.fi
.sp 1
.SH
\fBPUBLIC FUNCTIONS\fP
.IP
\fBGLine\fP(const GPoint& \fIend1\fP, const GPoint& \fIend2\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create a \fILine\fP defined by two points.
\fIP1\fP and \fIp2\fP may be equal.
.IP "\fIp1, p2\fP" .5i
.br
Specify the two points.
.RE
.sp 1
.IP
GBool \fBsetX\fP (GPoint& \fIpoint\fP);
.br
GBool \fBsetY\fP (GPoint& \fIpoint\fP);
.RS .8i
.IP \fIDescription\fP .5i
These two methods allow to set either the x coordinate or the y coordinate of \fIpoint\fP
but the other coordinate (either y or x) is changed in order to keep the point on the line
(e.g. the point is moved on the line).
These methods return FALSE if the line is vertical or horizontal and the move to the line cannot be
performed.
.IP \fIpoint\fP .5i
.br
Specifies the point to be moved.
.RE
.sp 1
.IP
GBool \fBintersect\fP(const GPoint& \fIa\fP, const GPoint& \fIb\fP, const GPoint& \fIc\fP, const GPoint& \fd\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function returns TRUE, if the line containing \fIa\fP and \fPb\fP 
intersects the segment ended by \fIc\fP and \fId\fP.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
None.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBPoint(3Go)\fP, \fBBool(3Go)\fP, \fBNumber(3Go)\fP.
.nrPN \n%
