.\" $Id: Point.n,v 1.1.1.1 1992/03/18 09:47:28 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Point 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBPoint\fP \(em the geometric point object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Point.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBPoint\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBVector\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBPoint\fP class is the classical geometric point defined by two
Numbers \fIx\fP and \fIy\fP.
.sp 1
\fBGPoint\fP is the C++ type for the \fIPoint\fP object class.
.sp 1
.br
.nf
.ta .15i .25i 1.50i
struct GPoint : public Vector {
		// Public methods
		GPoint ();
		GPoint (GNumber \fIx\fP, GNumber \fIy\fP);
		GPoint (GVector& \fIvector\fP);

		friend GNumber GSquareDistance (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP) const;
		friend GNumber GSquareDistance (const GPoint& \fIp\fP,
			const GPoint& \fIline_end1\fP, const GPoint& \fIline_end2\fP) const;

		friend GNumber GDistance (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP);
		friend GNumber GDistance (const GPoint& \fIp\fP,
			const GPoint& \fIline_end\fP, const GPoint& \fIline_end2\fP);

		friend GPoint operator + (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP);
		friend GPoint operator + (const GPoint& \fIp1\fP, const GVector& \fIv\fP);
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGPoint\fP ();
.br
\fBGPoint\fP (GNumber \fIx\fP, GNumber \fIy\fP);
.br
\fBGPoint\fP (GVector& \fIvector\fP);
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to create an instance of the \fIPoint\fP structure.
.IP "\fIx, y\fP" .5i
.br
Specify the point coordinates.
.IP \fIvector\fP .5i
.br
Specify the vector from which the \fIPoint\fP instance is
created.
.RE
.sp 1
.IP
friend GNumber \fBGSquareDistance\fP (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP) const;
.br
friend GNumber \fBGSquareDistance\fP (const GPoint& \fIp\fP, const GPoint& \fIline_end1\fP,
.br
	const GPoint& \fIline_end2\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
The first function returns the square of the distance of the point \fIp1\fP
and the point \fIp2\fP. The second one returns the square of the distance
between the point \fIp\fP and the line defined by \fIline_end1\fP and \fIline_end2\fP.
.IP "\fIp, p1, p2\fP" .5i
Specify the used points in the distance computation.
.IP "\fIline_end1, line_end2\fP" .5i
Specify the line to which the distance is computed.
.RE
.sp 1
.IP
friend GNumber \fBGDistance\fP (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP) const;
.br
friend GNumber \fBGDistance\fP (const GPoint& \fIp\fP, const GPoint& \fIline_end1\fP,
.br
	const GPoint& \fIline_end2\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
The first function returns the distance of the point \fIp1\fP
and the point \fIp2\fP. The second one returns the distance
between the point \fIp\fP and the line defined by \fIline_end1\fP and \fIline_end2\fP.
.IP "\fIp, p1, p2\fP" .5i
Specify the used points in the distance computation.
.IP "\fIline_end1, line_end2\fP" .5i
Specify the line to which the distance is computed.
.RE
.sp 1
.IP
friend GPoint \fBoperator +\fP (const GPoint& \fIp1\fP, const GPoint& \fIp2\fP);
.br
friend GPoint \fBoperator +\fP (const GPoint& \fIp1\fP, const GVector& \fIv\fP);
.RS .8i
.IP \fIDescription\fP .5i
These two functions return a \fIPoint\fP which is the result of the addition
between two other \fIPoint's\fP or between a \fIPoint\fP and a \fIVector\fP.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS
\fBHeader File\fP
.IP
#include <Go/Tools/cPoint.h>
.SS
\fBType Definitions\fP
.IP
.nf
.ta .15i .25i 1.0i
typedef struct _GPoint
{
	GNumber x;
	GNumber y;
} GPoint;
.fi
.sp 1
\fISee\fP public variables x and y defined in the \fIGVector\fP C++ object class.
.SS
\fBC Functions\fP
.IP
None.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBVector(3Go)\fP and \fBNumber(3Go)\fP.
.nrPN \n%
