.\" $Id: PtrArray.n,v 1.1.1.1 1992/03/18 09:47:33 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH PointerArray 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBPointerArray\fP \(em the array of pointers management.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Array.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBPointerArray\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBArray\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
\fBPointerArray\fP is a tool allowing to create, add, remove  pointer inside an array of pointers. The size of an element is \fIsizeof(void*)\fP. The current allocated number of elements  is modulo the \fIincr\fP value defined at creation time. The \fBPointerArray\fP object assumes that \fIsizeof(void*)\fP is equal to \fIsizeof(unsigned long)\fP.
.sp 1
\fBGPointerArray\fP is the C++ type for the \fIPointerArray\fP object class.
.sp 1
.nf
.ta .15i .25i 1.0i
struct  GPointerArray  : public GArray {
		GPointerArray(int \fIincr\fP = 1);
		GPointerArray(const void* \fIpointer\fP, int \fIincr\fP = 1);
		GPointerArray(const void* \fIpointers[]\fP, int \fInpointers\fP,int \fIincr\fP);

		void add(const void* \fIpointer\fP, int \fIindex\fP = -1);
		void add(const void* \fIpointers[]\fP, uint \fInpointers_to_add\fP, int \fIindex\fP);

		void rem (int \fIindex\fP = -1, uint \fInelems_to_free\fP = 1); 
		void rem (const void* \fIpointer\fP);

		void** data() const;
		void*  data(int \fIindex\fP) const;
}
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGPointerArray\fP (int \fIincr\fP = 1);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to create an array of pointers. The size of a pointer is \fIsizeof\fP(void*). Each allocation are done modulo \fIincr\fP elements.
.IP \fIincr\fP .5i
.br
Specifies the modulo of number of elements for each allocation.
.RE
.sp 1
.IP
void \fBGPointerArray\fP (const void* \fIpointer\fP, int \fIincr\fP = 1);
.RS .8i
.IP \fIDescription\fP .5i
This function  creates an array of \fBone\fP pointer and copies \fIpointer\fP inside the array.
.IP \fIpointer\fP .5i
.br
Specifies the  value to put inside the array.
.IP \fIincr\fP .5i
.br
Specifies the modulo of number of elements for each allocation.
.RE
.sp 1
.IP
void \fBGPointerArray\fP (const void* \fIpointers[]\fP, int \fInpointers\fP, int \fIincr\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function  creates an array of \fInpointers\fP pointers and, if \fIpointers\fP is non NULL, it copies the elements pointed to by \fIpointers\fP inside the array.
.IP \fIpointers[]\fP .5i
.br
Specifies the source of data to copy inside the array. If \fIpointers\fP is NULL, the function does not copy anything.
.IP \fInpointers\fP .5i
.br
Specifies the number of pointers to alloc. If \fIpointers\fP is non NULL, it is also the number of elements to copy inside the array.
.IP \fIincr\fP .5i
.br
Specifies the modulo of number of elements for each allocation.
.RE
.sp 1
.IP
void \fBadd\fP(const void* \fIpointer\fP, int \fIindex\fP = -1);
.RS .8i
.IP \fIDescription\fP .5i
This function adds the \fIpointer\fP inside the array at \fIindex\fP.
.IP \fIpointer\fP .5i
.br
Specifies the  value to put inside the array.
.IP \fIindex\fP .5i
.br
Specifies the \fIindex\fP to add the new value. If \fIindex\fP is -1, it is considered to be the number of elements inside the array. So without the last parameter the \fIpointer\fP is copied to the end of the array. \fIindex\fP is in the range 0 to the number of elements of the array.
.RE
.sp 1
.IP
void \fBadd\fP(const void* \fIpointers[]\fP, int \fInpointers\fP, int \fIindex\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function adds the elements pointed to by \fIpointers\fP inside the array at \fIindex\fP.
.IP \fIpointers[]\fP .5i
.br
Specifies the source of data to copy inside the array.
.IP \fInpointers\fP .5i
.br
Specifies the number of elements pointed to by \fIpointers\fP.
.IP \fIindex\fP .5i
.br
Specifies the \fIindex\fP to add the new data. If \fIindex\fP is -1, it is considered to be the number of elements inside the array. The effective \fIindex\fP is in the range 0 to the number of elements of the array.
.RE
.sp1
.IP
void \fBrem\fP(int \fIindex\fP = -1, int \fInpointers_to_remove\fP = 1);
.RS .8i
.IP \fIDescription\fP .5i
This function removes from the array  \fInpointers_to_remove\fP. The first element is at \fIindex\fP.
.IP \fIindex\fP .5i
.br
Specifies the index of the first element to remove. If \fIindex\fP is -1, it is the last pointer of the array.
.IP \fInbpointers_to_remove\fP .5i
.br
Specifies the number of elements to remove.  \fIindex\fP plus \fInbelems_to_remove\fP must be less or equal to the actual number of elements.
.RE
.sp 1
.IP
void \fBrem\fP(const void* \fIvalue\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function removes from the array the first element equal to \fIvalue\fP. If no element is equal to \fIvalue\fP the function just returns.
.IP \fIvalue\fP .5i
.br
Specifies the element to remove.
.RE
.sp 1
.IP
void** \fBdata\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the \fBaddress\fP of the first element of the array.
.RE
.sp 1
.IP
void* \fBdata\fP(int \fIindex\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the value of the pointer placed at \fIindex\fP.
.IP \fIvalue\fP .5i
.br
Specifies the \fIindex\fP of the element you want. The \fIindex\fP must be from 0 to \fInelems()\fP minus 1. No range checking is done.
.RE
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBAlloc(3Go), Array(3Go)\fP
.nrPN \n%
