.\" $Id: Set.n,v 1.1.1.1 1992/03/18 09:47:57 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Set 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBSet\fP \(em the set object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Set.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBSet\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBSet\fP class implements a set which gathers elements.
An element may added to or removed from a \fISet\fP. In a \fISet\fP,
elements are organized in a holeless array.
.IP
Elements are seen as \fIvoid*\fP.
.sp 1
\fBGSet\fP is the C++ type for the \fISet\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GSet {
	public:
		GSet();
		~GSet();
    
		void add(const void* \fIelement\fP);
		void remove(const void* \fIelement\fP);
		void clear ();

		GBool empty() const;
		GBool contains (const void* \fIelement\fP);

		void* first() const;
		void* next() const;
		const void** allSet(int& \fIcount\fP) const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
\fBGSet\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method allows to create an empty \fISet\fP.
.RE
.sp 1
.IP
\fB~GSet\fP();
.RS .8i
.IP \fIDescription\fP .5i
This method is called when the \fISet\fP is deleted.
.RE
.sp 1
.IP
void \fBadd\fP(const void* \fIelement\fP);
.br
void \fBremove\fP(const void* \fIelement\fP);
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add (\fIadd()\fP) or remove (\fIremove()\fP) an
element to (from) the set.
.IP \fIelement\fP .5i
.br
Specifies the element to be added to or removed from the set.
.RE
.sp 1
.IP
void \fBclear\fP ();
.RS .8i
.IP \fIDescription\fP .5i
Thie method allows to remove all the elements contained in the set.
.RE
.sp 1
.IP
GBool \fBempty\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE if the set does not contain any element.
.RE
.sp 1
.IP
GBool \fBcontains\fP (const void* \fIelement\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE is the set contains the given element.
.IP \fIelement\fP .5i
.br
Specifies the concerned element.
.RE
.sp 1
.IP
void* \fBfirst\fP () const;
.br
void* \fBnext\fP () const;
.RS .8i
.IP \fIDescription\fP .5i
The \fISet\fP object maintains the set as an array and a current index.
These methods returns the first (\fIfirst()\fP or the next (\fInext()\fP)
elements of the current index.
.RE
.sp 1
.IP
const void** allSet(int& \fIcount\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns all the set elements in a \fIvoid*\fP array.
.IP \fIcount\fP .5i
Specifies the actual array size.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
None.
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBBool(3Go)\fP.
.nrPN \n%
