.\" $Id: ShColormap.n,v 1.1.1.1 1992/03/18 09:48:18 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ShColormap 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBShColormap\fP \(em the shared colormap object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/ShColormap.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBShColormap\fP class inherits behavior from:
.RS 10
.IP \(em 3
\fBSharedObject\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBShColormap\fP object is a \fBShColor\fP (see \fIShColor(3Go)\fP) table.
It is used when drawing image or when using pattern (see \fIShPattern(3Go)\fP)
by \fBGoInterf\fP instances (see \fIGoInterf(3Go)\fP).
.IP
\fIShColor\fP objects may be added to or removed from the colormap. A
color in a table has an \fIindex\fP used in the \fIShPixelArray\fP (see
\fIShPixelArray(3Go)\fP) description.
.IP
The \fIShColormap\fP object is a shared object (see \fISharedObject(3Go)\fP)
and may be shared between several object (i.e. \fBShPattern\fP).
.sp 1
\fBGShColormap\fP is the C++ type for the \fIShColormap\fP object class.
.nf
.ta .15i .25i 1.50i
class GShColormap : public GSharedObject {
	public:
		friend GShColormap* GCreateShColormap (ulong \fImask\fP, const GColormapValues* \fIvalues\fP,
			const char* \fIname\fP = NULL);
		friend GShColormap* GCreateShColormap (const char* \fIname\fP);

		friend void GModify (GShColormap*& \fIsh_cmap\fP, ulong \fImask\fP, const GColormapValues \fIvalues\fP);
		friend void GModify (const char* \fIname\fP, ulong \fImask\fP, const GColormapValues \fIvalues\fP);
		friend void GRename (GShColormap*& \fIsh_cmap\fP, const char* \fIname\fP);
		GShColormap* dup () const;
		GBool match (const GShColormap* \fIsh_cmap\fP) const;

		void updatePostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fImask\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void incrRefPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void decrRefPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void destroyPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void addColorPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_map\fP, ulong \fIindex\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void remColorPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void replaceColorPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;


		const GColormapValues* values () const;
		ulong nColor() const;
		const GShColor** colors () const;

		// Modification methods
		ulong addColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIsh_color\fP); // returns index
		ulong replaceColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIold_color\fP, const GShColor* \fInew_color\fP);
		ulong replaceColor (GShColormap& \fIsh_cmap\fP, ulong \fIindex\fP, const GShColor* \fInew_color\fP);
		void remColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIsh_color\fP);
		void remColor (Colormap& \fIcmap\fP, ulong \fIindex\fP);

		/* Getting color object, returns NULL if not found */
		const GShColor* getColor (const char* \fIname\fP) const;
		const GShColor* getColor (const GRgb* \fIrgb\fP) const;
		const GShColor* getColor (uchar \fIgray\fP) const;
		const GShColor* getColor (const GShPattern* \fIhalftone\fP) const; 
		const GShColor* getColor (ulong \fIindex\fP) const;

		/* Getting index, returns -1 if not found */
		long getIndex (const char* \fIname\fP) const;
		long getIndex (const GRgb* \fIrgb\fP) const;
		long getIndex (ushar \fIgray\fP) const;
		long getIndex (const GShPattern* \fIhalftone\fP) const;
		long getIndex (const GShColor* \fIsh_color\fP) const;

		static const char* classname();
};
.fi
.sp 1
.SH
\fBGColormapValues STRUCTURE\fP
.IP
This structure may be used when creating or modifying a \fIShColormap\fP instance.
To set or to modify the color characteristics, the appropriate members of
the \fIGColormapValues\fP structure and the corresponding value bitmask have to be
set before calling \fIGCreateShColormap()\fP or \fIGModify()\fP methods.
The \fIGColormapValues\fP may have NULL color fields.
.sp 1
\fIGColormapValues\fP structure:
.sp 1
.nf
.ta .25i .60i 1.80i
struct GColormapValues {
	ulong n_color;
	GShColor** colors;
} ;
.fi
.sp 1
.RS .8i
.IP \fIn_color\fP .5i
.br
Specifies the color number (\fIbut not the table size, some table entries
may be NULL\fP).
.IP \fIcolors\fP .5i
.br
Specifies a pointer to the color table. Some entries may be NULL, that means
these color indexes are not used.
.RE
.IP
.sp 1
\fBColormap value mask bits\fP:
.sp 1
.nf
.ta .25i 1.5i 2.5i
	#define GCOLORMAP_COLORS	(1L<<0)
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
friend GShColormap* \fBGCreateShColormap\fP (ulong \fImask\fP, const GColormapValues* \fIvalues\fP,
	const char* \fIname\fP = NULL);
.br
friend GShColormap* \fBGCreateShColormap\fP (const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to create an instance of the \fIShColormap\fP class.
.IP \fImask\fP .5i
.br
Specifies the value bitmask.
.IP \fIvalues\fP .5i
.br
Specifies a \fBGColormapValues\fP value structure pointer.
.IP \fIname\fP .5i
.br
Specifies the colormap name.
.RE
.sp 1
.IP
friend void \fBGModify\fP (GShColormap*& \fIsh_cmap\fP, ulong \fImask\fP, const GColormapValues* \fIvalues\fP)
.br
.RS .8i
.IP \fIDescription\fP .5i
This function allows to modify the colormap values. Like other shared
objects (see \fISharedObject(3Go)\fP), the modification function returns the
new \fIShColormap\fP object (possibly the same). \fIValues\fP may
be freed after the modification.
.IP \fIsh_cmap\fP .5i
.br
Specifies the colormap object reference which has to be modified.
.IP \fImask\fP .5i
.br
Specifies the value bitmask for the modification.
.IP \fIvalues\fP .5i
.br
Specifies a \fIGColormapValues\fP structure pointer. The fields of this
structure corresponding to the mask contain the new values.
.RE
.sp 1
.IP
friend void \fBGModify\fP (const char* \fIname\fP, ulong \fImask\fP, const GColormapValues \fIvalues\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to a \fIShColormap\fP object referred by its name.
.IP \fIname\fP .5i
.br
Identifies the \fIShColormap\fP. If it does not exist, it is created.
.IP \fImask\fP .5i
.br
Specifies the value bitmask for the modification.
.IP \fIvalues\fP .5i
.br
Specifies a \fIGColormapValues\fP structure pointer. The fields of this
structure corresponding to the mask contain the new values.
.RE
.sp1
.IP
friend void \fBGRename\fP (GShColormap*& \fIsh_cmap\fP, const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allows to (re)name a \fIShColormap\fP. If the reference count is
greater than 1, a new \fIShColormap\fP is looked for matching and a new instance
may be created.
.IP \fIsh_cmap\fP .5i
.br
Specifies the concerned \fIShColormap\fP instance.
.IP \fIname\fP .5i
.br
Specifies the new name, it may be NULL.
.RE
.sp 1
.IP
GShColormap* \fBdup\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the current \fIShColormap\fP object but increments the
reference count. It allows to modify a copy of a shared \fIShColormap\fP instance.
.RE
.sp1
.IP
GBool \fBmatch\fP (const GShColormap* \fIsh_cmap\fP) const
.RS .8i
.IP \fIDescription\fP .5i
This function returns GTRUE if the given \fIShColormap\fP object matches with
the current object, that means either the two values mask does not intersect, or
if the masks intersect, the corresponding values are the same.
.IP \fIsh_cmap\fP .5i
.br
Specifies the \fIShColormap\fP object used to proceed the matching operation.
.RE
.sp1
.IP
.nf
void \fBupdatePostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This function allows to add or to remove callback procedure when the shared object \fIShColormap\fP is
updated. That means the \fIGModify()\fP method has been applied on the current object. In other
terms, when the reference count of a shared object is 1 and if no other shared object \fImatches\fP
with the modification, the current object can be directly updated.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be updated. The callback procedure is
called after the modification is done. Its parameters are the \fIclosure\fP, the shared object \fIsh_cmap\fP itself
and the update \fImask\fP. The \fImask\fP determines the modified field only.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the update
callback list. If \fIadd\fP is GREMOVE, the callback procedure \fIproc\fP will be removed
from  the callback list.
.RE
.sp1
.IP
.nf
void \fBincrRefPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBdecrRefPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This function allows to add or to remove a callback procedure which will be called
when the shared object \fIShColormap\fP
reference count is incremented or decremented. The reference count may be modified when
\fIGCreateShColormap(), GModify(), dup() and destroy()\fP methods are called.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object reference count will be modified.
The callback procedure is called after the increment/decrement. Its parameters are
the \fIclosure\fP and the shared object \fIsh_cmap\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
increment/decrement callback lists. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp1
.IP
.nf
void \fBdestroyPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This method allows to add or remove a callback procedure which will be called
when the shared object \fIShColormap\fP is destroyed.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be destroyed.
The callback procedure is called \fIjust before\fP the destruction of the object. Its parameters are
the \fIclosure\fP and the shared object \fIsh_cmap\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
destruction callback lists. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp 1
.IP
.nf
void \fBaddColorPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_map\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBremColorPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBreplaceColorPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These method allows to add or remove callback procedure on adding, removing or
replacing \fIShColor\fP entries in the \fIShColormap\fP.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the \fIShColormap\fp is modified.
The callback procedure is called after the modification. Its parameters are
the \fIclosure\fP, the shared object \fIsh_cmap\fP itself and the index of the \fIShColor\fP.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
appropriate callback list. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp 1
.IP
const GColormapValues* \fBvalues\fP () const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the \fIGColormapValues\fP structure of the \fIShColormap\fP.
.RE
.sp 1
.IP
ulong \fBnColor\fP () const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the number of valid entries of the colormap.
.RE
.sp 1
.IP
const GShColor** \fBcolors\fP () const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the pointer to the color array of the colormap.
.RE
.sp 1
.IP
ulong \fBaddColor\fP (GShColormap*& \fIsh_cmap\fP, const GShColor& \fIsh_color\fP); // returns index
.RS .8i
.IP \fIDescription\fP .5i
This method allows to add a new color in the colormap. It returns the
index of this color. If the color already exists, it simply returns
the index and the \fIaddColorPostcond\fP is not called.
The color may be freed after the method call.
.IP \fIsh_cmap\fP .5i
.br
Specifies the colormap which is going to be modified.
.IP \fIsh_color\fP .5i
.br
Specifies the \fIShColor\fP instance to be added.
.RE
.sp 1
.IP
ulong \fBreplaceColor\fP (GShColormap*& \fIsh_cmap\fP, const GShColor* \fIold_color\fP,
	const GShColor* \fInew_color\fP)
.br
ulong \fBreplaceColor\fP (GShColormap*& \fIsh_cmap\fP, ulong \fIindex\fP, const GShColor* \fInew_color\fP)
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to replace an existing color by an other in the
colormap and returns the index position of the color. If the old color does not exist,
the new one is inserted either at the first free location in the table or at the given
index position. In that last case, the \fIaddColorPostcond\fP procedure is called
instead of the \fIreplaceColorPostcond\fP procedure.
.IP \fIsh_cmap\fP .5i
.br
Specifies the colormap which is going to be modified.
.IP \fIold_color\fP .5i
.br
Specifies the \fIShColor\fP to be replaced.
.IP \fInew_color\fP .5i
.br
Specifies the \fIShColor\fP to be inserted.
.IP \fIindex\fP .5i
.br
Specifies the index position for the \fInew_color\fP.
.RE
.sp 1
.IP
void \fBremColor\fP (GShColormap*& \fIsh_cmap\fP, const GShColor& \fIsh_color\fP);
.br
void \fBremColor\fP (GShColormap*& \fIsh_cmap\fP, ulong \fIindex\fP);
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to remove an entry from the colormap. If such entry does not
exist, it simply returns and the \fIremColorPostcond\fP is not called.
.IP \fIsh_cmap\fP .5i
.br
Specifies the colormap which is going to be modified.
.IP \fIsh_color\fP .5i
.br
Specifies the \fIShColor\fP instance to be removed.
.IP \fIindex\fP .5i
.br
Specifies the index in the colormap of the color to be removed.
.RE
.sp 1
.IP
const GShColor* \fBgetColor\fP (const char* \fIname\fP) const;
.br
const GShColor* \fBgetColor\fP (const GRgb* \fIrgb\fP) const;
.br
const GShColor* \fBgetColor\fP (uchar \fIgray\fP) const;
.br
const GShColor* \fBgetColor\fP (const GShPattern* \fIhalftone\fP) const;
.br
const GShColor* \fBgetColor\fP (ushort \fIindex\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
This functions allow to get a colormap entry from a given attribute. It returns
NULL if no entry is found.
.IP \fIname\fP .5i
.br
Specifies the name of the color.
.IP \fIrgb\fP .5i
.br
Specifies the rgb values of the color.
.IP \fIgray\fP .5i
.br
Specifies the gray value of the color.
.IP \fIhalftone\fP .5i
.br
Specifies the halftone pattern of the color.
.IP \fIindex\fP .5i
.br
Specifies the index of the color in the colormap.
.RE
.sp 1
.IP
long \fBgetIndex\fP (const char* \fIname\fP) const;
.br
long \fBgetIndex\fP (const GRgb* \fIrgb\fP) const;
.br
long \fBgetIndex\fP (ushar \fIgray\fP) const;
.br
long \fBgetIndex\fP (const GShPattern* \fIhalftone\fP) const;
.br
long \fBgetIndex\fP (const GShColor* \fIsh_color\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to get the index of a color in the colormap from
a given attribute. It returns -1 if not found.
.IP \fIname\fP .5i
.br
Specifies the name of the color.
.IP \fIrgb\fP .5i
.br
Specifies the rgb values of the color.
.IP \fIgray\fP .5i
.br
Specifies the gray value of the color.
.IP \fIpattern\fP .5i
.br
Specifies the halftone pattern of the color.
.IP \fIcolor\fP .5i
.br
Specifies the \fBColor\fP instance in the colormap.
.RE
.sp 1
.IP
static const char* \fBclassname\fP();
.RS .8i
.IP \fIDescription\fP .5i
This static function returns a pointer to the string \fI``GShColormap''\fP.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS
\fBHeader file\fP
.IP
#include <Go/Tools/cShColormap.h>
.SS
\fBType Definitions\fP
.IP
.nf
.ta .15i .25i 1.0i
#define GCOLORMAP_COLORS			(1L<<0)

typedef struct _GColormapValues
{
	ulong n_color;
	GObjectId* sh_colors;
} GColormapValues;

(\fISee GColormapValues STRUCTURE section\fP)
.SS
\fBC Functions\fP
.IP
GObjectId \fBGGetNamedShColormap\fP (const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GShColormap* GCreateShColormap (const char* \fIname\fP).
.RE
.sp 1
.IP
void \fBGModifyShColormapByName\fP (const char* \fIname\fP, ulong \fImask\fP, const GColormapValues* \fIvalues\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: void GModify (const char* \fIname\fP, ulong \fImask\fP, const GColormapValues* \fIvalues\fP).
.RE
.sp 1
.IP
const GColormapValues* \fBGGetShColormapValues\fP (const GObjectId \fIsh_cmap\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP const GColormapValues* values().
.RE
.sp 1
.IP
ulong \fBGGetShColormapColorNumber\fP (const GObjectId sh_cmap);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: ulong nColor() const.
.RE
.sp 1
.IP
.nf
ulong \fBGAddShColormapShColor\fP (GObjectId* \fIsh_cmap\fP, const GObjectId \fIsh_color\fP);
void  \fBGRemShColormapShColor\fP (GObjectId* \fIsh_cmap\fP, const GObjectId \fIsh_color\fP);
void  \fBGRemShColormapIndexedShColor\fP (GObjectId* \fIsh_cmap\fP, ulong \fIindex\fP);
ulong \fBGRepShColormapShColor\fP (GObjectId* \fIsh_cmap\fP, const GObjectId \fIo_sh_color\fP,
	const GObjectId \fIn_sh_color\fP);
ulong \fBGRepShColormapIndexedShColor\fP (GObjectId* \fIsh_cmap\fP, ulong \fIindex\fP,
	const GObjectId \fBn_sh_color\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   ulong addColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIsh_color\fP);
   void remColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIsh_color\fP);
   void remColor (GShColormap& \fIsh_cmap\fP, ulong \fIindex\fP);
   ulong replaceColor (GShColormap& \fIsh_cmap\fP, const GShColor* \fIo_sh_color\fP, const GShColor* \fIn_sh_color\fP);
   ulong replaceColor (GShColormap& \fIsh_cmap\fP, ulong \fIindex\fP, const GShColor* \fIn_sh_color\fP);
.fi
.RE
.sp 1
.IP
.nf
const GObjectId \fBGGetShColormapShColorByName\fP (const GObjectId \fIsh_cmap\fP, const char* \fIname\fP);
const GObjectId \fBGGetShColormapShColorByRgb\fP (const GObjectId \fIsh_cmap\fP, const GRgb* \fIrgb\fP);
const GObjectId \fBGGetShColormapShColorByGray\fP (const GObjectId \fIsh_cmap\fP, uchar \fIgray\fP);
const GObjectId \fBGGetShColormapShColorByHalftone\fP (const GObjectId \fIsh_cmap\fP, const GObjectId \fIsh_pattern\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   const GShColor* getColor (const char* \fIname\fP) const;
   const GShColor* getColor (const GRgb* \fIrgb\fP) const;
   const GShColor* getColor (uchar \fIgray\fP) const;
   const GShColor* getColor (const GShPattern* \fIsh_pattern\fP) const; 
.fi
.RE
.sp 1
.IP
.nf
long \fBGGetShColormapShColorIndexByName\fP (const GObjectId \fIsh_cmap\fP, const char* \fIname\fP);
long \fBGGetShColormapShColorIndexByRgb\fP (const GObjectId \fIsh_cmap\fP, const GRgb* \fIrgb\fP);
long \fBGGetShColormapShColorIndexByGray\fP (const GObjectId \fIsh_cmap\fP, uchar \fIgray\fP);
long \fBGGetShColormapShColorIndexByHalftone\fP (const GObjectId \fIsh_cmap\fP, const GObjectId \fIsh_pattern\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   long getIndex (const char* \fIname\fP) const;
   long getIndex (const GRgb* \fIrgb\fP) const;
   long getIndex (ushar \fIgray\fP) const;
   long getIndex (const GShPattern* \fIsh_pattern\fP) const;
.fi
.RE
.sp 1
.IP
.nf
void \fBGAddShColormapShColorPostcond\fP (GObjectId \fIsh_cmap\fP, GAddOrRemove \fIadd\fP,
	void (*\fIfunction\fP)(void* \fIclosure\fP, GObjectId \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP);
void \fBGRemShColormapShColorPostcond\fP (GObjectId \fIsh_cmap\fP, GAddOrRemove \fIadd\fP,
	void (*\fIfunction\fP)(void* \fIclosure\fP, GObjectId \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP);
void \fBGRepShColormapShColorPostcond\fP (GObjectId \fIsh_cmap\fP, GAddOrRemove \fIadd\fP,
	void (*\fIfunction\fP)(void* \fIclosure\fP, GObjectId \fIsh_cmap\fP, ulong index),
	const void* \fIclosure\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   void addColorPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, GShColormap* \fIsh_map\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void remColorPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void replaceColorPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, GShColormap* \fIsh_cmap\fP, ulong \fIindex\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
.fi
.sp 1
.IP
const char* \fBGShColormapClassName\fP ();
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP static const char* classname();
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fIShColormap\fP class is a subclass of \fISharedObject\fP class. So, the \fIconstructor\fP
and \fIdestructor\fP methods are not public and the method \fIGCreateShColormap()\fP
and \fIdestroy()\fP must be called instead of \fInew\fP and \fIdelete\fP.
See also \fIColormap(3Go)\fP which is a non-shared object using a \fIShColormap\fP object.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBSharedObject(3Go)\fP, \fBColormap(3Go)\fP, \fBShColor(3Go)\fP, \fBShPattern(3Go)\fP,
\fBGoInterf(3Go)\fP.
.nrPN \n%
