.\" $Id: ShPxlArray.n,v 1.1.1.1 1992/03/18 09:48:52 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ShPixelArray 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBShPixelArray\fP \(em the shared pixel array object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/ShPixelArray.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBShPixelArray\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBSharedObject\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBShPixelArray\fP object is defined by an array of pixels (its value) and
a set of parameters describing the size or the format of the pixel array.
The format used in the \fIShPixelArray\fP is the \fIZ-Format\fP. The pixel
is used as an index in a colormap (see \fIColormap(3Go)\fP) when drawing
on an \fBGoInterf\fP instance (see \fIGoInterf(3Go)\fP). See below the
\fIGPixelArrayValues\fP structure.
.IP
The \fIShPixelArray\fP object is not modifiable but it is possible to create a
new \fIShPixelArray\fP instance by extracting a subPixelArray or by deforming
it.
.IP
The \fIShPixelArray\fP object is a shared object and is used by \fIShPattern\fP
(see \fIShPattern(3Go)\fP) and \fIGoImage\fP (see \fIGoImage(3Go)\fP) objects. 
.sp 1
\fBGShPixelArray\fP is the C++ type for the \fIShPixelArray\fP object class.
.sp 1
.nf
.ta .15i .25i 1.0i
class GShPixelArray : public GSharedObject {
	public:
		friend GShPixelArray* GCreateShPixelArray (ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP,
			const char* \fIname\fP = NULL, GDataSpace \fIspace\fP = GDATA_COPY);
		friend GShPixelArray* GCreateShPixelArray (const char* \fIname\fP);

		friend void GModify (GShPixelArray*& \fIsh_pxlArray\fP, ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP);
		friend void GModify (const char* \fIname\fP, ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP);
		friend void GRename (GShPixelArray*& \fIsh_pxlArray\fP, const char* \fIname\fP);

		GShPixelArray* dup() const;
		GBool match (const GShPixelArray* \fIsh_pxlArray\fP) const;
		void updatePostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP, ulong \fImask\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void incrRefPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void decrRefPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void destroyPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;

		const GPixelArrayValues* values() const;
		ulong bytesPerLine() const;
		ulong dataSize() const;

		GShPixelArray* subPixelArray (ushort \fIx\fP, ushort \fIy\fP, ushort \fIwidth\fP, ushort \fIheight\fP) const;
		GShPixelArray* subPixelArray (GNumber \fIx\fP, GNumber \fIy\fP,  GNumber \fIwidth\fP, GNumber \fIheight\fP) const;
		void subPixelArrayValues (ushort \fIx\fP, ushort \fIy\fP, ushort \fIwidth\fP, ushort \fIheight\fP,
			GPixelArrayValues& \fIsub_values\fP) const;
		void deformation (GPixelArrayValues* \fIresult\fP, ushort* \fIxorigin_result\fP, ushort* \fIyorigin_result\fP,
			const GCoordSys& \fIcs\fP, const GArray* \fIpixel_translation\fP, uchar \fIbits_per_pixel_of_result\fP,
			uchar \fIdepth_of_result\fP, uchar \fIbit_order_of_result\fP, uchar \fIbyte_order_of_result\fP,
			GQuality \fIquality\fP) const;
		static const char* classname();
};
.fi
.sp 1
.SH
\fBGPixelArrayValues STRUCTURE\fP
.IP
This structure may be used when creating or modifying a \fIShPixelArray\fP instance.
To set or to modify the pixel array characteristics, the appropriate members of
the \fIGPixelArrayValues\fP structure and the corresponding value bitmask have to be
set before calling \fIGCreateShPixelArray()\fP or \fIGModify()\fP methods. Unset
values are not set to \fIdefault values\fP.
.sp 1
\fBGPixelArrayValues\fP structure:
.sp 1
.nf
.ta .25i .60i 1.80i
struct GPixelArrayValues {
	ushort width;
	ushort height;
	ushort xoffset;
	uchar  bitmap_unit;
	uchar  padding;
	uchar  bits_per_pixels;
	uchar  depth;
	struct format {
	    unsigned bit : 1;
	    unsigned byte : 1;
	    unsigned coding : 2;
	}
	uchar* data;
}
.fi
.sp 1
.RS .8i
.IP \fIwidth\fP .5i
.br
Specifies the number of pixels per line.
.IP \fIheight\fP .5i
.br
Specifies the number of lines.
.IP \fIxoffset\fP .5i
.br
Specifies the number of unused pixels from the begin of a line in the pixel
array.
.IP \fIbitmap_unit\fP .5i
.br
Specifies ...
.IP \fIpadding\fP .5i
.br
Specifies the line padding.
.IP \fIbits_per_pixel\fP .5i
.br
Specifies the number of bits for the pixel coding.
.IP \fIdepth\fP .5i
.br
Specifies the significant number of bits par pixel.
.IP \fIformat.bit\fP .5i
.br
Specifies the bit order (GLSB_FIRST or GMSB_FIRST)
.IP \fIformat.byte\fP .5i
.br
Specifies the byte order (GLSB_FIRST or GMSB_FIRST)
.IP \fIformat.coding\fP .5i
.br
Specifies the pixel array encoding (GBITMAP_CODING, GGROUP3 or GGROUP4)
.IP \fIdata\fP .5i
.br
Specifies the pixel array itself.
.RE
.sp 1
.IP
.sp 1
\fBPixelArray value mask bits\fP:
.sp 1
.nf
.ta .25i 1.5i 2.5i
	#define GPXL_VALUE	(1L<<0)
	#define GPXL_SHARED	(1L<<1)
	#define GPXL_GIVEN	(1L<<2)
.fi
.IP
.sp 1
\fBGDataSpace  definitions\fP:
.sp 1
.nf
.ta .25i 1.5i 2.5i
	enum GDataSpace { GDATA_COPY = 0, GDATA_SHARE = GPXL_SHARED, GDATA_GIFT = GPXL_GIVEN }
.fi
.IP
.RS .8i
\fISee the GCreateShPixelArray() functions\fP.
.RE
.IP
.sp 1
\fBFlag definitions\fP:
.sp 1
.nf
.ta .25i 1.5i 2.5i
	#define GLSB_FIRST		0
	#define GMSB_FIRST		1
	#define	GBITMAP_CODING	0
	#define GGROUP3		1
	#define GGROUP4		2
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
friend GShPixelArray* \fBGCreateShPixelArray\fP (ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP,
	const char* \fIname\fP = NULL, GDataSpace \fIspace\fP = GDATA_COPY);
friend GShPixelArray* \fBGCreateShPixelArray\fP (const char* \fIname\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
This function allows to create an instance of \fIShPixelArray\fP class.
.IP \fImask\fP .5i
.br
Specifies the value bitmask.
.IP \fIvalues\fP
.br
Specifies the GPixelArrayValues structure used to create the \fIShPixelArray\fP object.
.IP \fIname\fP .5i
Specifies the \fIShPixelArray\fP name.
.IP \fIspace\fP .5i
If \fIGDATA_COPY\fP, it specifies that a copy of the data will be done, if \fIGDATA_SHARE\fP, it specifies that
the data will not be copied: it is the application responsibility the manage the data allocation.
If \fIGDATA_GIFT\fP, it specifies that the data is given to the object. In this case the data must be
allocated by \fImalloc\fP and it is the object responsibility to free the data.
.RE
.sp 1
.IP
friend void \fBGModify\fP (GShPixelArray*& \fIsh_pxlArray\fP, ulong \fImask\fP, const GPixelArrayValues* values)
.RS .8i
.IP \fIDescription\fP .5i
This function allows to modify the pixel array values. Like other shared
objects (see \fISharedObject(3Go)\fP), the modification function returns the
new \fIShPixelArray\fP object (possibly the same).
.IP \fIsh_pxlArray\fP .5i
.br
Specifies the \fIShPixelArray\fP object reference which has to be modified.
.IP \fImask\fP .5i
.br
Specifies the value bitmask for the modification.
.IP \fIvalues\fP .5i
.br
Specifies a \fBGPixelArrayValues\fP structure pointer. The fields of this
structure corresponding to the mask contain the new values.
.RE
.sp 1
.IP
friend void \fBGModify\fP (const char* \fIname\fP, ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP)
.RS .8i
.IP \fIDescription\fP .5i
This function allows to modify a \fIShPixelArray\fP object referred by its name.
.IP \fIname\fP .5i
Identifies the \fIShPixelArray\fP. It it does not exist, it is created.
.IP \fImask\fP .5i
.br
Specifies the value bitmask for the modification.
.IP \fIvalues\fP .5i
.br
Specifies a \fIGPixelArrayValues\fP structure pointer. The fields of this
structure corresponding to the mask contain the new values.
.RE
.sp 1
.IP
friend void \fBGRename\fP (GShPixelArray*& \fIsh_pxlArray\fP, const char* \fIname\fP)
.RS .8i
.IP \fIDescription\fP .5i
This function allows to (re)name a \fIShPixelArray\fP. If the reference count is
greater than 1, a new \fIShPixelArray\fP is looked for matching and a new instance
may be created.
.IP \fIsh_pxlArray\fP .5i
Specifies the concerned \fIShPixelArray\fP instance.
.IP \fIname\fP .5i
.br
Specifies the new name, it may be NULL.
.RE
.sp1
.IP
GShPixelArray* \fBdup\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the current \fIShPixelArray\fP object but increments the
reference count. It allows to modify a copy of a shared \fIShPixelArray\fP instance.
.RE
.sp1
.IP
GBool \fBmatch\fP (const GShPixelArray* \fIsh_pxlArray\fP) const
.RS .8i
.IP \fIDescription\fP .5i
This function returns GTRUE if the given \fIShPixelArray\fP object matches with
the current object, that means the two values mask does not intersect, or
if the masks intersect, the corresponding values are the same.
.IP \fIsh_pxlArray\fP .5i
Specifies the \fIShPixelArray\fP object used to proceed the matching operation.
.RE
.sp1
.IP
.nf
void \fBupdatePostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This function allows to add or to remove callback procedure when the shared object \fIShPixelArray\fP is
updated. That means the \fIGModify()\fP method has been applied on the current object. In other
terms, when the reference count of a shared object is 1 and if no other shared object \fImatches\fP
with the modification, the current object can be directly updated.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be updated. The callback procedure is
called after the modification is done. Its parameters are the \fIclosure\fP, the shared object \fIsh_pxlArray\fP
itself and the update \fImask\fP. The \fImask\fP determines the modified field only.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the update
callback list. If \fIadd\fP is GREMOVE, the callback procedure \fIproc\fP will be removed
from  the callback list.
.RE
.sp1
.IP
.nf
void \fBincrRefPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBdecrRefPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This function allows to add or to remove a callback procedure which will be called
when the shared object \fIShPixelArray\fP
reference count is incremented or decremented. The reference count may be modified when
\fIGCreateShPixelArray(), GModify(), dup() and destroy()\fP methods are called.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object reference count will be modified.
The callback procedure is called after the increment/decrement. Its parameters are
the \fIclosure\fP and the shared object \fIsh_pxlArray\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
increment/decrement callback lists. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp1
.IP
.nf
void \fBdestroyPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShPixelArray* \fIsh_pxlArray\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This method allows to add or remove a callback procedure which will be called
when the shared object \fIShPixelArray\fP is destroyed.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be destroyed.
The callback procedure is called \fIjust before\fP the destruction of the object. Its parameters are
the \fIclosure\fP and the shared object \fIsh_pxlArray\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
destruction callback lists. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp 1
.IP
const GPixelArrayValues& \fBvalues\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This function returns the GPixelArrayValues structure of the instance.
.RE
.sp 1
.IP
ulong \fBbytesPerLine\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method allows to get the number of bytes per line in the pixel array.
This number takes into account the padding.
.RE
.sp 1
.IP
ulong \fBdataSize\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method allows to get the memory size needed to store the pixel array.
.RE
.sp 1
.IP
GShPixelArray* \fBsubPixelArray\fP (ushort \fIx\fP, ushort \fIy\fP, ushort \fIwidth\fP, ushort \fIheight\fP);
.br
GShPixelArray* \fBsubPixelArray\fP (GNumber \fIrx\fP, GNumber \fIry\fP, GNumber \fIrwidth\fP, GNumber \fIrheight\fP);
.RS .8i
.IP \fIDescription\fP .5i
These functions allow to return a subpixelarray defined by its origin and
its size relatively to the instance. \fIWorks if the encoding is GBITMAP_CODING\fP,
else it returns NULL.
.IP "\fIx, y\fP" .5i
.br
Specify the origin in pixels relatively to the pixel array origin.
.IP "\fIwidth, height\fP" .5i
.br
Specify the width and the height expressed in pixels.
.IP "\fIrx, ry\fP" .5i
.br
Specify the origin expressed in the coordinate system ((0,0),(1,1)).
.IP "\fIrwidht, rheight\fP" .5i
.br
Specify the size of the sub pixel array expressed in the coordinate system
((0,0),(1,1)).
.RE
.sp 1
void \fBsubPixelArrayValues\fP (ushort \fIx\fP, ushort \fIy\fP, ushort \fIwidth\fP, ushort \fIheight\fP,
	GPixelArrayValues& \fIsub_values\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
This method allows to get the \fIGPixelArrayValues\fP structure corresponding
to a given sub pixel array.
.IP "\fIx, y, width, height\fP" .5i
Specify the sub pixel array in pixels.
.IP \fIsub_values\fP .5i
.br
Specifies a pointer to a \fIGPixelArrayValues\fP structure which will receive the
values.
.RE
.sp 1
.IP
.nf
void \fBdeformation\fP (GPixelArrayValues* \fIpav_result\fP, ushort* \fIxorigin_result\fP, ushort* \fIyorigin_result\fP,
	const GCoordSys& \fIcs\fP, const GArray* \fIpixel_translation\fP, uchar \fIbits_per_pixel_of_result\fP,
	uchar \fIdepth_of_result\fP, uchar \fIbit_order_of_result\fP, uchar \fIbyte_order_of_result\fP, GQuality \fIquality\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
The method  implements a general purpose deformation of the current \fIshPixelArray\fP.
It returns a GPixelArrayValues structure in \fIresult\fP, the \fIxorigin\fP and the \fIyorigin\fP
of the result according to the CoordSys passed in parameter.
.br
The method does not handle the \fIcoding\fP attribute of the ShPixelArray.
.IP "pav" .5i
.br
Specifies the GPixelArrayValues which will receive the result of the computation.
.IP "\fIxorigin_result, yorigin_result\fP" .5i
.br
Specify values which will receive  the \fIx\fP and \fIy\fP origin expressed in pixel of the Point(0,0).
.IP "\fIcs\fP" .5i
.br
Specifies the CoordSys used the deform the PixelArray. The vector I and J of \fIcs\fP gives the
wanted size in pixel and the wanted angles of the result.
Note that the origin field of \fIcs\fP must be the Point(0,0).
.br
.IP "\fIpixel_translation\fP" .5i
Specifies an Array of ulong used to translate each source pixel to the destination one. If \fIbits_per_pixel\fP  is 1, the \fIpixel_translation\fP is not used. If \fIpixel_translation\fP is NULL, there is no translation.
.br
.IP \fIbits_per_pixel_of_result\fP
.IP \fIdepth_of_result\fP
.IP \fIbit_order_of_result\fP
.IP \fIbyte_order_of_result\fP
.RS .5i
Specify the wanted attributes of the result.
.br
The method implements only \fIbit_per_pixel\fP equal 1 or 8 and attributes (\fIdepth, bit_order, byte_order\fP) of the source (\fIthis\fP) identicals to the wanted one.
.RE
.IP \fIquality\fP .5i
Specifies the \fIquality\fP of the computation (see \fIGCdef(3Go)\fP).
.RE
.sp 1
.IP
static const char* \fBclassname\fP();
.RS .8i
.IP \fIDescription\fP .5i
This static method returns a pointer to the string \fI``GShPixelArray''\fP.
.RE
.sp 1
.SH
\fBC BINDING\fP
.SS
\fBHeader file\fP
.IP
#include <Go/Tools/cShPxlArray.h>
.SS
\fBType Definitions\fP
.IP
\fISee the following above sections:\fP GPixelArrayValues STRUCTURE, PixelArray value mask bits,
GDataSpace definitions, Flag definitions.
.SS
\fBC Functions\fP
.IP
.nf
GObjectId \fBGGetNewShPixelArray\fP (ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP,
	const char* \fIname\fP, enum GDataSpace \fIspace\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GShPixelArray* GCreateShPixelArray (ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP,
	const char* \fIname\fP, GDataSpace \fIspace\fP);
.RE
.sp 1
.IP
GObjectId \fBGGetNamedShPixelArray\fP (const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GShPixelArray* GCreateShPixelArray (const char* \fIname\fP).
.RE
.sp 1
.IP
void \fBGModifyShPixelArrayByName\fP (const char* \fIname\fP, ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: void GModify (const char* \fIname\fP, ulong \fImask\fP, const GPixelArrayValues* \fIvalues\fP).
.RE
.sp 1
.IP
const GPixelArrayValues* \fBGGetShPixelArrayValues\fP (const GObjectId \fIsh_pxlArray\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP const GPixelArrayValues* values().
.RE
.sp 1
.nf
ulong \fBGShPixelArrayBytesPerLine\fP (const GObjectId sh_pxlArray);
ulong \fBGShPixelArrayDataSize\fP (const GObjectId sh_pxlArray);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   ulong bytesPerLine() const;
   ulong dataSize() const;
.fi
.RE
.sp 1
.IP
const char* \fBGShPixelArrayClassName\fP ();
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP static const char* classname();
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
Note that if the refcnt() of a \fIcreation\fP is greater than 1, the data exists yet so
do not forget to manage your \fIvalues.data\fP.
.IP
The \fIShPixelArray\fP class is a subclass of \fISharedObject\fP class. So, the \fIconstructor\fP
and \fIdestructor\fP methods are not public and the method \fIGCreateShPixelArray()\fP
and \fIdestroy()\fP must be called instead of \fInew\fP and \fIdelete\fP.
See also \fIPixelArray(3Go)\fP which is a non-shared object using a \fIShPixelArray\fP object.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBSharedObject(3Go)\fP, \fBShPattern(3Go)\fP, \fBColormap(3Go)\fP, \fBGoInterf(3Go)\fP.
.nrPN \n%
