.\" $Id: ShTxtBrush.n,v 1.1.1.1 1992/03/18 09:48:58 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH ShTextBrush 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBShTextBrush\fP \(em the shared text brush object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/ShTextBrush.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBShTextBrush\fP inherits behavior from:
.RS 10
.IP \(em 3
\fBSharedObject\fP class
.RE
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBShTextBrush\fP object is defined by a set of values which will be used by
a \fIGoInterf\fP instance for drawing text (see \fIGoInterf(3Go)\fP. These
values are described below in the \fIGTextBrushValues\fP structure. See also
\fIGCdef(3Go)\fP which defines some constant values used by \fIShTextBrush\fP and
other graphic context objects (\fIShPen, ShBrush, ShImageBrush\fP).
.IP
The \fIShTextBrush\fP has defaults values: we can say the default \fIShTextBrush\fP
is \fIa black and solid brush with a roman normal font\fP.
.IP
The \fIShTextBrush\fP object is a shared object (see \fISharedObject(3Go)\fP) and
may be shared between several other objects (i.e. \fIGo's\fP). The \fITextBrush\fP
(See \fIBrush(3Go)\fP) gives a non-shared interface to the \fIShTextBrush\fP.
.sp 1
\fBGShTextBrush\fP is the C++ type for the \fIShTextBrush\fP object class.
.sp 1
.nf
.ta .15i .25i 1.0i
class GShTextBrush : public GSharedObject {
	public:
		friend GShTextBrush* GCreateShTextBrush ();
		friend GShTextBrush* GCreateShTextBrush (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP,
			const char* \fIname\fP = NULL);
		friend GShTextBrush* GCreateShTextBrush (const char* \fIname\fP);

		GShTextBrush* dup() const;
		GBool match (const GShTextBrush* \fIsh_tbrush\fP) const;

		void updatePostcond (void \fIproc\fP(void* \fIclosure\fP, GShTextBrush* \fIsh_tbrush\fP, ulong \fImask\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void destroyPostcond (void \fIproc\fP(void* \fIclosure\fP, GShTextBrush* \fIsh_tbrush\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;

		// Getting values
		const GTextBrushValues* values() const;

		ulong function () const;
		ulong planeMask () const;
		const GShColor* color () const;
		const GShColor* altColor () const;

		ushort fillStyle () const;
		const GShPattern* tile () const;
		const GShPattern* stipple () const;
		GNumber xtsOrigin () const;
		GNumber ytsOrigin () const;

		const GShFont* font() const;

		// Modifying methods
		friend void GModify (GShTextBrush*& \fIsh_tbrush\fP, ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
		friend void GRename (GShTextBrush*& \fIsh_tbrush\fP, const char* \fIname\fP);

		friend void GSetFunction (GShTextBrush*& \fIsh_tbrush\fP, ulong \fIfunction\fP);
		friend void GSetPlaneMask (GShTextBrush*& \fIsh_tbrush\fP, ulong \fIplane_mask\fP);
		friend void GSetColor (GShTextBrush*& \fIsh_tbrush\fP, const GShColor* \fIcolor\fP);
		friend void GSetAltColor (GShTextBrush*& \fIsh_tbrush\fP, const GShColor* \fIalt_color\fP);

		friend void GSetFillStyle (GShTextBrush*& \fIsh_tbrush\fP, ushort \fIfill_style\fP);
		friend void GSetTile (GShTextBrush*& \fIsh_tbrush\fP, const GShPattern* \fItile\fP);
		friend void GSetStipple (GShTextBrush*& \fIsh_tbrush\fP, const GShPattern* \fIstipple\fP);
		friend void GSetTsOrigin (GShTextBrush*& \fIsh_tbrush\fP, GNumber \fIx_origin\fP, GNumber \fIy_origin\fP);

		friend void GSetFont (GShTextBrush*& \fIsh_tbrush\fP, const GShFont* \fIfont\fP);

		// updating named ShTextBrush
		friend void GModify (const char* \fIname\fP, ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);

		friend void GTextBrushFunction (const char* \fIname\fP, ulong \fIfunction\fP);
		friend void GTextBrushPlaneMask (const char* \fIname\fP, ulong \fIplane_mask\fP);
		friend void GTextBrushColor (const char* \fIname\fP, const GShColor* \fIcolor\fP);
		friend void GTextBrushAltColor (const char* \fIname\fP, const GShColor* \fIalt_color\fP);

		friend void GTextBrushFillStyle (const char* \fIname\fP, ushort \fIfill_style\fP);
		friend void GTextBrushTile (const char* \fIname\fP, const GShPattern* \fItile\fP);
		friend void GTextBrushStipple (const char* \fIname\fP, const GShPattern* \fIstipple\fP);
		friend void GTextBrushTsOrigin (const char* \fIname\fP, GNumber \fIx_origin\fP, GNumber \fIy_origin\fP);

		friend void GTextBrushFont (const char* \fIname\fP, const GShFont* \fIfont\fP);
		static const char* classname();
};
.fi
.sp 1
.SH
\fBGTextBrushValues STRUCTURE\fP
.IP
This structure may be used when creating or modifying a \fIShTextBrush\fP
or \fITextBrush\fP (see \fITextBrush(3Go)\fP) instance.
To set or to modify the brush characteristics, the appropriate members of
the \fIGTextBrushValues\fP structure and the corresponding value bitmask have to be
set before calling \fIGCreateShTextBrush()\fP or \fIGModify()\fP methods.
If the passed \fImask\fP is 0 the values are set to \fIdefault values\fP.
.sp 1
\fIGTextBrushValues\fP structure:
.sp 1
.nf
.ta .25i .60i 1.80i
struct GTextBrushValues {
	ulong function;
	ulong plane_mask;
	GShColor*  color;
	GShColor*  alt_color;

	/* fill attributes */
	struct {
	    unsigned style : 2;
	} fill;
	GShPattern* tile;
	GShPattern* stipple;
	GNumber   ts_x_origin;
	GNumber   ts_y_origin;

	/* text attributes */
	GShFont* font;
};
.fi
.sp 1
.RS .8i
.IP \fIfunction\fP .5i
.br
Defines the logical function allowing to combine the source and the destination
pixel values. Possible values are described in \fIGCdef(3Go)\fP, the value
for the default brush is \fIGCOPY\fP.
.IP \fIplane_mask\fP .5i
.br
Determines which planes of the output device will be affected by the drawing.
The value for the default brush is \fIGALL_PLANES\fP.
.IP \fIcolor\fP .5i
.br
Gives the color used by most of drawings. The value of the default brush is
``black'' (Rgb = (0, 0, 0)).
.IP \fIalt_color\fP .5i
.br
Gives the color used when the file style is \fIGFILL_OPAQUE_STIPPLED\fP for unset
bits of the stipple. There is no value for the default brush.
.IP \fIfill.style\fP .5i
.br
Determines if areas are filled using either a color, or a tile or a
stipple. Possible values are described in \fIGCdef(3Go)\fP. The value
for the default brush is \fIGFILL_SOLID\fP (i.e. areas are filled with
the color specified in the \fIcolor\fP field).
.IP \fItile\fP .5i
.br
Specifies the pattern (\fIShPattern\fP) used when the fill style is
\fIGFILL_TILED\fP. There is no value for the default brush.
.IP \fIstipple\fP .5i
.br
Specifies the 1-bit-depth pattern (monochorome \fIShPattern\fP) used
when the fill style is either \fIGFILL_STIPPLED\fP or \fIGFILL_OPAQUE_STIPPLED\fP.
There is no value for the default brush.
.IP \fIts_x_origin, ts_y_origin\fP .5i
Specify the origin (expressed in the absolute coordinate system) of both the \fItile\fP and
the \fIstipple\fP when they are used. The values for the default brush are
(0., 0.).
.IP \fIfont\fP .5i
.br
Specifies the font (\fIShFont\fP) used in the ShTextBrush. The default font is a roman normal one.
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
friend GShTextBrush* \fBGCreateShTextBrush\fP ();
friend GShTextBrush* \fBGCreateShTextBrush\fP (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP, const char* \fIname\fP = NULL);
friend GShTextBrush* \fBGCreateShTextBrush\fP (const char* \fIname\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to create instances of the \fIShTextBrush\fP class. Without any parameter
the default brush is returned. If the requested shared brush already exists, its reference
count is incremented and it is yielt.
.IP \fImask\fP .5i
.br
Specifies the value bitmask, making valid \fIvalues\fP fields.
.IP \fIvalues\fP .5i
.br
Specifies a pointer to a \fIGTextBrushValues\fP structure.
.IP \fIname\fP .5i
.br
Specifies the name of the shared brush. If such a named shared brush exists, it
is returned, else a named shared brush is created. If the name parameter is given
with \fImask\fP and \fIvalues\fP, the concerned named shared brush is modified. 
.RE
.sp 1
.IP
GShTextBrush* \fBdup\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns the current \fIShTextBrush\fP object but increments its
reference count. It allows to modify a copy of a shared \fIShTextBrush\fP instance.
For instance, this method is used when creating a \fIBrush\fP from an existing
\fIShTextBrush\fP (see \fIBrush(3Go)\fP).
.RE
.sp 1
.IP
GBool \fBmatch\fP (const GShTextBrush* \fIsh_tbrush\fP) const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns GTRUE if the given \fIShTextBrush\fP object values match the values
of the current object; that means either the two values mask does not intersect,
or if the masks intersect, the corresponding values are equal.
.IP \fIsh_brush\fP .5i
.br
Specifies the \fIShTextBrush\fP object used for the matching operation.
.RE
.sp 1
.IP
.nf
void \fBupdatePostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShTextBrush* \fIsh_tbrush\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to add or to remove postcondition procedures when the \fBShTextBrush\fP is
updated. That means the \fIGModify()\fP method has been applied on the current object. In other
terms, when the reference count of a shared object is 1 and if no other shared object \fImatches\fP
the modification, the current object can be directly updated.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be updated. Postcondition procedures are
called after the modification is done. Its parameters are the \fIclosure\fP, the shared object \fIShTextBrush\fP
itself and the update \fImask\fP. The \fImask\fP determines the modified field only.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the postcondition procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the postcondition procedure \fIproc\fP will be added to the update
callback list. If \fIadd\fP is GREMOVE, the callback procedure \fIproc\fP will be removed
from  the callback list.
.RE
.sp1
.IP
.nf
void \fBdestroyPostcond\fP (void (*\fIproc\fP)(void* \fIclosure\fP, GShTextBrush* \fIsh_TextBrush\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
This method allows to add or remove a postcondition procedures which will be called
when the shared object \fIShTextBrush\fP is destroyed.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be destroyed.
DestroyPostcond procedures are called \fIjust before\fP the destruction of the object. Their parameters are
the \fIclosure\fP and the shared object \fIsh_TextBrush\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to the
destruction callback list. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp1
.IP
const GTextBrushValues* \fBvalues\fP() const;
.RS .8i
.IP \fIDescription\fP .5i
This method returns a pointer to the values structure of the \fIShTextBrush\fP.
.RE
.sp 1
.IP
.nf
ulong \fBfunction\fP () const;
ulong \fBplaneMask\fP () const;
const GShColor* \fBcolor\fP () const;
const GShColor* \fBaltColor\fP () const;
.sp 1
ushort \fBfillStyle\fP () const;
const GShPattern* \fBtile\fP () const;
const GShPattern* \fBstipple\fP () const;
GNumber \fBxtsOrigin\fP () const;
GNumber \fBytsOrigin\fP () const;
const GShFont* \fBfont\fP () const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to get field by field the values of the \fIShTextBrush\fP.
These fields are valid, only if the corresponding bits are set in the mask
(\fImask()\fP).
.RE
.sp 1
.IP
friend void \fBGModify\fP (GShTextBrush*& \fIsh_TextBrush\fP, ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to modify a shared TextBrush. If the modified \fIShTextBrush\fP matches an already
existing \fIShTextBrush\fP, its reference count is incremented and it is returned in \fIsh_TextBrush\fP.
If \fIthis\fP is named, the modification is done directly on it. When a shared object
is effectively updated, the postcondition callbacks are invoked.
.IP \fIsh_TextBrush\fP .5i
.br
Specifies the shared TextBrush to be modified. This pointer may be modified.
.IP "\fImask, values\fP"
.br
Specify which fields in the values structure have to be modified and how.
.RE
.sp 1
.IP
.nf
friend void \fBGSetFunction\fP (GShTextBrush*& \fIsh_TextBrush\fP, ulong \fIfunction\fP);
friend void \fBGSetPlaneMask\fP (GShTextBrush*& \fIsh_TextBrush\fP, ulong \fIplane_mask\fP);
friend void \fBGSetColor\fP (GShTextBrush*& \fIsh_TextBrush\fP, const GShColor* \fIsh_color\fP);
friend void \fBGSetAltColor\fP (GShTextBrush*& \fIsh_TextBrush\fP, const GShColor* \fIsh_color\fP);
.sp 1
friend void \fBGSetFillStyle\fP (GShTextBrush*& \fIsh_TextBrush\fP, ushort \fIfill_style\fP);
friend void \fBGSetTile\fP (GShTextBrush*& \fIsh_TextBrush\fP, const GShPattern* \fItile\fP);
friend void \fBGSetStipple\fP (GShTextBrush*& \fIsh_TextBrush\fP, const GShPattern* \fIstipple\fP);
friend void \fBGSetTsOrigin\fP (GShTextBrush*& \fIsh_TextBrush\fP, GNumber \fIx_origin\fP, GNumber \fIy_origin\fP);
friend void GSetFont (GShTextBrush*& \fIsh_tbrush\fP, const GShFont* \fIfont\fP);	
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to modify field by field the \fIShTextBrush\fP values structure. These methods
behave like the \fIGModify()\fP method when only only bit is set in the mask. For performance
reasons, the \fIGModify()\fP method should be prefered when several fields have to modified
.RE
.sp 1
.IP
friend void \fBGRename\fP (GShTextBrush*& \fIsh_TextBrush\fP, const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to (re)name a shared TextBrush. If such a named object exists, it is
returned in \fIsh_TextBrush\fP (updatePostcond are invoked), else a new named shared TextBrush
is created (its reference count is 1 and its values are the current values).
.IP \fIsh_TextBrush\fP
.5i
Specifies the shared TextBrush to be named.
.IP \fIname\fP .5i
.br
Specifies the new name. It may be NULL, in that case, the named shared TextBrush becomes
unnamed.
.RE
.sp 1
.IP
friend void \fBGModify\fP (const char* \fIname\fP, ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
.RS .8i
.IP \fIDescription\fP .5i
This method allows to update a named shared TextBrush. If such a named shared TextBrush does not
exists, it is created. Update postconditions are invoked.
.IP \fIname\fP .5i
.br
Identifies the named shared TextBrush.
.IP "\fImask, values\fP" .5i
.br
Specify which fields in the values structure have to be modified and how.
.RE
.sp 1
.IP
.nf
friend void \fBGTextBrushFunction\fP (const char* \fIname\fP, ulong \fIfunction\fP);
friend void \fBGTextBrushPlaneMask\fP (const char* \fIname\fP, ulong \fIplane_mask\fP);
friend void \fBGTextBrushColor\fP (const char* \fIname\fP, const GShColor* \fIsh_color\fP);
friend void \fBGTextBrushAltColor\fP (const char* \fIname\fP, const GShColor* \fIsh_color\fP);
.sp 1
friend void \fBGTextBrushFillStyle\fP (const char* \fIname\fP, ushort \fIfill_style\fP);
friend void \fBGTextBrushTile\fP (const char* \fIname\fP, const GShPattern* \fItile\fP);
friend void \fBGTextBrushStipple\fP (const char* \fIname\fP, const GShPattern* \fIstipple\fP);
friend void \fBGTextBrushTsOrigin\fP (const char* \fIname\fP, GNumber \fIx_origin\fP, GNumber \fIy_origin\fP);
friend void \fBGTextBrushFont\fP (const char* \fIname\fP, const GShFont* \fIfont\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to modify field by field the named \fIShTextBrush\fP values structure. These methods
behave like the previous \fIGModify()\fP method when only only bit is set in the mask. For performance
reasons, the \fIGModify()\fP method should be prefered when several fields have to be modified
.RE
.sp 1
.IP
static const char* \fBclassname\fP();
.RS .8i
.IP \fIDescription\fP .5i
This static method returns a pointer to the string \fI``GShTextBrush''\fP.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be completed\fP
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fIShTextBrush\fP class is a subclass of \fISharedObject\fP class. So, the \fIconstructor\fP
and \fIdestructor\fP methods are not public and the method \fIGCreateShTextBrush()\fP
and \fIdestroy()\fP must be called instead of \fInew\fP and \fIdelete\fP.
See also \fITextBrush(3Go)\fP which is a non-shared object using a \fIShTextBrush\fP object.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBSharedObject(3Go)\fP, \fBShColor(3Go)\fP, \fBShFont(3Go)\fP, \fBShPattern(3Go)\fP,
\fBTxtBrush(3Go)\fP.
.nrPN \n%
