.\" $Id: Stack.n,v 1.1.1.1 1992/03/18 09:49:09 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Stack 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBStack\fP \(em the stack object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Stack.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBStack\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBStack\fP class implements a stack which can be updated (\fIpush, pop\fP)
from the first element.
.IP
Elements are seen as \fIvoid*\fP.
.sp 1
\fBGStack\fP is the C++ type for the \fIStack\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GStack {
	public:
		GStack();
		~GStack();

		void push (void* \fIelement\fP);
		void* pop();

		GBool empty() const;
		void clear();
		void* top() const;
		void top(void* \fIelement\fP); // Overlap the top
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.IP
\fBGStack\fP ();
.RS .8i
.IP \fIDescription\fP .5i
This function allows to create an instance of the \fBStack\fP class.
.RE
.sp 1
.IP
\fB~GStack\fP ();
.RS .8i
.IP \fIDescription\fP .5i
This method is called when an instance of this class is deleted.
.RE
.sp 1
.IP
void \fBpush\fP (void* \fIelement\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function allow to push an element at the top of the stack.
.IP \fIelement\fP .5i
.br
Element to be pushed.
.RE
.sp 1
.IP
void* \fBpop\fP();
.RS .8i
.IP \fIDescription\fP .5i
This function allow to pop and return the element placed at the top of the stack.
.RE
.sp 1
.IP
GBool \fBempty\fP();
.RS .8i
.IP \fIDescription\fP .5i
This function returns TRUE if at least one element is pushed on the stack, FALSE otherwise.
.RE
.sp 1
.IP
void* \fBtop\fP();
.RS .8i
.IP \fIDescription\fP .5i
This function returns the element placed at the top of the stack without poping it.
.RE
.sp 1
.IP
void \fBtop\fP (void* \fIelement\fP);
.RS .8i
.IP \fIDescription\fP .5i
This function is used to change the element placed at the top with the given one.
.IP \fIelement\fP .5i
.br
New top element.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
.sp 1
.SH
\fBSEE ALSO\fP
.IP
.nrPN \n%
