.\" $Id: TxtBrush.n,v 1.1.1.1 1992/03/18 09:49:23 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH TextBrush 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBTextBrush\fP \(em the TextBrush object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/TextBrush.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBTextBrush\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBTextBrush\fP object gives a non-shared object interface to the \fBShTextBrush\fP
object. As a \fIShTextBrush\fP, a \fITextBrush\fP is defined by a set of
values (see \fITextBrushValues\fP).
.sp 1
\fITo be completed\fP
.sp 1
\fBGTextBrush\fP is the C++ type of the \fITextBrush\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GTextBrush {
	public:
		GTextBrush ();
		GTextBrush (const GTextBrush* \fItbrush\fP);
		GTextBrush (const GShTextBrush* \fIsh_tbrush\fP);
		GTextBrush (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP, const char* \fIname\fP = NULL);
		GTextBrush (const char* \fIname\fP);
		~GTextBrush ();

		// Getting values
		const GShTextBrush* shTextBrush() const;
		const GTextBrushValues* values() const;
		ulong mask() const;

		const char* name() const;
		GBool isNamed() const;

		ulong function () const;
		ulong planeMask () const;
		const GShColor* color () const;
		const GShColor* altColor () const;

		ushort fillStyle () const;
		ushort fillRule () const;
		const GShPattern* tile () const;
		const GShPattern* stipple () const;
		GNumber xtsOrigin () const;
		GNumber ytsOrigin () const;

		const GShFont* font () const;

		// Modifying methods
		void modify (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
		void modify (const char* \fIname\fP);
		void modify (const GShTextBrush* \fIsh_tbrush\fP);

		void function (ulong function);
		void planeMask (ulong plane_mask);
		void color (const GColor* color);
		void color (const GShColor* sh_color);
		void color (const char* color_name);
		void altColor (const GColor* alt_color);
		void altColor (const GShColor* sh_alt_color);
		void altColor (const char* alt_color_name);

		void fillStyle (ushort fill_style);
		void fillRule (ushort fill_rule);
		void tile (const GPattern* tile);
		void tile (const GShPattern* sh_tile);
		void tile (const char* tile_name);
		void stipple (const GPattern* stipple);
		void stipple (const GShPattern* sh_stipple);
		void stipple (const char* stipple_name);
		void tsOrigin (GNumber x_origin, GNumber y_origin);

		void font (const GFont* font);
		void font (const GShFont* sh_font);
		void font (const char* font_name);

		// Pre and Post Conditions
		void modifyPrecond (GBool (*\fIproc\fP)(void* \fIclosure\fP, GTextBrush* \fItbrush\fP,
			ulong& \fImask\fP, TextValues* \fInew_values\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void modifyPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GTextBrush* \fItbrush\fP, ulong \fImask\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
		void destroyPostcond (void (*\fIproc\fP)(void* \fIclosure\fP, GTextBrush* \fItbrush\fP),
			const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
};
.fi
.sp 1
.SH
\fBGTextBrushValues STRUCTURE\fP
.IP
\fISee ShTextBrush(3Go)\fP
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
\fBGGTextBrush\fP();
\fBGGTextBrush\fP(const GGTextBrush* \fItbrush\fP);
\fBGGTextBrush\fP(const GShGTextBrush* \fIsh_tbrush\fP);
\fBGGTextBrush\fP(ulong mask, const GGTextBrushValues* \fIvalues\fP, const char* \fIname\fP = NULL)
;
\fBGGTextBrush\fP(const char* \fIname\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to create a new instance of the \fIGTextBrush\fP class. When no
parameters are passed to the constructor, the textbrush is created with the
default \fIShGTextBrush\fP (see \fIShGTextBrush(3Go)\fP).
.IP \fItbrush\fP .5i
.br
Specifies the \fIGTextBrush\fP instance used to intialize the new textbrush values.
Pre and postconditions are not copied.
.IP \fIsh_tbrush\fP .5i
.br
Specifies the \fIShGTextBrush\fP instance which is going to be referred in the
textbrush (the reference count of the shared textbrush is incremented).
.IP "\fImask, values\fP" .5i
.br
Specify the values of the textbrush. Unspecified fields in the \fIGTextBrushValues\fP
structure take default values (see \fIShGTextBrush(3Go)\fP).
.IP \fIname\fP .5i
.br
Specifies the name of the named \fIShGTextBrush\fP object to be refered.
If no such \fIShGTextBrush\fP exists, it is created.
.RE
.sp 1
.IP
\fB~GTextBrush\fP ();
.RS .8i
.IP \fIDescription\fP .5i
This method is called when a \fITextBrush\fP instance is deleted. The referred
\fShTextBrush\fP reference count is decremented. The \fIdestroyPostcond\fP is invoked.
.RE
.sp 1
.IP
.nf
const GShTextBrush* \fBshTextBrush\fP() const;
const GTextBrushValues* \fBvalues\fP() const;
ulong \fBmask\fP() const;
const char* \fBname\fP() const;
GBool \fBisNamed\fP() const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods returns either the \fIShTextBrush\fP referred by the textbrush, or
the values, the mask, the name of this \fIShTextBrush\fP. \fIisNamed()\fP returns
\fIGTRUE\fP, if the referred \fIShTextBrush\fP is named else it returns
\fIGFALSE\fP and \fIname()\fP returns NULL.
.RE
.sp 1
.IP
.nf
ulong \fBfunction\fP() const;
ulong \fBplaneMask\fP() const;
.sp 1
const GShColor* \fBcolor\fP() const;
const GShColor* \fBaltColor\fP() const;
.sp 1
ushort \fBfillStyle\fP() const;
ushort \fBfillRule\fP() const;
const ShPattern* \fBtile\fP() const;
const ShPattern* \fBstipple\fP() const;
GNumber \fBxtsOrigin\fP() const;
GNumber \fBytsOrigin\fP() const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to get field by field the \fIGTextBrushValues\fP structure
of the \fIShTextBrush\fP referred in the brush. These fields are only valid
if the corresponding bits in the mask (\fImask()\fP) are set.
.RE
.sp 1
.IP
.nf
void \fBmodify\fP(ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
void \fBmodify\fP(const char* \fIname\fP);
void \fBmodify\fP(const GShTextBrush* \fIsh_tbrush\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to modify the textbrush value either by giving a ``mask, values''
couple, or by giving a \fIShTextBrush\fP identified by its name or by its pointer.
.IP "\fImask, values\fP" .5i
Specify the values to be modified. Only fields specified in the mask will be
affected by the modification. Pre and postconditions are invoked when \fImodify()\fP
is called with these parameters.
.IP \fIname\fP .5i
.br
Specifies the name of a named \fIShTextBrush\fP instance. If such an instance
does not exist, a new named \fIShTextBrush\fP is created with the current textbrush
values. Preconditions and postconditions are invoked when \fImodify()\fP
is called with this parameter; the value mask is the complete named
\fIShTextBrush\fP mask. In preconditions functions, modifying the proposed
values will imply the named \fIShTextBrush\fP modification.
.IP \fIsh_tbrush\fP .5i
.br
Specifies a pointer to a \fIShTextBrush\fP instance, which will become the
\fIShTextBrush\fP referred in the textbrush. Pre and postconditions are invoked
when \fImodify()\fP is invoked with this parameter.
.RE
.sp 1
.IP
.nf
void \fBfunction\fP(ulong \fIfunction\fP);
void \fBplaneMask\fP(ulong \fIplane_mask\fP);
void \fBcolor\fP(const GColor* \fIcolor\fP);
void \fBcolor\fP(const GShColor* \fIsh_color\fP);
void \fBcolor\fP(const char* \fIcolor_name\fP);
void \fBaltColor\fP(const GColor* \fIalt_color\fP);
void \fBaltColor\fP(const GShColor* \fIsh_alt_color\fP);
void \fBaltColor\fP(const char* \fIalt_color_name\fP);
.sp
void \fBfillStyle\fP(ushort \fIfill_style\fP);
void \fBfillRule\fP(ushort \fIfill_rule\fP);
void \fBtile\fP(const GPattern* \fItile\fP);
void \fBtile\fP(const ShPattern* \fIsh_tile\fP);
void \fBtile\fP(const char* \fItile_name\fP);
void \fBstipple\fP(const GPattern* \fIstipple\fP);
void \fBstipple\fP(const ShPattern* \fIsh_stipple\fP);
void \fBstipple\fP(const char* \fIstipple_name\fP);
void \fBtsOrigin\fP(GNumber \fIx_origin\fP, GNumber \fIy_origin\fP);
.sp
void \fBfont\fP(const GFont* \fIfont\fP);
void \fBfont\fP(const GShFont* \fIsh_font\fP);
void \fBfont\fP(const char* \fIfont_name\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to modify field by field the \fIGTextBrushValues\fP structure
of the referred \fIShTextBrush\fP. Pre and postconditions are invoked.
It is recommended for perfomance reasons, to use \fImodify(mask, values)\fP when several
fields have to be modified, rather than calling the specific method for each field.
.RE
.sp 1
.IP
.nf
void \fBmodifyPrecond\fP(GBool (*\fIproc\fP)(void* \fIclosure\fP,
const GTextBrush* \fIbrush\fP,
	ulong& \fImask\fP, GTextBrushValues* \fInewValues\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
void \fBmodifyPostcond\fP(void (*\fIproc\fP)(void* \fIclosure\fP,
const GTextBrush* \fIbrush\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to add or to remove pre or postcondition procedures when the
\fITextBrush\fP is modified. That means the referred \fIShTextBrush\fP has been updated.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the \fITextBrush\fP will be modified.
The precondition procedure is called before the modification. It can either accept,
refuse or force an other modification.
The postcondition procedure is invoked after the modification is done.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the pre/postcondition procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be
added to the modify callback list. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp1
.IP
.nf
void \fBdestroyPostcond\fP(void (*\fIproc\fP)(void* \fIclosure\fP, const GTextBrush*
\fIbrush\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP = GADD) const;
.fi
.RS .8i
.IP \fIDescription\fP
This method allows to add or remove a callback procedure which will be called
when the \fITextBrush\fP will be destroyed.
.IP \fIproc\fP .5i
.br
Specifies the procedure which will be called when the object will be destroyed.
The callback procedure is called \fIjust before\fP the destruction of the object. Its par
ameters are the \fIclosure\fP and the object \fITextBrush\fP itself.
.IP \fIclosure\fP .5i
.br
Specifies a used data passed to the callback procedure.
.IP \fIadd\fP .5i
.br
If \fIadd\fP is GADD (default value), the callback procedure \fIproc\fP will be added to
the destruction callback list. If \fIadd\fP is GREMOVE, the callback procedure
\fIproc\fP will be removed from  the callback list.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
.SS
\fBHeader File\fP
.IP
#include <Go/Tools/cTextBrush.h>
.SS
\fBType Definitions\fP
.IP
The \fIShTextBrush\fP C interface defines the \fIGTextBrushValues\fP structure. This
structure is used by the \fITextBrush\fP C interface (see \fIShTextBrush(3Go)\fP).
.SS
\fBC Functions\fP
.IP
GObjectId \fBGCreateTextBrush\fP (ulong \fImask\fP, const GTextBrushValues*
\fIvalues\fP, const char* \fIname\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP: GTextBrush (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP,
const char* \fIname\fP).
.RE
.sp 1
.IP
void \fBGDestroyTextBrush\fP (GObjectId \fItbrush\fP);
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP ~GTextBrush ().
.RE
.sp 1
.IP
.nf
void \fBGModifyTextBrush\fP (GObjectId \fItbrush\fP, ulong \fImask\fP,
const GTextBrushValues* \fIvalues\fP);
void \fBGModifyTextBrushFromName\fP (GObjectId \fItbrush\fP, const char* \fIname\fP);
void \fBGModifyTextBrushFromShTextBrush\fP (GObjectId \fItbrush\fP, const GObjectId
\fIsh_tbrush\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP:
.nf
  void modify (ulong \fImask\fP, const GTextBrushValues* \fIvalues\fP);
  void modify (const char* \fIname\fP);
  void modify (const GShTextBrush* \fIsh_tbrush\fP);
.fi
.RE
.sp 1
.IP
.nf
const GTextBrushValues* \fBGGetTextBrushValues\fP (const GObjectId \fItbrush\fP);
const GObjectId \fBGGetTextBrushShBrush\fP (const GObjectId \fItbrush\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee\fP:
.nf
   const GTextBrushValues* values ();
   const GShTextBrush* shTextBrush ().
.fi
.RE
.sp 1
.IP
.nf
void \fBGModifyTextBrushPrecond\fP (GObjectId \fItbrush\fP, GAddOrRemove \fIadd\fP,
	GBool (*\fIfunction\fP)(void* \fIclosure\fP, const GObjectId \fItbrush\fP,
		ulong* \fImask\fP, GTextBrushValues* \fIvalues\fP),
	const void* \fIclosure\fP);
void \fBGModifyTextBrushPostcond\fP (GObjectId \fItbrush\fP, GAddOrRemove \fIadd\fP,
	void (*\fIfunction\fP)(void* \fIclosure\fP, GObjectId \fItbrush\fP,
		ulong \fImask\fP),
	const void* \fIclosure\fP);
void \fBGDestroyTextBrushPostcond\fP (GObjectId \fItbrush\fP, GAddOrRemove \fIadd\fP,
	void (*\fIfunction\fP)(void* \fIclosure\fP, const GObjectId \fItbrush\fP),
	const void* \fIclosure\fP);
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   void modifyPrecond (GBool (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fIbrush\fP,
	ulong& \fImask\fP, GTextBrushValues* \fInewValues\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void modifyPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fItbrush\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void destroyPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fItbrush\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
\fISee:\fP
.nf
   void modifyPrecond (GBool (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fItbrush\fP,
	ulong& \fImask\fP, GTextBrushValues* \fInewValues\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void modifyPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fItbrush\fP, ulong \fImask\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
   void destroyPostcond (void (*\fIfunction\fP)(void* \fIclosure\fP, const GTextBrush* \fIbrush\fP),
	const void* \fIclosure\fP, GAddOrRemove \fIadd\fP) const;
.fi
.RE
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fITextBrush\fP object is a non-shared object interface for the \fIShTextBrush\fP object,
see the \fIShTextBrush(3Go)\fP and \fISharedObject(3Go)\fP to know the shared object
usage.
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBSharedObject(3Go)\fP, \fBShTextBrush(3Go)\fP.
.nrPN \n%
