.\" $Id: Unit.n,v 1.1.1.1 1992/03/18 09:49:33 uep Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" licence from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH Unit 3Go "February 1992" "Version 1.1" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fBNAME\fP
.IP
\fBUnit\fP \(em the unit object class.
.sp 1
.SH 
\fBSYNOPSIS\fP
.IP
\fI#include <Go/Tools/Unit.h>\fP
.sp 1
.SH 
\fBCLASS\fP
.IP
\fBUnit\fP does not inherit behavior from any class.
.sp 1
.SH 
\fBDESCRIPTION\fP
.IP
The \fBUnit\fP class implements the general unit convertions.
.sp 1
\fBGUnit\fP is the C++ type for the \fIUnit\fP object class.
.sp 1
.nf
.ta .15i .25i 1.50i
class GUnit {
	public:
		uchar unit() const;
		float factor() const;
};
.fi
.sp 1
.SH
\fBPUBLIC METHODS\fP
.IP
.nf
uchar \fBunit\fP() const;
float \fBfactor\fP() const;
.fi
.RS .8i
.IP \fIDescription\fP .5i
These methods allow to get the base unit and the unit factor.
.RE
.sp 1
.SH
\fBC BINDING\fP
.IP
\fITo be defined\fP
.sp 1
.SH
\fBUSAGE INFORMATION\fP
.IP
The \fIUnit\fP class is an abstract class, instances cannot directly created
but instead \fIUnit\fP subclasses (i.e. \fILengthUnit\fP).
.sp 1
.SH
\fBSEE ALSO\fP
.IP
\fBLengthUnit\fP class.
.nrPN \n%
