.\" $Id: ch01.n,v 1.2 1992/12/28 16:39:03 davy Exp $
.\"
.\"
.\" Copyright (c) 1990, 1991 Bull S.A., Paris, France
.\"
.\" Permission to use, copy, modify, distribute FREE OF CHARGE this software
.\" and its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notices and this permission notice
.\" appear in all copies of the software and related documentation, and
.\" (ii) the name of Bull may not be used in any advertising or publicity
.\" relating to the software without the specific, prior written permission
.\" of Bull.
.\" 
.\" The permission to distribute or sublicense FOR CHARGE either this software
.\" (all or part) or products derived from this software is subject to prior
.\" license from Bull under separate agreement.
.\"
.\" The information in this software is subject to change without
.\" notice and should not be construed as a commitment by Bull.
.\"
.\" Bull assumes no responsibility for the use or inability to use any of its
.\" software. The software is provided "AS IS" without warranty of any
.\" kind, and Bull expressly disclaims all implied warranties, including
.\" but not limited to the implied warranties of merchantability and
.\" fitness for a particular purpose.
.\"
.\" In no event shall Bull be liable for any special, incidental, indirect
.\" or consequential damages of any kind, or any damages whatsoever
.\" resulting from loss of use, data or profits, whether or not advised of
.\" the possibility of damage, and on any theory of liability, arising out
.\" of or in connection with the use or performance of this software.
.\"
.\"
.EH ''''
.OH ''''
.EF ''''
.OF ''''
.TH \fBGo\fP \fB3Go\fP "December 1992" "Version 1.2" "Go Reference Manual" 
.nr% \n(PN+1
.SH 
\fB1. GENERATING Go BASED APPLICATIONS\fP
.LP
A \fBGo\fP based application can be written in \fBC++\fP or in ``old'' \fBC\fP.
.SH
\fB1.1 Source Files\fP
.LP
Source files using \fBGo\fP objects have to include the appropriate \fIheader
files\fP.
.LP
There is one C++ header file (C++ interface) and one C header file (C binding)
per C++ object. The name of
the object and the corresponding header files are similar, for example the
header files for the object \fIGoFoo\fP should be \fIFoo.h\fP and \fIcFoo.h\fP.
When the file name is too long (for certain file systems), it is truncated.
.LP
An (C++/C) application using an object has \fIonly\fP to include the
corresponding (C++/C) header file, other needed header files are
automatically included. For example, if the \fIGoFoo\fP class
is a subclass of the \fIGoBar\fP class, applications using \fIGoFoo\fP objects
need to include \fIFoo.h\fP (or \fIcFoo.h\fP) but need not to include
\fIBar.h\fP (or \fIcBar.h\fP).
.LP
Header files are usually located in a \fIGo\fP directory (i.e /usr/local/include/Go,
see the \fIGoPATH Installation Guide\fP),
thus it is highly recommended to include files as follows:

.br
.in +0.5i
   \fB#include <Go/Foo.h>\fP
.br
or
.br
   \fB#include <Go/cFoo.h>\fP
.in
.LP
Note that \fITools\fP and \fIExtensions\fP are located in the \fITools\fP
and \fIExt\fP subdirectories and hearder
files must be included as follows:

.br
.in +0.5i
   \fB#include <Go/Tools/Bar.h>\fP
.br
   \fB#include <Go/Ext/Toto.h>\fP
.br
or
.br
   \fB#include <Go/Tools/cBar.h>\fP
.br
   \fB#include <Go/Ext/cToto.h>\fP
.in
.SH
\fB1.2 Generating Go Based Applications\fP
.LP
All objects defined by \fBGo\fP are archived in three libraries called
\fBlibgo.a\fP, \fBlibbgo.a\fP and \fBlibgoext.a\fP. The first library
contains the basic \fBGo\fP classes (\fIGo, GoInterf, GoUI, GoStream\fP) as
well as the \fITools\fP classes, while the second contains the predefined
\fIGo\fP classes (geometric, textual, image, graph) and the last contains
some application oriented classes (clipboard, converters, filters, help,
editors, ...).
.LP
Usually libgo.a, libcgo.a and libgoext.a are located in /usr/local/lib/Go
(see your site installation and the \fIGoPATH Installation Guide\fP).
.LP
For example, if a (C++/C) application uses \fBGo\fP on top of the X
Window System, the typical command line will be:

.br
.in +0.5i
   \fBCC -o appli appli.cc -lgoext-lbgo -lgo -lX -lm\fP
.br
or
.br
   \fBcc -o appli appli.c -lgoext -lbgo -lgo -lX -lm\fP
.in 0
.LP
It is also possible to generate applications using \fIimake(1)\fP and
\fImake(1)\fP tools. In that case, it highly recommended to use the
template files available in the \fBGo\fP distribution (see \fIGoPATH
Installation Guide\fP).
.nrPN \n%
